#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ftnchek.h"
#include "symtab.h"
#include "valchek.h"
#include "tokdefs.h"
extern int new_error_level;
char *data_type[] = {
/*  1    2    3    4    5     6    7    8     9     10 */
   "I", "R", "D", "C", "DC", "L", "K", "HOL","GEN","SUBR",
/* 11         12      13        14       15   */
   "COMBLK", "PROG", "BLKDAT", "LABEL", "NMLIST",
};

typedef struct {
    char name[MAX_NAME+1];
    char sub_name[MAX_NAME+1];
    int entity_nb;
    Lsymtab **entity;
} crp_common2;

PRIVATE crp_common2 g_common2[MAX_COMMON_SUB];
PRIVATE Lsymtab *g_entity_tmp[MAX_ENTITY];
PRIVATE crp_string *xterntole = NULL, **xterntole_link = &xterntole;
PRIVATE crp_string *intrtole = NULL, **intrtole_link = &intrtole;
PRIVATE crp_string *intraut = NULL, **intraut_link = &intraut;
PRIVATE crp_string *arg_n = NULL, **arg_n_link = &arg_n;
PRIVATE crp_string *arg_t = NULL, **arg_t_link = &arg_t;
 
extern char *malloc();

void crp_setbegin_value_check_0(line_num)
int line_num;
{
    g_line_input = line_num-1;
}

void crp_init()
{
    g_sub2file_nb = 0;
    g_call_level = 0;
    g_sub2infos_nb = 0;
    g_sub2mem_nb = 0;
    strcpy(g_common_fname, "common");
    strcpy(g_common_fname_tmp, "common.tmp");
    strcpy(g_routine_fname, "routine");
    strcpy(g_routine_fname_tmp, "routine.tmp");
    strcpy(g_argument_fname_tmp, "argument.tmp");
    strcpy(g_argument_fname, "argument");
    g_lu_table_nb = 0;
    g_stmt_function_nb = 0; 
    g_entry_point_nb = 0;
    g_entity_nb = 0;
    g_com2infos_nb0 = 0;
    g_com2infos_nb = 0;
    g_common_sub_nb = 0;

    strcpy(g_bd_dir, ".");

    /* pour constituer la liste des sous programmes mise a jour */

}

void crp_init_bd()
{
    sprintf(g_common_fname,"%s/%s", g_bd_dir, "common");
    sprintf(g_common_fname_tmp,"%s/%s", g_bd_dir, "common.tmp");
    sprintf(g_routine_fname,"%s/%s", g_bd_dir, "routine");
    sprintf(g_routine_fname_tmp,"%s/%s", g_bd_dir, "routine.tmp");
    sprintf(g_argument_fname,"%s/%s", g_bd_dir, "argument");
    sprintf(g_argument_fname_tmp,"%s/%s", g_bd_dir, "argument.tmp");
    sprintf(g_argument_fname_tmp0,"%s/%s", g_bd_dir, "argument.tmp0");
}

void crp_read_data_base(routine,common, arg)
char *routine, *common, *arg;
{
    FILE *data_fd;
    int i, j, k, arg_len, nb, nb0, caller_nb, called_nb,
		caller_len, called_len, lsrcname;
    crp_sbr2 *called, *sbrl;
    crp_sbr1 *caller, *sbrr;
    crp_sbr1 **link;
    crp_sbr2 **linkl;
    crp_arg *argument; 
    crp_arg3 *arg_list; 
    crp_arg2 *argument2; 
    char *pchar;
    int argument_nb, arg_list_nb;

    nb0 = 0;
    if ( (data_fd = fopen(routine,"r")) != NULL )
    {
        fread((char *)&nb, sizeof(int), 1, data_fd);
        if ( nb + g_sub2infos_nb > MAX_SUB )
        {
	    printf("Le nombre %d de sous programmes est trop eleve. La limite est %d\n", nb + g_sub2infos_nb, MAX_SUB);
	   exit(4);
        }
        for(i=0;i<nb && g_sub2infos_nb < MAX_SUB ;i++)
        {
	    /* le nom du sous programme */
            fread(g_sub2infos[g_sub2infos_nb].sub_name, 1, MAX_NAME+1, data_fd);

            /* Les parametres du sous programme */
	
            fread((char *)&g_sub2infos[g_sub2infos_nb].type, sizeof(int), 1,
		    data_fd);
            fread((char *)&g_sub2infos[g_sub2infos_nb].size, sizeof(int), 1,
		    data_fd);
            fread((char *)&g_sub2infos[g_sub2infos_nb].line_num, sizeof(int),
		    1, data_fd);
            fread((char *)&g_sub2infos[g_sub2infos_nb].argument_nb,
			sizeof(int), 1, data_fd);
	    argument_nb = g_sub2infos[g_sub2infos_nb].argument_nb;
	    g_sub2infos[g_sub2infos_nb].maj = 1;
            if ( argument_nb > 0 )
	    {
                arg_len = g_sub2infos[g_sub2infos_nb].argument_nb*
				sizeof(crp_arg);
                g_sub2infos[g_sub2infos_nb].argument = (void *)malloc(arg_len);
                if ( g_sub2infos[g_sub2infos_nb].argument == NULL )
	        {
		    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");
		    exit(4);
	        }
	        argument    = g_sub2infos[g_sub2infos_nb].argument;
                fread((char *)argument, arg_len, 1, data_fd);
		for(j=0;j<argument_nb;j++)
		{
		    fread((char *)&argument[j].sbr_nb, sizeof(int), 1, data_fd);
		    argument[j].sbr = NULL;
		    if ( argument[j].sbr_nb > 0 )
		    {
			argument[j].sbr = (crp_sbr *)malloc(
				argument[j].sbr_nb*sizeof(crp_sbr));
			if ( argument[j].sbr == NULL )
			{
		    		printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");
		    		exit(4);
	        	}
			fread((char *)argument[j].sbr, argument[j].sbr_nb*
				sizeof(crp_sbr),1,data_fd);
		    }
		}
            }
	    /* les appelants */
	    fread((char *)&caller_nb,sizeof(int), 1, data_fd);
	    g_sub2infos[g_sub2infos_nb].caller_nb = caller_nb;
	    g_sub2infos[g_sub2infos_nb].caller = NULL;
	    if ( caller_nb > 0 )
	    {
		caller_len = caller_nb * sizeof(crp_sbr1);
		sbrr = (crp_sbr1 *)malloc(caller_len);
		if ( sbrr == NULL ) 
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }

		link = &(g_sub2infos[g_sub2infos_nb].caller);
		fread((char *)sbrr, caller_len, 1, data_fd);
                for(j=0;j<caller_nb;j++)
                {
		   caller = (crp_sbr1 *)malloc(sizeof(crp_sbr1));
		   if ( caller  == NULL ) 
                   { 
                       printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                       exit(4); 
                   }
		   memcpy((char *)caller, (char *)&sbrr[j], sizeof(crp_sbr1));
		   *link = caller;
		   caller->next = NULL;
		   link = &(caller->next);
                }
		g_sub2infos[g_sub2infos_nb].link = &(caller->next);
		free(sbrr);
	    }
            else
            {
                g_sub2infos[g_sub2infos_nb].link =
                        &(g_sub2infos[g_sub2infos_nb].caller);
            }
	    fread((char *)&called_nb,sizeof(int), 1, data_fd);
	    g_sub2infos[g_sub2infos_nb].called_nb = called_nb;
	    g_sub2infos[g_sub2infos_nb].called = NULL;
	    if ( called_nb > 0 )
	    {
		called_len = called_nb * sizeof(crp_sbr2);
		sbrl = (crp_sbr2 *)malloc(called_len);
                if ( sbrl  == NULL ) 
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }
		linkl = &(g_sub2infos[g_sub2infos_nb].called);
		fread((char *)sbrl, called_len, 1, data_fd);
                for(j=0;j<called_nb;j++)
                {
		   called = (crp_sbr2 *)malloc(sizeof(crp_sbr2));
		   if ( called  == NULL ) 
                   { 
                       printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                       exit(4); 
                   }
		   strcpy(called->name, sbrl[j].name);
		   *linkl = called;
		   called->next = NULL;
		   linkl = &(called->next);
                }  
		free(sbrl);
		called = g_sub2infos[g_sub2infos_nb].called;
		for(called = g_sub2infos[g_sub2infos_nb].called;
			called;called = called->next)
		{
		  fread((char *)&called->arg_list_nb, sizeof(int), 1, data_fd);
		  arg_list_nb = called->arg_list_nb;
		  if ( arg_list_nb > 0 )
		  {
		    arg_list = (crp_arg3 *)malloc(arg_list_nb*sizeof(crp_arg3));
		    if ( arg_list  == NULL ) 
                    { 
                        printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                        exit(4); 
                    }
		    called->arg_list = arg_list;
		    fread((char *)arg_list, arg_list_nb*sizeof(crp_arg3), 1,
			data_fd);
		    for(k=0;k<arg_list_nb;k++)
		    {
			fread((char *)&argument_nb, sizeof(int),
				1, data_fd); 
			arg_list[k].argument_nb = argument_nb;
			if ( argument_nb > 0 )
			{
			    fread((char *)&arg_list[k].argument,
				sizeof(long), 1, data_fd);
			}
		    }
		  }
		}
	    }
	    fread((char *)&g_sub2infos[g_sub2infos_nb].value_nb,
		sizeof(int), 1, data_fd);
	    g_sub2infos[g_sub2infos_nb].value = NULL;
	    if ( g_sub2infos[g_sub2infos_nb].value_nb > 0 )
	    {
		g_sub2infos[g_sub2infos_nb].value =
			(crp_sbr *)malloc(g_sub2infos[g_sub2infos_nb].value_nb*
					sizeof(crp_sbr));
	        if ( g_sub2infos[g_sub2infos_nb].value == NULL )
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }
		fread((char *)g_sub2infos[g_sub2infos_nb].value,
			g_sub2infos[g_sub2infos_nb].value_nb*sizeof(crp_sbr),
			1, data_fd);
	    }
	    fread((char *)&g_sub2infos[g_sub2infos_nb].common_nb,
		sizeof(int), 1, data_fd);
	    g_sub2infos[g_sub2infos_nb].common = NULL;
	    if ( g_sub2infos[g_sub2infos_nb].common_nb > 0 )
	    {
		g_sub2infos[g_sub2infos_nb].common = (crp_common1 *)malloc(
			g_sub2infos[g_sub2infos_nb].common_nb*
					sizeof(crp_common1));
		if ( g_sub2infos[g_sub2infos_nb].common == NULL ) 
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }
		fread((char *)g_sub2infos[g_sub2infos_nb].common,
			g_sub2infos[g_sub2infos_nb].common_nb*sizeof(crp_common1),
			1, data_fd);
	    }

	    g_sub2infos_nb++;
            nb0++;
        }
        fclose(data_fd);
        g_sub2mem_nb += nb0;
    }
    else
    {
/*
        g_sub2infos_nb = 0;
        g_sub2mem_nb = 0;
        g_sub2file_nb = 0;
*/
    }
    nb0 = 0;
    if ( (data_fd = fopen(common,"r")) != NULL )
    {
        fread((char *)&nb, sizeof(int), 1, data_fd);
        for(i=0;i<nb && g_com2infos_nb < MAX_COM ;i++)
        {
	    /* le nom du sous programme */
            fread(g_com2infos[g_com2infos_nb].name, 1, MAX_NAME+1, data_fd);
            fread(g_com2infos[g_com2infos_nb].sub_name, 1, MAX_NAME+1, data_fd);

            /* Les parametres du sous programme */
	
            fread((char *)&g_com2infos[g_com2infos_nb].entity_nb, sizeof(int), 1,
		    data_fd);
	    if ( g_com2infos[g_com2infos_nb].entity_nb > 0 )
	    {
		g_com2infos[g_com2infos_nb].entity = (crp_entity *)malloc(
			g_com2infos[g_com2infos_nb].entity_nb*sizeof(crp_entity));
		if ( g_com2infos[g_com2infos_nb].entity  == NULL ) 
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }
		fread((char *)g_com2infos[g_com2infos_nb].entity,
	              g_com2infos[g_com2infos_nb].entity_nb*sizeof(crp_entity),
		      1, data_fd);
	    }
	    else
	    {
		g_com2infos[g_com2infos_nb].entity = NULL;
	    }
	    fread((char *)&g_com2infos[g_com2infos_nb].sbr_nb, sizeof(int),
		1, data_fd);
	    if ( g_com2infos[g_com2infos_nb].sbr_nb > 0 )
	    {
		g_com2infos[g_com2infos_nb].sbr = (crp_sbr1 *)malloc(
			g_com2infos[g_com2infos_nb].sbr_nb*sizeof(crp_sbr1));
		if ( g_com2infos[g_com2infos_nb].sbr == NULL ) 
                { 
                    printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
                    exit(4); 
                }
		fread((char *)g_com2infos[g_com2infos_nb].sbr,
		   g_com2infos[g_com2infos_nb].sbr_nb*sizeof(crp_sbr1),
		   1, data_fd);
	    }
	    else
	    {
		g_com2infos[g_com2infos_nb].sbr = NULL;
	    }
	    g_com2infos_nb++;
            nb0++;
        }
        fclose(data_fd);
        g_com2mem_nb += nb0;
    }
    arg_fd = fopen(arg,"r");
}

int crp_value_violation(name, arg_num, sub_name, line)
char *name, **sub_name;
int arg_num;
int *line;
{
     int i, ret;
     crp_arg *argument;
     ret = 0;
     if ( crp_is_argument(name,arg_num) )
     {
	return 0;
     }
     for(i=0;i<g_sub2infos_nb;i++)
     {
	if ( strcmp(g_sub2infos[i].sub_name, name) == 0 )
	{
	   if ( arg_num < g_sub2infos[i].argument_nb )
	   {
	      ret = ((crp_arg *)g_sub2infos[i].argument)[arg_num].output;
	      *sub_name = ((crp_arg *)g_sub2infos[i].argument)[arg_num].sub_name_o;
	      *line = ((crp_arg *)g_sub2infos[i].argument)[arg_num].line_num_o;
	   }
	   else
	   {
	      ret = 8;
	   }
	   return ret;
	}
     }
     return 0;
}

void crp_print_loc_symbols(hash)
int hash;
{
/*
    fprintf(list_fd, "\n\nDans le module %s du fichier %s\n", (hashtab[hash].loc_symtab)->name, current_filename);
    fprintf(list_fd, "\n=================================================\n\n");
*/
}

void crp_print_module_name(str,name)
char *str, *name;
{
    fprintf(list_fd, "\n\n->Analyse %s %s du fichier %s\n\n", str, name, current_filename);
}

int crp_is_normal(name)
char *name;
{
    return ( /*is_not_intrinsic(name) &&*/ is_not_stmt_function(name) );
}

void crp_stmt_function(name)
char *name;
{
    int i;
    for(i=0;i<g_stmt_function_nb;i++)
    {
	if ( strcmp(g_stmt_function[i], name) == 0 )
	{
	    return;
	}
    }
    if ( g_stmt_function_nb < MAX_STMT_FUNCTION )
    {
        strcpy(g_stmt_function[g_stmt_function_nb], name);
	g_stmt_function_nb++;
    }
    else
    {
        printf("Nombre de statement function trop grand. Augmenter la taille MAX_STMT_FUNCTION actuellement a  %d\n", MAX_STMT_FUNCTION);
    }
}

int is_not_stmt_function(name)
char *name;
{
    int i;
    for(i=0;i<g_stmt_function_nb;i++)
    {
	if ( strcmp(name, g_stmt_function[i]) == 0 )
	{
	    return 0;
	}
    }
    return 1;
}

int crp_is_argument(name,arg_num)
char *name;
{
    int i;
    for(i=0;i<=arg_num;i++)
    {
	if ( strcmp(name,g_argument[i].name) == 0 )
	{
	    return 1;
	}
    }
    return 0;
}

int crp_write_tole(target, sub_name)
char *target, *sub_name;
{
}


void crp_actual_arg_set(argument, arg_num, id, ident)
Token *id;
crp_arg1 *argument;
int       arg_num, ident;
{
    int size, type;
    int i, i1;
  if ( arg_num < MAX_ARG )
  {
    type = id->class;
    size = id->size;
    if ( type >= type_SUBROUTINE )
    {
      if ( ! crp_is_argument(hashtab[id->value.integer].name,
		g_argument_nb-1) )
      {
	if ( (i1 = crp_search_subprog_tot(
		hashtab[id->value.integer].name)) == -1 )
	{
	    type = type_UNDEF_SUBROUTINE; /* pour ne pas a verifier
					     la coherence de type */
	    size = 1;  /* Pour eviter de recalculer la taille */
	    new_error_level = 4;
            sprintf(new_char_val, g_message[28],
                  hashtab[id->value.integer].name,
                  hashtab[id->value.integer].name);
            syntax_error(id->line_num,id->col_num,
                new_char_val, "CRP_998");
	}
	else
	{
	    type = (g_sub2infos[i1].type < type_SUBROUTINE)?
		g_sub2infos[i1].type+type_SUBROUTINE:
		g_sub2infos[i1].type;
	    size = g_sub2infos[i1].size;
	}
      }
      else
      {
	    type = type_UNDEF_SUBROUTINE;
            size = 1;  /* Pour eviter de recalculer la taille */
      }
    }
    if ( type == type_DP )
    {
	type = type_REAL;
	size = 8;
    }
    else if ( type == type_DCOMPLEX )
    {
	type = type_COMPLEX;
	size = 16;
    }
    argument[arg_num].type = type;
    argument[arg_num].size = (size == size_DEFAULT)? type_size[type]:size;
    argument[arg_num].line_num = id->line_num;
    argument[arg_num].col_num = id->col_num;
  }
  else
  {
        printf("Le nombre de parametre de %s atteint le maximum. Augmenter MAX_ARG dans valchek.h et recompiler.\n", new_subprogram_name);
	exit(4);
  }
}

void crp_actual_labelarg_set(argument, arg_num, id)
Token *id;
crp_arg1 *argument;
int       arg_num;
{
    argument[arg_num].type = -1;
    argument[arg_num].size = -1;
    argument[arg_num].line_num = id->line_num;
    argument[arg_num].col_num = id->col_num;
}

int crp_search_subprog_tot(name)
char *name;
{
    /* Recherche simple d'un sous programme de la liste totale */
    int i;
    for(i=0;i<g_sub2infos_nb;i++)
    {
        if ( g_sub2infos[i].maj >= 0 )
	{
            if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
            {
                return i;
            }
	}
    }   
    return -1;
}

void crp_mem_common(id)
Token *id;
{
    int i;
    crp_sbr1 *sb;
    for(i=0;i<g_common_sub_nb;i++)
    {
	if ( g_common_sub[i] == id->value.integer )
        {
	    return;
        }
    }
    if ( g_common_sub_nb < MAX_COMMON_SUB )
    {
	strcpy(g_common2[g_common_sub_nb].name, hashtab[id->value.integer].name);
	strcpy(g_common2[g_common_sub_nb].sub_name, new_subprogram_name);
        g_common2[g_common_sub_nb].entity_nb = g_entity_nb;
        g_common2[g_common_sub_nb].entity =
		(void *)malloc(sizeof(crp_entity)*g_entity_nb);
	if ( g_common2[g_common_sub_nb].entity == NULL ) 
        { 
            printf("Probleme d'allocation de memoire dans crp_read_data_base.\n");           
            exit(4); 
        }
        memcpy(g_common2[g_common_sub_nb].entity, g_entity_tmp,
		sizeof(crp_entity)*g_entity_nb);
        g_common_sub_nb++;
    }
    else
    {
	printf("Le nombre de common atteint le maximum. Augmenter MAX_COMMON_SUB et recompiler.\n");
	exit(4);
    }
}

void crp_set_common_type(id, entity_nb)
Token *id;
int *entity_nb;
{
    if ( *entity_nb >= MAX_ENTITY )
    {
        printf("Le nombre d'entity atteint le maximum %d.\nAugmenter MAX_ENTITY et recompiler.\n", MAX_ENTITY);
        exit(4);
    }
    g_entity_tmp[*entity_nb] = hashtab[id->value.integer].loc_symtab;
    (*entity_nb)++;
}

static crp_string *new_subprogram = NULL;
static crp_string **new_subprogram_link = &new_subprogram;
static int new_subprogram_nb=0;

void crp_ajout_new_sub(name)
char *name;
{
    crp_string *string;
    int i;

	new_subprogram_nb++;
	string = (crp_string *)malloc(sizeof(crp_string));
        if ( string == NULL ) 
        { 
            printf("Probleme d'allocation de memoire dans crp_ajout_new_sub.\n");           
            exit(4); 
        }
	string->next = NULL;
	string->name = malloc(strlen(name)+1);
        if ( string->name == NULL ) 
        { 
            printf("Probleme d'allocation de memoire dans crp_ajout_new_sub.\n");           
            exit(4); 
        }
        strcpy(string->name, name);
	*new_subprogram_link = string;
	new_subprogram_link = &string->next;
}
static int level=0, max_level = 100;
static char name_level[100][MAX_NAME+1];


void crp_value_processing(name)
char *name;
{
    int i, ind, argument_nb, sb_index, is_output, recursif;
    crp_arg *argument;
    crp_sbr1 *entryr;
    crp_string *crp_search_new_sub();
    
        /* Verification ascendante de violation de constantes */
 
    ind = crp_search_subprog_tot(name);
    if ( ind >= 0 )
    {
/*
      if (g_sub2infos[ind].arg_modifie )
*/
      {
        is_output = 0;
        argument = g_sub2infos[ind].argument;
        argument_nb = g_sub2infos[ind].argument_nb;
        for(i=0;i<argument_nb;i++)
        {
            if ( argument[i].output )
            {
                is_output = 1;
                break;
            }   
        }
        for(entryr=g_sub2infos[ind].caller;entryr;entryr=entryr->next)
        {
	  if ( crp_search_new_sub(entryr->name) == NULL )
          {
            sb_index = crp_search_subprog_tot(entryr->name);
            if ( sb_index >= g_sub2file_nb )
            {
                if ( is_output )
                {
                    strcpy(new_subprogram_name,entryr->name);
                    for(i=0;i<argument_nb;i++)
                    {
                        if ( argument[i].output )
                        {
                            crp_value_violation_ascendant( name,
                                   sb_index,i, argument[i].sub_name_o,
                                   argument[i].line_num_o);
                        }
                    }   
	            if ( crp_arg_propage(sb_index, name) )
	            {
                      recursif = 0;
        	      for(i=0;i<level;i++)
        	      {
	    		if ( strcmp(entryr->name, name_level[i]) == 0 )
	    		{
			   recursif = 1;
			   break;
	    	        }
        	      }
		      if ( ! recursif )
		      {
		        strcpy(name_level[level], entryr->name);
        	        level++;
		        crp_value_processing(entryr->name);
        	        level--;
		      }
	            }
                }
 
            }
          }
        }
      }
    }
}

int crp_arg_propage(ind, name)
int ind;
char *name;
{
    crp_arg *argument;
    int i, j, argument_nb;

    argument = g_sub2infos[ind].argument;
    argument_nb = g_sub2infos[ind].argument_nb;
    for(i=0;i<argument_nb;i++)
    {
	for(j=0;j<argument[i].sbr_nb;j++)
	{
	    if ( strcmp((argument[i].sbr[j]).name,name) == 0 )
	    {
		return 1;
	    }
	}
    }
    return 0;
}

void crp_end_processing()
{
    int i, ind;
    void crp_identity_common1();

    /*  Verification de concordance de type du sous programme */

    for(i=0;i<g_common_sub_nb;i++)
    {
        if ( crp_common_uniform_type(i) )
        {
            if ( (ind = crp_search_common_tot(g_common2[i].name))
		!= -1 )
	    {
	        crp_identity_common1(i,ind);
	    }
	    else
	    {
                fprintf(list_fd, "\nCRP_AVER. Impossible de trouver le common %s dans la base.\n", g_common2[i].name);
	    }
        }
        g_common2[i].entity_nb = 0;
    }
    g_common_sub_nb =0;
}

int crp_common_uniform_type(i)
{
    Lsymtab **entity;
    int j, type;
/*
    entity = g_common2[i].entity;
    type = entity[0]->type;
    for(j=0;j<g_common2[i].entity_nb;j++)
    {
	if ( entity[j]->type != type )
        {
                sprintf(new_char_val, g_message[24], entity[j]->name,
			g_common2[i].name,g_common2[i].sub_name);
                syntax_error(0,1, new_char_val,"CRP_151");
		return FALSE;
        }
    }
*/
    return TRUE;
}

void crp_identity_common1(i,ind)
{
    int j, c1, type, size, length, entity_nb, centity_nb;
    Lsymtab **entity;
    crp_entity *centity;
    entity_nb = g_common2[i].entity_nb;
    centity_nb = g_com2infos[ind].entity_nb;
    if ( entity_nb == centity_nb )
    {
        centity = g_com2infos[ind].entity;
        entity = g_common2[i].entity;
	for(j=0;j<entity_nb;j++)
	{
            size = entity[j]->size;
            type = entity[j]->type;
	    length = entity[j]->length;
	    if ( type == 0 )
	    {
		c1 = entity[j]->name[0] -'A';
		type = implicit_type[c1];
	    }
	    if ( size == 0 )
	    {
		size = implicit_size[c1];
		if ( size == size_DEFAULT )
		{
		    size = type_size[type];
		}
	    }
	    if ( length == 0 )
	    {
		length = 1;
		/* juste pour que cela concorde avec la valeur convenu a 
		   la base de donnees */
	    }
	    if ( size != centity[j].size ||
		 type != centity[j].type )
	    {
		sprintf(new_char_val,
		  g_message[24],
			entity[j]->name, g_common2[i].name, g_com2infos[ind].sub_name);
		syntax_error(0,1, new_char_val,"CRP_151");
		new_error_level = 4;
	    }
	    else if ( length != centity[j].length )
	    {
		sprintf(new_char_val,
                  g_message[25],
                        entity[j]->name, g_common2[i].name,g_com2infos[ind].sub_name);
                syntax_error(0,1, new_char_val,"CRP_152");
		new_error_level = 4;
	    }
	}
    }
    else
    {
	sprintf(new_char_val,g_message[23], g_common2[i].name,
		centity_nb, entity_nb, g_com2infos[ind].sub_name);
        syntax_error(0,0,new_char_val,"CRP_150");
	new_error_level = 4;
    }
    free(g_common2[i].entity);
}

int crp_search_common_tot(name)
char *name;
{
    int i;
    for(i=0;i<g_com2infos_nb;i++)
    {
	if ( strcmp(g_com2infos[i].name, name) == 0 )
	{
	    return i;
	}
    }
    return -1;
}

crp_set_array_var(id, length)
int length;
Token *id;
{
    g_lu_table[id->value.integer].length = length;
}

void crp_set_length(id,length)
Token *id;
int length;
{
    Lsymtab *symt = hashtab[id->value.integer].loc_symtab;
    symt->length = length;
}



int crp_mem_value_lu(id,value)
Token *id;
int value;
{
    g_lu_table[id->value.integer].length = value;
}

int crp_x_value_lu(id)
Token *id;
{
    return g_lu_table[id->value.integer].length;
}

int crp_x_value(id)
Token *id;
{
    if ( id->class == tok_identifier || id->class == tok_array_identifier )
    {
        return g_lu_table[id->value.integer].length;
    }
    else
    {
        return id->value.integer;
    }
}

int crp_toleutilicra(name)
char *name;
{
    return ( crp_in_list(intrtole,name) || crp_in_list(xterntole,name) );
}


void crp_inter_routine(name, arg_nb, argument,
		routine_type, routine_size, line_num, col_num)
char *name;
int arg_nb;
crp_arg1 *argument;
int line_num, col_num;
{
    int i, ind;
    char *typearg, *typebdarg, *type0 = "", *typesubr = "SUBROUTINE";
    crp_arg *bd_argument;

    if ( (ind = crp_search_subprog_tot(name)) != -1 && ! crp_in_list(arg_n,name) )
    {
	if ( arg_nb == g_sub2infos[ind].argument_nb )
	{
           if ( ! crp_in_list(arg_t, name) )
           {
	      bd_argument = g_sub2infos[ind].argument;
              for(i=0;i<arg_nb;i++)
              {
                 if ( argument[i].type + bd_argument[i].type <
			type_SUBROUTINE + type_UNDEF_SUBROUTINE )
		 {
		    if ( argument[i].type != bd_argument[i].type )
		    {

	                sprintf(new_char_val, g_message[20],
		           i+1, (i==0)?"er":"eme",name);
		        syntax_error(argument[i].line_num, argument[i].col_num,
			    new_char_val,"CRP_102");
		        new_error_level = 4;
		    }
		    else
		    {
		       if ( argument[i].size != bd_argument[i].size )
		       {
			  if ( (argument[i].type != type_SUBROUTINE)    &&
			       (argument[i].type != type_STRING ||
			                     bd_argument[i].size != -1) &&
                               (argument[i].type != type_STRING+10 ||
                                                argument[i].size != -1)      )
			  {
			        sprintf(new_char_val, g_message[20],
                                   i+1, (i==0)?"er":"eme", name);
                                syntax_error(argument[i].line_num,
				    argument[i].col_num,
                                    new_char_val, "CRP_102");
                                new_error_level = 4;
			  }
		       }
		    }
                 }
	      }
           }
        }
        else
        {
	    sprintf(new_char_val, g_message[19], name);
	    syntax_error(line_num,col_num,new_char_val,
			"CRP_101");
            new_error_level = 4;
        }

	if ( routine_type != g_sub2infos[ind].type )
	{
                if ( routine_type <= 7 && 
			     g_sub2infos[ind].type == type_SUBROUTINE )
		{
	           sprintf(new_char_val, g_message[22], name);
		   syntax_error(line_num,col_num, new_char_val,"CRP_104");
		   new_error_level = 4;
		}
		else if ( g_sub2infos[ind].type <= 7 &&
		             routine_type == type_SUBROUTINE )
		{
	           sprintf(new_char_val, g_message[21], name);
		   syntax_error(line_num,col_num, new_char_val,"CRP_103");
		   new_error_level = 4;
                }
		else if ( routine_type <= 7 &&
			     g_sub2infos[ind].type <= 7 &&
			     ! crp_in_list(arg_t, name) )
		{
	           sprintf(new_char_val, g_message[30], name,
			data_type[g_sub2infos[ind].type-1],
			g_sub2infos[ind].size, 
			data_type[routine_type-1], routine_size);
		   syntax_error(line_num,col_num, new_char_val,"CRP_105");
		   new_error_level = 4;
		}
	}
    }
}

char *crp_token_name(id)
Token id;
{
    return g_lu_table[id.value.integer].name;
}

int is_not_intrinsic(name)
char *name;
{
    IntrinsInfo *find_intrinsic(), *intr;
    intr = find_intrinsic(name);
    return (intr == NULL);
}

void crp_func_ref_expr( name, args, result )
Token *args, *result;
char *name;
{
     IntrinsInfo *find_intrinsic(), *defn;
     int rettype, retsize, i1;
     Lsymtab *symt;
     defn = find_intrinsic(name);
     if ( defn != NULL )
     {
	 rettype = defn->result_type;
         retsize = size_DEFAULT;
         if(rettype == type_GENERIC) {
                if(args->next_token == NULL) {
                  rettype = type_UNDECL;
                  retsize = size_DEFAULT;
                }
                else {
                    rettype = args->class;
                    retsize = args->size;
    		    if ( args->class == tok_identifier )
    		    {
			symt = hashtab[args->value.integer].loc_symtab;
			retsize = symt->size;
			rettype = symt->type;
    		    }
    		    if ( retsize == size_DEFAULT )
    		    {
        		    retsize = type_size[rettype];
    		    }
                }
		if(rettype == type_COMPLEX && (defn->intrins_flags&I_C_TO_R))
		{
                    rettype = type_REAL;
                    retsize = retsize/2;
                }
                if(rettype == type_DCOMPLEX &&(defn->intrins_flags&I_C_TO_R))
		{
                    rettype = type_DP;
                    retsize = size_DEFAULT;
                }
         }
     }
     else
     {
	symt = hashtab[result->value.integer].loc_symtab;
	if ( symt->type == type_SUBROUTINE )
	{
	    symt->type = 0;
	}
	rettype = get_type(symt);
        retsize = get_size(symt,rettype);
     }
         result->class = type_byte(class_VAR,rettype);
         result->size = retsize;
} 

void crp_end_file()
{
    int i, j, k, indref, ind, indr, nsub;
    crp_string *string, *string0;
    crp_sbr1 *caller;
    crp_sbr2 *called;
    crp_arg3 *arg_list;
    void crp_check_arg_type();
    crp_string *crp_search_new_sub();
    g_line_input = 0;
    for(string = new_subprogram;string; string = string->next)
    {
      if ( (indref = crp_search_subprog_tot(string->name)) != -1 )
      {
        caller=g_sub2infos[indref].caller;
	for(j=0;j<g_sub2infos[indref].caller_nb;j++)
	{
	    if ( crp_search_new_sub(caller->name) == NULL )
	    {
		indr = crp_search_subprog_tot(caller->name);
		called = g_sub2infos[indr].called;
		for(called=g_sub2infos[indr].called;called;called=called->next)
		{
		    if ( strcmp(called->name, string->name) == 0 )
		    {
			arg_list = called->arg_list;
			for(k=0;k<called->arg_list_nb;k++)
			{
			    strcpy(new_subprogram_name, caller->name);
			    crp_check_arg_type(indref,&arg_list[k], called->name);
			}
			break;
		    }
		}
	    }
	    caller = caller->next;
	}
      }
    }
    for(string = new_subprogram;string;string=string->next)
    {
        crp_value_processing(string->name);
    }
    for(string = new_subprogram;string;string=string0)
    {
	string0 = string->next;
	free(string);
    }
    new_subprogram = NULL;
    new_subprogram_link = &new_subprogram;
}

crp_string *crp_search_new_sub(name)
char *name;
{
    crp_string *string;
    int nsub;
    for(string = new_subprogram;string; string = string->next)
    {
	if ( strcmp(name,string->name) == 0 )
	{
	    return string;
	}
    }
    return NULL;
}

void crp_check_arg_type(indref,arg_list, name)
int indref;
crp_arg3 *arg_list;
char *name;
{
    extern unsigned prev_stmt_line_num; /* shared with advance.c */
    int i, ind, indtot;
    char *typearg, *typebdarg, *type0 = "", *typesubr = "subr";
    crp_arg *bd_argument;
    crp_arg2 *argument;

        if ( arg_list->argument_nb > 0 )
	{
	    argument = (crp_arg2 *)malloc(arg_list->argument_nb*sizeof(crp_arg2));
	    if ( argument == NULL ) 
            { 
                printf("Probleme d'allocation de memoire dans crp_check_arg_type.\n");           
                exit(4); 
            }
	    fseek(arg_fd,(long)arg_list->argument,0);
	    fread((char *)argument, arg_list->argument_nb*sizeof(crp_arg2),1,arg_fd);
	}
        else
        {
	    argument = NULL;
        }
	if ( arg_list->argument_nb == g_sub2infos[indref].argument_nb )
	{
	    bd_argument = g_sub2infos[indref].argument;
            for(i=0;i<arg_list->argument_nb;i++)
            {
                if ( argument[i].type >= type_SUBROUTINE &&
		     argument[i].type < type_UNDEF_SUBROUTINE )
		{
		    if ( (indtot = crp_search_subprog_tot(argument[i].name)) == -1 )
		    {
			argument[i].type = type_UNDEF_SUBROUTINE;
		    }
		    else
		    {
			argument[i].type =
			  (g_sub2infos[indtot].type < type_SUBROUTINE)?
                		g_sub2infos[indtot].type+type_SUBROUTINE:
                		g_sub2infos[indtot].type;
            		argument[i].size = g_sub2infos[indtot].size;;
		    }
		}
		if ( argument[i].type + bd_argument[i].type <
			type_SUBROUTINE + type_UNDEF_SUBROUTINE )
		{
		  if ( argument[i].type != bd_argument[i].type )
		  {
	            sprintf(new_char_val,
	     g_message[20], i+1, (i==0)?"er":"eme",name);
			prev_stmt_line_num = arg_list->line_num;
		    syntax_error(arg_list->line_num, 0,
			new_char_val,"CRP_102");
		    new_error_level = 4;
		  }
		  else
		  {
     
		    if ( argument[i].size != bd_argument[i].size )
		    {
		        if ( (argument[i].type != type_SUBROUTINE)  &&
			     (bd_argument[i].size != -1 ||
			           argument[i].type != type_STRING )&&
			     (argument[i].type != type_STRING+10 ||
                                                argument[i].size != -1)  )
		        {
			    sprintf(new_char_val,
                     g_message[20], i+1, (i==0)?"er":"eme", name);
			    prev_stmt_line_num = arg_list->line_num;
                            syntax_error(arg_list->line_num, 0,
                                new_char_val, "CRP_102");
                            new_error_level = 4;
		        }
		    }
		  }
                }
            }
        }
        else
        {
	    sprintf(new_char_val,
	     g_message[19],name);
			prev_stmt_line_num = arg_list->line_num;
	    syntax_error(arg_list->line_num,0,new_char_val,
			"CRP_101");
            new_error_level = 4;
        }
        if ( argument )
	{
	    free(argument);
	}
}

crp_read_list()
{
    crp_string *string;
    FILE *fin;
    int l;

    sprintf(new_char_val, "%s/xterntole", g_bd_dir);

    if ( fin = fopen(new_char_val, "r") )
    {
	while ( fgets(new_char_val, 250, fin) )
	{
            l = strlen(new_char_val); 
            new_char_val[l-1] = '\0'; 
            crp_toupper(new_char_val);
	    string = (crp_string *)malloc(sizeof(crp_string));
	    string->next = NULL;
	    string->name = malloc(l);
            strcpy(string->name, new_char_val);
	    *xterntole_link = string;
	    xterntole_link = &string->next;
        }
    }
    sprintf(new_char_val, "%s/intrtole", g_bd_dir);

    if ( fin = fopen(new_char_val, "r") )
    {
	while ( fgets(new_char_val, 250, fin) )
	{
	    l = strlen(new_char_val);
	    new_char_val[l-1] = '\0';
	    crp_toupper(new_char_val);
	    string = (crp_string *)malloc(sizeof(crp_string));
	    string->next = NULL;
	    string->name = malloc(l);
            strcpy(string->name, new_char_val);
	    *intrtole_link = string;
	    intrtole_link = &string->next;
        }
    }
    sprintf(new_char_val, "%s/intraut", g_bd_dir);

    if ( fin = fopen(new_char_val, "r") )
    {
	while ( fgets(new_char_val, 250, fin) )
	{
	    l = strlen(new_char_val);
	    new_char_val[l-1] = '\0';
	    crp_toupper(new_char_val);
	    string = (crp_string *)malloc(sizeof(crp_string));
	    string->next = NULL;
	    string->name = malloc(l);
            strcpy(string->name, new_char_val);
	    *intraut_link = string;
	    intraut_link = &string->next;
        }
    }
    sprintf(new_char_val, "%s/arg_n", g_bd_dir);

    if ( fin = fopen(new_char_val, "r") )
    {
	while ( fgets(new_char_val, 250, fin) )
	{
	    l = strlen(new_char_val);
	    new_char_val[l-1] = '\0';
	    crp_toupper(new_char_val);
	    string = (crp_string *)malloc(sizeof(crp_string));
	    string->next = NULL;
	    string->name = malloc(l);
            strcpy(string->name, new_char_val);
	    *arg_n_link = string;
	    arg_n_link = &string->next;
        }
    }
    sprintf(new_char_val, "%s/arg_t", g_bd_dir);

    if ( fin = fopen(new_char_val, "r") )
    {
	while ( fgets(new_char_val, 250, fin) )
	{
	    l = strlen(new_char_val);
	    new_char_val[l-1] = '\0';
	    crp_toupper(new_char_val);
	    string = (crp_string *)malloc(sizeof(crp_string));
	    string->next = NULL;
	    string->name = malloc(l);
            strcpy(string->name, new_char_val);
	    *arg_t_link = string;
	    arg_t_link = &string->next;
        }
    }
}


crp_toupper(str)
char *str;
{
    while( *str )
    {
	*str = toupper(*str);
	str++;
    }
}

int crp_in_list(beg, name)
crp_string *beg;
char *name;
{
    crp_string *string;
    for(string=beg;string;string=string->next)
    {
	if ( strcmp(string->name, name) == 0 )
	{
	    return TRUE;
	}
    }
    return FALSE;
}

int crp_value_violation_ascendant(name,sb_index,arg_num, sub_name,line_num )
char *name, *sub_name;
int sb_index, arg_num, line_num;
{
    int j;
    crp_sbr *sbr;
    if ( g_sub2infos[sb_index].value_nb > 0 )
    {
	sbr = g_sub2infos[sb_index].value;
        for(j=0;j<g_sub2infos[sb_index].value_nb;j++)
	{
	    if ( strcmp(sbr[j].name,name) ==0 && sbr[j].arg_num == arg_num )
	    {
                sprintf(new_char_val, g_message[26], arg_num+1,
                                    (arg_num==0)?"er":"eme", name,
                                    sub_name,
                                    line_num);
		syntax_error(sbr[j].line_num,1001, new_char_val, "CRP_200");
		new_error_level = 4;
	    }
	}
    }
}

