#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <unistd.h>

#include "ftnchek.h"
#include "symtab.h"
#include "tokdefs.h"
#include "valchek.h"

#define lu_table_name(id) (g_lu_table[(id)->value.integer].name)
extern char *malloc();
extern void crp_setxtrnal_if_arg();
extern int current_module_type;
static int name_len;

/*----debug CM debut-----*/
void tst_len(char* str, int max)
{
if (str) {
   if (strlen(str) > max) {
      printf("tst_len(%s,%d):FAUX\n",str,max);
      abort();
      }
   }
else {
   printf("tst_len(NULL,%d):FAUX\n",max);
   abort();
   }
}

/*----debug CM fin-----*/

void crp_get_dummy_argument(arg_num,id, return_label)
int arg_num;
Token *id;
int return_label;
{
    int lu;

  if ( arg_num < MAX_ARG )
  {
    lu = id->value.integer;
    g_lu_table[lu].var_type = PARAM_VAR;

    if ( return_label )
    {
        strcpy(g_argument[arg_num].name,"*");
        g_argument[arg_num].type = -1;
        g_argument[arg_num].size = -1;
    }
    else
    {
        strcpy(g_argument[arg_num].name,lu_table_name(id));
        g_argument[arg_num].type = g_lu_table[lu].type;
        g_argument[arg_num].size = g_lu_table[lu].size;
    }
    if ( arg_num == g_arg_num )
    {
            strcpy(g_arg_name,g_argument[arg_num].name);
    }
  }
  else
  {
	printf("Le nombre de parametres de %s atteint le maximum. Augmenter MAX_ARG de valchek.h et recompiler.\n", g_subprog_name);
	exit(4);
  }
}

void crp_end_processing_val()
{
    int i, j, i1, k, indentry;
    crp_sbr *sb, *sb0, *sb1, *sb2;
    int *entity, entity_nb, type, size, actual_size;
    crp_arg *sarg;


/*  rearranger les appels aux sous programmes associes a chaque 
    parametre */
    if ( current_module_type == type_UNDECL )
    {
	/* Dans le cas ou le type du module n'est pas defini
	   (l'instruction PROGRAM, SUBROUTINE, FUNCTION, etc... n'est
	    pas rencontre), il faut avancer le compteur de modules. En
	    effet le module a ete initialise mais pas encore compte. */
/*
        g_sub2infos_nb++;
*/
    }
    
    for(k=0;k<g_entry_point_nb;k++)
    {
       indentry = g_entry_point_ind[k];
       if ( g_sub2infos[indentry].size == size_SUBROUTINE )
       {
	   g_sub2infos[indentry].size = size_DEFAULT;
       }
       else
       {
          if ( ! crp_get_type_lu(indentry) )
	  {
            i1 = *g_sub2infos[indentry].sub_name - 'A';
            if ( g_sub2infos[indentry].type == 0 )
            {
	       g_sub2infos[indentry].type = implicit_type[i1];
            }
            if ( implicit_size[i1] != 0 && g_sub2infos[indentry].size == size_DEFAULT )
            {
	       actual_size = implicit_size[i1];
            }
            else
            {
	       actual_size = type_size[g_sub2infos[indentry].type];
            }
            g_sub2infos[indentry].size = (g_sub2infos[indentry].size ==
		size_DEFAULT)? actual_size: g_sub2infos[indentry].size;
	  }
      }
      sarg = g_sub2infos[indentry].argument;
      for(i=0;i<g_sub2infos[indentry].argument_nb;i++)
      {
        i1 = sarg[i].name[0] - 'A';
        if ( sarg[i].type == 0 )
	{
	    sarg[i].type = implicit_type[i1];
	}
	if ( implicit_size[i1] != 0 && sarg[i].size == size_DEFAULT )
	{
	    actual_size = implicit_size[i1];
	}
	else
	{
	    actual_size = type_size[
		(sarg[i].type<type_SUBROUTINE) ? sarg[i].type :
					sarg[i].type-type_SUBROUTINE];
	}
	sarg[i].size = (sarg[i].size == size_DEFAULT)?
		actual_size:sarg[i].size;
    
        if ( sarg[i].type < type_SUBROUTINE )
        {
            /* traitement dans le cas ou le parametre est declare
               en extrenal mais n'est appele par personne */
	    for(j=0;j<g_nbextrn;j++)
	    {
                if ( strcmp(sarg[i].name,g_extrn_name[j]) == 0 )
	        {
		    if ( crp_search_arg(sarg[i].name) >= 0 )
		    {
		        sarg[i].type += type_UNDEF_SUBROUTINE;
		    }
		    else
		    {
		        sarg[i].type += type_SUBROUTINE;
		    }
		    break;
	        }
	    }
        }
        /* les sous probrammes */
	if ( sarg[i].sbr_nb > 0 )
	{
	  sb1 = (crp_sbr *)malloc(sarg[i].sbr_nb*sizeof(crp_sbr));
	  if ( sb1 )
	  {
	    sb0 = sb1;
	    for(sb=sarg[i].sbr;sb;sb=sb->next)
	    {
		memcpy(sb1,sb,sizeof(crp_sbr));
		sb1->next = sb1 + 1;
		sb1++;
	    }
	    (sb1-1)->next = NULL;
	    for(sb=g_argument0[i].sbr;sb;sb=sb1)
	    {
	        sb1 = sb->next;
		free(sb);
	    }
	    sarg[i].sbr = sb0;
	  }
	  else
	  {
	        printf("impossible d'allouer la memoire\n");
	        exit(1);
	  }
	}
      }
      if ( g_sub2infos[indentry].value_nb > 0 )
      {
	sb1 = (crp_sbr *)malloc(g_sub2infos[indentry].value_nb*sizeof(crp_sbr));
	sb2 = sb1;
	if ( sb1 )
	{
	    for(sb=g_sub2infos[indentry].value;sb;sb=sb0)
	    {
		memcpy(sb1,sb,sizeof(crp_sbr));
		sb1++;
		sb0 = sb->next;
		free(sb);
	    }
	    g_sub2infos[indentry].value = sb2;
	}
	else
	{
	    printf("impossible d'allouer la memoire\n");
	    exit(1);
	}
      }
    }
    /* remise le compteur de statement function a 0 */
    for(i=g_com2infos_nb0;i<g_com2infos_nb;i++)
    {
	entity_nb = g_com2infos[i].entity_nb;
        entity = (int *)g_com2infos[i].entity;
	g_com2infos[i].entity = (crp_entity *)malloc(entity_nb*sizeof(crp_entity));
	for(j=0;j<entity_nb;j++)
	{
	    strcpy((g_com2infos[i].entity)[j].name, g_lu_table[entity[j]].name);
            i1 = (g_com2infos[i].entity)[j].name[0] - 'A';
	    type = g_lu_table[entity[j]].type;
            if ( type == 0 )
	    {
		type = implicit_type[i1];
	    }
	    (g_com2infos[i].entity)[j].type = type;
            size = g_lu_table[entity[j]].size;
            if ( size == size_DEFAULT)
            {
		size = (implicit_size[i1] == 0)? type_size[type]:implicit_size[i1];
            }
	    (g_com2infos[i].entity)[j].size = size;
	    (g_com2infos[i].entity)[j].length = g_lu_table[entity[j]].length;
	}
        free(entity);
    }
    if ( g_common_sub_nb > 0 )
    {
        g_sub2infos[g_sub2infos_ind].common_nb = g_common_sub_nb;
        g_sub2infos[g_sub2infos_ind].common = (crp_common1 *)malloc(g_common_sub_nb*sizeof(crp_common1));
        for(i=0;i<g_common_sub_nb;i++)
        {
	    strcpy((g_sub2infos[g_sub2infos_ind].common[i]).name, g_lu_table[g_common_sub[i]].name);
        }
    }
    g_common_sub_nb = 0;
    g_com2infos_nb0 = g_com2infos_nb;
    g_entity_nb = 0;
    g_entry_point_nb = 0;
    g_lu_table_nb = 0;
    g_stmt_function_nb = 0;
}


void crp_output_set(id, line_num)
Token *id;
int line_num;
{
    int anum;
	if ( (anum=crp_search_arg(lu_table_name(id))) != -1 )
	{
	    g_argument0[anum].output = 1;
	    g_argument0[anum].line_num_o = line_num - g_line_input;
            tst_len(g_subprog_name,MAX_NAME);
	    strcpy(g_argument0[anum].sub_name_o, g_subprog_name);
	}
}

void crp_set_string_type(id, size, line_num)
Token *id;
int size, line_num;
{
    int anum;

	if ( (anum=crp_search_arg(lu_table_name(id))) != -1 )
	{
		g_argument0[anum].size = size;
	        g_argument0[anum].line_num_t = line_num - g_line_input;
		strcpy(g_argument0[anum].sub_name_t, g_subprog_name);
		g_argument0[anum].type = type_STRING; /* pour signaler qu'il faut verifier
		                            la violation de la chaine */
	}
}

void crp_set_var_type_bd(id, type, size, line_num)
Token *id;
int size, type, line_num;
{
    int anum, lu;

	lu = id->value.integer;
	g_lu_table[lu].type = type;
	g_lu_table[lu].size = (size == size_DEFAULT)? type_size[type]: size;
	if ( g_lu_table[lu].var_type == PARAM_VAR )
	{
	    if ( (anum=crp_search_arg(lu_table_name(id))) != -1 )
	    {
		g_argument0[anum].size = g_lu_table[lu].size;
	        g_argument0[anum].line_num_t = line_num - g_line_input;
		strcpy(g_argument0[anum].sub_name_t, g_subprog_name);
		g_argument0[anum].type = type; /* pour signaler qu'il faut verifier
		                            la violation de la chaine */
	    }
	}
}

void crp_set_common_type_bd(id, entity_nb)
Token *id;
int *entity_nb;
{
	
    int lu;
    lu = id->value.integer;

        if ( *entity_nb >= MAX_ENTITY )
        {
            printf("Le nombre d'entity atteint le maximum %d.\nAugmenter MAX_ENTITY et recompiler.\n", MAX_ENTITY);
            exit(4);
        }
	g_lu_table[lu].var_type = COMMON_VAR;
	g_entity[*entity_nb] = lu;
	(*entity_nb)++;
}

void crp_mem_common_bd(id)
Token *id;
{
    int i;
    crp_sbr1 *sb;
    for(i=0;i<g_common_sub_nb;i++)
    {
	if ( g_common_sub[i] == id->value.integer )
        {
	    return;
        }
    }
    g_common_sub[g_common_sub_nb] = id->value.integer;
    g_common_sub_nb++;
    for(i=0;i<g_com2infos_nb;i++)
    {
	if ( strcmp(g_com2infos[i].name, lu_table_name(id)) == 0 )
	{
            /* Le common existe deja dans la base */
	    sb = (crp_sbr1 *)malloc(sizeof(crp_sbr1));
	    *(g_com2infos[i].sbr_link) = sb;
	    sb->next = NULL;
	    strcpy(sb->name,g_subprog_name);
            (g_com2infos[i].sbr_nb)++;
            g_com2infos[i].sbr_link = &(sb->next);
	    return;
	}
    }
    if ( g_com2infos_nb < MAX_COM )
    {
    /* Ajouter un nouveau common */
        strcpy(g_com2infos[g_com2infos_nb].name, lu_table_name(id));
        strcpy(g_com2infos[g_com2infos_nb].sub_name, g_subprog_name);
        g_com2infos[g_com2infos_nb].maj = 1;
        g_com2infos[g_com2infos_nb].entity_nb = g_entity_nb;
        g_com2infos[g_com2infos_nb].entity = (void *)malloc(sizeof(int)*g_entity_nb);
        sb = (crp_sbr1 *)malloc(sizeof(crp_sbr1));
        g_com2infos[g_com2infos_nb].sbr_nb = 1;
        g_com2infos[g_com2infos_nb].sbr = sb;
        sb->next = NULL;
	strcpy(sb->name,g_subprog_name);
        g_com2infos[g_com2infos_nb].sbr_link = &(sb->next);
        memcpy(g_com2infos[g_com2infos_nb].entity, g_entity, sizeof(int)*g_entity_nb);
        g_com2infos_nb++;
    }
    else
    {
	printf("Le nombre de common atteint le maximum. Augmenter MAX_COM et recompiler.\n");
	exit(4);
    }
}

void crp_actual_arg_set_val(sblevel, id, line_num, value)
crp_sblevel *sblevel;
Token *id;
int line_num, value;
{
    int anum, i1, suptype, i;
    crp_sbr *sb;
  if ( sblevel->call_arg_num < MAX_ARG )
  {
    suptype = 0;
    if ( id->class == tok_identifier ||
	            id->class == tok_array_identifier )
    {
	i1 = id->value.integer;
	id->class = g_lu_table[i1].type;
	if ( id->class == 0 )
	{
	    id->class = get_type(0, g_lu_table[i1].name);
	}
        if ( id->size == size_DEFAULT )
        {
	    id->size = g_lu_table[i1].size;
	    if ( id->size == size_DEFAULT )
	    {
	        id->size = get_size(0, g_lu_table[i1].name);
	    }
        }
        else
        {
        }
        /* Voir si le parametre est declare avec EXTERNAL */
	for(i=0;i<g_nbextrn;i++)
	{
	    if ( strcmp(g_lu_table[i1].name,g_extrn_name[i]) == 0 )
	    {
		/* tester si le parametre est en parametre */
		if ( crp_search_arg(lu_table_name(id)) >= 0 )
		{
		  /* auquel cas, le type est ajoute a 1000 pour
		     signifier que le controle de coherence se
		     fait seulement en tant que sous programme
		  */
		   suptype = type_UNDEF_SUBROUTINE;
                   g_lu_table[i1].type = id->class + type_UNDEF_SUBROUTINE;
		   g_lu_table[i1].size = 1;
		}
		else
		{
		   /* Le nom du parametre actuel est declare avec
		      EXTERNAL.  Par contre ce nom n'est pas en
                      parametre formel du sous programme appelant.
		      Alors, le nom doit exister en tant que sous
		      programme qui doit figurer obligatoirement
		      dans la BD. On ajoute donc le type a 10
		      (type_SUBROUTINE) pour signifier que le nom
		      doit etre recherche dans la base pour deter
		      miner son type effectif avant de le comparer
		      avec le meme parametre du vrai sous programme.
		      En realite, le vrai type du parametre detecte
		      dans le sous programme est pour le moment ignore,
		      pour n'interesser que le type declare dans
		      la base.
		   */
		   suptype = type_SUBROUTINE;
		   /*
		      memorisation du nom du sous programme afin de
		      pouvoir determiner ulterieurement le type
		      du sous programme.
		   */

		}
		break;
	    }
	}
    }
    if ( id->size == size_DEFAULT )
    {
        id->size = type_size[id->class];
    }
    if ( id->class == type_DP )
    {
	id->class = type_REAL;
        id->size = 8;
    }
    else if ( id->class == type_DCOMPLEX )
    {
        id->size = 16;
	id->class = type_COMPLEX;
    }
    if ( ! value )
    {
        if ( (anum = crp_search_arg(lu_table_name(id))) != -1 )
        {
            if ( crp_search_sbr(g_argument0[anum].sbr,
			        sblevel->subprogram_name,
				sblevel->call_arg_num) == 0 )
	    {
	        sb = (crp_sbr *) malloc(sizeof(crp_sbr));
	        strcpy(sb->name, sblevel->subprogram_name);
	        sb->arg_num = sblevel->call_arg_num;
	        sb->line_num = line_num - g_line_input;
	        sb->next = NULL;
	        *(g_argument0[anum].sbr_link) = sb;
                g_argument0[anum].sbr_link = &(sb->next);
                g_argument0[anum].sbr_nb++;
            }
        }
	strcpy(sblevel->argument[sblevel->call_arg_num].name,lu_table_name(id));
    }
    sblevel->argument[sblevel->call_arg_num].type = id->class + suptype;
    sblevel->argument[sblevel->call_arg_num].size = id->size;
  }
  else
  {
	printf("Le nombre de parametres atteint le maximum. Augmenter MAX_ARG dans valchek.h et recompiler.\n");
	exit(4);
  }
}

void crp_update_argument(sblevel)
crp_sblevel *sblevel;
{
    int i, j, not_found;
    long offset;
    static int l=0;
    crp_arg2 *argument;
    crp_arg5 *arg;
    crp_arg3 *arg3;
    crp_sbr2 *entry;
    for(i=0;i<g_entry_point_nb;i++)
    {
            not_found = 1;
            for(entry=g_sub2infos[g_entry_point_ind[i]].called;
			entry;entry=entry->next)
	    {
		if ( strcmp(sblevel->subprogram_name, entry->name) == 0 )
		{
		    if ( sblevel->call_arg_num > 0 )
		    {
			offset = ftell(arg_fd_tmp0);
			argument = (crp_arg2 *)malloc(sblevel->call_arg_num*
				sizeof(crp_arg2));
			arg = sblevel->argument;
			for(j=0;j<sblevel->call_arg_num;j++)
			{
			    strcpy(argument[j].name,arg[j].name);
			    argument[j].type = arg[j].type;
			    argument[j].size = arg[j].size;
			}
			l += sblevel->call_arg_num*sizeof(crp_arg2);
			fwrite((char *)argument,
			  sblevel->call_arg_num*sizeof(crp_arg2),1,
				arg_fd_tmp0);
			free(argument);
		    }
		    else
		    {
			argument = NULL;
		    }
		    arg3 = (crp_arg3 *)malloc(sizeof(crp_arg3));
		    arg3->argument_nb = sblevel->call_arg_num;
		    arg3->argument    = (crp_arg2 *)offset;
		    arg3->line_num    = sblevel->line_num;
		    arg3->next        = NULL;
		    entry->arg_list_nb++;
		    *entry->link = arg3;
		    entry->link = &(arg3->next);
		    break;
		}
	    }
    }
    
}

int crp_recursive()
{
    int i;
    for(i=0;i<g_call_level;i++)
    {
	if ( strcmp(g_level_subr[i].name, g_subprog_name) == 0 &&
	     g_level_subr[i].arg_num == g_arg_num )
	{
	    return i;
	}
    }
    return -1;
}

/*  Nom  : crp_search_subprog
    Role : Recherche d'un sous programme dans la base de donnees

    valeur retournee :

	0      : Le sous programme n'est pas dans la liste.
        i (>0) : Le sous programme est trouve est trouve dans la liste
		 a l'indice (i-1) et il a ete mis a jour.
	i (<0) : Le sous programme est trouve est trouve dans la liste
	         a l'indice -i-1 mais il est en fichier source. Il faut
		 donc l'explorer.
*/

int crp_search_subprog(name)
char *name;
{
    int i;
    for(i=0;i<g_sub2infos_nb;i++)
    {
      if ( g_sub2infos[i].maj >= 0 )
      {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
	    g_line_input = g_sub2infos[i].line_num;
            if ( g_sub2infos[i].maj )
	    {
		/* le sous programme est deja mis a jour
                   et remis dans la base */
                return i+1;
	    }
	    else
	    {
		/* Le sous programme est encore sous forme de
		   fichier. */
                return -(i+1);
	    }
	}
      }
    }
    return 0;
}

void crp_set_srcname(id, type, size)
Token *id;
int type, size;
{
    int i, l;
    int crp_search_subprog_tot();
    int retsearch;
    static int num_blkdata = 0;
    char name[MAX_NAME+1];

    if ( type == type_BLOCK_DATA && size == -1000 && id == NULL )
    {
        sprintf(name,"BLDT%.2d", num_blkdata++);
    }
    else
    {
	strcpy(name, lu_table_name(id));
    }
    if ( g_sub2infos_nb < MAX_SUB &&
		(retsearch=crp_search_subprog_tot(name)) == -1 )
    {
        /* inserer un autre sous programme */
        strcpy(g_sub2infos[g_sub2infos_nb].sub_name,name);
        strcpy(g_subprog_name, name);
        g_sub2infos[g_sub2infos_nb].maj = 0;
        g_sub2infos[g_sub2infos_nb].argument_nb = g_argument_nb;
        if ( g_argument_nb > 0 )
        {
    	    l = g_argument_nb*sizeof(crp_arg);
    	    g_sub2infos[g_sub2infos_nb].argument = (crp_arg *)malloc(l);
    	    memcpy(g_sub2infos[g_sub2infos_nb].argument, g_argument, l);
    	    g_argument0 = g_sub2infos[g_sub2infos_nb].argument;

    	    for(i=0;i<g_argument_nb;i++)
    	    {
		g_argument0[i].sbr_nb = 0;
		g_argument0[i].sbr = NULL;
		g_argument0[i].sbr_link = &(g_argument0[i].sbr);
    	    }
        }
        else
        {
            g_sub2infos[g_sub2infos_nb].argument = NULL;
        }
        g_sub2infos[g_sub2infos_nb].line_num = g_line_input;
        g_sub2infos[g_sub2infos_nb].type = type;
        if ( type == type_SUBROUTINE )
        {
            g_sub2infos[g_sub2infos_nb].size = size_SUBROUTINE;
	}
	else
	{
            g_sub2infos[g_sub2infos_nb].size = size;
	}
        g_sub2infos[g_sub2infos_nb].file_name = g_srcname_p;
	/* creation de lien pour les noms des sous programmes appeles */
	g_sub2infos[g_sub2infos_nb].called = NULL;
	g_sub2infos[g_sub2infos_nb].called_nb = 0;
        /* Les valeurs passes en parametres */
	g_sub2infos[g_sub2infos_nb].value_nb = 0;
	g_sub2infos[g_sub2infos_nb].value = NULL;
	g_value_link = &(g_sub2infos[g_sub2infos_nb].value);
	g_value_nb  = &(g_sub2infos[g_sub2infos_nb].value_nb);
        /*  Les point d'entree */
	g_entry_point[g_entry_point_nb] = &(g_sub2infos[g_sub2infos_nb].called);
	g_entry_point_ind[g_entry_point_nb] = g_sub2infos_nb;
	g_ep_called_nb[g_entry_point_nb] = &(g_sub2infos[g_sub2infos_nb].called_nb);
	g_entry_point_nb++;   /* pour traiter les ENTRY. Ce compteur
				 est remise a 0 a chaque commencement d'un
				 sous programme */
        g_sub2infos_ind = g_sub2infos_nb;
        g_sub2infos_nb++;
    }
    if ( retsearch != -1 )
    {
	printf("CRP_996. Le sp %s ligne %d du fichier %s est deja trouve a la ligne %d du fichier %s. Arret d'analyse.\n",
	    name, g_line_input+1, g_srcname_p,
	    g_sub2infos[retsearch].line_num+1,g_sub2infos[retsearch].file_name);
	exit(4);
    }
}

void crp_set_srcname_name(name)
char  *name;
{
    int i, l;
    int crp_search_subprog_tot();

    if ( g_sub2infos_nb < MAX_SUB &&
		crp_search_subprog_tot(name) == -1 )
    {
        /* inserer un autre sous programme */
        strcpy(g_sub2infos[g_sub2infos_nb].sub_name,name);
        strcpy(g_subprog_name, name);
        g_sub2infos[g_sub2infos_nb].maj = 0;
        g_sub2infos[g_sub2infos_nb].argument_nb = g_argument_nb;
        if ( g_argument_nb > 0 )
        {
    	    l = g_argument_nb*sizeof(crp_arg);
    	    g_sub2infos[g_sub2infos_nb].argument = (crp_arg *)malloc(l);
    	    memcpy(g_sub2infos[g_sub2infos_nb].argument, g_argument, l);
    	    g_argument0 = g_sub2infos[g_sub2infos_nb].argument;

    	    for(i=0;i<g_argument_nb;i++)
    	    {
		g_argument0[i].sbr_nb = 0;
		g_argument0[i].sbr = NULL;
		g_argument0[i].sbr_link = &(g_argument0[i].sbr);
    	    }
        }
        else
        {
            g_sub2infos[g_sub2infos_nb].argument = NULL;
        }
        g_sub2infos[g_sub2infos_nb].line_num = g_line_input;

	/* creation de lien pour les noms des sous programmes appeles */
	g_sub2infos[g_sub2infos_nb].called = NULL;
	g_sub2infos[g_sub2infos_nb].called_nb = 0;
        /* Les valeurs passes en parametres */
	g_sub2infos[g_sub2infos_nb].value_nb = 0;
	g_sub2infos[g_sub2infos_nb].value = NULL;
	g_value_link = &(g_sub2infos[g_sub2infos_nb].value);
	g_value_nb  = &(g_sub2infos[g_sub2infos_nb].value_nb);
        /*  Les point d'entree */
	g_entry_point[g_entry_point_nb] = &(g_sub2infos[g_sub2infos_nb].called);
	g_entry_point_ind[g_entry_point_nb] = g_sub2infos_nb;
	g_ep_called_nb[g_entry_point_nb] = &(g_sub2infos[g_sub2infos_nb].called_nb);
	g_entry_point_nb++;   /* pour traiter les ENTRY. Ce compteur
				 est remise a 0 a chaque commencement d'un
				 sous programme */
        g_sub2infos_ind = g_sub2infos_nb;
    }
}

void crp_set_offset(fd, line_num)
FILE *fd;
int line_num;
{
    g_line_input = line_num-1;
}

void crp_write_data_base()
{
    FILE *data_fd, *fd;
    int i, j, k, arg_len, caller_nb, called_nb, nb, lsrcname;
    crp_sbr1 *caller;
    crp_sbr2 *called;
    crp_arg *argument;
    int argument_nb, size, actual_size, i1, arg_list_nb;
    crp_arg3 *arg_list;
    crp_arg2 *arg2;

    arg_fd = fopen(g_argument_fname,"r");
    arg_fd_tmp = fopen(g_argument_fname_tmp,"w");
    arg_fd_tmp0 = fopen(g_argument_fname_tmp0,"r");
    if ( (data_fd = fopen(g_routine_fname_tmp,"w")) != NULL )
    {
        fwrite((char *)&g_sub2infos_nb, sizeof(int), 1, data_fd);
        nb = 0;
        for(i=0;i<g_sub2infos_nb;i++)
        {
	  if ( g_sub2infos[i].maj >= 0 )
	  {
            fwrite(g_sub2infos[i].sub_name, 1, MAX_NAME+1, data_fd);
            fwrite((char *)&g_sub2infos[i].type, sizeof(int), 1,
		    data_fd);
            fwrite((char *)&g_sub2infos[i].size, sizeof(int), 1,
		    data_fd);
            fwrite((char *)&g_sub2infos[i].line_num, sizeof(int), 1,
		    data_fd);
            fwrite((char *)&g_sub2infos[i].argument_nb, sizeof(int), 1,
		    data_fd);
	    /*  si g_sub2infos[i].maj != -1 il represente le nombre
		d'argument du sous programmes */
	    argument_nb = g_sub2infos[i].argument_nb;
	    argument = g_sub2infos[i].argument;
	    if ( argument_nb > 0 )
	    {
                arg_len = argument_nb*sizeof(crp_arg);
                fwrite((char *)argument, arg_len, 1, data_fd);
		for(j=0;j<argument_nb;j++)
		{
		    fwrite((char *)&argument[j].sbr_nb, sizeof(int), 1, data_fd);
		    if ( argument[j].sbr_nb > 0 )
		    {
			fwrite((char *)argument[j].sbr,
			   argument[j].sbr_nb*sizeof(crp_sbr), 1, data_fd);
		    }
		}
	    }
	    caller_nb = g_sub2infos[i].caller_nb;
            fwrite((char *)&caller_nb, sizeof(int), 1, data_fd);
	    if ( caller_nb > 0 )
	    {
		fwrite((char *)g_sub2infos[i].caller,
				caller_nb * sizeof(crp_sbr1), 1, data_fd);
	    }
	    called_nb = g_sub2infos[i].called_nb;
	    fwrite((char *)&g_sub2infos[i].called_nb,sizeof(int), 1, data_fd);
	    if ( called_nb > 0 )
	    {
		fwrite((char *)g_sub2infos[i].called,
			called_nb * sizeof(crp_sbr2), 1, data_fd);
		for (k=0;k<called_nb;k++)
		{
		  arg_list_nb = g_sub2infos[i].called[k].arg_list_nb;
		  fwrite((char *)&arg_list_nb, sizeof(int), 1, data_fd);
		  arg_list = g_sub2infos[i].called[k].arg_list;
		  if ( arg_list_nb > 0 )
		  {
		    fwrite((char *)arg_list, arg_list_nb*sizeof(crp_arg3),
				1, data_fd);
		    for(j=0;j<arg_list_nb;j++)
		    {
			argument_nb = arg_list[j].argument_nb;
			fwrite((char *)&argument_nb, sizeof(int), 1, data_fd);
			if ( argument_nb > 0 )
			{
			    arg2 = (crp_arg2 *)malloc(argument_nb*sizeof(crp_arg2));
                            if ( i < g_sub2file_nb )
                            {
                               fd = arg_fd_tmp0;
                            }
                            else
                            {
                               fd = arg_fd;
                            }
                            fseek(fd, (long)arg_list[j].argument, 0);
                            fread((char *)arg2, argument_nb*sizeof(crp_arg2),
                                        1, fd);
                            arg_list[j].argument = (crp_arg2 *)ftell(arg_fd_tmp);
                            fwrite((char *)arg2, argument_nb*sizeof(crp_arg2),
                                        1, arg_fd_tmp);
                            free(arg2);
			    fwrite((char *)&arg_list[j].argument,
				sizeof(long), 1, data_fd);
			}
		    }
		  }
		}
	    }
	    fwrite((char *)&g_sub2infos[i].value_nb, sizeof(int), 1, data_fd);
	    if ( g_sub2infos[i].value_nb > 0 )
	    {
		fwrite((char *)g_sub2infos[i].value,
			g_sub2infos[i].value_nb*sizeof(crp_sbr),1,
			data_fd);
	    }
	    fwrite((char *)&g_sub2infos[i].common_nb, sizeof(int), 1, data_fd);
	    if ( g_sub2infos[i].common_nb > 0 )
	    {
		fwrite((char *)g_sub2infos[i].common,
			g_sub2infos[i].common_nb*sizeof(crp_common1),1,
			data_fd);
	    }
	    nb++;
	  }
        }
	if ( nb < g_sub2infos_nb )
	{
	    fseek(data_fd,0,0);
            fwrite((char *)&nb,sizeof(int), 1, data_fd);
	}
        fclose(data_fd);
    }
    if ( (data_fd = fopen(g_common_fname_tmp,"w")) != NULL )
    {
        fwrite((char *)&g_com2infos_nb, sizeof(int), 1, data_fd);
        nb = 0;
        for(i=0;i<g_com2infos_nb;i++)
        {
	  if ( g_com2infos[i].maj >= 0 )
	  {
	    /* le nom du sous programme */
            fwrite(g_com2infos[i].name, 1, MAX_NAME+1, data_fd);
            fwrite(g_com2infos[i].sub_name, 1, MAX_NAME+1, data_fd);

            /* Les parametres du sous programme */
	
            fwrite((char *)&g_com2infos[i].entity_nb, sizeof(int),
		 1, data_fd);
	    if ( g_com2infos[i].entity_nb > 0 )
	    {
		fwrite((char *)g_com2infos[i].entity,
	              g_com2infos[i].entity_nb*sizeof(crp_entity),
		      1, data_fd);
	    }
	    fwrite((char *)&g_com2infos[i].sbr_nb, sizeof(int),
		1, data_fd);
	    if ( g_com2infos[i].sbr_nb > 0 )
	    {
		fwrite((char *)g_com2infos[i].sbr,
		   g_com2infos[i].sbr_nb*sizeof(crp_sbr1),
		   1, data_fd);
	    }
            nb++;
          }
        }
	if ( nb < g_com2infos_nb )
	{
	    fseek(data_fd,0,0);
            fwrite((char *)&nb,sizeof(int), 1, data_fd);
	}
        fclose(data_fd);
    }
}

void crp_ajout_inexist(name, sub_name, line_num)
char *name, *sub_name;
int line_num;
{
   int i;
   crp_inexist *inexist;
       for(inexist = g_inexist0;inexist;inexist=inexist->next)
       {
	    if ( strcmp(inexist->name, name) == 0 )
	    {
	        return;
	    }
       }
       if ( (inexist = (crp_inexist *)malloc(sizeof(crp_inexist))) != NULL )
       {
           strcpy(inexist->name,name);
           strcpy(inexist->sub_name,sub_name);
	   inexist->line_num = line_num;
	   inexist->next = NULL;
	   *g_inexist = inexist;
	   g_inexist = &(inexist->next);
       }
       else
       {
	   printf("Le nombre de sous programmes inexistants depasse le maximum prevu.\n");
       }
}

int crp_lookup(s)
char *s;
{
    int i, l;
    {
        for(i=0;i<g_lu_table_nb;i++)
        {
	    if ( strcmp(s, g_lu_table[i].name) == 0 )
	    {
	        return i;
	    }
        }
        if ( g_lu_table_nb < MAX_LU_TABLE )
        {
            l = strlen(s);
            name_len = (l > MAX_NAME)? MAX_NAME:l;
            strncpy(g_lu_table[g_lu_table_nb].name,s, name_len);
            g_lu_table[g_lu_table_nb].name[name_len]='\0';
	    g_lu_table[g_lu_table_nb].var_type = NORMAL_VAR;
	    g_lu_table[g_lu_table_nb].type = 0;
	    g_lu_table[g_lu_table_nb].size = 0;
	    g_lu_table[g_lu_table_nb].length = 1;
            g_lu_table[g_lu_table_nb].array_var = 0;
            i = g_lu_table_nb;
            g_lu_table_nb++;
        }
        else
        {
	    printf("La taille du tableau lookup n'est pas assez grand.\nRecompiler avec LARGE_MACHINE\n");
        }
        return i;
    }
}


crp_def_arg(id)
Token *id;
{
}

crp_set_array_var_bd(id, length)
int length;
Token *id;
{
    g_lu_table[id->value.integer].array_var = 1;
    g_lu_table[id->value.integer].length = length;
}

int crp_search_subprog_tot1(name)
char *name;
{
    /* Recherche simple d'un sous programme de la liste totale */
    int i;
    for(i=0;i<=g_maj_index;i++)
    {
      if ( g_sub2infos[i].maj >= 0 )
      {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
            return i;
	}
      }
    }
    for(i=g_sub2file_nb;i<g_sub2infos_nb;i++)
    {
      if ( g_sub2infos[i].maj >= 0 ) 
      {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
            return i;
	}
      }
    }
    return -1;
}

int crp_search_subprog_mem(name)
char *name;
{
    /* Recherche simple d'un sous programme dans la base de donnees */
    int i;
    for(i=g_sub2file_nb;i<g_sub2infos_nb;i++)
    {
      if ( g_sub2infos[i].maj >= 0 )  
      {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
            return i;
	}
      }
    }
    return -1;
}

int crp_search_subprog_mem1(name)
char *name;
{
    /* Recherche simple d'un sous programme dans la base de donnees */
    int i;
    for(i=g_sub2file_nb;i<g_sub2infos_nb;i++)
    {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
            return i;
	}
    }
    return -1;
}

int crp_search_subprog_file(name)
char *name;
{
    /* Recherche simple d'un sous programme dans la base de donnees */
    int i;
    for(i=0;i<g_sub2file_nb;i++)
    {
      if ( g_sub2infos[i].maj >= 0 )   
      {
	if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
	{
            return i;
	}
      }
    }
    return -1;
}

void crp_maj1_caller()
{
    /* Ranger les appelant aux bons endroits en se servant des
       listes des appeles. */
    int i, j, k, l, sb_index, found, ind;
    int crp_not_found_in_caller();
    crp_sbr2 **linkl, *entryl;
    crp_sbr1 *caller, **link, *entryr, *entry;
    crp_common1 *common1, *common2;
    char *pname;
    crp_arg3 *arg, *arg0, *arg_list;
   

    for(i=0;i<g_sub2file_nb;i++)
    {
	if ( (sb_index=crp_search_subprog_mem(g_sub2infos[i].sub_name)) != -1 )
	{
	    g_sub2infos[i].caller_nb = g_sub2infos[sb_index].caller_nb;
	    g_sub2infos[sb_index].maj=-1;
	    link = &(g_sub2infos[i].caller);
	    for(entryr=g_sub2infos[sb_index].caller;entryr;entryr=entryr->next)
	    {
		caller = (crp_sbr1 *)malloc(sizeof(crp_sbr1));
		memcpy((char *)caller, (char *)entryr, sizeof(crp_sbr1));
		caller->next = NULL;
		*link = caller;
		link = &(caller->next);
	    }
	    g_sub2infos[i].link = link;

            /* mise a jour la liste des commons */
	    common2 = g_sub2infos[sb_index].common;
	    common1 = g_sub2infos[i].common;
	    for(j=0;j<g_sub2infos[sb_index].common_nb;j++)
	    {
                pname = common2[j].name;
		found = 0;
		for(k=0;k< g_sub2infos[i].common_nb;k++)
		{
		   if ( strcmp(pname, common1[k].name) == 0 )
		   {
			found = 1;
			break;
		   }
		}
                if ( ! found )
		{
		    /* le common n'est plus dans le sous programme. Il
			faut enlever le sous programme de la liste
			des sous programme du common pname */
		    ind = crp_search_common_mem(pname);
		    entry = g_com2infos[ind].sbr;
		    for(k=0;k<g_com2infos[ind].sbr_nb;k++)
		    {
			if ( strcmp(g_sub2infos[sb_index].sub_name,
				entry[k].name) == 0 )
			{
			    for(l=k+1;l<g_com2infos[ind].sbr_nb;l++)
			    {
				memcpy((char *)&entry[l-1], (char *)&entry[l],
				    sizeof(crp_sbr1));
			    }
			    g_com2infos[ind].sbr_nb--;
			    if ( g_com2infos[ind].sbr_nb == 0 )
			    {
				g_com2infos[ind].maj = -1;
			    }
			}
		    }
		}
	    }
	}
    }
    /* reorganiser les appeles */
    for(i=0;i<g_sub2file_nb;i++)
    {
	for(entryl=g_sub2infos[i].called;entryl;entryl=entryl->next)
	{
	    if ( entryl->arg_list_nb > 0 )
	    {
		arg_list = (crp_arg3 *)malloc(entryl->arg_list_nb*
			sizeof(crp_arg3));
		arg = entryl->arg_list;
		for(j=0;j<entryl->arg_list_nb;j++)
		{
		    memcpy(&arg_list[j], arg, sizeof(crp_arg3));
		    arg0 = arg->next;
		    free(arg);
		    arg = arg0;
		}
		entryl->arg_list = arg_list;
	    }
	    else
	    {
		entryl->arg_list = NULL;
	    }
	    /* remmettre les callers */
	    if ( (sb_index=crp_search_subprog_tot(entryl->name)) != -1 )
	    {
		/* c'est un sous programme qui est donne avec le(ou les)
		   fichiers */
                if ( crp_not_found_in_caller(g_sub2infos[i].sub_name,sb_index) )
		{	
		        caller = (crp_sbr1 *)malloc(sizeof(crp_sbr1));
		        strcpy(caller->name, g_sub2infos[i].sub_name);
			caller->line_num = entryl->line_num;
		        caller->next = NULL;
		        *g_sub2infos[sb_index].link = caller;
		        g_sub2infos[sb_index].link = &(caller->next);
		        (g_sub2infos[sb_index].caller_nb)++;
		}
	    }
	}
    }
}

void crp_maj3_caller()
{
    /* Mise en forme (compactage) des appelants avant d'ecrire sur la
       base de donnees */

    int i, len, j;
    crp_sbr1 *caller, *caller0, *entryr, *entryr0;
    crp_sbr2 *entry, *entry0, *called, *called0;

    for(i=0;i<g_sub2infos_nb;i++)
    {
      if ( g_sub2infos[i].maj >= 0 )
      {
	if ( g_sub2infos[i].caller_nb > 0 )
        {
	    caller0 = g_sub2infos[i].caller;
	    len = g_sub2infos[i].caller_nb * sizeof(crp_sbr1);
	    caller = (crp_sbr1 *)malloc(len);
	    if ( caller != NULL )
	    {
	        g_sub2infos[i].caller = caller;
		entryr=caller0;

		/* ATTENTION !!!!
 
                   Cette boucle remplace l'ancienne dont l'indice de la
                   boucle est entryr non la variable j et dont le test
                   de la fin de la boucle est sur ce pointeur entryr
                   au lieu de la comparaison j<g_sub2infos[i].caller_nb.
 
                   Apparamment, il y a un bug en amont qu'il faut trouver
                   a tout prix. Ce bug peut etre le fait que la fin
                   de la liste chainee entryr->next est mal affecte
                   a NULL ou ne l'est pas du tout.
 
                */
	        for(j=0;j<g_sub2infos[i].caller_nb;j++)
	        {
		    memcpy((char *)caller, (char *)entryr, sizeof(crp_sbr1));
		    caller->next = caller+1;
		    caller++;
		    entryr=entryr->next;
	        }
	        caller--;
	        caller->next = NULL;
	        for(entryr=caller0;entryr; entryr=entryr0)
	        {
	            entryr0 = entryr->next;
		    free(entryr);
	        }
	    }
	    else
	    {
	        printf("impossible de d'allouer de memoire\n");
	        exit(1);
	    }
        }
	else
	{
	    g_sub2infos[i].caller = NULL;
	}
	if ( g_sub2infos[i].called_nb > 0 )
        {
	    called0 = g_sub2infos[i].called;
	    len = g_sub2infos[i].called_nb * sizeof(crp_sbr2);
	    called = (crp_sbr2 *)malloc(len);
            if ( called != NULL )
	    {
	        g_sub2infos[i].called = called;
	        for(entry=called0;entry;entry=entry->next)
	        {
		    memcpy(called, entry, sizeof(crp_sbr2));
		    called->next = called+1;
		    called++;
	        }
	        called--;
	        called->next = NULL;
	        for(entry=called0;entry; entry=entry0)
	        {
	            entry0 = entry->next;
		    free(entry);
	        }
	    }
	    else
	    {
		printf("impossible de d'allouer de memoire\n");
	        exit(1);
	    }
        }
	else
	{
	    g_sub2infos[i].called = NULL;
	}
      }
    }
}

void crp_maj2_caller()
{
    /* enlever des appelants en trop */
    crp_sbr2 *called, *called0;
    crp_sbr1 *caller, **caller0;
    int crp_not_found_in_called();
    int sb_index, sb_index1;
    int i;

    for(i=0;i<g_sub2file_nb;i++)
    {
	    if ( (sb_index=crp_search_subprog_mem1(g_sub2infos[i].sub_name)) != -1 )
	    {
		    for(called0=g_sub2infos[sb_index].called;called0;
					called0=called0->next)
		    {
	    		if ( crp_not_found_in_called(called0->name, i) )
	    		{
				/* le sous programme called0->name n'est plus
		   		dans le la liste des appelants de
		   		g_sub2infos[i].sub_name */
				/* enlever g_sub2infos[i].sub_name de la liste
		   		des caller de called0->name */
			    if ( (sb_index1=crp_search_subprog_tot(called0->name)) != -1 )
			    {
				caller0 = &(g_sub2infos[sb_index1].caller);
				for(caller=g_sub2infos[sb_index1].caller;caller;
					caller=caller->next)
				{
				    if ( strcmp(g_sub2infos[i].sub_name, caller->name) == 0 )
				    {
					*caller0 = caller->next;
					free(caller);
					break;
				    }
				    caller0 = &(caller->next);
				}
                                g_sub2infos[sb_index1].caller_nb--;
			    }
			}
		    }
	    }
    }
}

void crp_init_caller()
{
    int i;
    for(i=0;i<g_sub2file_nb;i++) 
    {
	g_sub2infos[i].caller = NULL;
        g_sub2infos[i].link = &(g_sub2infos[i].caller);
        g_sub2infos[i].caller_nb = 0;
    }
}


int crp_not_found_in_caller(name,index)
char *name;
int index;
{
    crp_sbr1 *caller;
    for(caller=g_sub2infos[index].caller;caller;caller=caller->next)
    {
	if ( strcmp(caller->name,name) == 0 )
	{
	    return 0;
	}
    }
    return 1;
}

int crp_not_found_in_called(name,index)
char *name;
int index;
{
    crp_sbr2 *called;
    for(called=g_sub2infos[index].called;called;called=called->next)
    {
	if ( strcmp(called->name,name) == 0 )
	{
	    return 0;
	}
    }
    return 1;
}


void crp_set_subprog_carac(sblevel,id)
crp_sblevel *sblevel;
Token *id;
{
    crp_sbr2 *called, *entry;
    int i, not_found, arg, is_not_argument;

    strcpy(sblevel->subprogram_name, lu_table_name(id));
    crp_setxtrnal_if_arg(sblevel,&is_not_argument);
    sblevel->normal_subprogram = /*is_not_intrinsic(sblevel->subprogram_name) &&*/
		    is_not_stmt_function(sblevel->subprogram_name) &&
		    is_not_argument;
	/* creation d'un nouvel appel */
    sblevel->line_num = id->line_num - g_line_input;
    if ( sblevel->normal_subprogram )
    {
	for(i=0;i<g_entry_point_nb;i++)
	{
            not_found = 1;
            for(entry=g_sub2infos[g_entry_point_ind[i]].called;
			entry;entry=entry->next)
	    {
		if ( strcmp(sblevel->subprogram_name, entry->name) == 0 )
		{
		    not_found = 0;
		    break;
		}
	    }
            if ( not_found )
	    {
	        (*g_ep_called_nb[i])++;
	        called = (crp_sbr2 *)malloc(sizeof(crp_sbr2));
	        called->line_num = id->line_num - g_line_input;
	        called->next = NULL;
	        called->link = &(called->arg_list);
	        called->arg_list_nb = 0;
                strcpy(called->name, sblevel->subprogram_name);
	        *(g_entry_point[i]) = called;
	        g_entry_point[i] = &(called->next);
	    }
	}
    }
}

void crp_set_subprog_carac0(sblevel,id)
Token *id;
crp_sblevel *sblevel;
{
    crp_sbr2 *called, *entry;
    int i, ret, is_not_argument;
 
    strcpy(sblevel->subprogram_name, lu_table_name(id));
    sblevel->normal_subprogram = /*is_not_intrinsic(sblevel->subprogram_name) &&*/
	is_not_stmt_function(sblevel->subprogram_name) && 
	(ret =crp_test_if_arg(sblevel));
        /* creation d'un nouvel appel */
    sblevel->line_num = id->line_num - g_line_input;
}
 
void crp_set_subprog_carac1(sblevel)
crp_sblevel *sblevel;
{
    crp_sbr2 *called, *entry;
    int i, not_found;

        /* creation d'un nouvel appel */
    if ( sblevel->normal_subprogram )
    {
        for(i=0;i<g_entry_point_nb;i++)
        {
            not_found = 1;
            for(entry=g_sub2infos[g_entry_point_ind[i]].called;
                        entry;entry=entry->next)
            {
                if ( strcmp(sblevel->subprogram_name, entry->name) == 0 )
                {
                    not_found = 0;
                    break;
                }
            }
            if ( not_found )
            {
                (*g_ep_called_nb[i])++;
                called = (crp_sbr2 *)malloc(sizeof(crp_sbr2));
                called->line_num = sblevel->line_num;
                called->next = NULL;
	        called->link = &(called->arg_list);
	        called->arg_list_nb = 0;
                strcpy(called->name, sblevel->subprogram_name);
                *(g_entry_point[i]) = called;
                g_entry_point[i] = &(called->next);
            }
        }
    }
}

/*  Set external if argument */
void crp_setxtrnal_if_arg(sblevel, ret)
crp_sblevel *sblevel;
int *ret;
{
    int i, k, arg_num;
    crp_arg *argument;
    for ( k=g_entry_point_nb-1; k>=0; k--)
    {
        arg_num = g_sub2infos[g_entry_point_ind[k]].argument_nb;
        argument = g_sub2infos[g_entry_point_ind[k]].argument;
        for(i=0;i<arg_num;i++)
        {
	    if ( strcmp(sblevel->subprogram_name,argument[i].name) == 0 )
	    {
	        argument[i].type = type_SUBROUTINE;
	        argument[i].size = -1;
		*ret = 0;
	        return;
	    }
        }
    }
    *ret = 1;
    return;
}

int crp_test_if_arg(sblevel)
crp_sblevel *sblevel;
{
    int i, k, arg_num;
    void crp_get_sizetype();
    crp_arg *argument;
    for ( k=g_entry_point_nb-1; k>=0; k--)
    {
        arg_num = g_sub2infos[g_entry_point_ind[k]].argument_nb;
        argument = g_sub2infos[g_entry_point_ind[k]].argument;
        for(i=0;i<arg_num;i++)
        {
	    if ( strcmp(sblevel->subprogram_name,argument[i].name) == 0 )
	    {
                crp_get_sizetype(&argument[i]);
		sblevel->ptype = &argument[i].type;
		return FALSE;
	    }
        }
    }
    return TRUE;
}

void crp_get_sizetype(argument)
crp_arg *argument;
{
    if ( argument->type == 0 )
    {
	argument->type = get_type(0, argument->name);
    }
    if ( argument->size == size_DEFAULT )
    {
	argument->size = get_size(0, argument->name);
	if ( argument->size == size_DEFAULT )
	{
	    argument->size = type_size[argument->type];
	}
    }
}

void crp_maj_subprog(subprog_indx)
int subprog_indx;
{
    char name[MAX_NAME+1];
    void crp_ajout_inexist(), crp_maj_ascendant();
    int search_value, arg_len;
    crp_sbr2 *sb_nouv, *entry;
    crp_sbr1 *entryr;
    crp_arg *argument;
    crp_sbr *sbr;
    int i, line_num, sb_index, sb_index1, is_output, argument_nb;
    void crp_valeur();


        g_argument_nb = g_sub2infos[subprog_indx].argument_nb;

        if ( g_argument_nb > 0 )
	{
            strcpy(g_subprog_name, g_sub2infos[subprog_indx].sub_name);
	    g_argument0 = g_sub2infos[subprog_indx].argument;

    /* recuperer les informations sur les parametres */
            for(g_arg_num=0;g_arg_num<g_argument_nb;g_arg_num++)
            {
		g_valcheck.type = g_argument0[g_arg_num].type;
		g_valcheck.output = 0;
                crp_valeur();
		if ( g_valcheck.output )
		{
                    tst_len(g_valcheck.sub_name_o,MAX_NAME);

		    strcpy(g_argument0[g_arg_num].sub_name_o, g_valcheck.sub_name_o);
		    g_argument0[g_arg_num].line_num_o = g_valcheck.line_num_o;
		    g_argument0[g_arg_num].output = 1;
		}
            }
	}

        /* Mise a jour de la base de donnees pour le sous
           programme venant d'etre explore */


        /**************** Fin de mise a jour de subprog_indx ************/

	/*  Mise a jour ascendant */

	if ( (sb_index = crp_search_subprog_mem1(
		g_sub2infos[subprog_indx].sub_name)) != -1 )
        { 
	   /* Le sous programme qui est donne avec le fichier
	      existe aussi dans la base. Ce n'est donc un nouveau. Il
	      faut donc fair la mise a jour de la base quant a tous ses
	      appelants. Ceci seulement quand le sous programme change
	      les etats de ses parametres. */
            if ( crp_argument_not_match(subprog_indx, sb_index) )
            {
	       	is_output = 0;
	       	argument = g_sub2infos[subprog_indx].argument;
	       	argument_nb = g_sub2infos[subprog_indx].argument_nb;
	       	for(i=0;i<argument_nb;i++)
	       	{
		    if ( argument[i].output )
		    {
			is_output = 1;
			break;
		    }
		}
               	for(entryr=g_sub2infos[sb_index].caller;entryr;entryr=entryr->next)
               	{ 
                   crp_maj_ascendant(entryr->name);
		   /*  Verification si il y a des appels avec des
		       violations des constantes pour des parametres
		       de g_sub2infos[subprog_indx].sub_name qui sont en
		       output
		   */
               	} 
            }
        }

	/************** FIN  *****************/
}

int crp_argument_not_match(indx1,indx2)
int indx1, indx2;
{
    int i;
    crp_arg *argument1, *argument2;

    if ( g_sub2infos[indx1].argument_nb != g_sub2infos[indx2].argument_nb )
    {
        return 1;
    }
    else
    {   
        argument1 = g_sub2infos[indx1].argument;
        argument2 = g_sub2infos[indx2].argument;
        for(i=0;i<g_sub2infos[indx1].argument_nb;i++)
        {

           if ( argument1[i].output != argument2[i].output )
           {   
                return 1;
           }
        }
        return 0;
    }
}

int crp_argument_not_match1(argument1,argument2,argument_nb)
int argument_nb;
crp_arg *argument1, *argument2;
{
        int i;
        for(i=0;i<argument_nb;i++)
        {
           if ( argument1[i].output != argument2[i].output )
           {   
                return 1;
           }
        }
        return 0;
}

#include <unistd.h>


void crp_maj_ascendant(name)
char *name;
{
	crp_arg *called_arg;
        int sb_index, i, j, k, modif, output, size, type, ind1;
	int argument_nb;
	crp_sbr *sbr;
        crp_sbr2 *entry;
        crp_sbr1 *entryr;
	crp_arg *argument, *argument0;

	modif = 0;
	sb_index = crp_search_subprog_mem1(name);
	argument_nb = g_sub2infos[sb_index].argument_nb;
	if ( argument_nb > 0 )
	{
	    argument = g_sub2infos[sb_index].argument;
            /* memorisation de arguments pour comparer si il y a la
		difference */
	    argument0 = (crp_arg *)malloc(argument_nb*sizeof(crp_arg));
	    memcpy((char *)argument0, (char *)argument,
			           argument_nb*sizeof(crp_arg));
	    for (j=0;j<argument_nb;j++)
	    {
	        output = argument[j].output;
		type = argument[j].type;
		size = argument[j].size;
		if ( argument[j].output )
		{
		     /* Dans le cas ou l'argument est en output dans le sous
			programme lui meme (son output vaut 1 et le nom du
			sous programme est lui meme), il faut le laisser et
			passer a l'argument suivant */

		    if ( strcmp(argument[j].sub_name_o, name) != 0 )
		    {
		        argument[j].output = 0;
		    }
		}
		if ( argument[j].sbr_nb > 0 && ! argument[j].output )
		{
	    	   sbr = argument[j].sbr;
	    	   for(k=0;k<argument[j].sbr_nb;k++)
	    	   {
                      if ( (ind1=crp_search_subprog_tot1(sbr[k].name)) >= 0 )
		      {
			called_arg = g_sub2infos[ind1].argument;
			if ( called_arg[sbr[k].arg_num].output )
			{
                        if (sbr[k].arg_num < g_sub2infos[ind1].argument_nb) {

		    	    argument[j].output = 1;
                            tst_len(called_arg[sbr[k].arg_num].sub_name_o,MAX_NAME);

		    	    strcpy(argument[j].sub_name_o,
				  called_arg[sbr[k].arg_num].sub_name_o);
		    	    argument[j].line_num_o =
				  called_arg[sbr[k].arg_num].line_num_o;
                            }
                         /*else {
                            printf("--- crp_maj_ascendant:%d>%d\n",sbr[k].arg_num,
                                  g_sub2infos[ind1].argument_nb);
                            }
                         */
			}
                      }
	    	   }
		}
	    }
/* TOT1 */
            if ( crp_argument_not_match1(argument0, argument, argument_nb) )
	    {
              if ( (ind1 = crp_search_subprog_mem1(name)) >= 0 )
	      {
                for(entryr=g_sub2infos[ind1].caller;entryr;entryr=entryr->next)
                { 
                    crp_maj_ascendant(entryr->name);
                } 
	      }
            }
            free(argument0);
	}
}

int crp_get_sub2file(file)
char *file;
{
    strcpy(g_srcname, file);
    valchek();
}

void crp_valeur()
{
      crp_sbr *sb0, *sb;
      int i, j, arg_len, ircs;
      int search_value, sb_index;
      crp_arg *argument, *local_argument0;
      void  crp_ajout_inexist();
      int local_line_num, local_arg_num;
      char local_subprog_name[MAX_NAME+1], local_subprog_name_app[MAX_NAME+1];

      if ( (ircs = crp_recursive()) != -1 )
      {
	 *g_sbr_link = g_sbr->next;
	 (*g_sbr_nb)--;
	 free(g_sbr);
         printf("CRP_BD_AVER. Il y a appel recursif de %s parametre no %d\n",
			g_subprog_name, g_arg_num+1);
	 printf("\tDans %s a la ligne no %d\n", g_level_subr[ircs].sub_name,
			g_level_subr[ircs].line_num);
	 printf("\t  et %s a la ligne no %d\n", g_subprog_name_app, g_line_num);
      }
      else
      {
        if ( (search_value = crp_search_subprog(g_subprog_name)) == 0 )
        {
	    crp_ajout_inexist(g_subprog_name, g_subprog_name_app, g_line_num);
	}
	else if ( search_value < 0 )
	{
	  sb_index = -search_value - 1;
	  if ( g_arg_num < g_sub2infos[sb_index].argument_nb )
	  {
            argument = g_sub2infos[sb_index].argument;
            if ( ! g_valcheck.output && argument[g_arg_num].output )
            {
		g_valcheck.output = 1;
                g_valcheck.line_num_o = argument[g_arg_num].line_num_o;
                tst_len(argument[g_arg_num].sub_name_o,MAX_NAME);
                tst_len(argument[g_arg_num].sub_name_o,MAX_NAME);
	        strcpy(g_valcheck.sub_name_o, argument[g_arg_num].sub_name_o);
            }
            if ( ! g_valcheck.output )
            {
	       g_level_subr[g_call_level].line_num = g_line_num;
	       g_level_subr[g_call_level].arg_num = g_arg_num;
	       strcpy(g_level_subr[g_call_level].name, g_subprog_name);
	       strcpy(g_level_subr[g_call_level].sub_name, g_subprog_name_app);
               if ( g_call_level < MAX_LEVEL )
	       {
                   g_call_level++;
		   g_sbr_link = &(argument[g_arg_num].sbr);
		   g_sbr_nb   = &(argument[g_arg_num].sbr_nb);
	           for(sb=argument[g_arg_num].sbr;
				sb && (! g_valcheck.output )
			      		;sb = sb->next)
	           {
                        local_line_num = g_line_num;
                        local_arg_num = g_arg_num;
			strcpy(local_subprog_name, g_subprog_name);
			strcpy(local_subprog_name_app, g_subprog_name_app);
			strcpy(g_subprog_name_app, g_subprog_name);
	                strcpy(g_subprog_name, sb->name);
	                g_line_num = sb->line_num;
	                g_arg_num = sb->arg_num;
			g_sbr = sb;
	                crp_valeur();
			g_arg_num = local_arg_num;
			g_line_num = local_line_num;
			strcpy(g_subprog_name, local_subprog_name);
			strcpy(g_subprog_name_app, local_subprog_name_app);
	           }
                   g_call_level--;
               }
               else
	       {
		   printf("Trop de niveaux d'appels\n");
	       }
            }
	  }
	  else
	  {
	    printf("%s ligne %d. No param %d a l'appel de %s > Nb de param prevu : %d\n",
		g_subprog_name_app, g_line_num, g_arg_num, g_subprog_name, g_sub2infos[sb_index].argument_nb);
	  }
        }
	else
	{
	    /* Le sous programme est deja connu dans la base. Il suffit
	       d'extraire les informations */
	    if ( g_sub2infos[search_value - 1].argument_nb > 0 )
	    {
	       	argument = (crp_arg *) g_sub2infos[search_value - 1].argument;
	       	g_valcheck.output = argument[g_arg_num].output;
	       	if ( g_valcheck.output )
	       	{
	       	    g_valcheck.line_num_o = argument[g_arg_num].line_num_o;
                    tst_len(argument[g_arg_num].sub_name_o,MAX_NAME);
	       	    strcpy(g_valcheck.sub_name_o,
			argument[g_arg_num].sub_name_o);
	    	}
	    }
	}
      }
}

int crp_search_arg(arg_name)
char *arg_name;
{
    int i;
    for(i=0;i<g_argument_nb;i++)
    {
	if ( strcmp(arg_name, g_argument0[i].name) == 0 )
	{
	    return i;
	}
    }
    return -1;
}

int crp_search_sbr(sbr0, sb_name,arg_num)
crp_sbr *sbr0;
char *sb_name;
int arg_num;
{
    crp_sbr *sb;
    for(sb=sbr0;sb;sb = sb->next)
    {
	    if ( strcmp(sb_name, sb->name) == 0 && sb->arg_num == arg_num )
	    {
	        return 1;
	    }
    }
    return 0;
}

void crp_mem_value(sblevel, line_num)
/*
   Memorisation de l'appel avec le passage des valeurs comme des parametres
*/
crp_sblevel *sblevel;
int line_num;
{
    crp_sbr *sb;
    int found, i;
    found = 0;
    if ( g_sub2infos_ind == 2 )
    {
	found = 0;
    }
    for(sb=g_sub2infos[g_sub2infos_ind].value;sb;sb=sb->next)
    {
	if ( strcmp(sb->name,sblevel->subprogram_name) == 0 &&
		sb->arg_num == sblevel->call_arg_num )
	{
/*
	    found = 1;
*/
	    break;
	}
    }
    if ( ! found )
    {	
	    sb = (crp_sbr *)malloc(sizeof(crp_sbr));
	    strcpy(sb->name, sblevel->subprogram_name);
	    sb->arg_num = sblevel->call_arg_num;
	    sb->line_num = line_num - g_line_input;
	    sb->next = NULL;
	    *g_value_link = sb;
	    (*g_value_nb)++;
	    g_value_link = &(sb->next);
    }
}

void crp_val_stmt_function(id)
Token *id;
{
    int i;
    for(i=0;i<g_stmt_function_nb;i++)
    {
	if ( strcmp(g_stmt_function[i], lu_table_name(id)) == 0 )
	{
	    return;
	}
    }
    if ( g_stmt_function_nb < MAX_STMT_FUNCTION )
    {
        strcpy(g_stmt_function[g_stmt_function_nb], lu_table_name(id));
	g_stmt_function_nb++;
    }
    else
    {
        printf("Nombre de statement function trop grand. Augmenter la taille MAX_STMT_FUNCTION actuellement a  %d\n", MAX_STMT_FUNCTION);
    }
}

void crp_verif_called()
{
    int i, j;
    crp_sbr2 *sb;
    for(i=0;i<g_sub2file_nb;i++)
    {
	if ( g_sub2infos[i].called_nb > 0 )
	{
	    sb = g_sub2infos[i].called;
	    for(sb=g_sub2infos[i].called;sb;sb=sb->next)
	    {
		if ( crp_search_subprog_tot(sb->name) == -1 )
		{
		    crp_ajout_inexist(sb->name, g_sub2infos[i].sub_name,
				sb->line_num);
		}
	    }
	}
    }
}


void crp_tok_name(id)
Token *id;
{
	printf("Token name %s\n", lu_table_name(id));
}

void crp_suppr_caller(name0)
char *name0;
{
    int i, ind, ind0, l;
    crp_sbr2 *sb;
    crp_sbr1 **caller0, *caller, *sbr;
    char *name;
    l = strlen(name0);
    name = malloc(l+1);
    strcpy(name, name0);
    for(i=0;i<l;i++)
    {
        name[i] = toupper(name0[i]);
    }
    name[l] = '\0';
    if ( (ind = crp_search_subprog_tot(name)) == -1 )
    {
	printf("CRP_997. Le module %s n'existe pas. Pas de suppression.\n", name);
    }
    else
    {
	    for(sb=g_sub2infos[ind].called;sb;sb=sb->next)
	    {
		caller0 = &(g_sub2infos[ind0=crp_search_subprog_tot(sb->name)].caller);
		for(caller=g_sub2infos[ind0].caller;caller;
			caller=caller->next)
                {
                    if ( strcmp(name, caller->name) == 0 )
                    {
                          *caller0 = caller->next;
                          free(caller);
                          break;
                    }
                    caller0 = &(caller->next);
                }
	        g_sub2infos[ind0].caller_nb--;
	    }
    }
    free(name);
}

void crp_suppr(name0)
char *name0;
{
    int i, ind, ind0, l, j, k;
    crp_sbr2 *sb;
    crp_sbr1 **caller0, *caller, *sbr, **link;
    char *name;
    l = strlen(name0);
    name = malloc(l+1);
    strcpy(name, name0);
    for(i=0;i<l;i++)
    {
        name[i] = toupper(name0[i]);
    }
    name[l] = '\0';
    if ( (ind = crp_search_subprog_tot(name)) == -1 )
    {
	printf("CRP_997. Le module %s n'existe pas. Pas de suppression.\n", name);
    }
    else
    {
	if ( g_sub2infos[ind].caller_nb > 0 )
        {
	    sprintf(new_char_val,g_message[27], name,
		(g_sub2infos[ind].caller[0]).line_num,
		name, (g_sub2infos[ind].caller[0]).name, name);
	    printf("%s\n", new_char_val);
/*
	    i = 1;
	    for(sbr=g_sub2infos[ind].caller;sbr;sbr=sbr->next)
	    {
		printf("%d : %s a la ligne %d\n", i++, sbr->name, sbr->line_num);
	    }
*/
	}
	else
	{
	    g_sub2infos[ind].maj = -1;
/*  Suppression de sous programme du common  */
            for ( i=0;i<g_com2infos_nb;i++)
	    {
		for(j=0;j<g_com2infos[i].sbr_nb;j++)
		{
		    sbr = g_com2infos[i].sbr;
		    if ( strcmp(name, sbr[j].name) == 0 )
		    {
			l = 0;
			link = &g_com2infos[i].sbr;
			for(k=0;k<g_com2infos[i].sbr_nb;k++)
			{
			    if ( strcmp(name, sbr[k].name) != 0 )
			    {
				memcpy((char *)&sbr[l], (char *)&sbr[k],
					sizeof(crp_sbr1));
				*link = &sbr[l];
				link = &(sbr[l].next);
				l++;
			    }
			}
			*link = NULL;
			g_com2infos[i].sbr_nb = l;
			if ( l == 0 )
			{
			    g_com2infos[i].maj = -1;
			}
			else
			{
			    strcpy(g_com2infos[i].sub_name,
				g_com2infos[i].sbr[0].name);
			}
			break;
		    }
		}
	    }
	}
    }
    free(name);
}

void crp_maj1_common()
{
    int i, j, k, ind;
    void crp_liberer();
    crp_common1 *common1;
    crp_sbr1    *sb, *sb_nouv, *sb_nouv_next;
    int sb_ind, sb_nb, sb_nb_tot, sb_num, found;
    char *pname;

    sb_num = -1;
    /* mise a jour des common dans mem */
    for(i=0;i<g_com2file_nb;i++)
    {
        if ( (ind=crp_search_common_mem(g_com2infos[i].name)) != -1 )
	{
	    if ( crp_entity_not_identity(i,ind) )
	    {
		if ( crp_include_sub(ind) )
		{
		    /* la liste des sous programme du common ind
			est inclue dans la liste des sous programmes modifies.
			Cela veut dire qu'il
			faut remplacer l'ancien common par le nouveau
			dans la base */
		    memcpy((char *)&g_com2infos[ind],
			(char *)&g_com2infos[i],
			sizeof(crp_com2infos));
		    if ( g_com2infos[ind].sbr_nb > 0 )
		    {
		        sb = g_com2infos[ind].sbr;
		        g_com2infos[ind].sbr = (crp_sbr1 *)malloc(
				g_com2infos[ind].sbr_nb*sizeof(crp_sbr1));
			sb_nouv = g_com2infos[ind].sbr;
			for(j=0;j<g_com2infos[ind].sbr_nb;j++)
			{
			   strcpy(sb_nouv[j].name, sb->name);
			   sb = sb->next;
			}
		    }
                    /* Le nom du sous programme de reference est deja
			a jour, inutile de modifier */
		    sb_num = -2;
		}
	    }

            /* Il faut mettre a jour la liste des sous programmes
               de ind car c'est lui que l'on garde. */

            sb_nb = g_com2infos[ind].sbr_nb;
	    sb = g_com2infos[ind].sbr;
	    sb_nb_tot = 0;

	    for(j=0;j<sb_nb;j++)
	    {

		if ( (sb_ind=crp_search_subprog_file(sb[j].name)) != -1 )
		{
                    /*  Le sous programme j (sb[j].name, de la liste des
                        sous programmes du common ind) est donne avec le
			fichier donc il est modifie. Si le common en
			question n'existe plus dans
			la liste des common du sous programme modifie,
			il faut enlever le sous programme de la liste.
		    */
                       
		    common1= g_sub2infos[sb_ind].common;
		    found = 0;
		    for(k=0;k<g_sub2infos[sb_ind].common_nb;k++)
		    {
			if ( strcmp(common1[k].name, g_com2infos[i].name) == 0 )
			{
			    found = 1;
			    break;
			}
		    }
		    if ( ! found )
		    {
			/* Le common en question n'est plus dans le nouveau
			   sous programme, donc ce dernier (sb[j].name) est
			   a supprimer de la liste */

			sb[j].name[0] = '\0';
		    }
		    else
		    {
		        sb_nb_tot++;
		    }
		}
		else
		{
		    if ( sb_num == -1 )
		    {
			sb_num = -2;
			strcpy(g_com2infos[ind].sub_name,
			        g_com2infos[ind].sbr[j].name);
		    }
		    sb_nb_tot++;
		}
	    }

	    /*  Suppression des sous programme en double de la
		liste des sous programme du common modifie */

            sb_nouv = g_com2infos[i].sbr;

            /* sb_nouv : liste des sous programme du nouveau common
               (par nouveau common nous entendons par common trouve dans le
               nouveau sous programme ou sous programme modifie) modifie */
 

	    for(j=0;j<g_com2infos[i].sbr_nb;j++)
	    {
		pname = sb_nouv->name;
		found = 0;
		for(k=0;k<sb_nb;k++)
		{
		    if ( strcmp(sb[k].name, pname) == 0 )
		    {
			found = 1;
			break;
		    }
		}
		if ( found )
		{
		    /* le sous programme existe deja dans la liste du meme
		       common de la base. Il est donc inutile de le conserver.
		    */
		    (sb_nouv->name)[0] = '\0';
		}
		else
		{
		    sb_nb_tot++;
		}
		sb_nouv = sb_nouv->next;
	    }
	    g_com2infos[ind].sbr_nb = sb_nb_tot;
	    if ( sb_nb_tot > 0 )
	    {
                /* Copier les deux listes dans une seule liste */
	        g_com2infos[ind].sbr = (crp_sbr1 *)malloc(sb_nb_tot*
				sizeof(crp_sbr1));
		k = 0;
		for(j=0;j<sb_nb;j++)
		{
		    if ( (sb[j].name)[0] )
		    {
			strcpy((g_com2infos[ind].sbr[k]).name, sb[j].name);
			k++;
		    }
		}
                sb_nouv = g_com2infos[i].sbr;
		for(j=0;j<g_com2infos[i].sbr_nb;j++)
		{
		    if ( (sb_nouv->name)[0] )
		    {
			strcpy((g_com2infos[ind].sbr[k]).name,sb_nouv->name);
			k++;
		    }
		    sb_nouv = sb_nouv->next;
		}
	    }
            /* liberer le common ind */
	    free(sb);
	    /* liberer le common i */
	    sb_nouv = g_com2infos[i].sbr;
	    for(j=0;j<g_com2infos[i].sbr_nb;j++)
	    {
		sb_nouv_next = sb_nouv->next;
		free(sb_nouv);
		sb_nouv = sb_nouv_next;
	    }
	    g_com2infos[i].maj = -1;
	}
	else
	{
	    /* C'est un nouveau common qu'il faut ajouter dans la bd */
	    sb = g_com2infos[i].sbr;
	    if ( g_com2infos[i].sbr_nb > 0 )
	    {
	        g_com2infos[i].sbr = (crp_sbr1 *)malloc(
			sizeof(crp_sbr1)*g_com2infos[i].sbr_nb);
		for(j=0;j<g_com2infos[i].sbr_nb;j++)
		{
		   memcpy(&(g_com2infos[i].sbr[j]), sb, sizeof(crp_sbr1));
		   sb_nouv = sb->next;
		   free(sb);
		   sb = sb_nouv;
		}
	    }
	}
    }
}

void crp_liberer(ind)
int ind;
{
/*
	printf("Il faut liberer le common %d\n", ind);
*/
    g_com2infos[ind].maj = -1;
}

int crp_include_sub(ind) 
int ind; 
{ 
  /* tester si les sous programmes du common ind1 est inclu dans celle
     du common ind2 */

    crp_sbr1 *sbr; 
    int i, j, found;
	sbr = g_com2infos[ind].sbr;
 
        for(i=0;i<g_com2infos[ind].sbr_nb;i++)
        {
/*
	  if ( ! crp_isdelete(sbr[i].name) )
	  {
*/
            found = 0;
	    for(j=0;j<g_sub2file_nb;j++)
            {
	        if ( strcmp(sbr[i].name, g_sub2infos[j].sub_name) == 0 )
		{
		    found = 1;
		    break;
		}
            }
	    if ( ! found )
	    {
		return FALSE;
	    }
/*
	  }
*/
        }
        return TRUE;
}

int crp_search_common_mem(name)
char *name;
{
    int i;
    for(i=g_com2file_nb;i<g_com2infos_nb;i++)
    {
	if ( strcmp(g_com2infos[i].name, name) == 0 )
	{
	    return i;
	}
    }
    return -1;
}

int crp_entity_not_identity(ind1, ind2)
int ind1, ind2;
{
    crp_entity *entity1, *entity2;
    int i;

    if ( g_com2infos[ind1].entity_nb != g_com2infos[ind2].entity_nb )
    {
       return TRUE;
    }
    else
    {
	entity1 = g_com2infos[ind1].entity;
	entity2 = g_com2infos[ind2].entity;
	for(i=0;i<g_com2infos[ind1].entity_nb;i++)
	{
	    if ( entity1[i].type != entity2[i].type ||
		 entity1[i].size != entity2[i].size ||
		 entity1[i].length != entity2[i].length ||
		 strcmp(entity1[i].name, entity2[i].name) != 0 )
	    {
		return TRUE;
	    }
	}
	return FALSE;
    }
}

void crp_func_ref_expr_val(name, args, result )
char *name;
Token *args, *result;
{
     IntrinsInfo *find_intrinsic(), *defn;
     int rettype, retsize, i1;
     if ( result->class == tok_identifier /* inutile pour le nom de fonction
			|| result->class == tok_array_identifier */ )
     {
        i1 = result->value.integer;
	rettype = g_lu_table[i1].type;
	if ( rettype == 0 )
	{
	    rettype = get_type(0, g_lu_table[i1].name);
	}
        retsize = g_lu_table[i1].size;
	if ( retsize == size_DEFAULT )
	{
	    retsize = get_size(0, g_lu_table[i1].name);
	    if ( retsize == size_DEFAULT )
	    {
		retsize = type_size[rettype];
	    }
	}
     }
     defn = find_intrinsic(name);
     if ( defn != NULL )
     {
	 rettype = defn->result_type;
         retsize = size_DEFAULT;
         if(rettype == type_GENERIC) {
                if(args->next_token == NULL) {
                  rettype = type_UNDECL;
                  retsize = size_DEFAULT;
                }
                else {
                    rettype = args->class;
                    retsize = args->size;
    		    if ( args->class == tok_identifier || args->class == tok_array_identifier )
    		    {
			    i1 = args->value.integer;
			    retsize = get_size(0,g_lu_table[i1].name);
			    rettype = get_type(0,g_lu_table[i1].name);
    		    }
    		    if ( retsize == size_DEFAULT )
    		    {
        		    retsize = type_size[rettype];
    		    }
                }
		if(rettype == type_COMPLEX && (defn->intrins_flags&I_C_TO_R))
		{
                    rettype = type_REAL;
                    retsize = retsize/2;
                }
                if(rettype == type_DCOMPLEX &&(defn->intrins_flags&I_C_TO_R))
		{
                    rettype = type_DP;
                    retsize = size_DEFAULT;
                }
         }
     }
     result->class = type_byte(class_VAR,rettype);
     result->size = retsize;
}


int crp_get_type_lu(ind)
int ind;
{
    int i;
    for(i=0;i<g_lu_table_nb;i++)
    {
	if ( strcmp(g_lu_table[i].name,g_sub2infos[ind].sub_name) == 0 )
	{
	    if ( g_lu_table[i].type != type_UNDECL && g_lu_table[i].size != size_DEFAULT )
	    {
		g_sub2infos[ind].type = g_lu_table[i].type;
		g_sub2infos[ind].size = g_lu_table[i].size;
		return TRUE;
	    }
	    else
	    {
		return FALSE;
	    }
	}
    }
}



void  crp_concat_string(s1,s2,res)
Token *s1, *s2, *res;
{
    int lu, size1, size2;
    if ( s1->class == tok_identifier || s1->class == tok_array_identifier )
    {
	lu = s1->value.integer; 
	size1 = g_lu_table[lu].size;
    }
    else
    {
	size1 = s1->size;
    }
    if ( s2->class == tok_identifier || s2->class == tok_array_identifier )
    {
        lu = s2->value.integer; 
        size2 = g_lu_table[lu].size; 
    }
    else 
    { 
        size2 = s2->size; 
    }
    if ( size1 == -1 || size2 == -1 )
    {
	res->size = -1;
    }
    else
    {
	res->size = size1 + size2;
    }
    res->class = type_STRING;
}

void crp_binexpr_type_val(t1,operator,t2,res)
Token *operator,*t1, *t2, *res;
{
    int lu, type1, type2, size1, size2, val1, val2;
    int op = operator->class;
    extern void crp_set_type();
    if ( t1->class == tok_identifier || t1->class == tok_array_identifier )
    {
	lu = t1->value.integer; 
        crp_set_type(lu);
	type1 = g_lu_table[lu].type;
        size1 = g_lu_table[lu].size;
	val1  = g_lu_table[lu].length;
    }
    else
    {
	type1 = t1->class;
        size1 = t1->size;
        val1 = t1->value.integer;
    }
    if ( t2->class == tok_identifier || t2->class == tok_array_identifier )
    {
	lu = t2->value.integer; 
        crp_set_type(lu);
	type2 = g_lu_table[lu].type;
        size2 = g_lu_table[lu].size;
        val2  = g_lu_table[lu].length;
    }
    else
    {
	type2 = t2->class;
        size2 = t2->size;
        val2 =  t2->value.integer;
    }
    if ( type1 == type2 )
    {
        if ( size1 < size2 )
        {
            res->size = size2;
        }
        else
        {
            res->size = size1;
        }
        res->class = type2;
    }
    else if ( type1 > type2 )
    {
        res->class = type1;
        res->size = size1;
    }
    else
    {
        res->class = type2;
        res->size = size2;
    }
    switch(op) {
            case '+':
                {
                    res->value.integer = val1 + val2;
                    break;
                }
            case '-':
                {
                    res->value.integer = val1 - val2;
                    break;
                }
            case '*':
                {
                    res->value.integer = val1 * val2;
                    break;
                }
            case '/':
                {
                    if ( val2 != 0 )
                    {
                        res->value.integer = val1 / val2;
                    }
                    break;
                }
     }   
}


void crp_unexpr_type_val(t,res)
Token *t, *res;
{
    int lu;
    extern void crp_set_type();
    if ( t->class == tok_identifier || t->class == tok_array_identifier )
    {
	lu = t->value.integer; 
        crp_set_type(lu);
	res->class = g_lu_table[lu].type;
        res->size = g_lu_table[lu].size;
    }
    else
    {
        res->class = t->class;
        res->size = t->size;
    }
}

void crp_set_type(lu)
int lu;
{
    int i1;
    if ( g_lu_table[lu].type == 0 )
    {
        g_lu_table[lu].type = get_type(0,g_lu_table[lu].name);
/*
	if ( implicit_type[i1] == 0 )
	{
	    g_lu_table[lu].type = get_type(0,g_lu_table[lu].name);
	}
	else
	{
	    g_lu_table[lu].type = implicit_type[i1];
	}
*/
    }
    if ( g_lu_table[lu].size == size_DEFAULT )
    {
	     g_lu_table[lu].size = get_size(0, g_lu_table[lu].name);
/*
        if ( implicit_size[i1] == 0 )
	{
	     g_lu_table[lu].size = get_size(0, g_lu_table[lu].name);
	}
        else
	{
	     g_lu_table[lu].size = implicit_size[i1];
	}
*/
    }
}


void crp_end_file_val()
{
    crp_arg2 *argument;
    int ind;

/*
    for(arg=g_arg_subroutine;arg;arg=arg0) 
    {    
        fseek(arg_fd_tmp0,arg->offset, 0); 
	argument = (crp_arg2 *)malloc(arg->nb_arg*sizeof(crp_arg2));
	fread((char *)argument,
                   arg->nb_arg*sizeof(crp_arg2),1, arg_fd_tmp0);
	if ( (ind = crp_search_subprog_tot(arg->name)) >= 0 )
	{
	    argument[arg->arg_num].type = g_sub2infos[ind].type;
	    argument[arg->arg_num].size = g_sub2infos[ind].size;
            fseek(arg_fd_tmp0,arg->offset, 0); 
	    fwrite((char *)argument,
                   arg->nb_arg*sizeof(crp_arg2),1, arg_fd_tmp0);
	}
	arg0 = arg->next;
	free(arg);
	free(argument);
    }    
    g_arg_subroutine = NULL;
    g_arg_subroutine_link = &g_arg_subroutine;
*/
}

int crp_isdelete(name)
char *name;
{
    /* Test si un sous programme est supprime ou non. Le fait que
       le sous programme n'existe pas, ce sous programme est considere
       comme supprome */
    int i;
    for(i=0;i<g_sub2infos_nb;i++)
    {
        if ( g_sub2infos[i].maj != -1 )
        {
            if ( strcmp(g_sub2infos[i].sub_name,name) == 0 )
            {
                if ( g_sub2infos[i].maj == -2 )
                {
                    return TRUE;
                }
                else
                {
                    return FALSE;
                }
            }
        }
    }
    return TRUE;
}
