#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 10 "fortran.y"

/*
  fortran.c:

    Copyright (C) 1992 by Robert K. Moniot.
    This program is free software.  Permission is granted to
    modify it and/or redistribute it.  There is no warranty
    for this program.


	    This grammar is ANSI standard-conforming, except for:
		-- complex constant and a few other ambiguities needing
		   significant lookahead cannot be split across lines.

	    Extensions supported:
	        -- Case insensitive.
	 	-- Hollerith constants.
		-- Variable names may be longer than 6 characters.  Also
		   allows underscores and dollar signs in names.
		-- DO ... ENDDO and DO WHILE loop forms allowed.
		-- NAMELIST supported.
		-- TYPE and ACCEPT I/O statements allowed.
		-- Tabs are permitted in input, and (except in character data)
		   expand into blanks up to the next column equal to 1 mod 8.
		-- Type declarations INTEGER*2, REAL*8, etc. are allowed.
		-- IMPLICIT NONE allowed.
	 */

/*  Author: R. Moniot
 *  Date:   August 1988
 *  Last revision: July 1993
 *  Modif   A. Y
 *  Date    June   1995
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ftnchek.h"
#include "valchek.h"
#include "symtab.h"

	/* The following section is for use with bison-derived
	   parser.  Define alloca to be malloc for those cases
	   not covered by the cases covered there.  The ifdefs
	   are those in the skeleton parser with includes removed */
#ifdef AIXC	/* IBM RS/6000 xlc compiler does it this way */
#pragma alloca
#endif
#ifndef alloca
#ifdef __GNUC__
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#else /* Not sparc */
#ifdef MSDOS
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#define alloca malloc
#endif /* alloca now defined.  */

void exit();

#ifndef YYDEBUG	/* If not declared otherwise... */
/*int yydebug;	 declare yydebug to satisfy extern in ftnchek.c */
#ifdef DEVELOPMENT
#define YYDEBUG 1		/* For development it is handy */
#else
#define YYDEBUG 0
#endif
#endif

#ifdef DEVELOPMENT
#define DEBUG_PARSER
#endif

int current_datatype,	/* set when parse type_name or type_stmt */
    stmt_sequence_no,   /* set when parsing, reset to 0 at end_stmt */
    control_item_count;	/* count of items in control_info_list */
long current_typesize;	/* for type*len declarations */

extern unsigned prev_stmt_line_num; /* shared with advance */

unsigned true_prev_stmt_line_num;	/* shared with symtab.c */

int current_module_hash = -1,	/* hashtable index of current module name */
    current_module_type = type_UNDECL,
    current_module_size,
    executable_stmt=FALSE,
    prev_stmt_class=0,
		 /* flags for lexer */
    complex_const_allowed=FALSE, /* for help in lookahead for these */
    in_assignment_stmt=FALSE,
    inside_format=FALSE,	/* when inside parens of FORMAT  */
    integer_context=FALSE,	/* says integers-only are to follow */
    prev_goto=FALSE,
    goto_flag=FALSE;	/* if unconditional GOTO was encountered */


/******  AY ajout ************/

PRIVATE char intrn_name[MAX_XTERNAL][8];
PRIVATE int nbintrn;

PRIVATE crp_sblevel *subprog_level, *subprog_level0;

PRIVATE int return_label;
PRIVATE int def_arg_num = 0;
PRIVATE int value_flag;
PRIVATE int len_specification_ok;
PRIVATE int char_type_specif;
PRIVATE int in_read_stmt = 0;
PRIVATE int complex_true = 0;
PRIVATE Token subprogram_token;

int arith_expression_type;
extern char *crp_token_name();

/******  Fin AY ajout ********/

PRIVATE void
END_processing();
		/* Uses of Token fields for nonterminals: */
/*
  1. dim_bound_lists: dimensioning info for arrays:
       token.class = no. of dimensions,
       token.subclass = no. of elements
  2. expressions
       token.value.integer = hash index (of identifier)
       token.class = type_byte = storage_class << 4 + datatype
       token.subclass = flags: CONST_EXPR, LVALUE_EXPR, etc.
  3. common variable lists
       token.subclass = flag: COMMA_FLAG used to handle extra/missing commas
*/

#define SEQ_HEADER   1
#define SEQ_IMPLICIT 2
#define SEQ_SPECIF   3
#define SEQ_STMT_FUN 4
#define SEQ_EXEC     5
#define SEQ_END      6

#line 160 "y.tab.c"
#define YYERRCODE 256
#define tok_identifier 257
#define tok_array_identifier 258
#define tok_label 259
#define tok_integer_const 260
#define tok_real_const 261
#define tok_dp_const 262
#define tok_complex_const 263
#define tok_dcomplex_const 264
#define tok_logical_const 265
#define tok_string 266
#define tok_hollerith 267
#define tok_edit_descriptor 268
#define tok_letter 269
#define tok_relop 270
#define tok_AND 271
#define tok_OR 272
#define tok_EQV 273
#define tok_NEQV 274
#define tok_NOT 275
#define tok_power 276
#define tok_concat 277
#define tok_ACCEPT 278
#define tok_ASSIGN 279
#define tok_BACKSPACE 280
#define tok_BLOCK 281
#define tok_BLOCKDATA 282
#define tok_BYTE 283
#define tok_CALL 284
#define tok_CHARACTER 285
#define tok_CLOSE 286
#define tok_COMMON 287
#define tok_COMPLEX 288
#define tok_CONTINUE 289
#define tok_DATA 290
#define tok_DIMENSION 291
#define tok_DO 292
#define tok_DOUBLE 293
#define tok_DOUBLECOMPLEX 294
#define tok_DOUBLEPRECISION 295
#define tok_DOWHILE 296
#define tok_ELSE 297
#define tok_ELSEIF 298
#define tok_END 299
#define tok_ENDDO 300
#define tok_ENDFILE 301
#define tok_ENDIF 302
#define tok_ENTRY 303
#define tok_EQUIVALENCE 304
#define tok_EXTERNAL 305
#define tok_FILE 306
#define tok_FORMAT 307
#define tok_FUNCTION 308
#define tok_GO 309
#define tok_GOTO 310
#define tok_IF 311
#define tok_IMPLICIT 312
#define tok_INCLUDE 313
#define tok_INQUIRE 314
#define tok_INTEGER 315
#define tok_INTRINSIC 316
#define tok_LOGICAL 317
#define tok_NAMELIST 318
#define tok_NONE 319
#define tok_OPEN 320
#define tok_PARAMETER 321
#define tok_PAUSE 322
#define tok_PRECISION 323
#define tok_PRINT 324
#define tok_PROGRAM 325
#define tok_READ 326
#define tok_REAL 327
#define tok_RETURN 328
#define tok_REWIND 329
#define tok_SAVE 330
#define tok_STOP 331
#define tok_SUBROUTINE 332
#define tok_THEN 333
#define tok_TO 334
#define tok_TYPE 335
#define tok_WHILE 336
#define tok_WRITE 337
#define tok_illegal 338
#define EOS 127
#define REDUCE 339
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    2,    2,    3,    3,    5,
    5,    7,    7,    7,    7,    7,    8,    8,    8,    8,
    6,    6,   16,    4,    9,    9,    9,    9,    9,   17,
   17,   21,   21,   21,   21,   21,   21,   21,   21,   10,
   10,   32,   32,   32,   32,   32,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   11,   11,   56,   56,   56,   56,   57,
   57,   57,   12,   22,   66,   22,   13,   68,   70,   68,
   68,   72,   68,   69,   71,   74,   73,   73,   73,   14,
   78,   80,   78,   79,   67,   67,   81,   81,   82,   82,
   15,   15,   83,   83,   24,   84,   84,   85,   86,   86,
   87,   87,   87,   87,   90,   25,   89,   89,   91,   91,
   92,   92,   92,   93,   94,   94,   26,   26,   26,   98,
   98,  101,   99,  100,  100,  100,   97,   97,  102,  102,
  103,  103,   27,  104,  104,  105,  106,  107,  107,  108,
  108,   28,   28,   28,   28,   75,   75,   75,  111,  111,
  111,  111,  113,  113,  113,  113,  113,   76,   77,  109,
  109,  115,  115,  110,  110,  116,  116,  116,  116,  117,
   19,   19,  118,  120,  118,  122,  119,  121,  121,  123,
  123,  114,  114,  114,   18,  125,  125,  127,  126,   29,
  129,  129,   30,  130,  130,   31,   31,  131,  131,  132,
  132,   20,  133,  133,  133,  137,  138,  134,  135,  135,
  139,  139,  136,  136,  142,  142,  144,  144,  143,  143,
  146,  146,  147,  147,  141,  149,  149,  151,  152,   39,
  140,  140,  140,  140,   40,   34,   41,   41,   35,   35,
   35,  158,  158,  159,  159,   36,   58,   59,  162,  161,
   62,  163,  164,   62,   63,   64,   64,   60,  167,   60,
  168,   60,  165,  165,  165,  166,  166,   61,   61,   42,
   37,   43,  170,  170,  170,  170,  172,   46,  174,   46,
  175,  171,   44,   44,   44,   44,   44,  177,   45,  179,
  180,   45,   47,   47,   48,  181,  182,   48,  176,  176,
  183,  183,  185,  185,  185,  186,  186,  173,  173,  187,
  187,  188,  189,   52,  190,   53,  191,   54,   50,   50,
  192,   51,   51,  193,  193,   49,   49,  194,  184,  184,
  178,  178,  196,   23,  197,  197,  198,  198,  199,  199,
  199,  200,  200,  201,  201,  201,  201,  202,  202,  202,
  202,  202,  202,  205,  203,  203,  203,  204,  155,  207,
  207,  208,  208,  209,  211,   55,  212,   55,  214,   55,
  210,  213,  213,  213,  213,   38,   38,  215,  216,  217,
  217,  218,  218,  128,  150,  219,  219,  219,  220,  220,
  221,  221,  222,  222,  223,  223,  224,  224,  224,  224,
  224,  225,  225,  225,  226,  226,  195,  195,  227,  227,
  227,  227,  227,  227,  230,  230,  230,  230,  231,  231,
  231,  231,  231,  160,  169,  124,   88,  148,  228,   95,
   95,  233,  229,  229,  154,  154,   96,   96,   96,   96,
  234,  153,  153,  206,  232,   65,   65,  145,  145,  145,
  145,  145,  145,  112,  156,  157,
};
const short yylen[] = {                                         2,
    1,    0,    1,    2,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,
    1,    2,    2,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    3,    0,    7,    1,    3,    0,    7,
    3,    0,    7,    2,    1,    1,    1,    1,    1,    1,
    3,    0,    7,    1,    0,    1,    1,    3,    1,    1,
    2,    3,    2,    1,    3,    1,    3,    4,    1,    3,
    1,    3,    1,    3,    0,    4,    3,    5,    3,    3,
    1,    1,    1,    4,    2,    2,    3,    3,    4,    1,
    2,    0,    3,    3,    2,    1,    1,    2,    1,    2,
    1,    1,    3,    1,    2,    2,    3,    1,    2,    1,
    2,    3,    3,    3,    4,    1,    3,    1,    1,    1,
    1,    1,    2,    1,    2,    1,    1,    1,    3,    1,
    3,    1,    1,    1,    3,    1,    3,    1,    3,    1,
    3,    3,    1,    0,    4,    0,    5,    1,    3,    1,
    3,    3,    1,    3,    5,    1,    3,    0,    4,    3,
    1,    3,    3,    1,    3,    2,    3,    1,    3,    1,
    3,    3,    1,    2,    3,    0,    0,    6,    1,    3,
    1,    1,    1,    3,    1,    3,    1,    1,    1,    1,
    1,    3,    1,    1,    7,    3,    5,    0,    0,    6,
    1,    1,    1,    1,    6,    4,    6,    7,    3,    6,
    7,    1,    2,    2,    4,   10,    2,    3,    0,    5,
    2,    0,    0,    8,    2,    2,    3,    5,    0,    7,
    0,    6,    3,    4,    2,    3,    5,    3,    2,    2,
    3,    3,    0,    1,    1,    1,    0,    3,    0,    4,
    0,    5,    5,    6,    7,    3,    5,    1,    3,    0,
    0,    7,    3,    5,    3,    0,    0,    7,    1,    3,
    3,    1,    1,    3,    3,    3,    1,    1,    3,    1,
    1,    7,    0,    6,    0,    6,    0,    6,    3,    5,
    1,    3,    5,    1,    2,    3,    5,    1,    1,    1,
    1,    1,    0,    6,    0,    1,    1,    2,    1,    1,
    1,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    2,    2,    3,    4,    0,
    1,    1,    3,    1,    0,    3,    0,    5,    0,    6,
    2,    1,    3,    3,    5,    2,    3,    4,    1,    0,
    1,    1,    3,    1,    1,    1,    3,    3,    1,    3,
    1,    3,    1,    2,    1,    3,    1,    2,    2,    3,
    3,    1,    3,    3,    1,    3,    1,    3,    1,    1,
    1,    1,    1,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    4,    4,    1,
    3,    1,    2,    2,    2,    2,    3,    4,    4,    5,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    1,    1,    1,    1,    0,    1,
};
const short yydefred[] = {                                      0,
    0,  454,  455,    0,    0,  465,  331,    0,  104,  167,
    0,  168,  325,    0,  161,    0,    0,    0,  465,    0,
  166,  164,    0,    0,    0,    0,    0,  334,    0,    0,
  115,    0,  343,   86,    0,  252,    0,  180,    0,  327,
  159,    0,  162,    0,  323,    0,    0,    0,    0,  298,
  160,    0,  338,    0,    0,   94,    0,  291,    7,    0,
    0,    3,    5,    6,    8,    9,   11,   12,   13,   14,
   15,   17,   18,   19,   20,   21,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
   69,   70,   71,   72,   77,    0,    0,    0,   85,    0,
    0,    0,   90,    0,    0,    0,  158,    0,    0,    0,
  241,  243,  244,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   16,   10,   22,  429,  430,  431,
  432,  433,  428,  426,  427,    0,  342,  419,    0,    0,
    0,  421,    0,  417,    0,  422,  423,  425,    0,    0,
  103,  456,  457,  381,    0,  136,    0,    0,  142,    0,
    0,  130,  132,  137,    0,  280,    0,    0,  213,    0,
  219,  221,  222,    0,    0,  106,    0,  165,  163,  271,
  265,  261,    0,  262,    0,  335,    0,   23,  279,  266,
    0,    0,  201,    0,    0,  253,  259,    0,    0,  204,
    0,    0,    0,  144,    0,    0,    0,  284,  286,  285,
    0,    0,    0,  386,    0,    0,    0,    0,    0,    0,
  412,  206,    0,  210,    0,  208,    0,    0,    0,    4,
    0,    0,   84,    0,  173,    0,  170,    0,    0,    0,
    0,  174,    0,    0,    0,  101,    0,    0,    0,    0,
   87,    0,   89,    0,  183,  238,    0,  446,  465,    0,
    0,    0,    0,  257,    0,  465,    0,    0,  452,  453,
    0,    0,    0,    0,    0,  318,  321,  395,    0,    0,
  401,    0,    0,    0,    0,    0,  340,    0,    0,    0,
    0,    0,    0,    0,  445,    0,    0,    0,    0,  299,
  300,    0,    0,  443,  444,    0,  466,    0,    0,  135,
    0,    0,  127,    0,  138,  128,  131,    0,  140,  234,
    0,  231,  233,    0,  212,    0,  214,    0,  216,  105,
    0,    0,    0,    0,  278,  267,   74,    0,    0,    0,
  200,    0,    0,    0,   24,    0,  203,    0,    0,  143,
  145,    0,    0,  148,    0,  198,    0,  196,  282,  303,
    0,   73,    0,    0,  387,    0,    0,    0,    0,    0,
    0,  207,    0,  281,  305,  306,    0,   78,    0,   81,
    0,  152,    0,  464,    0,  193,  169,    0,    0,  153,
    0,    0,  154,   91,    0,  102,  157,  182,  186,  181,
  184,    0,    0,    0,    0,    0,    0,  249,  465,    0,
    0,  258,    0,  269,    0,    0,    0,    0,    0,    0,
  288,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  309,  312,  296,    0,    0,  329,    0,  332,    0,
  336,    0,    0,    0,  372,  377,  465,    0,    0,  376,
    0,    0,  440,  424,    0,  418,    0,    0,    0,    0,
    0,    0,    0,  134,  113,    0,  109,    0,    0,  129,
    0,    0,  215,  220,    0,  107,  274,    0,    0,    0,
    0,    0,    0,    0,  123,  116,    0,  202,  365,  354,
  355,  353,  360,    0,  358,  361,  359,    0,  362,  364,
    0,    0,    0,    0,  347,  349,  350,  351,  356,  357,
  363,    0,    0,  205,  147,  151,  149,    0,  313,    0,
    0,    0,    0,    0,  416,    0,    0,  414,  413,  211,
  209,    0,    0,    0,    0,  171,    0,    0,    0,  177,
  179,  175,  155,    0,    0,    0,    0,  447,    0,    0,
  254,    0,  465,    0,  465,  246,  465,    0,    0,    0,
    0,    0,    0,    0,  319,  290,    0,  402,  406,    0,
    0,    0,    0,    0,    0,    0,  369,    0,    0,    0,
  379,    0,  438,    0,    0,  388,    0,  439,    0,    0,
  108,    0,    0,    0,  232,    0,  461,  462,  463,    0,
    0,    0,  227,    0,  223,  225,    0,  229,  458,    0,
  263,  100,   99,    0,    0,   97,    0,  125,  117,    0,
    0,  126,    0,    0,  366,  367,    0,    0,  348,  260,
    0,    0,    0,    0,    0,  195,  197,  304,    0,  292,
    0,    0,  192,  194,    0,    0,    0,  188,  185,    0,
  449,  448,    0,    0,    0,    0,    0,    0,    0,    0,
  268,    0,    0,  311,  293,    0,    0,  310,  297,  330,
  333,  337,  374,  373,  378,  383,    0,  465,    0,  441,
    0,    0,  245,  326,  110,  114,  112,    0,  459,  460,
    0,    0,    0,  272,    0,    0,    0,    0,  120,  119,
    0,  352,  368,  344,  328,  314,  324,    0,  315,  199,
    0,    0,    0,    0,    0,    0,  187,    0,  240,  450,
    0,  247,  255,  250,    0,    0,    0,    0,    0,    0,
  294,  380,    0,  302,    0,    0,  224,  218,  230,  226,
    0,   76,   98,  124,  118,    0,  308,   80,   83,   93,
  191,  189,  248,  251,  465,  270,    0,    0,  295,  385,
    0,  235,  264,  316,    0,  277,  322,    0,    0,    0,
  256,  237,
};
const short yydgoto[] = {                                      60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  124,  459,  368,  644,  125,  126,  409,
  127,  411,  128,  129,  130,  131,  132,  133,  134,  425,
  645,  646,  135,  205,  189,  496,  497,  498,  370,  222,
  512,  513,  514,  515,  481,  288,  190,  191,  192,  193,
  348,  194,  195,  233,  234,  235,  383,  384,  266,  271,
  136,  416,  137,  417,  267,  272,  138,  284,  285,  576,
  677,  575,  678,  568,  387,  388,  551,  740,  224,  231,
  255,  256,  198,  199,  200,  634,  505,  722,  201,  139,
  203,  635,  636,  637,  638,  351,  352,  140,  766,  318,
  432,  680,  168,  142,  143,  436,  338,  144,  437,  247,
  145,  374,  364,  725,  146,  589,  588,  363,  590,  241,
  147,  304,  305,  453,  259,  461,  148,  169,  485,  711,
  562,  742,  462,  463,  550,  739,  306,  307,  236,  185,
  229,  149,  150,  151,  248,  225,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  171,  473,  474,  475,  153,
  327,  609,  479,  707,  172,  173,  488,  489,  308,  309,
  310,  311,  312,  313,  250,  251,  174,  175,  176,  177,
  178,  179,  483,  435,
};
const short yysindex[] = {                                   1069,
  -84,    0,    0, 1151,  913,    0,    0, -187,    0,    0,
  167,    0,    0,    7,    0,    9,   82,  167,    0, -182,
    0,    0,   91,  -94,  115,  245,   41,    0,   61,  167,
    0,  167,    0,    0, -188,    0,  159,    0,  -35,    0,
    0,  167,    0,  203,    0,  255,  453,  913,  167,    0,
    0,  784,    0,  229,  453,    0,  913,    0,    0,    0,
 1069,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  167,  167,   30,    0,  167,
  180,   85,    0,  167,  -19,  304,    0,  788,  259,  326,
    0,    0,    0,  150, 1227,  234,  718, 1046,  490,  523,
  597,  334,  414,  429,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  751,    0,    0,   27,  206,
    0,    0,  465,    0,  326,    0,    0,    0,  477,  262,
    0,    0,    0,    0,  494,    0,   95,  504,    0,  -10,
   25,    0,    0,    0,  525,    0,    4,  100,    0,  117,
    0,    0,    0,  504,   32,    0,  262,    0,    0,    0,
    0,    0,  215,    0,  463,    0,  472,    0,    0,    0,
  474,  552,    0,   44,  563,    0,    0,  483,  578,    0,
   55,  167,   96,    0,  167,  586,  167,    0,    0,    0,
  485,  116,  501,    0,  859,  859,  521,  278,  163,  290,
    0,    0,  167,    0,  174,    0,  547,  264,  647,    0,
  562,  569,    0,  504,    0,  315,    0,   10,  406,  663,
  317,    0,  167,  351,  618,    0,  619,  506,  651,  742,
    0,  750,    0,  357,    0,    0,  874,    0,    0,  105,
  262,  487,  668,    0,  262,    0,  757,  738,    0,    0,
 1035,  718,  310,  679,  781,    0,    0,    0,  556,  564,
    0,  571,  163,  613,  372,  613,    0,  310,  712,  613,
  725,  613,  729,  874,    0,  415,  739,  751,  -14,    0,
    0,  859,  643,    0,    0,  751,    0,  561,  613,    0,
  866,  949,    0,   50,    0,    0,    0,  167,    0,    0,
  853,    0,    0,  429,    0,   82,    0,   82,    0,    0,
  167,  890,  751,  751,    0,    0,    0,  908,  167,  391,
    0,  167,  151,  751,    0,  613,    0,  167,  911,    0,
    0,  933,  167,    0,  613,    0,  344,    0,    0,    0,
  718,    0,  290,  290,    0,  859,  859,  859,  859,  859,
  940,    0,  169,    0,    0,    0,  613,    0,  912,    0,
  948,    0,  167,    0,  960,    0,    0,   10,   10,    0,
  167,  423,    0,    0,  957,    0,    0,    0,    0,    0,
    0,  751,  980,  163,  943,  262,  449,    0,    0,  966,
  883,    0,  978,    0, 1035,  571,  -14,  984,  751,  751,
    0,  718,  902,  751,  751, 1035,    0,    0,  982,  310,
  520,    0,    0,    0,  718,  608,    0,  671,    0,  778,
    0,    0,  998, 1008,    0,    0,    0,  310,  782,    0,
  796,  310,    0,    0,  718,    0,  310, 1029, 1010,  163,
  809,  412,  846,    0,    0,  848,    0, 1007,  163,    0,
  167,  164,    0,    0,  925,    0,    0,   15,   20,  182,
 1037,  850, 1041,  326,    0,    0, 1039,    0,    0,    0,
    0,    0,    0,  151,    0,    0,    0,  839,    0,    0,
  858, 1035, 1067,  151,    0,    0,    0,    0,    0,    0,
    0,   33,  852,    0,    0,    0,    0, 1068,    0,  871,
 1072, 1015,  167,  426,    0,  290,  290,    0,    0,    0,
    0,  718,  879,  182,  182,    0, 1102, 1103,  163,    0,
    0,    0,    0,  182,  876, 1204,  310,    0, 1105,  991,
    0, 1013,    0,  897,    0,    0,    0,  751, 1020, 1104,
  163,  718,  556,  556,    0,    0,  564,    0,    0,  664,
  468,  613,  433, 1022, 1023, 1025,    0,  412, 1026,  262,
    0,  699,    0,  751,  781,    0,  751,    0, 1027, 1028,
    0,  949, 1024, 1090,    0,    0,    0,    0,    0,  549,
  549,    0,    0, 1112,    0,    0, 1115,    0,    0, 1031,
    0,    0,    0, 1119, 1117,    0,  643,    0,    0,  167,
  167,    0,  167,   19,    0,    0, 1106, 1040,    0,    0,
 1042,  664, 1045,  167,  751,    0,    0,    0,  781,    0,
 1140, 1143,    0,    0, 1152, 1149,  899,    0,    0, 1070,
    0,    0, 1154, 1035, 1076,  262, 1077,  901,  262,   45,
    0, 1035, 1144,    0,    0,  718,  466,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1081,    0,  310,    0,
 1092,  310,    0,    0,    0,    0,    0, 1035,    0,    0,
  925, 1181, 1057,    0,  896, 1107,  182,  903,    0,    0,
  905,    0,    0,    0,    0,    0,    0, 1169,    0,    0,
  310, 1108, 1109, 1123, 1132,  962,    0,  876,    0,    0,
 1133,    0,    0,    0, 1134, 1188, 1135, 1189, 1035,  470,
    0,    0,  262,    0, 1195, 1222,    0,    0,    0,    0,
 1137,    0,    0,    0,    0,  664,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1035, 1224,    0,    0,
 1035,    0,    0,    0,  262,    0,    0, 1223, 1139, 1035,
    0,    0,
};
const short yyrindex[] = {                                   1268,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1142,    0,    0,    0,
    0,    0,    0,    0, 1142,    0,    0,    0,    0,    0,
 1272,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  975,
  986,  997,    0,    0,    0,   -4,    0,    0,    0,  577,
    0,    0,    0, 1056, 1056,    0, 1202,    0,    0,    0,
    0,  603,  483,  607,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  471,
  389,    0,    0,    0,  572,    0,    0,    0,  544,    0,
    0,    0,    0,    0,    0,    0,    0,   23,    0,    0,
    0,    0,    0,    0,   58,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  464,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1290,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  789,  -13,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1291, 1292,    0,  480,    0,    0,    0,    0,  481,  482,
    0,    0,    0,    0, 1293,    0,    0,    0,    0,    0,
    0, 1294,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  484,    0, 1208,    0,    0,    0,  107,  125,
    0,  131,   51,    0,    0,    0,    0,   52,    0,    0,
    0,    0,    0, 1295,    0,    0,    0,    0,    0,    0,
    0,    0, 1296,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  502,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1297,    0,    0,    0,    0,    0,    0,    0,
    0,  322,  106,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  824,  840,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   89,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  201, 1298,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  421,  498,    0,  954,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   68,    0, 1299,    0,    0,    0,  955,    0,    0,
    0,  963,    0,    0,    0,    0,  983,    0, 1300,   77,
    0,    0,    0,    0,    0,    0,    0,  989,  659,    0,
   57,    0,    0,    0,    0,    0,    0,    0,    0, 1302,
  994,    0,    0,  996,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1303,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  892,  928,    0,    0,    0,
    0,    0,    0, 1302, 1302,    0,    0,    0, 1043,    0,
    0,    0,    0, 1302,    0,    0, 1212,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  369,    0,  233,  349,    0,    0,  228,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1218,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  585,    0,    0,    0,    0,
    0,  720,    0, 1328,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1305,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1261,    0,
    0,    0,    0,    0,    0, 1048,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  531,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1049,    0,
    0, 1060,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1065,    0,    0,
 1086,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   75,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1351,    0,    0,
    0,    0,
};
const short yygindex[] = {                                      0,
    0, 1341,    0,    0,    0,    0, 1399,    0,    0, 1260,
    0,    0,    0,    0,    0, 1406,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1387,    0,
    0,    0,    0,    0,   -7,    0,  -85,    0,    0,    0,
    0,    0, -135, 1284, -133, -124, -123,    0,    0,    0,
    0,  686,    0,    0,    2,    0,  792,  793,    0,    0,
  762,   34,    0,    0, -317, -122, 1071, 1228, -152,    0,
    0, -168,    0,    0, 1184,    0,    0, 1038,    0,  -32,
    0, -276,    0,  305, 1009,  999,    0,    0,  847,    0,
    0,    0,  676,  -73,    0,  872,    0,    0,    0,    0,
    0, 1054,    0, -167,    0,    0,    0,    0, 1116,   21,
 -173,  705,  704,    0,    0,    0,  926, -171,    0,  -65,
    0,    0,   12,    0,    0,   -6, -201,    0, -382, -491,
  152,    0,    0,    0,    0,  711,    0,    0, -617, 1409,
    0,    0, -284,    0,    0,  752,    0,  108,    0,    0,
    0,    0,  888, -141,    0,    0, -406,    0,    0,    0,
    0,    0,    0,    0,  235,    0,    0,  967, -454,    0,
    0,    0,    0,    0,    0,   28,    0,    0,  885,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  288,
 1047, 1053, -249,  -51, -177,  377, 1162,    0,    0,    0,
 -418,   17,  881, -375,
};
#define YYTABLESIZE 1564
const short yytable[] = {                                     180,
  249,  427,  280,  184,  281,  362,  188,  319,  321,  323,
  204,  141,  207,  282,  283,  141,  154,  448,  491,  206,
  154,  345,  221,  350,  223,  353,  484,  152,  141,  325,
  357,  152,  211,  154,  230,  156,  187,  202,  347,  240,
  657,  243,  155,  197,  152,  595,  254,  240,  434,  415,
  334,  446,  335,  187,  530,  640,  584,  579,  524,  732,
  641,  531,  525,  528,  529,  527,  141,  393,  394,  141,
  331,  187,  141,  660,  758,  361,  526,  154,  532,  659,
  407,  303,  407,  407,  407,  757,  639,  372,  152,  441,
  685,  405,  339,  443,  405,  339,  187,  407,  378,  274,
  329,  407,  181,  133,  139,  208,  554,  276,  374,  419,
  419,  374,  419,  434,  419,  276,  343,  405,  261,  262,
  405,  197,  264,  269,  269,  419,  275,  277,  273,  451,
  210,  265,  270,  270,  451,  196,  290,  291,  295,  197,
  209,  340,  232,  356,  439,  226,  451,  396,  440,  141,
  396,  346,  146,  330,  214,  242,  141,  298,  360,  391,
  358,  154,  300,  359,  258,  399,  407,  219,  399,  796,
  371,  403,  152,  299,  403,  213,  500,  405,  339,  341,
  603,  377,  188,  133,  139,  595,  530,  220,  503,  289,
  524,  347,  751,  531,  525,  528,  529,  527,  227,  659,
  615,  276,  688,  197,  683,  398,  599,  397,  526,  141,
  532,  719,  720,  354,  154,  253,   37,  403,  202,  556,
  557,  268,  380,  642,  379,  152,  355,  382,  633,  386,
  228,  438,  146,  396,  581,  434,  447,  182,  183,  170,
  422,  404,  390,  549,  404,  401,  182,  183,  460,  232,
  460,  399,  156,  156,  460,  315,  460,  403,  449,  450,
  478,    3,  482,  182,  183,  269,  186,  487,  400,  414,
  482,  400,  434,  397,  270,  253,  397,  669,  519,  141,
  141,  490,  170,  186,  520,  521,  522,  449,  450,  295,
  499,  170,  449,  450,  237,  523,  296,  508,  509,  141,
  402,  186,  639,  156,  639,  449,  450,  406,  542,  407,
  407,  407,  407,  407,  139,  139,  697,  449,  450,  286,
  405,  405,  405,  405,  405,  303,  186,  404,  350,  728,
  353,  399,  345,  133,  139,  472,  400,   34,    2,    3,
  188,  182,  183,  419,  419,  278,  405,  405,  405,  405,
  405,  182,  183,  204,  400,  252,    2,    3,  413,  397,
  421,  511,  506,  569,  518,  287,  577,  141,  150,  141,
  544,  218,  154,  324,  154,  382,  202,  548,  202,  396,
  396,  434,  170,  152,  552,  152,  303,  553,  648,  398,
  405,  652,  398,  591,  421,  254,  399,  399,  399,  303,
  431,  403,  403,  403,  403,  264,  182,  183,  706,  435,
  519,  760,  435,  269,  265,  465,  520,  521,  522,  303,
  182,  458,  270,  182,  183,  182,  183,  523,  389,  452,
  452,  452,  452,  452,  517,  452,  182,  183,  182,  183,
  280,  412,  281,  420,  633,  342,  452,  418,  150,  452,
  452,  282,  283,  326,  166,  476,  477,  246,  694,  245,
  454,  454,  454,  454,  454,  454,  421,  454,  328,  452,
  610,  404,  404,  404,  404,  398,  452,  423,  671,  672,
  249,  456,  332,  430,  753,  182,  183,  756,  675,  582,
    2,    3,  583,  188,  624,  435,  303,  632,  464,  400,
  400,  400,  643,  619,  333,  397,  397,  302,  300,  452,
  246,  696,  245,  452,  341,  452,  336,  516,  354,  299,
  736,  337,  690,  172,  176,  178,  303,  320,  434,  316,
  249,  317,  246,  339,  245,  303,  215,  455,  455,  455,
  455,  455,  455,  342,  455,  386,  709,  293,  482,  573,
  216,  712,  668,  396,  332,  217,  643,  643,  457,  699,
  601,  790,  320,  602,  317,  246,  643,  245,  349,  297,
  499,  499,  419,  419,  419,  419,  686,  419,  150,  150,
  689,  482,  449,  450,  453,  453,  453,  453,  453,  365,
  453,  369,  761,  799,  695,  490,  789,  341,  366,  741,
  367,  453,  373,  693,  453,  453,  172,  176,  178,  375,
  320,  389,  420,  420,  420,  420,  420,  376,  420,  703,
  242,  398,  398,  242,  300,  385,  464,  392,  429,  420,
  303,  429,  249,  420,  794,  299,  322,  242,  317,  246,
  591,  245,  511,  511,  765,  511,  452,  395,  604,  452,
  453,  602,  166,  453,  317,  246,  738,  245,  452,  452,
  452,  452,  452,  452,  452,  452,  569,  453,    2,    3,
  453,    2,    3,  404,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  729,  730,  246,  407,  245,  408,  301,
  454,  454,  454,  454,  454,  410,  454,  454,  420,  437,
  433,  763,  437,  166,  419,  317,  246,  591,  245,  182,
  183,  605,  238,  632,  602,  769,  437,  798,  239,  643,
  275,  275,  570,  571,    2,    3,  802,  158,  159,  160,
  161,  162,  163,  164,  165,  591,  593,  594,  166,  569,
  708,  246,  301,  245,  424,  426,    2,    3,  569,  158,
  159,  160,  161,  162,  163,  164,  165,  302,  273,  273,
  246,  228,  245,  230,  301,  414,  230,  455,  455,  455,
  455,  455,  555,  455,  455,  558,  559,  428,  795,    2,
    3,  429,  158,  159,  160,  161,  162,  163,  164,  165,
  166,  268,  216,  246,  442,  245,  444,  301,  445,  275,
  419,  419,  419,  419,  419,  451,  419,  419,  158,  159,
  160,  161,  162,  453,  453,  453,  453,  453,  606,  453,
  453,  602,  611,  166,  452,  612,  246,  454,  245,  415,
  415,  415,  415,  415,  455,  415,  613,  273,  467,  614,
  456,  420,  420,  420,  420,  420,  415,  420,  420,  618,
  415,  469,  614,    2,    3,  471,  158,  159,  160,  161,
  162,  163,  164,  165,  408,  480,  408,  408,  408,  457,
  458,  301,  158,  159,  160,  161,  162,  163,  164,  165,
  409,  408,  409,  409,  409,  408,  620,  301,  621,  602,
  649,  622,  661,  650,  492,  602,  502,  409,  166,    2,
    3,  409,  158,  159,  160,  161,  162,  163,  164,  165,
  244,  663,  494,  166,  664,  415,  246,  301,  245,  670,
    2,    3,  602,  158,  159,  160,  161,  162,  163,  164,
  165,  433,  411,  507,  411,  411,  411,  687,  301,  747,
  583,  755,  748,  774,  583,  775,  614,  510,  650,  411,
  408,  564,  166,  411,  167,    2,    3,  545,  158,  159,
  160,  161,  162,  163,  164,  165,  409,  631,  410,  630,
  410,  410,  410,  301,    2,    3,  546,  158,  159,  160,
  161,  162,  163,  164,  165,  410,  560,  565,  166,  410,
  495,  246,  301,  245,  339,  382,  574,  339,  382,  166,
  580,  567,  246,  442,  245,  585,  442,    2,    3,  586,
  158,  159,  160,  161,  162,  163,  164,  165,  411,  166,
  578,  587,  246,  392,  245,  301,  392,  592,  596,  111,
  166,  682,  111,  246,  121,  245,  122,  121,  607,  122,
    2,    3,  600,  158,  159,  160,  161,  162,  163,  164,
  165,  608,  166,  617,  410,  246,  684,  245,  415,  415,
  415,  415,  415,  166,  623,  716,  246,  466,  245,  616,
   10,  468,   12,  470,  166,   15,  647,  246,  653,  245,
   20,   21,   22,  436,  651,  314,  436,  167,  190,  384,
  493,  190,  384,  408,  408,  408,  408,  408,  655,  631,
  393,  630,   41,  393,   43,  317,  279,  658,  317,  409,
  409,  409,  409,  409,   51,    2,    3,  656,  158,  159,
  160,  161,  162,  163,  164,  165,  394,  543,  662,  394,
    2,    3,  665,  158,  159,  160,  161,  162,  163,  164,
  165,  666,  673,  674,  676,  681,  691,  692,  700,  701,
  718,  702,  705,  713,  714,  721,  723,  724,  563,  726,
  727,  411,  411,  411,  411,  411,  734,  733,  735,    2,
    3,  737,  158,  159,  160,  161,  162,  163,  164,  165,
  743,  182,  183,  744,  626,  159,  160,  161,  162,  627,
  628,  629,  745,  746,  750,   59,  749,  410,  410,  410,
  410,  410,  752,  754,  759,    2,    3,  762,  158,  159,
  160,  161,  162,  163,  164,  165,    2,    3,  764,  158,
  159,  160,  161,  162,  163,  164,  165,  768,  771,  776,
  781,  785,  787,  772,  777,  778,    2,    3,  791,  158,
  159,  160,  161,  162,  163,  164,  165,    2,    3,  779,
  158,  159,  160,  161,  162,  163,  164,  165,  780,  783,
  784,  786,  792,  793,  797,  801,  800,    2,  283,    2,
    3,    1,  158,  159,  160,  161,  162,  163,  164,  165,
    2,    3,   87,  158,  159,  160,  161,  162,  163,  164,
  165,    2,    3,   88,  158,  159,  160,  161,  162,  163,
  164,  165,    2,    3,   89,  158,  159,  160,  161,  162,
  163,  164,  165,  182,  183,  465,  158,  159,  160,  161,
  162,  627,  628,  629,    1,    2,    3,    4,  287,   75,
   79,   82,   92,   88,  289,  370,  390,  345,  239,  371,
  391,  320,   95,  346,  301,   96,    5,    6,    7,    8,
    9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
   19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
   29,   30,   31,   32,  217,   33,   34,   35,   36,   37,
   38,   39,   40,   41,   42,   43,   44,  307,   45,   46,
   47,  236,   48,   49,   50,   51,   52,   53,   54,   55,
   56,  260,  156,   57,  294,   58,    1,    2,    3,  157,
  212,  263,  773,  715,  731,  717,  381,  344,  501,  572,
  547,  566,  679,  782,  667,  767,  770,  625,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,  561,   33,   34,   35,
   36,   37,   38,  257,   40,   41,   42,   43,   44,  788,
   45,   46,   47,  504,   48,   49,   50,   51,   52,   53,
   54,   55,   56,    2,    3,   57,   10,   58,   12,  698,
  654,   15,  704,  486,  710,    0,   20,   21,   22,    0,
  597,    0,    0,    0,    5,    6,    7,  598,    0,    0,
   11,    0,   13,    0,    0,   16,    0,    0,   41,    0,
   43,    0,    0,    0,    0,  292,    0,   28,    0,    0,
   51,    0,    0,    0,    0,   35,   36,   37,    0,    0,
   40,    0,    0,    0,    0,    0,   45,    0,   47,    0,
   48,    0,   50,    0,   52,   53,    0,   55,    0,  293,
    0,   57,    0,   58,
};
const short yycheck[] = {                                       6,
   52,  278,  138,   11,  138,  207,   14,  149,  150,  151,
   18,    0,   19,  138,  138,    4,    0,  302,  336,   18,
    4,  190,   30,  197,   32,  197,   41,    0,   17,  152,
  198,    4,  127,   17,   42,   40,   47,   17,  191,   47,
  532,   49,  127,   40,   17,  452,   54,   55,   62,   40,
  173,  301,  175,   47,   36,   41,  439,  433,   40,   41,
   41,   43,   44,   45,   46,   47,   44,  245,  246,   47,
   44,   47,   61,   41,  692,   44,   58,   61,   60,  534,
   41,  147,   43,   44,   45,   41,  505,   44,   61,  291,
  582,   41,   41,  295,   44,   44,   47,   58,   44,  132,
  166,   62,  290,   47,   47,  288,  391,  127,   41,   42,
   43,   44,   45,  127,   47,   41,  127,   41,  126,  127,
   44,   40,  130,  131,  132,   58,  134,  135,   44,   41,
   40,  130,  131,  132,   58,  127,  144,  144,  145,   40,
  323,   47,   47,   44,   40,  334,   58,   41,   44,  127,
   44,  127,   47,  127,   40,   48,  145,  146,  127,   44,
   44,  145,  146,   47,   57,   41,  127,  127,   44,  787,
  127,   41,  145,  146,   44,   24,  127,  127,  127,  187,
  465,  127,  190,  127,  127,  592,   36,  127,  356,   40,
   40,  344,  684,   43,   44,   45,   46,   47,   40,  654,
  485,  127,  585,   40,  580,   43,  456,   45,   58,  198,
   60,  630,  631,  197,  198,   47,  311,   44,  198,  397,
  398,   42,  127,   42,  232,  198,  127,  235,  505,  237,
  266,  127,  127,  127,  436,  287,  302,  257,  258,    5,
  273,   41,  127,  385,   44,  253,  257,  258,  314,   47,
  316,  127,  257,  258,  320,  148,  322,  127,  273,  274,
  326,  258,  328,  257,  258,  273,  277,  333,   41,  260,
  336,   44,  324,   41,  273,   47,   44,  562,  260,  257,
  258,  333,   48,  277,  266,  267,  268,  273,  274,  296,
  342,   57,  273,  274,   40,  277,  145,  363,  364,  277,
  127,  277,  721,  308,  723,  273,  274,   44,  374,  270,
  271,  272,  273,  274,  257,  258,  601,  273,  274,   61,
  270,  271,  272,  273,  274,  391,  277,  127,  502,  647,
  502,   42,  501,  277,  277,  324,   47,  308,  257,  258,
  348,  257,  258,  276,  277,   42,  270,  271,  272,  273,
  274,  257,  258,  361,  127,  127,  257,  258,   44,  127,
   44,  369,  361,  415,  372,   40,  432,  356,   47,  358,
  378,  127,  356,   40,  358,  383,  356,  385,  358,  273,
  274,  433,  148,  356,   41,  358,  452,   44,  511,   41,
  127,  514,   44,  445,   44,  403,  272,  273,  274,  465,
   44,  271,  272,  273,  274,  413,  257,  258,  610,   41,
  260,  696,   44,  421,  413,   44,  266,  267,  268,  485,
  257,  258,  421,  257,  258,  257,  258,  277,   40,   41,
   42,   43,   44,   45,   44,   47,  257,  258,  257,  258,
  576,  127,  576,  127,  721,   40,   58,   42,  127,   61,
   62,  576,  576,   40,   40,   41,   42,   43,  600,   45,
   40,   41,   42,   43,   44,   45,   44,   47,   40,   44,
  477,  271,  272,  273,  274,  127,   44,  127,  564,  565,
  532,   61,  277,  127,  686,  257,  258,  689,  574,   41,
  257,  258,   44,  501,  502,  127,  562,  505,  127,  272,
  273,  274,  510,  492,   40,  273,  274,   40,  492,   44,
   43,   44,   45,   44,   44,  127,   40,  127,  502,  492,
  662,  260,  588,   44,   44,   44,  592,   44,  580,   40,
  582,   42,   43,   40,   45,  601,  292,   40,   41,   42,
   43,   44,   45,   40,   47,  553,  612,  333,  614,  127,
  306,  617,  127,  276,  277,  311,  564,  565,   61,  127,
   41,  763,   40,   44,   42,   43,  574,   45,   44,  336,
  622,  623,   42,   43,   44,   45,  583,   47,  257,  258,
  587,  647,  273,  274,   41,   42,   43,   44,   45,  127,
   47,   40,  127,  795,  127,  647,  127,  127,  127,  665,
  127,   58,   40,  592,   61,   62,  127,  127,  127,  127,
  127,  127,   41,   42,   43,   44,   45,   40,   47,  608,
   44,  273,  274,   47,  608,   40,   42,  127,   44,   58,
  696,   47,  684,   62,  776,  608,   40,   61,   42,   43,
  692,   45,  650,  651,  718,  653,   44,  127,   41,   47,
   44,   44,   40,   47,   42,   43,  664,   45,  270,  271,
  272,  273,  274,   61,  276,  277,  718,   61,  257,  258,
  127,  257,  258,  127,  260,  261,  262,  263,  264,  265,
  266,  267,   40,  650,  651,   43,   40,   45,  127,  275,
  270,  271,  272,  273,  274,  127,  276,  277,  127,   41,
   58,  708,   44,   40,   42,   42,   43,  759,   45,  257,
  258,   41,  260,  721,   44,  723,   58,  791,  266,  727,
  257,  258,  418,  419,  257,  258,  800,  260,  261,  262,
  263,  264,  265,  266,  267,  787,  449,  450,   40,  791,
   42,   43,  275,   45,  127,  127,  257,  258,  800,  260,
  261,  262,  263,  264,  265,  266,  267,   40,  257,  258,
   43,   42,   45,   44,  275,  260,   47,  270,  271,  272,
  273,  274,  396,  276,  277,  399,  400,  127,  785,  257,
  258,   40,  260,  261,  262,  263,  264,  265,  266,  267,
   40,   42,  306,   43,  127,   45,   40,  275,   61,  336,
  270,  271,  272,  273,  274,  127,  276,  277,  260,  261,
  262,  263,  264,  270,  271,  272,  273,  274,   41,  276,
  277,   44,   41,   40,   44,   44,   43,  272,   45,   41,
   42,   43,   44,   45,  271,   47,   41,  336,  127,   44,
  270,  270,  271,  272,  273,  274,   58,  276,  277,   41,
   62,  127,   44,  257,  258,  127,  260,  261,  262,  263,
  264,  265,  266,  267,   41,  127,   43,   44,   45,  257,
  258,  275,  260,  261,  262,  263,  264,  265,  266,  267,
   41,   58,   43,   44,   45,   62,   41,  275,   41,   44,
   41,   44,   41,   44,  334,   44,   44,   58,   40,  257,
  258,   62,  260,  261,  262,  263,  264,  265,  266,  267,
  127,   41,   47,   40,   44,  127,   43,  275,   45,   41,
  257,  258,   44,  260,  261,  262,  263,  264,  265,  266,
  267,   58,   41,   44,   43,   44,   45,   41,  275,   41,
   44,   41,   44,   41,   44,   41,   44,   40,   44,   58,
  127,   40,   40,   62,   42,  257,  258,   47,  260,  261,
  262,  263,  264,  265,  266,  267,  127,   43,   41,   45,
   43,   44,   45,  275,  257,  258,   44,  260,  261,  262,
  263,  264,  265,  266,  267,   58,   47,   40,   40,   62,
   42,   43,  275,   45,   41,   41,   40,   44,   44,   40,
   58,   42,   43,   41,   45,   40,   44,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,  127,   40,
   41,   44,   43,   41,   45,  275,   44,   44,  127,   41,
   40,   41,   44,   43,   41,   45,   41,   44,   41,   44,
  257,  258,   61,  260,  261,  262,  263,  264,  265,  266,
  267,   44,   40,   44,  127,   43,   44,   45,  270,  271,
  272,  273,  274,   40,   58,   42,   43,  316,   45,   41,
  283,  320,  285,  322,   40,  288,   40,   43,   40,   45,
  293,  294,  295,   41,   44,   40,   44,   42,   41,   41,
  339,   44,   44,  270,  271,  272,  273,  274,  260,   43,
   41,   45,  315,   44,  317,   41,  319,   41,   44,  270,
  271,  272,  273,  274,  327,  257,  258,  260,  260,  261,
  262,  263,  264,  265,  266,  267,   41,  376,   61,   44,
  257,  258,   61,  260,  261,  262,  263,  264,  265,  266,
  267,  127,   41,   41,  269,   41,  127,   44,  127,  127,
   61,  127,  127,  127,  127,   44,   42,  127,  407,   41,
   44,  270,  271,  272,  273,  274,  127,   62,  127,  257,
  258,  127,  260,  261,  262,  263,  264,  265,  266,  267,
   41,  257,  258,   41,  260,  261,  262,  263,  264,  265,
  266,  267,   41,   45,   41,  127,  127,  270,  271,  272,
  273,  274,  127,  127,   61,  257,  258,  127,  260,  261,
  262,  263,  264,  265,  266,  267,  257,  258,  127,  260,
  261,  262,  263,  264,  265,  266,  267,   47,  333,   61,
  269,   44,   44,  127,  127,  127,  257,  258,   44,  260,
  261,  262,  263,  264,  265,  266,  267,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,  127,  127,
  127,  127,   41,  127,   41,  127,   44,    0,  127,  257,
  258,    0,  260,  261,  262,  263,  264,  265,  266,  267,
  257,  258,  308,  260,  261,  262,  263,  264,  265,  266,
  267,  257,  258,  308,  260,  261,  262,  263,  264,  265,
  266,  267,  257,  258,  308,  260,  261,  262,  263,  264,
  265,  266,  267,  257,  258,  260,  260,  261,  262,  263,
  264,  265,  266,  267,  256,  257,  258,  259,  127,   40,
   40,   40,   40,   40,  127,   41,   41,   41,  127,   41,
   41,   44,   41,   41,  127,   41,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,  305,   47,  307,  308,  309,  310,  311,
  312,  313,  314,  315,  316,  317,  318,  127,  320,  321,
  322,   41,  324,  325,  326,  327,  328,  329,  330,  331,
  332,   61,    4,  335,  145,  337,  256,  257,  258,    4,
   24,  128,  727,  622,  653,  623,  233,  190,  348,  421,
  383,  413,  576,  748,  553,  721,  723,  502,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  403,  307,  308,  309,
  310,  311,  312,   55,  314,  315,  316,  317,  318,  759,
  320,  321,  322,  358,  324,  325,  326,  327,  328,  329,
  330,  331,  332,  257,  258,  335,  283,  337,  285,  602,
  524,  288,  608,  332,  614,   -1,  293,  294,  295,   -1,
  454,   -1,   -1,   -1,  278,  279,  280,  455,   -1,   -1,
  284,   -1,  286,   -1,   -1,  289,   -1,   -1,  315,   -1,
  317,   -1,   -1,   -1,   -1,  299,   -1,  301,   -1,   -1,
  327,   -1,   -1,   -1,   -1,  309,  310,  311,   -1,   -1,
  314,   -1,   -1,   -1,   -1,   -1,  320,   -1,  322,   -1,
  324,   -1,  326,   -1,  328,  329,   -1,  331,   -1,  333,
   -1,  335,   -1,  337,
};
#define YYFINAL 60
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 339
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'$'",0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,
0,0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"EOS",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"tok_identifier","tok_array_identifier","tok_label",
"tok_integer_const","tok_real_const","tok_dp_const","tok_complex_const",
"tok_dcomplex_const","tok_logical_const","tok_string","tok_hollerith",
"tok_edit_descriptor","tok_letter","tok_relop","tok_AND","tok_OR","tok_EQV",
"tok_NEQV","tok_NOT","tok_power","tok_concat","tok_ACCEPT","tok_ASSIGN",
"tok_BACKSPACE","tok_BLOCK","tok_BLOCKDATA","tok_BYTE","tok_CALL",
"tok_CHARACTER","tok_CLOSE","tok_COMMON","tok_COMPLEX","tok_CONTINUE",
"tok_DATA","tok_DIMENSION","tok_DO","tok_DOUBLE","tok_DOUBLECOMPLEX",
"tok_DOUBLEPRECISION","tok_DOWHILE","tok_ELSE","tok_ELSEIF","tok_END",
"tok_ENDDO","tok_ENDFILE","tok_ENDIF","tok_ENTRY","tok_EQUIVALENCE",
"tok_EXTERNAL","tok_FILE","tok_FORMAT","tok_FUNCTION","tok_GO","tok_GOTO",
"tok_IF","tok_IMPLICIT","tok_INCLUDE","tok_INQUIRE","tok_INTEGER",
"tok_INTRINSIC","tok_LOGICAL","tok_NAMELIST","tok_NONE","tok_OPEN",
"tok_PARAMETER","tok_PAUSE","tok_PRECISION","tok_PRINT","tok_PROGRAM",
"tok_READ","tok_REAL","tok_RETURN","tok_REWIND","tok_SAVE","tok_STOP",
"tok_SUBROUTINE","tok_THEN","tok_TO","tok_TYPE","tok_WHILE","tok_WRITE",
"tok_illegal","REDUCE",
};
const char * const yyrule[] = {
"$accept : prog_body",
"prog_body : stmt_list",
"prog_body :",
"stmt_list : stmt_list_item",
"stmt_list : stmt_list stmt_list_item",
"stmt_list_item : ordinary_stmt",
"stmt_list_item : include_stmt",
"stmt_list_item : EOS",
"ordinary_stmt : stmt",
"ordinary_stmt : end_stmt",
"stmt : tok_label unlabeled_stmt",
"stmt : unlabeled_stmt",
"unlabeled_stmt : subprogram_header",
"unlabeled_stmt : specification_stmt",
"unlabeled_stmt : executable_stmt",
"unlabeled_stmt : restricted_stmt",
"unlabeled_stmt : error EOS",
"subprogram_header : prog_stmt",
"subprogram_header : function_stmt",
"subprogram_header : subroutine_stmt",
"subprogram_header : block_data_stmt",
"end_stmt : unlabeled_end_stmt",
"end_stmt : tok_label unlabeled_end_stmt",
"unlabeled_end_stmt : tok_END EOS",
"include_stmt : tok_INCLUDE tok_string EOS",
"specification_stmt : anywhere_stmt",
"specification_stmt : parameter_stmt",
"specification_stmt : implicit_stmt",
"specification_stmt : data_stmt",
"specification_stmt : specif_stmt",
"anywhere_stmt : entry_stmt",
"anywhere_stmt : format_stmt",
"specif_stmt : dimension_stmt",
"specif_stmt : equivalence_stmt",
"specif_stmt : common_stmt",
"specif_stmt : namelist_stmt",
"specif_stmt : type_stmt",
"specif_stmt : external_stmt",
"specif_stmt : intrinsic_stmt",
"specif_stmt : save_stmt",
"executable_stmt : transfer_stmt",
"executable_stmt : nontransfer_stmt",
"transfer_stmt : unconditional_goto",
"transfer_stmt : assigned_goto",
"transfer_stmt : arithmetic_if_stmt",
"transfer_stmt : stop_stmt",
"transfer_stmt : return_stmt",
"nontransfer_stmt : assignment_stmt",
"nontransfer_stmt : assign_stmt",
"nontransfer_stmt : computed_goto",
"nontransfer_stmt : continue_stmt",
"nontransfer_stmt : pause_stmt",
"nontransfer_stmt : read_stmt",
"nontransfer_stmt : accept_stmt",
"nontransfer_stmt : write_stmt",
"nontransfer_stmt : print_stmt",
"nontransfer_stmt : type_output_stmt",
"nontransfer_stmt : rewind_stmt",
"nontransfer_stmt : backspace_stmt",
"nontransfer_stmt : endfile_stmt",
"nontransfer_stmt : open_stmt",
"nontransfer_stmt : close_stmt",
"nontransfer_stmt : inquire_stmt",
"nontransfer_stmt : call_stmt",
"restricted_stmt : restricted_nontransfer_stmt",
"restricted_stmt : else_or_endif_stmt",
"restricted_nontransfer_stmt : logical_if_stmt",
"restricted_nontransfer_stmt : block_if_stmt",
"restricted_nontransfer_stmt : do_stmt",
"restricted_nontransfer_stmt : enddo_stmt",
"else_or_endif_stmt : else_if_stmt",
"else_or_endif_stmt : else_stmt",
"else_or_endif_stmt : end_if_stmt",
"prog_stmt : tok_PROGRAM symbolic_name EOS",
"entry_stmt : tok_ENTRY symbolic_name EOS",
"$$1 :",
"entry_stmt : tok_ENTRY symbolic_name $$1 '(' dummy_argument_list ')' EOS",
"function_stmt : unlabeled_function_stmt",
"unlabeled_function_stmt : typed_function_handle symbolic_name EOS",
"$$2 :",
"unlabeled_function_stmt : typed_function_handle symbolic_name $$2 '(' dummy_argument_list ')' EOS",
"unlabeled_function_stmt : plain_function_handle symbolic_name EOS",
"$$3 :",
"unlabeled_function_stmt : plain_function_handle symbolic_name $$3 '(' dummy_argument_list ')' EOS",
"typed_function_handle : type_name function_keyword",
"plain_function_handle : function_keyword",
"function_keyword : tok_FUNCTION",
"type_name : arith_type_name",
"type_name : plain_char_type_name",
"type_name : char_type_name",
"subroutine_stmt : unlabeled_subroutine_stmt",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name EOS",
"$$4 :",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name $$4 '(' dummy_argument_list ')' EOS",
"subroutine_handle : tok_SUBROUTINE",
"dummy_argument_list :",
"dummy_argument_list : non_empty_arg_list",
"non_empty_arg_list : dummy_argument",
"non_empty_arg_list : non_empty_arg_list ',' dummy_argument",
"dummy_argument : symbolic_name",
"dummy_argument : '*'",
"block_data_stmt : block_data_handle EOS",
"block_data_stmt : block_data_handle symbolic_name EOS",
"block_data_handle : tok_BLOCK tok_DATA",
"block_data_handle : tok_BLOCKDATA",
"dimension_stmt : tok_DIMENSION array_declarator_list EOS",
"array_declarator_list : array_declarator",
"array_declarator_list : array_declarator_list ',' array_declarator",
"array_declarator : symbolic_name '(' dim_bound_list ')'",
"dim_bound_list : dim_bound_item",
"dim_bound_list : dim_bound_list ',' dim_bound_item",
"dim_bound_item : dim_bound_expr",
"dim_bound_item : dim_bound_expr ':' dim_bound_expr",
"dim_bound_item : '*'",
"dim_bound_item : dim_bound_expr ':' '*'",
"$$5 :",
"equivalence_stmt : tok_EQUIVALENCE $$5 equivalence_list EOS",
"equivalence_list : '(' equivalence_list_item ')'",
"equivalence_list : equivalence_list ',' '(' equivalence_list_item ')'",
"equivalence_list_item : equiv_entity ',' equiv_entity",
"equivalence_list_item : equivalence_list_item ',' equiv_entity",
"equiv_entity : symbolic_name",
"equiv_entity : array_equiv_name",
"equiv_entity : substring_equiv_name",
"array_equiv_name : symbolic_name '(' subscript_list ')'",
"substring_equiv_name : symbolic_name substring_interval",
"substring_equiv_name : array_equiv_name substring_interval",
"common_stmt : tok_COMMON common_variable_list EOS",
"common_stmt : tok_COMMON common_block_list EOS",
"common_stmt : tok_COMMON common_variable_list common_block_list EOS",
"common_block_list : labeled_common_block",
"common_block_list : common_block_list labeled_common_block",
"$$6 :",
"labeled_common_block : common_block_name $$6 common_variable_list",
"common_block_name : '/' symbolic_name '/'",
"common_block_name : '/' '/'",
"common_block_name : tok_concat",
"common_variable_list : common_list_item",
"common_variable_list : common_variable_list common_list_item",
"common_list_item : common_entity",
"common_list_item : common_entity ','",
"common_entity : symbolic_name",
"common_entity : array_declarator",
"namelist_stmt : tok_NAMELIST namelist_list EOS",
"namelist_list : namelist_decl",
"namelist_list : namelist_list namelist_decl",
"namelist_decl : namelist_name namelist_var_list",
"namelist_name : '/' symbolic_name '/'",
"namelist_var_list : namelist_item",
"namelist_var_list : namelist_var_list namelist_item",
"namelist_item : symbolic_name",
"namelist_item : symbolic_name ','",
"type_stmt : arith_type_name arith_type_decl_list EOS",
"type_stmt : plain_char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name ',' char_type_decl_list EOS",
"arith_type_name : sizeable_type_name",
"arith_type_name : sizeable_type_name '*' nonzero_unsigned_int_const",
"arith_type_name : unsizeable_type_name",
"sizeable_type_name : tok_INTEGER",
"sizeable_type_name : tok_REAL",
"sizeable_type_name : tok_COMPLEX",
"sizeable_type_name : tok_LOGICAL",
"unsizeable_type_name : tok_DOUBLE tok_PRECISION",
"unsizeable_type_name : tok_DOUBLEPRECISION",
"unsizeable_type_name : tok_DOUBLE tok_COMPLEX",
"unsizeable_type_name : tok_DOUBLECOMPLEX",
"unsizeable_type_name : tok_BYTE",
"plain_char_type_name : tok_CHARACTER",
"char_type_name : plain_char_type_name '*' len_specification",
"arith_type_decl_list : arith_type_decl_item",
"arith_type_decl_list : arith_type_decl_list ',' arith_type_decl_item",
"arith_type_decl_item : symbolic_name",
"arith_type_decl_item : array_declarator",
"char_type_decl_list : char_type_decl_item",
"char_type_decl_list : char_type_decl_list ',' char_type_decl_item",
"char_type_decl_item : symbolic_name",
"char_type_decl_item : symbolic_name '*' len_specification",
"char_type_decl_item : array_declarator",
"char_type_decl_item : array_declarator '*' len_specification",
"implicit_handle : tok_IMPLICIT",
"implicit_stmt : implicit_handle implicit_decl_list EOS",
"implicit_stmt : implicit_handle tok_NONE EOS",
"implicit_decl_list : implicit_decl_item",
"$$7 :",
"implicit_decl_list : implicit_decl_list ',' $$7 implicit_decl_item",
"$$8 :",
"implicit_decl_item : type_name '(' $$8 letter_list ')'",
"letter_list : letter_list_item",
"letter_list : letter_list ',' letter_list_item",
"letter_list_item : tok_letter",
"letter_list_item : tok_letter '-' tok_letter",
"len_specification : '(' '*' ')'",
"len_specification : nonzero_unsigned_int_const",
"len_specification : '(' int_constant_expr ')'",
"parameter_stmt : tok_PARAMETER '(' parameter_defn_list ')' EOS",
"parameter_defn_list : parameter_defn_item",
"parameter_defn_list : parameter_defn_list ',' parameter_defn_item",
"$$9 :",
"parameter_defn_item : symbolic_name $$9 '=' parameter_expr",
"external_stmt : tok_EXTERNAL external_name_list EOS",
"external_name_list : symbolic_name",
"external_name_list : external_name_list ',' symbolic_name",
"intrinsic_stmt : tok_INTRINSIC intrinsic_name_list EOS",
"intrinsic_name_list : symbolic_name",
"intrinsic_name_list : intrinsic_name_list ',' symbolic_name",
"save_stmt : tok_SAVE EOS",
"save_stmt : tok_SAVE save_list EOS",
"save_list : save_item",
"save_list : save_list ',' save_item",
"save_item : symbolic_name",
"save_item : '/' symbolic_name '/'",
"data_stmt : tok_DATA data_defn_list EOS",
"data_defn_list : data_defn_item",
"data_defn_list : data_defn_list data_defn_item",
"data_defn_list : data_defn_list ',' data_defn_item",
"$$10 :",
"$$11 :",
"data_defn_item : data_defn_assignee_list '/' $$10 data_value_list $$11 '/'",
"data_defn_assignee_list : data_defn_assignee",
"data_defn_assignee_list : data_defn_assignee_list ',' data_defn_assignee",
"data_defn_assignee : lvalue",
"data_defn_assignee : data_implied_do_list",
"data_value_list : data_value",
"data_value_list : data_value_list ',' data_value",
"data_value : data_constant_value",
"data_value : data_repeat_factor '*' data_constant_value",
"data_repeat_factor : nonzero_unsigned_int_const",
"data_repeat_factor : symbolic_name",
"data_constant_value : data_constant",
"data_constant_value : symbolic_name",
"data_dlist : data_dlist_item",
"data_dlist : data_dlist ',' data_dlist_item",
"data_dlist_item : array_element_lvalue",
"data_dlist_item : data_implied_do_list",
"data_implied_do_list : '(' data_dlist ',' symbolic_name '=' data_do_loop_bounds ')'",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr ',' int_constant_expr",
"$$12 :",
"$$13 :",
"assignment_stmt : lvalue '=' $$12 expr $$13 EOS",
"lvalue : variable_name",
"lvalue : array_element_lvalue",
"lvalue : substring_lvalue",
"lvalue : stmt_function_handle",
"assign_stmt : tok_ASSIGN pre_label label tok_TO variable_name EOS",
"unconditional_goto : goto pre_label label EOS",
"computed_goto : goto '(' goto_list ')' integer_expr EOS",
"computed_goto : goto '(' goto_list ')' ',' integer_expr EOS",
"assigned_goto : goto symbolic_name EOS",
"assigned_goto : goto symbolic_name '(' goto_list ')' EOS",
"assigned_goto : goto symbolic_name ',' '(' goto_list ')' EOS",
"goto : tok_GOTO",
"goto : tok_GO tok_TO",
"goto_list : pre_label label",
"goto_list : goto_list ',' pre_label label",
"arithmetic_if_stmt : if_handle pre_label label ',' pre_label label ',' pre_label label EOS",
"logical_if_stmt : if_handle executable_stmt",
"block_if_stmt : if_handle tok_THEN EOS",
"$$14 :",
"if_handle : tok_IF '(' $$14 expr ')'",
"else_if_stmt : tok_ELSE block_if_stmt",
"$$15 :",
"$$16 :",
"else_if_stmt : tok_ELSEIF '(' $$15 expr ')' $$16 tok_THEN EOS",
"else_stmt : tok_ELSE EOS",
"end_if_stmt : tok_ENDIF EOS",
"end_if_stmt : tok_END tok_IF EOS",
"do_stmt : do_handle variable_name '=' do_loop_bounds EOS",
"$$17 :",
"do_stmt : do_handle tok_WHILE '(' $$17 expr ')' EOS",
"$$18 :",
"do_stmt : tok_DOWHILE '(' $$18 expr ')' EOS",
"do_handle : tok_DO pre_label label",
"do_handle : tok_DO pre_label label ','",
"do_handle : tok_DO pre_label",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr ',' int_real_dp_expr",
"enddo_stmt : tok_END tok_DO EOS",
"enddo_stmt : tok_ENDDO EOS",
"continue_stmt : tok_CONTINUE EOS",
"stop_stmt : tok_STOP stop_info EOS",
"pause_stmt : tok_PAUSE stop_info EOS",
"stop_info :",
"stop_info : tok_integer_const",
"stop_info : symbolic_name",
"stop_info : tok_string",
"$$19 :",
"write_stmt : write_handle $$19 EOS",
"$$20 :",
"write_stmt : write_handle io_list $$20 EOS",
"$$21 :",
"write_handle : tok_WRITE $$21 '(' control_info_list ')'",
"read_stmt : read_handle '(' control_info_list ')' EOS",
"read_stmt : read_handle '(' control_info_list ')' io_list EOS",
"read_stmt : read_handle '(' control_info_list ')' ',' io_list EOS",
"read_stmt : read_handle format_id EOS",
"read_stmt : read_handle format_id ',' io_list EOS",
"read_handle : tok_READ",
"accept_stmt : tok_ACCEPT format_id EOS",
"$$22 :",
"$$23 :",
"accept_stmt : tok_ACCEPT format_id ',' $$22 io_list $$23 EOS",
"print_stmt : tok_PRINT format_id EOS",
"print_stmt : tok_PRINT format_id ',' io_list EOS",
"type_output_stmt : tok_TYPE format_id EOS",
"$$24 :",
"$$25 :",
"type_output_stmt : tok_TYPE format_id ',' $$24 io_list $$25 EOS",
"control_info_list : control_info_item",
"control_info_list : control_info_list ',' control_info_item",
"control_info_item : symbolic_name '=' unit_id",
"control_info_item : unit_id",
"open_info_list : unit_id",
"open_info_list : symbolic_name '=' unit_id",
"open_info_list : open_info_list ',' open_info_item",
"open_info_item : symbolic_name '=' unit_id",
"open_info_item : symbolic_name",
"io_list : io_item",
"io_list : io_list ',' io_item",
"io_item : expr",
"io_item : io_implied_do_list",
"io_implied_do_list : '(' io_list ',' variable_name '=' do_loop_bounds ')'",
"$$26 :",
"open_stmt : tok_OPEN $$26 '(' open_info_list ')' EOS",
"$$27 :",
"close_stmt : tok_CLOSE $$27 '(' control_info_list ')' EOS",
"$$28 :",
"inquire_stmt : tok_INQUIRE $$28 '(' control_info_list ')' EOS",
"backspace_stmt : backspace_handle unit_id EOS",
"backspace_stmt : backspace_handle '(' control_info_list ')' EOS",
"backspace_handle : tok_BACKSPACE",
"endfile_stmt : endfile_handle unit_id EOS",
"endfile_stmt : endfile_handle '(' control_info_list ')' EOS",
"endfile_handle : tok_ENDFILE",
"endfile_handle : tok_END tok_FILE",
"rewind_stmt : rewind_handle unit_id EOS",
"rewind_stmt : rewind_handle '(' control_info_list ')' EOS",
"rewind_handle : tok_REWIND",
"unit_id : expr",
"unit_id : '*'",
"format_id : char_expr",
"format_id : '*'",
"$$29 :",
"format_stmt : tok_FORMAT $$29 '(' format_spec ')' EOS",
"format_spec :",
"format_spec : nonempty_format_spec",
"nonempty_format_spec : fmt_spec_item",
"nonempty_format_spec : nonempty_format_spec fmt_spec_item",
"fmt_spec_item : repeatable_fmt_item",
"fmt_spec_item : unrepeatable_fmt_item",
"fmt_spec_item : fmt_item_separator",
"repeatable_fmt_item : '(' nonempty_format_spec ')'",
"repeatable_fmt_item : tok_edit_descriptor",
"unrepeatable_fmt_item : tok_string",
"unrepeatable_fmt_item : tok_hollerith",
"unrepeatable_fmt_item : repeat_spec",
"unrepeatable_fmt_item : variable_fmt_item",
"fmt_item_separator : ','",
"fmt_item_separator : '/'",
"fmt_item_separator : tok_concat",
"fmt_item_separator : ':'",
"fmt_item_separator : '.'",
"fmt_item_separator : nonstandard_fmt_item",
"nonstandard_fmt_item : '$'",
"repeat_spec : tok_integer_const",
"repeat_spec : '-' tok_integer_const",
"repeat_spec : '+' tok_integer_const",
"variable_fmt_item : '<' integer_expr '>'",
"stmt_function_handle : scalar_name '(' stmt_function_dummy_list ')'",
"stmt_function_dummy_list :",
"stmt_function_dummy_list : nonempty_stmt_fun_dummy_list",
"nonempty_stmt_fun_dummy_list : stmt_function_dummy_arg",
"nonempty_stmt_fun_dummy_list : nonempty_stmt_fun_dummy_list ',' stmt_function_dummy_arg",
"stmt_function_dummy_arg : variable_name",
"$$30 :",
"call_stmt : call_handle $$30 EOS",
"$$31 :",
"call_stmt : call_handle '(' ')' $$31 EOS",
"$$32 :",
"call_stmt : call_handle '(' expr_list ')' $$32 EOS",
"call_handle : tok_CALL symbolic_name",
"expr_list : expr",
"expr_list : '*' pre_label label",
"expr_list : expr_list ',' expr",
"expr_list : expr_list ',' '*' pre_label label",
"return_stmt : tok_RETURN EOS",
"return_stmt : tok_RETURN integer_expr EOS",
"function_reference : fun_or_substr_handle '(' fun_arg_list ')'",
"fun_or_substr_handle : scalar_name",
"fun_arg_list :",
"fun_arg_list : nonempty_fun_arg_list",
"nonempty_fun_arg_list : expr",
"nonempty_fun_arg_list : nonempty_fun_arg_list ',' expr",
"parameter_expr : expr",
"expr : log_expr",
"log_expr : log_disjunct",
"log_expr : expr tok_EQV log_disjunct",
"log_expr : expr tok_NEQV log_disjunct",
"log_disjunct : log_term",
"log_disjunct : log_disjunct tok_OR log_term",
"log_term : log_factor",
"log_term : log_term tok_AND log_factor",
"log_factor : log_primary",
"log_factor : tok_NOT log_primary",
"log_primary : arith_expr",
"log_primary : log_primary tok_relop log_primary",
"arith_expr : term",
"arith_expr : '-' term",
"arith_expr : '+' term",
"arith_expr : arith_expr '+' term",
"arith_expr : arith_expr '-' term",
"term : factor",
"term : term '/' factor",
"term : term '*' factor",
"factor : char_expr",
"factor : char_expr tok_power factor",
"char_expr : primary",
"char_expr : char_expr tok_concat primary",
"primary : variable_name",
"primary : array_element_name",
"primary : function_reference",
"primary : substring_name",
"primary : literal_const",
"primary : '(' expr ')'",
"literal_const : numeric_const",
"literal_const : tok_string",
"literal_const : tok_hollerith",
"literal_const : tok_logical_const",
"numeric_const : tok_integer_const",
"numeric_const : tok_real_const",
"numeric_const : tok_dp_const",
"numeric_const : tok_complex_const",
"numeric_const : tok_dcomplex_const",
"integer_expr : arith_expr",
"int_real_dp_expr : arith_expr",
"int_constant_expr : arith_expr",
"dim_bound_expr : arith_expr",
"array_element_lvalue : array_name '(' subscript_list ')'",
"array_element_name : array_name '(' subscript_list ')'",
"subscript_list : subscript",
"subscript_list : subscript_list ',' subscript",
"subscript : expr",
"substring_name : fun_or_substr_handle substring_interval",
"substring_name : array_element_name substring_interval",
"substring_lvalue : scalar_name substring_interval",
"substring_lvalue : array_element_lvalue substring_interval",
"substring_interval : '(' ':' ')'",
"substring_interval : '(' substr_index_expr ':' ')'",
"substring_interval : '(' ':' substr_index_expr ')'",
"substring_interval : '(' substr_index_expr ':' substr_index_expr ')'",
"substr_index_expr : arith_expr",
"variable_name : scalar_name",
"variable_name : array_name",
"scalar_name : tok_identifier",
"array_name : tok_array_identifier",
"symbolic_name : tok_identifier",
"symbolic_name : tok_array_identifier",
"data_constant : numeric_const",
"data_constant : '-' numeric_const",
"data_constant : '+' numeric_const",
"data_constant : tok_logical_const",
"data_constant : tok_string",
"data_constant : tok_hollerith",
"nonzero_unsigned_int_const : tok_integer_const",
"pre_label :",
"label : tok_integer_const",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 1936 "fortran.y"
void
init_parser()			/* Initialize various flags & counters */
{
	initial_flag = TRUE;	/* set flag for keyword test */
	implicit_flag=FALSE;	/* clear flags for IMPLICIT stmt */
	implicit_letter_flag = FALSE;
	implicit_type_given = FALSE;
	implicit_none = FALSE;
	global_save = FALSE;
	complex_const_allowed = FALSE;
	prev_token_class = EOS;
	stmt_sequence_no = 0;
	true_prev_stmt_line_num = 0;
}

/* After having parsed prog_stmt, function_stmt, subroutine_stmt,
   block_data_stmt, the stmt_sequence_no is set to the value SEQ_HEADER.
*/

	/* After having parsed end_stmt, common block lists and
	   subprogram argument lists are copied over into global symbol
	   table, the local symbol table is printed out and then cleared,
	   and stmt_sequence_no is set to zero for start of next module.
	*/

PRIVATE void
END_processing(t)
	Token *t;
{
  crp_end_processing_val();
  if(current_module_hash != -1) {
	{
/*
            process_lists(current_module_hash);
*/
	}
        init_symtab();
  }
  /*  Initialisation pour les verifications de valeurs */
  stmt_sequence_no = 0;
  current_module_hash = -1;
  implicit_type_given = FALSE;
  implicit_none = FALSE;
  in_assignment_stmt = FALSE;
  true_prev_stmt_line_num = 0;
  integer_context = FALSE;
  global_save = FALSE;

  nbintrn = 0;
  g_nbextrn = 0;
}
#line 1548 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 264 "fortran.y"
{
				/* Create id token for prog if unnamed. */

			  if(curr_stmt_class == tok_END) {
			    END_processing(&(yyval));
			  }
			  integer_context = FALSE;
			}
break;
case 16:
#line 294 "fortran.y"
{
			    complex_const_allowed = FALSE;
			    integer_context = FALSE;
			    in_assignment_stmt = FALSE;
			    yyerrok; /* (error message already given) */
			}
break;
case 17:
#line 303 "fortran.y"
{
			    current_module_type = type_PROGRAM;
			    current_module_hash = type_PROGRAM;
			}
break;
case 18:
#line 308 "fortran.y"
{
			    current_module_type = current_datatype;
			    current_module_hash = current_datatype;
			}
break;
case 19:
#line 313 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			    current_module_hash = type_SUBROUTINE;
			}
break;
case 20:
#line 318 "fortran.y"
{
			    current_module_type = type_BLOCK_DATA;
			    current_module_hash = type_BLOCK_DATA;
			}
break;
case 24:
#line 332 "fortran.y"
{
#ifdef ALLOW_INCLUDE
			  if(f77_standard) {
			      nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			  }
 			  open_include_file(yyvsp[-1].value.string);
#endif
 			}
break;
case 25:
#line 348 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				stmt_sequence_no = SEQ_IMPLICIT;
			     }
			}
break;
case 26:
#line 354 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				   stmt_sequence_no = SEQ_IMPLICIT;
			     }
			     else if(stmt_sequence_no > SEQ_SPECIF) {
			     }
			}
break;
case 28:
#line 363 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_STMT_FUN) {
				stmt_sequence_no = SEQ_STMT_FUN;
		 	     }
			}
break;
case 30:
#line 372 "fortran.y"
{
			     goto_flag = prev_goto = FALSE;
			}
break;
case 40:
#line 392 "fortran.y"
{
			    goto_flag=TRUE;
			}
break;
case 41:
#line 396 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 64:
#line 429 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 65:
#line 433 "fortran.y"
{
			    prev_goto = goto_flag =FALSE;
			}
break;
case 73:
#line 452 "fortran.y"
{
			    g_argument_nb = 0;
			    g_line_input = yyvsp[-2].line_num - 1;
                             crp_set_srcname(&(yyvsp[-1]), type_PROGRAM, 0);
			}
break;
case 74:
#line 464 "fortran.y"
{
			    g_argument_nb = 0;
			    g_line_input = yyvsp[-2].line_num - 1;
			    crp_set_srcname(&(yyvsp[-1]), current_module_type, current_module_size);
			}
break;
case 75:
#line 470 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			}
break;
case 76:
#line 474 "fortran.y"
{
                             crp_set_srcname(&(yyvsp[-5]), current_module_type, current_module_size);
			}
break;
case 78:
#line 485 "fortran.y"
{
			    g_argument_nb = 0;
			    g_line_input = yyvsp[-2].line_num - 1;
			    crp_set_srcname(&(yyvsp[-1]), current_module_type, current_module_size);
			}
break;
case 79:
#line 491 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			}
break;
case 80:
#line 495 "fortran.y"
{
			     crp_set_srcname(&(yyvsp[-5]), current_module_type, current_module_size);
			}
break;
case 81:
#line 500 "fortran.y"
{
			    g_argument_nb = 0;
			    g_line_input = yyvsp[-2].line_num - 1;
			     crp_set_srcname(&(yyvsp[-1]), current_module_type, current_module_size);
			}
break;
case 82:
#line 506 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			}
break;
case 83:
#line 510 "fortran.y"
{
			     crp_set_srcname(&(yyvsp[-5]), current_module_type, current_module_size);
			}
break;
case 84:
#line 517 "fortran.y"
{
			    current_module_type = current_datatype;
			    current_module_size = current_typesize;
			}
break;
case 85:
#line 524 "fortran.y"
{
			    current_module_type = 0;
			    current_module_size = size_DEFAULT;
			}
break;
case 91:
#line 547 "fortran.y"
{
			    g_argument_nb = 0;
			    g_line_input = yyvsp[-2].line_num - 1;
			    crp_set_srcname(&(yyvsp[-1]), type_SUBROUTINE, size_SUBROUTINE);
			}
break;
case 92:
#line 553 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			    strcpy(g_subprog_name,crp_token_name(yyvsp[0]));
			}
break;
case 93:
#line 558 "fortran.y"
{
			      crp_set_srcname(&(yyvsp[-5]), type_SUBROUTINE, size_SUBROUTINE);
			}
break;
case 94:
#line 564 "fortran.y"
{current_module_type=type_SUBROUTINE;}
break;
case 95:
#line 568 "fortran.y"
{
			    g_argument_nb = 0;
			    def_arg_num = -1;
			    yyval.next_token = (Token*)NULL;
			}
break;
case 96:
#line 574 "fortran.y"
{
                            g_argument_nb = def_arg_num+1;
                        }
break;
case 97:
#line 581 "fortran.y"
{
			    def_arg_num = 0;
			    crp_get_dummy_argument(def_arg_num,&(yyvsp[0]), return_label);
			}
break;
case 98:
#line 586 "fortran.y"
{
			    def_arg_num++;
			    crp_get_dummy_argument(def_arg_num,&(yyvsp[0]), return_label);
			}
break;
case 99:
#line 593 "fortran.y"
{ return_label = FALSE; }
break;
case 100:
#line 595 "fortran.y"
{ return_label = TRUE;}
break;
case 101:
#line 602 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			    crp_set_srcname(NULL, type_BLOCK_DATA, -1000);
			}
break;
case 102:
#line 607 "fortran.y"
{
			    g_line_input = yyvsp[-2].line_num - 1;
			    crp_set_srcname(&(yyvsp[-1]), type_BLOCK_DATA, size_SUBROUTINE);
			}
break;
case 108:
#line 626 "fortran.y"
{ crp_set_array_var_bd(&(yyvsp[-3]), g_length_array); }
break;
case 109:
#line 631 "fortran.y"
{
			        g_length_array = yyvsp[0].value.integer;
			}
break;
case 110:
#line 635 "fortran.y"
{
			        g_length_array *= yyvsp[0].value.integer;
			}
break;
case 112:
#line 642 "fortran.y"
{
			  yyval.value.integer=yyvsp[0].value.integer-yyvsp[-2].value.integer+1;
			}
break;
case 115:
#line 650 "fortran.y"
{equivalence_flag = TRUE;}
break;
case 116:
#line 651 "fortran.y"
{equivalence_flag = FALSE;}
break;
case 131:
#line 687 "fortran.y"
{
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			}
break;
case 132:
#line 693 "fortran.y"
{g_entity_nb=0;}
break;
case 133:
#line 694 "fortran.y"
{
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			     crp_mem_common_bd(&(yyvsp[-2]));
			}
break;
case 134:
#line 702 "fortran.y"
{
			     yyval = yyvsp[-1];
			}
break;
case 137:
#line 711 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			}
break;
case 138:
#line 715 "fortran.y"
{
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			}
break;
case 141:
#line 726 "fortran.y"
{
                            crp_set_common_type_bd(&(yyvsp[0]), &g_entity_nb);
			}
break;
case 142:
#line 730 "fortran.y"
{
                            crp_set_common_type_bd(&(yyvsp[0]), &g_entity_nb);
			}
break;
case 147:
#line 752 "fortran.y"
{
			    yyval = yyvsp[-1];
			}
break;
case 149:
#line 759 "fortran.y"
{
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			}
break;
case 156:
#line 777 "fortran.y"
{
			  current_typesize = type_size[current_datatype];
			}
break;
case 157:
#line 782 "fortran.y"
{
			    current_typesize = yyvsp[0].value.integer;
#if 0 /* defunct feature */
			    if(local_wordsize > 0) {
			      /*  recognize REAL*2w as DOUBLE PRECISION */
			      if(current_datatype == type_REAL
				 && yyvsp[0].value.integer == type_size[type_DP])
				current_datatype = type_DP;
			      /*  recognize COMPLEX*4w as DOUBLE COMPLEX */
			      if(current_datatype == type_COMPLEX
				 && yyvsp[0].value.integer==type_size[type_DCOMPLEX])
				current_datatype = type_DCOMPLEX;
			    }
#endif
			}
break;
case 159:
#line 802 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     integer_context = TRUE;
			}
break;
case 160:
#line 807 "fortran.y"
{
			     current_datatype = type_REAL;
			     integer_context = TRUE;
			}
break;
case 161:
#line 812 "fortran.y"
{
			     current_datatype = type_COMPLEX;
			     integer_context = TRUE;
			}
break;
case 162:
#line 817 "fortran.y"
{
			     current_datatype = type_LOGICAL;
			     integer_context = TRUE;
			}
break;
case 163:
#line 824 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			}
break;
case 164:
#line 829 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			}
break;
case 165:
#line 834 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			}
break;
case 166:
#line 839 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			}
break;
case 167:
#line 844 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     current_typesize = 1;
			}
break;
case 168:
#line 851 "fortran.y"
{
			     current_datatype = type_STRING;
			     current_typesize = 1;
			     len_specification_ok = 0;
			     integer_context = TRUE;
			}
break;
case 169:
#line 860 "fortran.y"
{
			     current_typesize = yyvsp[0].value.integer;
			}
break;
case 172:
#line 870 "fortran.y"
{
			    crp_set_var_type_bd(&(yyvsp[0]), current_datatype,
				current_typesize, yyvsp[0].line_num);
			}
break;
case 173:
#line 875 "fortran.y"
{
			    crp_set_var_type_bd(&(yyvsp[0]), current_datatype,
				current_typesize, yyvsp[0].line_num);
			}
break;
case 176:
#line 886 "fortran.y"
{
                            crp_set_var_type_bd(&(yyvsp[0]), current_datatype,  
                                current_typesize, yyvsp[0].line_num);
			}
break;
case 177:
#line 891 "fortran.y"
{
                            crp_set_var_type_bd(&(yyvsp[-2]), current_datatype, 
                                current_typesize, yyvsp[-2].line_num);
			}
break;
case 178:
#line 896 "fortran.y"
{
                            crp_set_var_type_bd(&(yyvsp[0]), current_datatype,
                                current_typesize, yyvsp[0].line_num);
			}
break;
case 179:
#line 901 "fortran.y"
{
                            crp_set_var_type_bd(&(yyvsp[-2]), current_datatype,
                                current_typesize, yyvsp[-2].line_num);
			}
break;
case 180:
#line 909 "fortran.y"
{implicit_flag=TRUE;}
break;
case 184:
#line 918 "fortran.y"
{initial_flag = TRUE;}
break;
case 186:
#line 924 "fortran.y"
{implicit_letter_flag = TRUE;}
break;
case 187:
#line 925 "fortran.y"
{implicit_letter_flag = FALSE;}
break;
case 190:
#line 933 "fortran.y"
{
			   int c1 = (int)yyvsp[0].subclass;
			   set_implicit_type(current_datatype,current_typesize,
                                        c1,c1);
			}
break;
case 191:
#line 939 "fortran.y"
{
			   int c1 = (int)yyvsp[-2].subclass;
			   int c2 = (int)yyvsp[0].subclass;
			   set_implicit_type(current_datatype,current_typesize,
                                        c1,c2);
			}
break;
case 192:
#line 950 "fortran.y"
{yyval.value.integer = size_ADJUSTABLE;len_specification_ok = 1;}
break;
case 193:
#line 952 "fortran.y"
{yyval.value.integer = yyvsp[0].value.integer;len_specification_ok = 0;}
break;
case 194:
#line 954 "fortran.y"
{
                                if ( value_flag )
				{
				    yyval.value.integer = yyvsp[-1].value.integer;
				}
				else
				{
				    yyval.value.integer = crp_x_value_lu(&(yyvsp[-1]));
				}
				len_specification_ok = 0;
			    }
break;
case 198:
#line 975 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 199:
#line 977 "fortran.y"
{
			    complex_const_allowed = FALSE;
			    crp_mem_value_lu(&(yyvsp[-3]), crp_x_value(&(yyvsp[0])));
			}
break;
case 201:
#line 988 "fortran.y"
{
                             if ( g_nbextrn < MAX_XTERNAL )
                             {
                                 strcpy(g_extrn_name[g_nbextrn], crp_token_name(yyvsp[0]));
                                 g_nbextrn++;
                             } 
			}
break;
case 202:
#line 996 "fortran.y"
{ 
                             if ( g_nbextrn < MAX_XTERNAL ) 
                             {
                                 strcpy(g_extrn_name[g_nbextrn], crp_token_name(yyvsp[0])); 
                                 g_nbextrn++; 
                             }  
                        }
break;
case 204:
#line 1010 "fortran.y"
{
                            if ( nbintrn < MAX_XTERNAL )
                            {
                                strcpy(intrn_name[nbintrn], crp_token_name(yyvsp[0]));
                                nbintrn++;
                            }
			}
break;
case 205:
#line 1018 "fortran.y"
{
                            if ( nbintrn < MAX_XTERNAL )
                            {
                                strcpy(intrn_name[nbintrn], crp_token_name(yyvsp[0]));
                                nbintrn++;
                            }
                        }
break;
case 206:
#line 1029 "fortran.y"
{
			  global_save = TRUE;
			}
break;
case 216:
#line 1053 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 217:
#line 1055 "fortran.y"
{complex_const_allowed=FALSE;}
break;
case 238:
#line 1102 "fortran.y"
{complex_const_allowed = TRUE;
                                    in_assignment_stmt = TRUE;}
break;
case 239:
#line 1104 "fortran.y"
{
			  complex_const_allowed = FALSE;
                          in_assignment_stmt = FALSE;
			  crp_output_set(&(yyvsp[-3]), yyvsp[-3].line_num);
			}
break;
case 252:
#line 1141 "fortran.y"
{
                            integer_context=TRUE;
			}
break;
case 253:
#line 1145 "fortran.y"
{
                            integer_context=TRUE;
			}
break;
case 259:
#line 1167 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 260:
#line 1168 "fortran.y"
{complex_const_allowed = FALSE;initial_flag = TRUE;}
break;
case 262:
#line 1173 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 263:
#line 1174 "fortran.y"
{complex_const_allowed = FALSE;initial_flag = TRUE;}
break;
case 269:
#line 1198 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 270:
#line 1200 "fortran.y"
{complex_const_allowed=FALSE;}
break;
case 271:
#line 1202 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 272:
#line 1204 "fortran.y"
{complex_const_allowed=FALSE;}
break;
case 275:
#line 1210 "fortran.y"
{integer_context=FALSE;}
break;
case 287:
#line 1241 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 289:
#line 1243 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 291:
#line 1246 "fortran.y"
{control_item_count = 0;}
break;
case 292:
#line 1248 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 293:
#line 1256 "fortran.y"
{in_read_stmt=0;}
break;
case 294:
#line 1258 "fortran.y"
{in_read_stmt=0;}
break;
case 295:
#line 1260 "fortran.y"
{in_read_stmt=0;}
break;
case 296:
#line 1262 "fortran.y"
{in_read_stmt=0;}
break;
case 297:
#line 1264 "fortran.y"
{in_read_stmt=0;}
break;
case 298:
#line 1266 "fortran.y"
{control_item_count = 0;in_read_stmt=1;}
break;
case 300:
#line 1270 "fortran.y"
{in_read_stmt=1;}
break;
case 301:
#line 1270 "fortran.y"
{in_read_stmt=0;}
break;
case 306:
#line 1280 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 307:
#line 1281 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 320:
#line 1316 "fortran.y"
{
			    if ( in_read_stmt )
			    {
				crp_output_set(&(yyvsp[0]), yyvsp[0].line_num);
			    }
			}
break;
case 323:
#line 1330 "fortran.y"
{control_item_count = 0;}
break;
case 325:
#line 1335 "fortran.y"
{control_item_count = 0;}
break;
case 327:
#line 1340 "fortran.y"
{control_item_count = 0;}
break;
case 331:
#line 1348 "fortran.y"
{control_item_count = 0;}
break;
case 334:
#line 1355 "fortran.y"
{control_item_count = 0;}
break;
case 335:
#line 1356 "fortran.y"
{control_item_count = 0;}
break;
case 338:
#line 1363 "fortran.y"
{control_item_count = 0;}
break;
case 343:
#line 1381 "fortran.y"
{inside_format=TRUE;}
break;
case 344:
#line 1382 "fortran.y"
{
			    inside_format=FALSE;
			}
break;
case 369:
#line 1435 "fortran.y"
{
				crp_val_stmt_function(&(yyvsp[-3]));
			}
break;
case 375:
#line 1453 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 376:
#line 1454 "fortran.y"
{
			    crp_update_argument(subprog_level);
			    free(subprog_level);
			}
break;
case 377:
#line 1458 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 378:
#line 1460 "fortran.y"
{
			    crp_update_argument(subprog_level);
			    free(subprog_level);
			}
break;
case 379:
#line 1465 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 380:
#line 1466 "fortran.y"
{
			    crp_update_argument(subprog_level);
			    free(subprog_level);
			}
break;
case 381:
#line 1473 "fortran.y"
{
			     subprog_level = (crp_sblevel *)malloc(	
					sizeof(crp_sblevel));
			     subprog_level->call_arg_num = 0;
			     subprog_level->prev = NULL;
			     yyval = yyvsp[0];
   			     crp_set_subprog_carac(subprog_level, &(yyvsp[0]));
			     complex_const_allowed = TRUE;
			}
break;
case 382:
#line 1484 "fortran.y"
{
			    if ( subprog_level->normal_subprogram )
			    {
			        if ( value_flag )
			        {
				  crp_mem_value(subprog_level, yyvsp[0].line_num);
			        }
				crp_actual_arg_set_val( subprog_level,&(yyvsp[0]),
					yyvsp[0].line_num, value_flag);
			    }
			    subprog_level->call_arg_num++;
			}
break;
case 383:
#line 1497 "fortran.y"
{
			    subprog_level->call_arg_num++;
			}
break;
case 384:
#line 1501 "fortran.y"
{
			    if ( subprog_level->normal_subprogram )
			    {
			        if ( value_flag )
                                {
				  crp_mem_value(subprog_level, yyvsp[0].line_num);
			        }
			        crp_actual_arg_set_val( subprog_level,&(yyvsp[0]),
					yyvsp[0].line_num, value_flag);
			    }
			    subprog_level->call_arg_num++;
			}
break;
case 385:
#line 1514 "fortran.y"
{
			    subprog_level->call_arg_num++;
			}
break;
case 388:
#line 1526 "fortran.y"
{
   			    crp_set_subprog_carac1(subprog_level);
			    if ( subprog_level->ptype != NULL )
			    {
                                if ( *subprog_level->ptype < type_SUBROUTINE )
			        {
			            *subprog_level->ptype += type_SUBROUTINE;
				}
			    }
			    crp_update_argument(subprog_level);
			    crp_func_ref_expr_val(subprog_level->subprogram_name,
					&(yyvsp[-1]), &(yyval));
			    subprog_level0 = subprog_level->prev;
			    free(subprog_level);
			    subprog_level= subprog_level0;
			    complex_const_allowed=FALSE;
			    in_assignment_stmt = TRUE;
			}
break;
case 389:
#line 1547 "fortran.y"
{
			  subprog_level0 = (crp_sblevel *)malloc(sizeof(crp_sblevel));
                          subprog_level0->ptype = NULL;
			  subprog_level0->prev = subprog_level;
			  subprog_level = subprog_level0;
			  subprog_level->call_arg_num = 0;
                          crp_set_subprog_carac0(subprog_level, &(yyvsp[0]));
			  if ( complex_const_allowed )
			  {
			    complex_true = 1;
			  }
			  complex_const_allowed=TRUE;
			  in_assignment_stmt = FALSE;
			}
break;
case 392:
#line 1567 "fortran.y"
{
			    if ( subprog_level->normal_subprogram )
			    {
			        if ( value_flag )
			 	{
				   crp_mem_value(subprog_level, yyvsp[0].line_num);
			    	}
			        crp_actual_arg_set_val( subprog_level,&(yyvsp[0]),
					yyvsp[0].line_num, value_flag);
			    }
			    subprog_level->call_arg_num++;
			}
break;
case 393:
#line 1580 "fortran.y"
{
			    if (subprog_level->normal_subprogram )
			    {
			        if ( value_flag )
				{
				  crp_mem_value(subprog_level, yyvsp[0].line_num);
			    	}
			        crp_actual_arg_set_val( subprog_level,&(yyvsp[0]),
					yyvsp[0].line_num, value_flag);
			    }
			    subprog_level->call_arg_num++;
			}
break;
case 397:
#line 1606 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 398:
#line 1610 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 400:
#line 1618 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 402:
#line 1626 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 404:
#line 1634 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 406:
#line 1642 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 408:
#line 1651 "fortran.y"
{
                            value_flag = 1;
			    crp_unexpr_type_val(&(yyvsp[0]),&(yyval));
			    if ( arith_expression_type == type_INTEGER )
			    {
			        yyval.value.integer = -(yyvsp[0].value.integer);
			    }
			}
break;
case 409:
#line 1660 "fortran.y"
{
/*
			    crp_unexpr_type_val(&($2),&($$));
*/
			    yyval = yyvsp[0];
                            value_flag = 1;
			}
break;
case 410:
#line 1668 "fortran.y"
{
			    crp_binexpr_type_val(&(yyvsp[-2]), &(yyvsp[-1]), &(yyvsp[0]), &(yyval));
                            value_flag = 1;
			}
break;
case 411:
#line 1673 "fortran.y"
{
			    crp_binexpr_type_val(&(yyvsp[-2]), &(yyvsp[-1]), &(yyvsp[0]), &(yyval));
                            value_flag = 1;
			}
break;
case 413:
#line 1682 "fortran.y"
{
                            value_flag = 1;
			    crp_binexpr_type_val(&(yyvsp[-2]), &(yyvsp[-1]), &(yyvsp[0]), &(yyval));
			}
break;
case 414:
#line 1687 "fortran.y"
{
			    crp_binexpr_type_val(&(yyvsp[-2]), &(yyvsp[-1]), &(yyvsp[0]), &(yyval));
                            value_flag = 1;
			}
break;
case 416:
#line 1695 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 418:
#line 1703 "fortran.y"
{
                            crp_concat_string(&(yyvsp[-2]), &(yyvsp[0]), &(yyval));
                            value_flag = 3;
			}
break;
case 419:
#line 1710 "fortran.y"
{ value_flag = 0; }
break;
case 420:
#line 1713 "fortran.y"
{ value_flag = 0; }
break;
case 421:
#line 1716 "fortran.y"
{ value_flag = 0; }
break;
case 422:
#line 1719 "fortran.y"
{
			    value_flag = 0;
			}
break;
case 423:
#line 1723 "fortran.y"
{
                            value_flag = 1;
			}
break;
case 424:
#line 1727 "fortran.y"
{
			    yyval = yyvsp[-1];
				/* (identifier) becomes a non-identifier */
                            value_flag = 1;
			}
break;
case 425:
#line 1737 "fortran.y"
{
			    /* (class is set in numeric_const productions) */
			    yyval.size = size_DEFAULT;
			}
break;
case 426:
#line 1742 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_STRING);
			}
break;
case 427:
#line 1746 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_HOLLERITH);
			}
break;
case 428:
#line 1750 "fortran.y"
{
			    yyval.size = size_DEFAULT;
                            yyval.class = type_byte(class_VAR,type_LOGICAL);
			}
break;
case 429:
#line 1757 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_INTEGER);
                        }
break;
case 430:
#line 1761 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_REAL);
                        }
break;
case 431:
#line 1765 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_DP);
                        }
break;
case 432:
#line 1769 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_COMPLEX);
                        }
break;
case 433:
#line 1773 "fortran.y"
{
                            yyval.class = type_byte(class_VAR,type_DCOMPLEX);
                        }
break;
case 437:
#line 1794 "fortran.y"
{
			    yyval.value.integer = crp_x_value(&(yyvsp[0]));
/*
			    if ( value_flag )
			    {
				$$.value.integer = $1.value.integer;
			    }
			    else
			    {
				$$.value.integer = crp_x_value_lu(&($1));
			    }
*/
			}
break;
case 443:
#line 1828 "fortran.y"
{
			    subprog_level0 = subprog_level->prev;
			    free(subprog_level);
			    subprog_level= subprog_level0;
                            if (! complex_true )
			    {
			        complex_const_allowed=FALSE;
			    }
			    complex_true = 0;
			    yyval.size=substring_size_val(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 444:
#line 1841 "fortran.y"
{
                            yyval.size=substring_size_val(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 445:
#line 1847 "fortran.y"
{
                            yyval.size=substring_size_val(&(yyvsp[-1]),&(yyvsp[0]));
                        }
break;
case 446:
#line 1851 "fortran.y"
{
                            yyval.size=substring_size_val(&(yyvsp[-1]),&(yyvsp[0]));
                        }
break;
case 447:
#line 1857 "fortran.y"
{
                            yyval.class=1;
                            yyval.subclass=0; /* 0 means LEN */
			}
break;
case 448:
#line 1862 "fortran.y"
{
                            yyval.class=yyvsp[-2].value.integer;
                            yyval.subclass=0; /* 0 means LEN */
                        }
break;
case 449:
#line 1867 "fortran.y"
{
                            yyval.class=1;
                            yyval.subclass=yyvsp[-1].value.integer;
                        }
break;
case 450:
#line 1872 "fortran.y"
{
                              yyval.class=yyvsp[-3].value.integer;
                              yyval.subclass=yyvsp[-1].value.integer;
                        }
break;
case 465:
#line 1921 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 466:
#line 1928 "fortran.y"
{
				integer_context=FALSE;
			}
break;
#line 2971 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
