#define MAX_NAME 8
#define MAX_SUB 9000
#define MAX_ARG 200
#define MAX_LEVEL 200
#define MAX_STMT_FUNCTION 100
#define MAX_ENTRY 60

/************************************************/
/*  MAX_PARM et MAX_LINE ne doit pas etre modifies sans accord
    de EDF. C'est la limite des parametres autorises et des lignes
    autorisees dans les regles de programmation */

#define MAX_PARM 20
#define MAX_LINE 500

/************************************************/

#define MAX_ENTITY 500
#define MAX_COMMON_SUB 300
#define MAX_COM 1000

#define MAX_XTERNAL 160

#ifdef LARGE_MACHINE
#define MAX_LU_TABLE 3000
#else
#define MAX_LU_TABLE 1000
#endif

typedef struct arg2 {
    char name[MAX_NAME+1];   /* nom du parametre */
    int size;                /* La taille de l'argument. Si taille est -1
				et type = 7 (CHARACTER) c'est que le parametre
				est declare avec CHARACTER*(*) */
    int type;                /* son type  (voir la structure crp_vck plus
				haut) */
    struct arg2 *next;
} crp_arg2;

typedef struct arg3 {
    int line_num;
    int argument_nb;
    crp_arg2 *argument;
    struct arg3 *next;
} crp_arg3;

/* crp_arg4 sert a memoriser le nom de la routine passe
   en parametre pour determiner son type a la fin de
   l'analyse */

typedef struct arg4 {
    char name[MAX_NAME+1]; /* nom du parametre */
    int offset;            /* offset dans le fichier pour l'extraction
			      des argument */
    int arg_num;	   /* Numero de parametre dans la liste des
			      parametres effectifs */
    int nb_arg;		   /* Nombre total d'arguments */
    struct arg4 *next;
} crp_arg4;

/*  Structures pour enregistrer un sous programme appele.  */

typedef struct ssbr { 
    char name[MAX_NAME+1];  /* nom du sous programme */
    int  arg_num;         /* numero de parametre a verifier */
    int  line_num;        /* numero de ligne ou le sous programme est appele */
    int  recursive;       /* indicateur de recursivite. S'agit il d'une
			     branche d'appel recursif ou non */
    struct ssbr *next;    /* le chainage. */
} crp_sbr;

typedef struct ssbr1 {
    char name[MAX_NAME+1];
    int  line_num;        /* numero de ligne ou le sous programme est appele */
    struct ssbr1 *next;
} crp_sbr1;

typedef struct ssbr2 {
    char name[MAX_NAME+1];
    int  line_num;        /* numero de ligne ou le sous programme est appele */
    int  arg_list_nb;
    crp_arg3 *arg_list;
    crp_arg3 **link;
    struct ssbr2 *next;
} crp_sbr2;


/* structure valchek pour verifier un parametre donne. ... */

typedef struct { 
    int output;     /* indicateur si le parametre est en output ou non */
    int type;       /* type de parametre :

			    type = 0 : il faut faire des recherche
				Dans notre cas, il s'agit d'un parametre
				declare en chaine de caracteres.
			    type = 1 : le type est deja correct
			    type = 2 : le parametre est mal declare. Dans
				notre cas, il s'agit d'un parametre
				chaine de caracteres mais declare en
				CHARACTER*n ou n est un nombre en dur.
		    */

    char sub_name_o[MAX_NAME+1]; /* nom du sous programme lorsque type = 2 */ 
    char sub_name_t[MAX_NAME+1]; /* nom du sous programme lorsque type = 2 */ 
    int line_num_o;   /* numero de ligne ou le output est produit */
    int line_num_t;   /* numero de ligne ou la chaine est mal declaree */
    int size;         /* taille de la chaine de caractere lorsque type est 2 */
    struct ssbr *subprog; /* Une liste chaine des sous programmes appeles
			avec le numero de son parametre */
} crp_vck;

/* Informations pour detecter la recursivite (voir g_level_subr plus bas
   pour plus d'informations).*/

typedef struct {
    char sub_name[MAX_NAME+1];   /* Le nom du sous programme appelant */
    char name[MAX_NAME+1];       /* Le nom du sous programme */
    int  arg_num;                /* le numero de parametre */
    int  line_num;               /* le numero de ligne */
} crp_rcrs;


/* Informations sur les parametres d'un sous programme */

typedef struct {
    char name[MAX_NAME+1];
    /* char sub_name[MAX_NAME+1]; Le nom du sous programme ou appartient
				  l'argument */
    char sub_name_t[MAX_NAME+1]; /* Le nom du sous programme ou se produit
				l'incidence */
    char sub_name_o[MAX_NAME+1]; /* Le nom du sous programme ou se produit
				l'incidence */
    int line_num_o;          /* Le numero de ligne dans ce sous programme */
    int line_num_t;          /* Le numero de ligne dans ce sous programme */
    int output;              /* Si cet argument est en output ou non */
    int size;                /* La taille de l'argument. Si taille est -1
				et type = 7 (CHARACTER) c'est que le parametre
				est declare avec CHARACTER*(*) */
    int type;                /* son type  (voir la structure crp_vck plus
				haut) */
    int     sbr_nb;          /* nombre de sous programme associes a un
				perametre */
    crp_sbr *sbr;            /* les sous programmes */
    crp_sbr **sbr_link;      /* le lien aux sous programmes */
} crp_arg;

typedef struct {
    int size;                /* La taille de l'argument. Si taille est -1
				et type = 7 (CHARACTER) c'est que le parametre
				est declare avec CHARACTER*(*) */
    int type;                /* son type  (voir la structure crp_vck plus
				haut) */
    int line_num;
    int col_num;
} crp_arg1;

typedef struct {
    char name[MAX_NAME+1];
    int size;                /* La taille de l'argument. Si taille est -1
				et type = 7 (CHARACTER) c'est que le parametre
				est declare avec CHARACTER*(*) */
    int type;                /* son type  (voir la structure crp_vck plus
				haut) */
    int line_num;
    int col_num;
} crp_arg5;

typedef struct sbl {
    char subprogram_name[MAX_NAME+1];
    int normal_subprogram;
    int call_arg_num;
    crp_arg5 argument[MAX_ARG];
    int line_num;
    int *ptype;
    int *psize;
    struct sbl *prev;
} crp_sblevel;

typedef struct {
    char name[MAX_NAME+1];
    int size;
    int type;
    int length;
} crp_entity;

typedef struct {
    char name[MAX_NAME+1];
    char sub_name[MAX_NAME+1];
    int  maj;                  /* indicateur de mise a jour du sous programme */
    int entity_nb;           /* Le numero de ligne dans ce sous programme */
    crp_entity *entity;      /* Le numero de ligne dans ce sous programme */
    int     sbr_nb;          /* nombre de sous programme associes a un
				perametre */
    crp_sbr1 *sbr;           /* les sous programmes utilisant ce common */
    crp_sbr1 **sbr_link;
} crp_com2infos;

typedef struct {
    char name[MAX_NAME+1];
} crp_common1;

typedef struct string {
    char *name;
    struct string *next;
} crp_string;

/*  Correspondance entre le nom du sous programme et les informations */

typedef struct {
    char sub_name[MAX_NAME+1]; /* le nom du sous programme */
    char *file_name;
    int  type;                 /* Type de la routine. Si la routine
				  est une fonction alors son type est
				  celui de type de data (voir type decrit
				  dans le typedef structure crp_lu_table
				  plus bas). Sinon son
				  son type est du type subroutine (10)
			       */
    int  size;                 /* Taille de l'identificateur de fonction. Cette
				  taille vaut -1 s'il s'agit d'un subroutine
			       */
    int  maj;                  /* indicateur de mise a jour du sous programme */
    int  arg_modifie;          /* etat d'entree sortie de parametre. 1 si l'un
				  de ses parametres a change d'etat. 0 sinon. */
    int  argument_nb;               /* Nombre des arguments */
    crp_arg *argument;        /* les parametres du sous programme */
    int  line_num;             /* Le numero de ligne correspondant */
    int called_nb;
    crp_sbr2 *called;          /* liste des sous programmes appeles  */
    int  caller_nb;	       /* nombre de callers */
    crp_sbr1 *caller;	       /* Les callers */
    crp_sbr1 **link;
    crp_sbr  *value;
    int       value_nb;
    int       common_nb;
    crp_common1 *common;
} crp_sub2infos;

SHARED crp_sbr **g_value_link;
SHARED int *g_value_nb;
SHARED char g_subprog_name[MAX_NAME+1], /* nom du sous programme en cours */
            g_subprog_name_app[MAX_NAME+1], /* nom du sous programme appele
						en cours */
            g_arg_name[MAX_NAME+1];     /* nom du parametre en cours */
SHARED char g_filtre[10];
SHARED int  g_line_input;             /* numero de ligne calcule en cours */
SHARED int  g_real_line_input;        /* numero de ligne reel en cours. */
SHARED char g_srcname[160];           /* nom du fichier source en cours */
SHARED char *g_srcname_p;
SHARED char g_bd_dir[160];           /* nom du repertoire de reference */
SHARED char g_routine_fname[160],
	    g_routine_fname_tmp[160], /* nom du fichier base de donnees pour
				les valeurs */
            g_argument_fname[160],
	    g_argument_fname_tmp[160],
	    g_argument_fname_tmp0[160], /* nom du fichier base de donnees pour
				les parametres */
	    g_common_fname[160],
	    g_common_fname_tmp[160];  /* nom du fichier base de donnees pour les valeurs */
SHARED int  g_arg_num;                /* Numero de parametre en cours */
SHARED int  g_arg_num0;                /* Numero de parametre en cours */
SHARED int  g_line_num;               /* Numero de ligne en cours */
SHARED int  g_check_type;             /* verification de type caractere */
SHARED crp_vck  g_valcheck;	      /* variable pour memoriser le resultat
					 de verification */

/* g_subprog : variable servant pour le chainage */
SHARED crp_sbr  **g_subprog;
SHARED int  g_subprog_nb;

/*************************************************************************
    Pour le besoin de detecter la recursivite dans l'appel
    des sous programmes.

    g_level_subr : tableau memorisant le nom du sous programme et
                   le parametre (donne par son numero) a chaque
                   niveau d'appel
    g_call_level : le niveau d'appel

    A chaque niveau d'appel (dans le profondeur), l'outil compare
    le nom du sous programme rencontre avec ce qu'il y a dans la liste.
    Si le nom existe deja, cela veut dire qu'il y a appel recursif. Ensuite
    il regarde s'il s'agit du meme parametre auquel cas il est inutile
    d'aller plus loin. Sinon, il memoire le nom du sous programme
    et le numero de parametre et il descend un niveau plus bas.

**************************************************************************/
SHARED crp_rcrs g_level_subr[MAX_LEVEL];
SHARED int  g_call_level;

/*  Correspondance entre le nom du sous programme et le fichier

    g_sub2infos    : liste de correspondances (sous programmes/fichier)
    g_sub2infos_nb : nombre de correspondances
*/

SHARED crp_sub2infos g_sub2infos[MAX_SUB];
SHARED int  g_sub2infos_nb;
SHARED int  g_sub2file_nb;
SHARED int  g_sub2mem_nb;
SHARED int  g_sub2infos_ind;
SHARED int  g_entry_point_nb;
SHARED crp_sbr2 **g_entry_point[MAX_ENTRY];
SHARED int *g_ep_called_nb[MAX_ENTRY];
SHARED int g_entry_point_ind[MAX_ENTRY];

typedef struct sinexist {
    char name[MAX_NAME+1];
    char sub_name[MAX_NAME+1];
    int line_num;
    struct sinexist *next;
} crp_inexist;

SHARED crp_inexist  **g_inexist, *g_inexist0;

/* Tableau pour memoriser les informations des parametres d'un sous
   programme donne */
SHARED  crp_arg  g_argument[MAX_ARG];   /* liste des parametres detectes */
SHARED  crp_arg  *g_argument0;
SHARED  int  g_argument_nb;    /* nombre de parametres detectes */

/*  Table lookup */

typedef struct {
    char name[MAX_NAME+1];
    int type;           /* type de l'identificateur. Les types
                           sont : 
				1 : INTEGER
				2 : REAL
				3 : DOUBLE PRECISION
				4 : COMPLEX
				5 : DOUBLE COMPLEX
				6 : LOGICAL
				7 : CHARACTER
				8 : HOLLERIH
				9 : GENERIC
				10 : SUBROUTINE
				11 : COMMON BLOCK
				12 : PROGRAM
				13 : CLOCK DATA
				14 : LABEL
				15 : NAME LIST
                        */
    int size;           /* Taille de l'identificateur en tant
			   que type de donnees. */
    int length;         /* Nombre d'elements s'il s'agit d'un tableau */
    int var_type;    	/* type de variable :
				 0 	: variable normale,
				 PARAM_VAR  : parametre du sous programme
				 COMMON_VAR : variable d'un common
			*/
    int array_var;
} crp_lu_table;

enum { NORMAL_VAR, PARAM_VAR, COMMON_VAR };

SHARED int g_lu_table_nb;
SHARED crp_lu_table g_lu_table[MAX_LU_TABLE];
SHARED int g_stmt_function_nb;
SHARED char g_stmt_function[MAX_STMT_FUNCTION][MAX_NAME+1];


/*  liste des sous programme deja mise a jour */

SHARED int g_must_explore;
SHARED int g_maj_index;       /*indice dans le tableau g_sub2infos du
				sous programme actuellement mis a jour
				Cet indice sert a faire des recherche
				dans le tableau en entier search_tot1 */

SHARED crp_sbr **g_sbr_link, *g_sbr;
SHARED int *g_sbr_nb;
			      /* pointeur memorisant l'adresse d'un membre
				 recursive de crp_sbr pour le positionner
				 au cas ou il y a appel recursif */

SHARED int g_entity_nb, g_length_array, g_com2infos_nb0;
SHARED crp_com2infos g_com2infos[MAX_COM];
SHARED int g_entity[MAX_ENTITY];

SHARED int g_common_sub[MAX_COMMON_SUB];

SHARED int g_common_sub_nb;

SHARED int  g_com2infos_nb;
SHARED int  g_com2file_nb;
SHARED int  g_com2mem_nb;

SHARED char g_extrn_name[MAX_XTERNAL][8];
SHARED int g_nbextrn;

SHARED char *g_message[] 
#ifdef MAIN
= {
/* 0 CRP_2 */ "les commentaires doivent commencer par un C en 1ere colonne.",
/* 1 CRP_3 */ "toute routine doit contenir l'une des 2 instructions suivantes :\n       'IMPLICIT NONE' ou 'IMPLICIT REAL*8 (A-H,O-Z)'.",
/* 2 CRP_4 */ "les seuls types FORTRAN autorises sont :\n       LOGICAL, INTEGER, CHARACTER, REAL*8, COMPLEX*16.",
/* 3 CRP_5 */ "les constantes reelles (ou complexes) doivent etre ecrites\n       avec un exposant D, exemple : 1.D0.",
/* 4 CRP_6 */ "l'appel a %s n'est tolere que sur justification.",
/* 5 CRP_7 */ "ne pas utiliser la declaration EXTERNAL.",
/* 6 CRP_8 */ "l'usage des retours etiquetes est interdite.",
/* 7 CRP_9 */ "la definition des retours etiquetes est interdite.",
/* 8 CRP_10 */ "les commentaires sont interdites entre les cartes suites.",
/* 9 CRP_11 */ "les etiquettes ne sont autorisees que devant les instructions\n       CONTINUE et FORMAT.",
/* 10 CRP_12 */ "l'instruction STOP est interdite.",
/* 11 CRP_14 */ "l'instruction RETURN est interdite.",
/* 12 CRP_15 */ "l'instruction ENTRY est interdite.",
/* 13 CRP_16 */ "l'instruction BLOCK DATA est interdite.",
/* 14 CRP_17 */ "l'instruction DIMENSION est interdite.",
/* 15 CRP_18 */ "l'instruction EQUIVALENCE est interdite.",
/* 16 CRP_19 */ "l'instruction INTRINSIC est interdite.",
/* 17 CRP_20 */ "le nombre de lignes d'un sous programme ne doit pas depasser %d.",
/* 18 CRP_21 */ "le nombre d'arguments d'un sous programme ne doit pas depasser %d.",
/* 19 CRP_101 */ "l'appel au sous programme %s n'a pas le bon nombre d'arguments.",
/* 20 CRP_102 */ "le %d%s argument du sous programme %s n'est pas du bon type.",
/* 21 CRP_103 */ "le sous programme %s est une FUNCTION et il est appele comme une\n       SUBROUTINE.",
/* 22 CRP_104 */ "le sous programme %s est une SUBROUTINE et il est appele comme\n       une FUNCTION.",
/* 23 CRP_150 */ "le nombre de variables du COMMON %s(%d) est different de\n       ce qu'il est (%d) dans sa declaration (routine %s).",
/* 24 CRP_151 */ "le type de la variables %s du COMMON %s est different de\n       ce qu'il est dans sa declaration (routine %s).",
/* 25 CRP_152 */ "la dimension du tableau %s du COMMON %s est differente de\n       ce qu'elle est dans sa declaration (routine %s).",
/* 26 CRP_200 */ "le %d%s argument du sous programme %s est une constante\n       Cette constante peut etre ecrasee dans le sous programme %s\n       a la ligne %d.",
/* 27 CRP_997 */ "CRP_997 routine %s ligne %d\n      %s est appellee par %s.\n       %s ne peut pas etre detruite.",
/* 28 CRP_998 */ "l'appel a %s est interdit, car l'interface d'appel de\n       %s est inconnue.",
/* 29 CRP_999 */ "erreur syntaxique",
/* 30 CRP_105 */ "la fonction %s est de type %s*%d mais elle est utilisee\n       avec le type %s*%d.",
}
#endif
;
