#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 10 "fortran.y"

/*
  fortran.c:

    Copyright (C) 1992 by Robert K. Moniot.
    This program is free software.  Permission is granted to
    modify it and/or redistribute it.  There is no warranty
    for this program.


	    This grammar is ANSI standard-conforming, except for:
		-- complex constant and a few other ambiguities needing
		   significant lookahead cannot be split across lines.

	    Extensions supported:
	        -- Case insensitive.
	 	-- Hollerith constants.
		-- Variable names may be longer than 6 characters.  Also
		   allows underscores and dollar signs in names.
		-- DO ... ENDDO and DO WHILE loop forms allowed.
		-- NAMELIST supported.
		-- TYPE and ACCEPT I/O statements allowed.
		-- Tabs are permitted in input, and (except in character data)
		   expand into blanks up to the next column equal to 1 mod 8.
		-- Type declarations INTEGER*2, REAL*8, etc. are allowed.
		-- IMPLICIT NONE allowed.
	 */

/*  Author: R. Moniot
 *  Date:   August 1988
 *  Last revision: July 1993
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ftnchek.h"
#include "symtab.h"

 char* MODULE_NAME="????";




	/* The following section is for use with bison-derived
	   parser.  Define alloca to be malloc for those cases
	   not covered by the cases covered there.  The ifdefs
	   are those in the skeleton parser with includes removed */
#ifdef AIXC	/* IBM RS/6000 xlc compiler does it this way */
#pragma alloca
#endif
#ifndef alloca
#ifdef __GNUC__
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#else /* Not sparc */
#ifdef MSDOS
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#define alloca malloc
#endif /* alloca now defined.  */

void exit();

#ifndef YYDEBUG	/* If not declared otherwise... */
int yydebug;	/* declare yydebug to satisfy extern in ftnchek.c */
#ifdef DEVELOPMENT
#define YYDEBUG 1		/* For development it is handy */
#else
#define YYDEBUG 0
#endif
#endif

#ifdef DEVELOPMENT
#define DEBUG_PARSER
#endif

int current_datatype,	/* set when parse type_name or type_stmt */
    stmt_sequence_no,   /* set when parsing, reset to 0 at end_stmt */
    control_item_count;	/* count of items in control_info_list */
long current_typesize;	/* for type*len declarations */

extern unsigned prev_stmt_line_num; /* shared with advance */

unsigned true_prev_stmt_line_num;	/* shared with symtab.c */

int current_module_hash = -1,	/* hashtable index of current module name */
    current_module_type,
    executable_stmt=FALSE,
    prev_stmt_class=0,
		 /* flags for lexer */
    complex_const_allowed=FALSE, /* for help in lookahead for these */
    in_assignment_stmt=FALSE,
    inside_format=FALSE,	/* when inside parens of FORMAT  */
    integer_context=FALSE,	/* says integers-only are to follow */
    prev_goto=FALSE,
    goto_flag=FALSE;	/* if unconditional GOTO was encountered */

long exec_stmt_count=0;	/* count of executable stmts in program */

PRIVATE void
print_comlist(), print_exprlist(), END_processing();
PRIVATE Token *
  append_token();
PRIVATE int
  do_bounds_type();
		/* Uses of Token fields for nonterminals: */
/*
  1. dim_bound_lists: dimensioning info for arrays:
       token.class = no. of dimensions,
       token.subclass = no. of elements
  2. expressions
       token.value.integer = hash index (of identifier)
       token.class = type_byte = storage_class << 4 + datatype
       token.subclass = flags: CONST_EXPR, LVALUE_EXPR, etc.
  3. common variable lists
       token.subclass = flag: COMMA_FLAG used to handle extra/missing commas
*/

#define SEQ_HEADER   1
#define SEQ_IMPLICIT 2
#define SEQ_SPECIF   3
#define SEQ_STMT_FUN 4
#define SEQ_EXEC     5
#define SEQ_END      6

#line 145 "y.tab.c"
#define YYERRCODE 256
#define tok_identifier 257
#define tok_array_identifier 258
#define tok_label 259
#define tok_integer_const 260
#define tok_real_const 261
#define tok_dp_const 262
#define tok_complex_const 263
#define tok_dcomplex_const 264
#define tok_logical_const 265
#define tok_string 266
#define tok_hollerith 267
#define tok_edit_descriptor 268
#define tok_letter 269
#define tok_relop 270
#define tok_AND 271
#define tok_OR 272
#define tok_EQV 273
#define tok_NEQV 274
#define tok_NOT 275
#define tok_power 276
#define tok_concat 277
#define tok_ACCEPT 278
#define tok_ASSIGN 279
#define tok_BACKSPACE 280
#define tok_BLOCK 281
#define tok_BLOCKDATA 282
#define tok_BYTE 283
#define tok_CALL 284
#define tok_CHARACTER 285
#define tok_CLOSE 286
#define tok_COMMON 287
#define tok_COMPLEX 288
#define tok_CONTINUE 289
#define tok_DATA 290
#define tok_DIMENSION 291
#define tok_DO 292
#define tok_DOUBLE 293
#define tok_DOUBLECOMPLEX 294
#define tok_DOUBLEPRECISION 295
#define tok_DOWHILE 296
#define tok_ELSE 297
#define tok_ELSEIF 298
#define tok_END 299
#define tok_ENDDO 300
#define tok_ENDFILE 301
#define tok_ENDIF 302
#define tok_ENTRY 303
#define tok_EQUIVALENCE 304
#define tok_EXTERNAL 305
#define tok_FILE 306
#define tok_FORMAT 307
#define tok_FUNCTION 308
#define tok_GO 309
#define tok_GOTO 310
#define tok_IF 311
#define tok_IMPLICIT 312
#define tok_INCLUDE 313
#define tok_INQUIRE 314
#define tok_INTEGER 315
#define tok_INTRINSIC 316
#define tok_LOGICAL 317
#define tok_NAMELIST 318
#define tok_NONE 319
#define tok_OPEN 320
#define tok_PARAMETER 321
#define tok_PAUSE 322
#define tok_PRECISION 323
#define tok_PRINT 324
#define tok_PROGRAM 325
#define tok_READ 326
#define tok_REAL 327
#define tok_RETURN 328
#define tok_REWIND 329
#define tok_SAVE 330
#define tok_STOP 331
#define tok_SUBROUTINE 332
#define tok_THEN 333
#define tok_TO 334
#define tok_TYPE 335
#define tok_WHILE 336
#define tok_WRITE 337
#define tok_illegal 338
#define EOS 127
#define REDUCE 339
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    2,    2,    3,    3,    5,
    5,    7,    7,    7,    7,    7,    8,    8,    8,    8,
    6,    6,   16,    4,    9,    9,    9,    9,    9,   17,
   17,   21,   21,   21,   21,   21,   21,   21,   21,   10,
   10,   32,   32,   32,   32,   32,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   11,   11,   56,   56,   56,   56,   57,
   57,   57,   66,   12,   22,   22,   13,   68,   68,   68,
   68,   69,   70,   72,   71,   71,   71,   14,   76,   76,
   77,   67,   67,   78,   78,   79,   79,   15,   15,   80,
   80,   24,   81,   81,   82,   83,   83,   84,   84,   84,
   84,   87,   25,   86,   86,   88,   88,   89,   89,   89,
   90,   91,   91,   26,   26,   26,   95,   95,   96,   97,
   97,   97,   94,   94,   98,   98,   99,   99,   27,  100,
  100,  101,  102,  103,  103,  104,  104,   28,   28,   28,
   28,   73,   73,   73,  107,  107,  107,  107,  109,  109,
  109,  109,  109,   74,   75,  105,  105,  111,  111,  106,
  106,  112,  112,  112,  112,  113,   19,   19,  114,  116,
  114,  118,  115,  117,  117,  119,  119,  110,  110,  110,
   18,  121,  121,  123,  122,   29,  125,  125,   30,  126,
  126,   31,   31,  127,  127,  128,  128,   20,  129,  129,
  129,  133,  134,  130,  131,  131,  135,  135,  132,  132,
  138,  138,  140,  140,  139,  139,  142,  142,  143,  143,
  137,  145,  145,  147,  148,   39,  136,  136,  136,  136,
   40,   34,   41,   41,   35,   35,   35,  154,  154,  155,
  155,   36,   58,   59,  158,  157,   62,  159,  160,   62,
   63,   64,   64,   60,  163,   60,  164,   60,  161,  161,
  161,  162,  162,   61,   61,   42,   37,   43,  166,  166,
  166,  166,  168,   46,  170,   46,  171,  167,   44,   44,
   44,   44,   44,  173,   45,   45,   47,  175,  176,   47,
   48,  177,  178,   48,  172,  172,  179,  179,  181,  181,
  181,  182,  182,  169,  169,  183,  183,  184,  185,   52,
  186,   53,  187,   54,   50,   50,  188,   51,   51,  189,
  189,   49,   49,  190,  180,  180,  174,  174,  192,   23,
  193,  193,  194,  194,  195,  195,  195,  196,  196,  197,
  197,  197,  197,  198,  198,  198,  198,  198,  198,  201,
  199,  199,  199,  202,  203,  200,  151,  205,  205,  206,
  206,  207,  209,   55,  210,   55,  212,   55,  208,  211,
  211,  211,  211,   38,   38,  213,  214,  215,  215,  216,
  216,  124,  146,  217,  217,  217,  218,  218,  219,  219,
  220,  220,  221,  221,  222,  222,  222,  222,  222,  223,
  223,  223,  224,  224,  191,  191,  225,  225,  225,  225,
  225,  225,  228,  228,  228,  228,  229,  229,  229,  229,
  229,  156,  165,  120,   85,  144,  226,   92,   92,  231,
  227,  227,  150,  150,   93,   93,   93,   93,  232,  149,
  149,  204,  230,   65,   65,  141,  141,  141,  141,  141,
  141,  108,  152,  153,
};
const short yylen[] = {                                         2,
    1,    0,    1,    2,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,
    1,    2,    2,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    4,    3,    6,    1,    3,    6,    3,
    6,    2,    1,    1,    1,    1,    1,    1,    3,    6,
    1,    0,    1,    1,    3,    1,    1,    2,    3,    2,
    1,    3,    1,    3,    4,    1,    3,    1,    3,    1,
    3,    0,    4,    3,    5,    3,    3,    1,    1,    1,
    4,    2,    2,    3,    3,    4,    1,    2,    2,    3,
    2,    1,    1,    2,    1,    2,    1,    1,    3,    1,
    2,    2,    3,    1,    2,    1,    2,    3,    3,    3,
    4,    1,    3,    1,    1,    1,    1,    1,    2,    1,
    2,    1,    1,    1,    3,    1,    3,    1,    1,    1,
    3,    1,    3,    1,    3,    1,    3,    3,    1,    0,
    4,    0,    5,    1,    3,    1,    3,    3,    1,    3,
    5,    1,    3,    0,    4,    3,    1,    3,    3,    1,
    3,    2,    3,    1,    3,    1,    3,    3,    1,    2,
    3,    0,    0,    6,    1,    3,    1,    1,    1,    3,
    1,    3,    1,    1,    1,    1,    1,    3,    1,    1,
    7,    3,    5,    0,    0,    6,    1,    1,    1,    1,
    6,    4,    6,    7,    3,    6,    7,    1,    2,    2,
    4,   10,    2,    3,    0,    5,    2,    0,    0,    8,
    2,    2,    3,    5,    0,    7,    0,    6,    3,    4,
    2,    3,    5,    3,    2,    2,    3,    3,    0,    1,
    1,    1,    0,    3,    0,    4,    0,    5,    5,    6,
    7,    3,    5,    1,    3,    5,    3,    0,    0,    7,
    3,    0,    0,    7,    1,    3,    3,    1,    1,    3,
    3,    3,    1,    1,    3,    1,    1,    7,    0,    6,
    0,    6,    0,    6,    3,    5,    1,    3,    5,    1,
    2,    3,    5,    1,    1,    1,    1,    1,    0,    6,
    0,    1,    1,    2,    1,    1,    1,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    0,    0,    5,    4,    0,    1,    1,
    3,    1,    0,    3,    0,    5,    0,    6,    2,    1,
    3,    3,    5,    2,    3,    4,    1,    0,    1,    1,
    3,    1,    1,    1,    3,    3,    1,    3,    1,    3,
    1,    2,    1,    3,    1,    2,    2,    3,    3,    1,
    3,    3,    1,    3,    1,    3,    1,    1,    1,    1,
    1,    3,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    4,    4,    1,    3,    1,
    2,    2,    2,    2,    3,    4,    4,    5,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    1,    1,
    1,    1,    0,    1,
};
const short yydefred[] = {                                      0,
    0,  452,  453,    0,    0,  463,  327,    0,  101,  163,
    0,  164,  321,    0,  157,    0,    0,    0,  463,    0,
  162,  160,    0,    0,    0,    0,    0,  330,    0,    0,
  112,    0,  339,   84,    0,  248,    0,  176,    0,  323,
  155,    0,  158,    0,  319,    0,    0,    0,   73,  294,
  156,    0,  334,    0,    0,   91,    0,  287,    7,    0,
    0,    3,    5,    6,    8,    9,   11,   12,   13,   14,
   15,   17,   18,   19,   20,   21,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
   69,   70,   71,   72,   77,    0,    0,    0,   83,    0,
    0,    0,   88,    0,    0,    0,  154,    0,    0,    0,
  237,  239,  240,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   16,   10,   22,  427,  428,  429,
  430,  431,  426,  424,  425,    0,  338,  417,    0,    0,
    0,  419,    0,  415,    0,  420,  421,  423,    0,    0,
  100,  454,  455,  379,    0,  132,    0,    0,  138,    0,
    0,  127,    0,  133,    0,  276,    0,    0,  209,    0,
  215,  217,  218,    0,    0,  103,    0,  161,  159,  267,
  261,  257,    0,  258,    0,  331,    0,   23,  275,  262,
    0,    0,  197,    0,    0,  249,  255,    0,    0,  200,
    0,    0,    0,  140,    0,    0,    0,  280,  282,  281,
    0,    0,    0,  384,    0,    0,    0,    0,    0,    0,
  410,  202,    0,  206,    0,  204,    0,    0,    0,    4,
    0,    0,   82,    0,  169,    0,  166,    0,    0,    0,
    0,  170,    0,    0,    0,   98,    0,    0,    0,    0,
   85,    0,   87,    0,  179,  234,    0,  444,  463,    0,
    0,    0,    0,  253,    0,  463,    0,    0,  450,  451,
    0,    0,    0,    0,    0,  314,  317,  393,    0,    0,
  399,    0,    0,    0,    0,    0,  336,    0,    0,    0,
    0,    0,    0,    0,  443,    0,    0,    0,    0,  295,
    0,    0,    0,  441,  442,    0,  464,    0,    0,  131,
    0,    0,  124,    0,  134,  125,  128,    0,  136,  230,
    0,  227,  229,    0,  208,    0,  210,    0,  212,  102,
    0,    0,    0,    0,  274,  263,   75,    0,    0,    0,
  196,    0,    0,    0,   24,    0,  199,    0,    0,  139,
  141,    0,    0,  144,    0,  194,    0,  192,  278,  297,
  298,    0,    0,    0,  385,    0,    0,    0,    0,    0,
    0,  203,    0,  277,  301,  302,    0,   78,    0,   80,
    0,  148,    0,  462,    0,  189,  165,    0,    0,  149,
    0,    0,  150,   89,    0,   99,  153,  178,  182,  177,
  180,    0,    0,    0,    0,    0,    0,  245,  463,    0,
    0,  254,    0,  265,    0,    0,    0,    0,    0,    0,
  284,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  305,  308,  292,    0,    0,  325,    0,  328,    0,
  332,    0,    0,    0,  370,  375,  463,    0,    0,  374,
    0,    0,  438,  422,    0,  416,    0,    0,    0,    0,
    0,    0,    0,  130,  110,    0,  106,    0,    0,  126,
    0,  211,  216,    0,  104,  270,    0,    0,   97,   96,
    0,    0,   94,    0,    0,    0,    0,  120,  113,    0,
  198,  361,  350,  351,  349,  356,    0,  354,  357,  355,
    0,  358,  360,    0,  364,    0,    0,  343,  345,  346,
  347,  352,  353,  359,    0,    0,  201,  143,  147,  145,
    0,  309,    0,    0,    0,    0,    0,   74,  414,    0,
    0,  412,  411,  207,  205,    0,    0,    0,    0,  167,
    0,    0,    0,  173,  175,  171,  151,    0,    0,    0,
    0,  445,    0,    0,  250,    0,  463,    0,  463,  242,
  463,    0,    0,    0,    0,    0,    0,    0,  315,  286,
    0,  400,  404,    0,    0,    0,    0,    0,    0,    0,
  367,    0,    0,    0,  377,    0,  436,    0,  296,  386,
    0,  437,    0,    0,  105,    0,    0,    0,  228,    0,
  459,  460,  461,    0,    0,    0,  223,    0,  219,  221,
    0,  225,  456,    0,  259,    0,    0,    0,  122,  114,
    0,    0,  123,    0,    0,  362,  363,    0,    0,  344,
  256,    0,    0,    0,    0,    0,  191,  193,    0,    0,
  288,    0,    0,  188,  190,    0,    0,    0,  184,  181,
    0,  447,  446,    0,    0,    0,    0,    0,    0,    0,
    0,  264,    0,    0,  307,  289,    0,    0,  306,  293,
  326,  329,  333,  372,  371,  376,  381,    0,  463,    0,
  439,    0,  241,  322,  107,  111,  109,    0,  457,  458,
    0,    0,    0,  268,    0,   76,   95,    0,  117,  116,
    0,  348,  365,  340,  324,  310,  320,    0,  311,  195,
    0,    0,    0,   79,   81,   90,    0,  183,    0,  236,
  448,    0,  243,  251,  246,    0,    0,    0,    0,    0,
    0,  290,  378,    0,    0,    0,  220,  214,  226,  222,
    0,  121,  115,    0,    0,  300,  304,  187,  185,  244,
  247,  463,  266,    0,    0,  291,  383,    0,  231,  260,
  366,  312,    0,  273,  318,    0,    0,    0,  252,  233,
};
const short yydgoto[] = {                                      60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  124,  459,  243,  511,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,  512,  513,  135,
  205,  189,  496,  497,  498,  370,  222,  515,  516,  517,
  518,  481,  288,  190,  191,  192,  193,  194,  195,  233,
  234,  235,  383,  384,  266,  271,  136,  416,  137,  417,
  267,  272,  138,  284,  285,  580,  678,  579,  679,  572,
  387,  388,  554,  740,  224,  231,  255,  256,  198,  199,
  200,  638,  504,  722,  201,  139,  203,  639,  640,  641,
  642,  351,  352,  140,  766,  318,  432,  681,  168,  142,
  143,  436,  338,  144,  437,  247,  145,  374,  364,  725,
  146,  593,  592,  363,  594,  241,  147,  304,  305,  453,
  259,  461,  148,  169,  557,  742,  566,  743,  462,  463,
  553,  739,  306,  307,  236,  185,  229,  149,  150,  151,
  248,  225,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  658,  774,  171,  473,  474,  475,  153,  327,  613,
  479,  708,  172,  173,  488,  489,  308,  309,  310,  311,
  312,  313,  250,  251,  174,  175,  176,  177,  178,  179,
  483,  435,
};
const short yysindex[] = {                                   1122,
   -4,    0,    0, 1204,  869,    0,    0, -177,    0,    0,
 -105,    0,    0,   40,    0,   14,   94, -105,    0,   57,
    0,    0,   87,  -90,  139,  -18,   70,    0,  131, -105,
    0, -105,    0,    0,  -56,    0,  259,    0,   97,    0,
    0, -105,    0,  295,    0,  309,  494,  869,    0,    0,
    0,  839,    0,  233,  494,    0,  869,    0,    0,    0,
 1122,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -105, -105,   78,    0, -105,
   43,  -10,    0, -105,  -47,  323,    0, 1023,  327,  344,
    0,    0,    0,  100, 1280, -107,  586, 1067,  537,  553,
  639,  359,  363,  368,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  608,    0,    0,  245,  143,
    0,    0,  391,    0,  344,    0,    0,    0,  430,  185,
    0,    0,    0,    0,  435,    0,  -12,  466,    0,  216,
    4,    0, -105,    0,  436,    0,  -16,  104,    0,  248,
    0,    0,    0,  466,  349,    0,  185,    0,    0,    0,
    0,    0,  167,    0,  393,    0,  407,    0,    0,    0,
   76,  499,    0,  377,  507,    0,    0,  441,  546,    0,
  416, -105,   96,    0, -105,  550, -105,    0,    0,    0,
  472,  417, -105,    0,  904,  904,  478,  219,  227,  280,
    0,    0, -105,    0,  438,    0,  509,  440,  552,    0,
  122,  128,    0,  466,    0,  445,    0,    1,  314,  596,
  467,    0, -105,  496,  137,    0,  513,  384,  519,  624,
    0,  638,    0,  497,    0,    0,  970,    0,    0,  404,
  185,  379,  556,    0,  185,    0,  666,  651,    0,    0,
 1038,  586,  336,  589,  680,    0,    0,    0,  474,  493,
    0,  501,  227,  662,  512,  662,    0,  336,  617,  662,
  646,  662,  656,  970,    0,  355,  699,  608,    3,    0,
  586,  904,  465,    0,    0,  608,    0,  500,  662,    0,
  792,  893,    0,   44,    0,    0,    0, -105,    0,    0,
  797,    0,    0,  368,    0,   94,    0,   94,    0,    0,
 -105,  801,  608,  608,    0,    0,    0,  182, -105,  520,
    0, -105,   52,  608,    0,  662,    0, -105,  810,    0,
    0,  823, -105,    0,  662,    0,  504,    0,    0,    0,
    0,  749,  280,  280,    0,  904,  904,  904,  904,  904,
  831,    0,  159,    0,    0,    0,  662,    0,  182,    0,
  182,    0, -105,    0,  927,    0,    0,    1,    1,    0,
 -105,  527,    0,    0,  182,    0,    0,    0,    0,    0,
    0,  608,  981,  227,  822,  185,  701,    0,    0,  848,
  765,    0,  854,    0, 1038,  501,    3,  866,  608,  608,
    0,  586,  804,  608,  608, 1038,    0,    0,  871,  336,
  731,    0,    0,    0,  586,  814,    0,  815,    0,  845,
    0,    0,  900,  901,    0,    0,    0,  336,  877,    0,
  898,  336,    0,    0,  543,    0,  336,  907,  921,  227,
  899,  443,  911,    0,    0,  932,    0,  916,  227,    0,
  117,    0,    0, 1094,    0,    0,   33,   64,    0,    0,
  955,  963,    0,  969,  938,  967,  344,    0,    0,  978,
    0,    0,    0,    0,    0,    0,   52,    0,    0,    0,
  771,    0,    0,  776,    0,  984,   52,    0,    0,    0,
    0,    0,    0,    0,   95,  956,    0,    0,    0,    0,
  987,    0,  960, 1002,  940, -105,  586,    0,    0,  280,
  280,    0,    0,    0,    0,  586,  961, 1033, 1039,    0,
 1045, 1047,  227,    0,    0,    0,    0, 1053,  826, 1257,
  336,    0, 1057,  994,    0, 1015,    0,  962,    0,    0,
    0,  608,  983, 1064,  227,  586,  474,  474,    0,    0,
  493,    0,    0,  696,  411,  662,  570,  985,  989,  990,
    0,  443,  991,  185,    0,  723,    0,  608,    0,    0,
  608,    0,  992,  998,    0,  893, 1026, 1050,    0,    0,
    0,    0,    0,  545,  545,    0,    0, 1069,    0,    0,
 1072,    0,    0, 1011,    0, 1013,  182,  465,    0,    0,
 -105, -105,    0, -105,   19,    0,    0, 1038, 1014,    0,
    0, 1022,  696, 1025, -105,  608,    0,    0,  680,  680,
    0, 1036, 1046,    0,    0, 1048, 1070,  973,    0,    0,
 1054,    0,    0, 1087, 1038, 1055,  185, 1056,  975,  185,
  140,    0, 1038, 1086,    0,    0,  586,  581,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1059,    0,  336,
    0,  336,    0,    0,    0,    0,    0, 1038,    0,    0,
 1094, 1101, 1129,    0,  862,    0,    0,  979,    0,    0,
  986,    0,    0,    0,    0,    0,    0, 1135,    0,    0,
  336, 1071, 1073,    0,    0,    0,  928,    0,  826,    0,
    0, 1074,    0,    0,    0, 1075, 1155, 1076, 1160, 1038,
  588,    0,    0,  185, 1161, 1165,    0,    0,    0,    0,
 1080,    0,    0, 1146,  696,    0,    0,    0,    0,    0,
    0,    0,    0, 1038, 1168,    0,    0, 1038,    0,    0,
    0,    0,  185,    0,    0, 1166, 1084, 1038,    0,    0,
};
const short yyrindex[] = {                                   1212,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1088,    0,    0,    0,
    0,    0,    0,    0, 1088,    0,    0,    0,    0,    0,
 1213,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  908,
  909,  910,    0,    0,    0,  -14,    0,    0,    0,  706,
    0,    0,    0,  954,  954,    0, 1092,    0,    0,    0,
    0,  730, 1098,  793,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  593,
  385,    0,    0,    0,  516,    0,    0,    0,  508,    0,
    0,    0,    0,    0,    0,    0,    0,   67,    0,    0,
    0,    0,    0,    0,  331,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  433,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  780,   93,  819,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  616,    0,    0,    0,    0,  621,  622,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1186,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  643,    0, 1102,    0,    0,    0,   31,   37,
    0,   42,   -5,    0,    0,    0,    0,  457,    0,    0,
    0,    0,    0, 1199,    0,    0,    0,    0,    0,    0,
    0,    0, 1209,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   59,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  460,    0,    0,    0,    0,    0, 1221,    0,    0,
    0,    0, 1222,    0,    0,    0,    0,    0,    0,    0,
    0,  456,   98,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  850,  872,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1221,    0,
 1221,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1221,    0,    0,    0,    0,    0,
    0,    0,    0,  124,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   60, 1220,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  422,  485,    0,  988,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   26,    0, 1224,    0,    0,    0,  997,    0,    0,
    0,  999,    0,    0,    0,    0, 1001,    0, 1225,  164,
    0,    0,    0,    0,    0,    0,    0, 1003,  934,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1226,    0, 1005,    0,    0, 1020,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1227,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  906,
  950,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1021,    0,    0,    0,    0,    0,    0,    0,
 1126,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  473,    0,   74,  213,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  112,
    0,    0,    0,    0,    0,  843,    0, 1223,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1142, 1144,
    0,    0,    0,    0,    0,    0, 1029,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  559,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1031,
    0, 1035,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1041,    0,    0,
 1043,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   62,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1233,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0, 1236,    0,    0,    0,    0, 1281,    0,    0, 1149,
    0,    0,    0,    0,    0, 1303,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1285,    0,
    0,    0,    0,    0,   -2,    0, -262,    0,    0,    0,
 -130, 1182, -128, -127, -121,    0,    0,    0,  665,    0,
    0,  -11,    0,  687,  688,    0,    0,  660,  405,    0,
    0, -318, -125, 1127, 1131, -144,    0, -134,    0,    0,
 1089,    0,    0,  936,    0,  -74,    0, -272,    0,  292,
  913,  902,    0,    0,  755,    0,    0,    0,  587, -618,
    0,  781,    0,    0,    0,    0,    0,  941,    0, -141,
    0,    0,    0,    0,  995,   -3, -175,  618,  620,    0,
    0,    0,  840, -166,    0, -124,    0,    0,   15,    0,
    0,   -6, -202,    0, -396, -402,   83,    0,    0,    0,
    0,  585,    0,    0, -558, 1291,    0,    0, -282,    0,
    0,  102,    0,   69,    0,    0,    0,    0,  741, -147,
    0,    0, -344,    0,    0,    0,    0,    0,    0,    0,
   89,    0,    0,  821, -483,    0,    0,    0,    0,    0,
    0,    0,    0,   29,    0,    0,  737,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  285,  912,  914,
 -240,  -51,  291,  119, 1030,    0,    0,    0, -244,   21,
  745, -331,
};
#define YYTABLESIZE 1617
const short yytable[] = {                                     180,
  249,  319,  321,  323,  362,  427,  206,  280,  184,  281,
  282,  188,  207,  202,  141,  204,  283,  491,  141,  448,
  154,  350,  303,  197,  154,  152,  325,  221,  152,  223,
  353,  141,  152,  273,  340,  403,  211,  154,  403,  230,
  415,  329,  588,  484,  240,  152,  347,  334,  485,  335,
  187,  254,  240,  660,  533,  345,  357,  274,  527,  732,
  446,  534,  528,  531,  532,  530,  372,  417,  417,  372,
  417,  394,  417,  644,  394,  141,  529,  397,  535,  276,
  397,  154,  401,  417,  268,  401,  187,  533,  441,  152,
  187,  527,  443,  170,  534,  528,  531,  532,  530,  765,
  402,  583,  272,  402,  645,  129,  213,  599,  218,  529,
  137,  535,  181,  137,  395,  368,  242,  395,  265,  270,
  270,  403,  155,  261,  262,  258,  210,  264,  269,  269,
  346,  275,  277,  197,  759,  661,  170,  291,  295,  289,
  196,  290,  232,  197,  142,  170,  568,  356,  569,    2,
    3,  182,  183,  462,  432,  427,  197,  394,  427,  141,
  298,  409,  578,  397,  449,  154,  300,  411,  401,  796,
  500,  660,  398,  152,  299,  398,  425,  447,  214,  800,
  758,  449,  607,  686,  341,  129,  402,  188,  272,  460,
  188,  460,  689,  137,  202,  460,  219,  460,  422,  347,
  395,  478,  367,  482,  403,  253,  303,  403,  487,  182,
  183,  482,  141,  345,  502,  603,  315,  354,  154,  432,
   37,  449,  380,  509,  142,  794,  152,  296,  297,  379,
  355,  637,  382,  585,  386,  434,  170,  552,  507,  508,
  392,    3,  152,  152,  182,  183,  182,  183,  408,  545,
  401,  599,  684,  396,  410,  733,  396,  220,  398,  643,
  414,  270,  187,  424,  403,  403,  403,  403,  403,  398,
  269,  397,  434,  215,  669,  449,  450,  226,  522,  253,
  186,  490,  752,  670,  523,  524,  525,  216,  331,  295,
  499,  358,  217,  152,  359,  526,  182,  183,  227,  182,
  183,  417,  417,  394,  394,  449,  450,  581,  397,  397,
  397,  522,  401,  401,  401,  401,  186,  523,  524,  525,
  186,  399,  698,  137,  137,  350,  400,  303,  526,  728,
  402,  402,  402,  402,  353,  129,  449,  450,  472,  396,
  303,  232,  343,  137,  208,  188,  395,  395,  237,  505,
    2,    3,  202,  342,  202,  418,  182,  183,  204,  252,
    2,    3,  228,  573,  278,  510,  514,  449,  450,  521,
  141,  330,  141,  182,  458,  547,  154,  135,  154,  209,
  382,  434,  551,  287,  152,   34,  152,  286,  649,  719,
  720,  653,  361,  595,  166,  476,  477,  246,  324,  245,
  254,  265,  326,  398,  398,  398,  510,  328,  510,  270,
  264,  707,  449,  450,  761,  182,  183,  466,  269,  332,
  372,  468,  510,  470,  387,  450,  450,  450,  450,  450,
  333,  450,  303,  403,  403,  403,  403,  403,  182,  183,
  493,  303,  450,  439,  337,  450,  450,  440,  637,  280,
  302,  281,  282,  246,  697,  245,  695,  135,  283,  378,
  391,  452,  452,  452,  452,  452,  452,  691,  452,  336,
  614,  303,  182,  183,  339,  360,  643,  546,  643,  349,
  303,  403,  454,  406,  754,  396,  396,  757,  413,  182,
  183,  710,  186,  482,  396,  332,  712,  335,  628,  293,
  335,  636,  146,  371,  166,  342,  623,  246,  567,  245,
  421,  450,  300,  433,  559,  736,  433,  562,  563,  365,
  299,  354,  433,  482,  453,  453,  453,  453,  453,  453,
  438,  453,  434,  366,  249,  393,  394,  696,  369,  421,
  431,  741,  377,  390,  555,  455,  373,  556,  451,  451,
  451,  451,  451,  386,  451,  465,  418,  418,  418,  418,
  418,  787,  418,  520,  402,  451,  405,  375,  451,  451,
  421,  412,  303,  418,  499,  499,  316,  418,  317,  246,
  687,  245,  146,  335,  690,  376,  452,  135,  135,  385,
  797,  407,  320,  420,  317,  246,  490,  245,  389,  433,
  417,  417,  417,  417,  395,  417,  249,  135,  449,  450,
  694,    2,    3,  452,  158,  159,  160,  161,  162,  163,
  164,  165,  423,  430,  452,  302,  704,  792,  246,  301,
  245,  452,  300,  249,  451,  404,  337,  419,  464,  426,
  299,  595,  418,  414,  510,  428,  519,  166,  514,  514,
  246,  514,  245,  577,  450,  450,  450,  450,  450,  168,
  450,  450,  738,  429,  172,  174,  573,    2,    3,  619,
  158,  159,  160,  161,  162,  163,  164,  165,  322,  268,
  317,  246,  442,  245,  216,  301,  316,  560,  561,  271,
  271,  452,  452,  452,  452,  452,  700,  452,  452,    2,
    3,  166,  764,  317,  246,  444,  245,  762,  595,  574,
  575,  445,  146,  146,  786,  451,  269,  269,  636,  337,
  769,    2,    3,  452,  158,  159,  160,  161,  162,  163,
  164,  165,  595,  597,  598,  166,  573,  317,  246,  301,
  245,  586,  168,  467,  587,  454,  573,  172,  174,  238,
  182,  183,  238,  238,  453,  453,  453,  453,  453,  239,
  453,  453,  166,  455,  709,  246,  238,  245,  271,  316,
  456,  605,  469,  450,  606,  793,  450,  451,  451,  451,
  451,  451,  471,  451,  451,  418,  418,  418,  418,  418,
  450,  418,  418,    2,    3,  269,  158,  159,  160,  161,
  162,  163,  164,  165,  158,  159,  160,  161,  162,    2,
    3,  301,  158,  159,  160,  161,  162,  163,  164,  165,
  413,  413,  413,  413,  413,  480,  413,  301,  417,  417,
  417,  417,  417,  492,  417,  417,  451,  413,  494,  451,
  501,  413,    2,    3,  506,  158,  159,  160,  161,  162,
  163,  164,  165,  451,  608,  609,  548,  606,  606,  405,
  301,  405,  405,  405,    2,    3,  549,  158,  159,  160,
  161,  162,  163,  164,  165,  558,  405,  564,  166,  584,
  405,  246,  301,  245,  224,  610,  226,  589,  606,  226,
  406,  590,  406,  406,  406,    2,    3,  591,  158,  159,
  160,  161,  162,  163,  164,  165,  413,  406,  166,  596,
  167,  406,  407,  301,  407,  407,  407,  615,  457,  458,
  616,  158,  159,  160,  161,  162,  163,  164,  165,  407,
  600,  604,  166,  407,  495,  246,  301,  245,  617,  622,
  611,  618,  618,  166,  612,  405,  409,  620,  409,  409,
  409,  624,    2,    3,  606,  158,  159,  160,  161,  162,
  163,  164,  165,  409,  621,  244,  166,  409,  571,  246,
  301,  245,  625,  627,  435,  626,  406,  435,  650,    2,
    3,  651,  158,  159,  160,  161,  162,  163,  164,  165,
  408,  435,  408,  408,  408,  646,  662,  301,  407,  606,
  664,  671,  688,  665,  606,  587,  647,  408,  648,  166,
  652,  408,  246,  748,  245,  756,  749,  654,  587,  772,
  166,  582,  618,  246,  659,  245,  773,  433,  335,  651,
  656,  335,  409,  166,  683,  657,  246,  380,  245,  440,
  380,  390,  440,  108,  390,  118,  108,  663,  118,  413,
  413,  413,  413,  413,  166,  729,  730,  246,  685,  245,
  119,  434,  666,  119,  434,  166,  667,  716,  246,  186,
  245,  382,  186,  672,  382,  391,  408,  166,  391,  673,
  246,  313,  245,  392,  313,  674,  392,  675,  405,  405,
  405,  405,  405,  676,  677,    2,    3,  682,  158,  159,
  160,  161,  162,  163,  164,  165,  314,  693,  167,  692,
  718,  701,  721,  723,  747,  702,  703,  706,  713,  406,
  406,  406,  406,  406,  714,    2,    3,  751,  158,  159,
  160,  161,  162,  163,  164,  165,  635,  724,  634,  726,
  734,  407,  407,  407,  407,  407,  760,  768,  735,    2,
    3,  737,  158,  159,  160,  161,  162,  163,  164,  165,
    2,    3,  744,  158,  159,  160,  161,  162,  163,  164,
  165,  635,  745,  634,  746,  409,  409,  409,  409,  409,
  750,  753,  755,    2,    3,  763,  158,  159,  160,  161,
  162,  163,  164,  165,  771,  775,  778,  776,  782,  777,
  780,  781,  783,  784,  788,  789,  790,  791,  795,  798,
  799,    2,    1,  463,  279,   85,   86,   87,  283,  408,
  408,  408,  408,  408,  373,   86,    2,    3,  285,  158,
  159,  160,  161,  162,  163,  164,  165,    2,    3,  368,
  158,  159,  160,  161,  162,  163,  164,  165,   59,  388,
    2,    3,  235,  158,  159,  160,  161,  162,  163,  164,
  165,   92,  341,  316,  369,  389,   93,  342,  299,  213,
  303,    2,    3,  232,  158,  159,  160,  161,  162,  163,
  164,  165,    2,    3,  156,  158,  159,  160,  161,  162,
  163,  164,  165,  294,    2,    3,  260,  158,  159,  160,
  161,  162,  163,  164,  165,   10,  157,   12,  212,  263,
   15,  727,  715,  731,  717,   20,   21,   22,  550,  348,
  344,  381,  576,    2,    3,  570,  158,  159,  160,  161,
  162,  163,  164,  165,  680,  779,  668,   41,  767,   43,
  629,  279,  770,  565,  785,  257,  699,  655,  705,   51,
  182,  183,  503,  630,  159,  160,  161,  162,  631,  632,
  633,  486,  711,    0,    0,  601,    0,    0,  602,    0,
    0,    0,    0,    0,    0,    0,    0,    1,    2,    3,
    4,    0,    0,    0,    0,  182,  183,    0,  158,  159,
  160,  161,  162,  631,  632,  633,    0,    0,    0,    5,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,    0,   33,   34,
   35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
    0,   45,   46,   47,    0,   48,   49,   50,   51,   52,
   53,   54,   55,   56,    0,    0,   57,    0,   58,    1,
    2,    3,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,    0,
   33,   34,   35,   36,   37,   38,    0,   40,   41,   42,
   43,   44,    0,   45,   46,   47,    0,   48,   49,   50,
   51,   52,   53,   54,   55,   56,    2,    3,   57,   10,
   58,   12,    0,    0,   15,    0,    0,    0,    0,   20,
   21,   22,    0,    0,    0,    0,    0,    5,    6,    7,
    0,    0,    0,   11,    0,   13,    0,    0,   16,    0,
    0,   41,    0,   43,    0,    0,    0,    0,  292,    0,
   28,    0,    0,   51,    0,    0,    0,    0,   35,   36,
   37,    0,    0,   40,    0,    0,    0,    0,    0,   45,
    0,   47,    0,   48,    0,   50,    0,   52,   53,    0,
   55,    0,  293,    0,   57,    0,   58,
};
const short yycheck[] = {                                       6,
   52,  149,  150,  151,  207,  278,   18,  138,   11,  138,
  138,   14,   19,   17,    0,   18,  138,  336,    4,  302,
    0,  197,  147,   40,    4,   40,  152,   30,    0,   32,
  197,   17,    4,   44,   47,   41,  127,   17,   44,   42,
   40,  166,  439,   41,   47,   17,  191,  173,  331,  175,
   47,   54,   55,  537,   36,  190,  198,  132,   40,   41,
  301,   43,   44,   45,   46,   47,   41,   42,   43,   44,
   45,   41,   47,   41,   44,   61,   58,   41,   60,  127,
   44,   61,   41,   58,   42,   44,   47,   36,  291,   61,
   47,   40,  295,    5,   43,   44,   45,   46,   47,  718,
   41,  433,   41,   44,   41,   47,   24,  452,  127,   58,
   44,   60,  290,   47,   41,   40,   48,   44,  130,  131,
  132,  127,  127,  126,  127,   57,   40,  130,  131,  132,
  127,  134,  135,   40,  693,   41,   48,  144,  145,   40,
  127,  144,   47,   40,   47,   57,  409,   44,  411,  257,
  258,  257,  258,   42,   62,   44,   40,  127,   47,  145,
  146,   40,  425,  127,   41,  145,  146,   40,  127,  788,
  127,  655,   41,  145,  146,   44,   40,  302,   40,  798,
   41,   58,  465,  586,  187,  127,  127,  190,  127,  314,
  193,  316,  589,  127,  198,  320,  127,  322,  273,  344,
  127,  326,  127,  328,   41,   47,  331,   44,  333,  257,
  258,  336,  198,  348,  356,  456,  148,  197,  198,  127,
  311,   58,  127,   42,  127,  784,  198,  145,  336,  232,
  127,  504,  235,  436,  237,  287,  148,  385,  363,  364,
  243,  258,  257,  258,  257,  258,  257,  258,  127,  374,
  253,  596,  584,   41,  127,  658,   44,  127,  127,  504,
  260,  273,   47,  127,  270,  271,  272,  273,  274,   43,
  273,   45,  324,  292,  557,  273,  274,  334,  260,   47,
  277,  333,  685,  566,  266,  267,  268,  306,   44,  296,
  342,   44,  311,  308,   47,  277,  257,  258,   40,  257,
  258,  276,  277,  273,  274,  273,  274,  432,  272,  273,
  274,  260,  271,  272,  273,  274,  277,  266,  267,  268,
  277,   42,  605,  257,  258,  501,   47,  452,  277,  648,
  271,  272,  273,  274,  501,  277,  273,  274,  324,  127,
  465,   47,  127,  277,  288,  348,  273,  274,   40,  361,
  257,  258,  356,   40,  358,   42,  257,  258,  361,  127,
  257,  258,  266,  415,   42,  368,  369,  273,  274,  372,
  356,  127,  358,  257,  258,  378,  356,   47,  358,  323,
  383,  433,  385,   40,  356,  308,  358,   61,  514,  634,
  635,  517,   44,  445,   40,   41,   42,   43,   40,   45,
  403,  413,   40,  272,  273,  274,  409,   40,  411,  421,
  413,  614,  273,  274,  697,  257,  258,  316,  421,  277,
   44,  320,  425,  322,   40,   41,   42,   43,   44,   45,
   40,   47,  557,  270,  271,  272,  273,  274,  257,  258,
  339,  566,   58,   40,  260,   61,   62,   44,  721,  580,
   40,  580,  580,   43,   44,   45,  604,  127,  580,   44,
   44,   40,   41,   42,   43,   44,   45,  592,   47,   40,
  477,  596,  257,  258,   40,  127,  721,  376,  723,   44,
  605,   44,   61,   44,  687,  273,  274,  690,   44,  257,
  258,  616,  277,  618,  276,  277,  621,   41,  501,  333,
   44,  504,   47,  127,   40,   40,  492,   43,  407,   45,
   44,  127,  492,   41,  396,  663,   44,  399,  400,  127,
  492,  501,   58,  648,   40,   41,   42,   43,   44,   45,
  127,   47,  584,  127,  586,  245,  246,  127,   40,   44,
   44,  666,  127,  127,   41,   61,   40,   44,   41,   42,
   43,   44,   45,  556,   47,   44,   41,   42,   43,   44,
   45,  764,   47,   44,  127,   58,  127,  127,   61,   62,
   44,  127,  697,   58,  626,  627,   40,   62,   42,   43,
  587,   45,  127,  127,  591,   40,   44,  257,  258,   40,
  793,   40,   40,  127,   42,   43,  648,   45,  127,  127,
   42,   43,   44,   45,  127,   47,  658,  277,  273,  274,
  596,  257,  258,   44,  260,  261,  262,  263,  264,  265,
  266,  267,  127,  127,   44,   40,  612,  775,   43,  275,
   45,   44,  612,  685,  127,  127,   44,   42,  127,  127,
  612,  693,  127,  260,  647,  127,  127,   40,  651,  652,
   43,  654,   45,  127,  270,  271,  272,  273,  274,   44,
  276,  277,  665,   40,   44,   44,  718,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,   40,   42,
   42,   43,  127,   45,  306,  275,   44,  397,  398,  257,
  258,  270,  271,  272,  273,  274,  127,  276,  277,  257,
  258,   40,  709,   42,   43,   40,   45,  127,  760,  418,
  419,   61,  257,  258,  127,  127,  257,  258,  721,  127,
  723,  257,  258,   44,  260,  261,  262,  263,  264,  265,
  266,  267,  784,  449,  450,   40,  788,   42,   43,  275,
   45,   41,  127,  127,   44,  272,  798,  127,  127,   44,
  257,  258,   47,  260,  270,  271,  272,  273,  274,  266,
  276,  277,   40,  271,   42,   43,   61,   45,  336,  127,
  270,   41,  127,   44,   44,  782,   47,  270,  271,  272,
  273,  274,  127,  276,  277,  270,  271,  272,  273,  274,
   61,  276,  277,  257,  258,  336,  260,  261,  262,  263,
  264,  265,  266,  267,  260,  261,  262,  263,  264,  257,
  258,  275,  260,  261,  262,  263,  264,  265,  266,  267,
   41,   42,   43,   44,   45,  127,   47,  275,  270,  271,
  272,  273,  274,  334,  276,  277,   44,   58,   47,   47,
   44,   62,  257,  258,   44,  260,  261,  262,  263,  264,
  265,  266,  267,   61,   41,   41,   47,   44,   44,   41,
  275,   43,   44,   45,  257,  258,   44,  260,  261,  262,
  263,  264,  265,  266,  267,  127,   58,   47,   40,   58,
   62,   43,  275,   45,   42,   41,   44,   40,   44,   47,
   41,  127,   43,   44,   45,  257,  258,   44,  260,  261,
  262,  263,  264,  265,  266,  267,  127,   58,   40,   44,
   42,   62,   41,  275,   43,   44,   45,   41,  257,  258,
   44,  260,  261,  262,  263,  264,  265,  266,  267,   58,
  127,   61,   40,   62,   42,   43,  275,   45,   41,   41,
   41,   44,   44,   40,   44,  127,   41,   41,   43,   44,
   45,   41,  257,  258,   44,  260,  261,  262,  263,  264,
  265,  266,  267,   58,   44,  127,   40,   62,   42,   43,
  275,   45,   41,   58,   41,   44,  127,   44,   41,  257,
  258,   44,  260,  261,  262,  263,  264,  265,  266,  267,
   41,   58,   43,   44,   45,   41,   41,  275,  127,   44,
   41,   41,   41,   44,   44,   44,   44,   58,   40,   40,
   44,   62,   43,   41,   45,   41,   44,   40,   44,   41,
   40,   41,   44,   43,   41,   45,   41,   58,   41,   44,
  260,   44,  127,   40,   41,  260,   43,   41,   45,   41,
   44,   41,   44,   41,   44,   41,   44,   61,   44,  270,
  271,  272,  273,  274,   40,  651,  652,   43,   44,   45,
   41,   41,   61,   44,   44,   40,  127,   42,   43,   41,
   45,   41,   44,   41,   44,   41,  127,   40,   44,   41,
   43,   41,   45,   41,   44,   41,   44,   41,  270,  271,
  272,  273,  274,   41,  269,  257,  258,   41,  260,  261,
  262,  263,  264,  265,  266,  267,   40,   44,   42,  127,
   61,  127,   44,   42,   45,  127,  127,  127,  127,  270,
  271,  272,  273,  274,  127,  257,  258,   41,  260,  261,
  262,  263,  264,  265,  266,  267,   43,  127,   45,  127,
  127,  270,  271,  272,  273,  274,   61,   47,  127,  257,
  258,  127,  260,  261,  262,  263,  264,  265,  266,  267,
  257,  258,  127,  260,  261,  262,  263,  264,  265,  266,
  267,   43,  127,   45,  127,  270,  271,  272,  273,  274,
  127,  127,  127,  257,  258,  127,  260,  261,  262,  263,
  264,  265,  266,  267,  333,   61,  269,  127,   44,  127,
  127,  127,  127,   44,   44,   41,  127,   62,   41,   44,
  127,    0,    0,  260,  127,  308,  308,  308,  127,  270,
  271,  272,  273,  274,  127,   40,  257,  258,  127,  260,
  261,  262,  263,  264,  265,  266,  267,  257,  258,   41,
  260,  261,  262,  263,  264,  265,  266,  267,  127,   41,
  257,  258,  127,  260,  261,  262,  263,  264,  265,  266,
  267,   41,   41,   44,   41,   41,   41,   41,  127,   47,
  127,  257,  258,   41,  260,  261,  262,  263,  264,  265,
  266,  267,  257,  258,    4,  260,  261,  262,  263,  264,
  265,  266,  267,  145,  257,  258,   61,  260,  261,  262,
  263,  264,  265,  266,  267,  283,    4,  285,   24,  128,
  288,  647,  626,  654,  627,  293,  294,  295,  383,  193,
  190,  233,  421,  257,  258,  413,  260,  261,  262,  263,
  264,  265,  266,  267,  580,  749,  556,  315,  721,  317,
  501,  319,  723,  403,  760,   55,  606,  527,  612,  327,
  257,  258,  358,  260,  261,  262,  263,  264,  265,  266,
  267,  332,  618,   -1,   -1,  454,   -1,   -1,  455,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  256,  257,  258,
  259,   -1,   -1,   -1,   -1,  257,  258,   -1,  260,  261,
  262,  263,  264,  265,  266,  267,   -1,   -1,   -1,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
   -1,  320,  321,  322,   -1,  324,  325,  326,  327,  328,
  329,  330,  331,  332,   -1,   -1,  335,   -1,  337,  256,
  257,  258,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  278,  279,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,  305,   -1,
  307,  308,  309,  310,  311,  312,   -1,  314,  315,  316,
  317,  318,   -1,  320,  321,  322,   -1,  324,  325,  326,
  327,  328,  329,  330,  331,  332,  257,  258,  335,  283,
  337,  285,   -1,   -1,  288,   -1,   -1,   -1,   -1,  293,
  294,  295,   -1,   -1,   -1,   -1,   -1,  278,  279,  280,
   -1,   -1,   -1,  284,   -1,  286,   -1,   -1,  289,   -1,
   -1,  315,   -1,  317,   -1,   -1,   -1,   -1,  299,   -1,
  301,   -1,   -1,  327,   -1,   -1,   -1,   -1,  309,  310,
  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,  320,
   -1,  322,   -1,  324,   -1,  326,   -1,  328,  329,   -1,
  331,   -1,  333,   -1,  335,   -1,  337,
};
#define YYFINAL 60
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 339
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'$'",0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,
0,0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"EOS",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"tok_identifier","tok_array_identifier","tok_label",
"tok_integer_const","tok_real_const","tok_dp_const","tok_complex_const",
"tok_dcomplex_const","tok_logical_const","tok_string","tok_hollerith",
"tok_edit_descriptor","tok_letter","tok_relop","tok_AND","tok_OR","tok_EQV",
"tok_NEQV","tok_NOT","tok_power","tok_concat","tok_ACCEPT","tok_ASSIGN",
"tok_BACKSPACE","tok_BLOCK","tok_BLOCKDATA","tok_BYTE","tok_CALL",
"tok_CHARACTER","tok_CLOSE","tok_COMMON","tok_COMPLEX","tok_CONTINUE",
"tok_DATA","tok_DIMENSION","tok_DO","tok_DOUBLE","tok_DOUBLECOMPLEX",
"tok_DOUBLEPRECISION","tok_DOWHILE","tok_ELSE","tok_ELSEIF","tok_END",
"tok_ENDDO","tok_ENDFILE","tok_ENDIF","tok_ENTRY","tok_EQUIVALENCE",
"tok_EXTERNAL","tok_FILE","tok_FORMAT","tok_FUNCTION","tok_GO","tok_GOTO",
"tok_IF","tok_IMPLICIT","tok_INCLUDE","tok_INQUIRE","tok_INTEGER",
"tok_INTRINSIC","tok_LOGICAL","tok_NAMELIST","tok_NONE","tok_OPEN",
"tok_PARAMETER","tok_PAUSE","tok_PRECISION","tok_PRINT","tok_PROGRAM",
"tok_READ","tok_REAL","tok_RETURN","tok_REWIND","tok_SAVE","tok_STOP",
"tok_SUBROUTINE","tok_THEN","tok_TO","tok_TYPE","tok_WHILE","tok_WRITE",
"tok_illegal","REDUCE",
};
const char * const yyrule[] = {
"$accept : prog_body",
"prog_body : stmt_list",
"prog_body :",
"stmt_list : stmt_list_item",
"stmt_list : stmt_list stmt_list_item",
"stmt_list_item : ordinary_stmt",
"stmt_list_item : include_stmt",
"stmt_list_item : EOS",
"ordinary_stmt : stmt",
"ordinary_stmt : end_stmt",
"stmt : tok_label unlabeled_stmt",
"stmt : unlabeled_stmt",
"unlabeled_stmt : subprogram_header",
"unlabeled_stmt : specification_stmt",
"unlabeled_stmt : executable_stmt",
"unlabeled_stmt : restricted_stmt",
"unlabeled_stmt : error EOS",
"subprogram_header : prog_stmt",
"subprogram_header : function_stmt",
"subprogram_header : subroutine_stmt",
"subprogram_header : block_data_stmt",
"end_stmt : unlabeled_end_stmt",
"end_stmt : tok_label unlabeled_end_stmt",
"unlabeled_end_stmt : tok_END EOS",
"include_stmt : tok_INCLUDE tok_string EOS",
"specification_stmt : anywhere_stmt",
"specification_stmt : parameter_stmt",
"specification_stmt : implicit_stmt",
"specification_stmt : data_stmt",
"specification_stmt : specif_stmt",
"anywhere_stmt : entry_stmt",
"anywhere_stmt : format_stmt",
"specif_stmt : dimension_stmt",
"specif_stmt : equivalence_stmt",
"specif_stmt : common_stmt",
"specif_stmt : namelist_stmt",
"specif_stmt : type_stmt",
"specif_stmt : external_stmt",
"specif_stmt : intrinsic_stmt",
"specif_stmt : save_stmt",
"executable_stmt : transfer_stmt",
"executable_stmt : nontransfer_stmt",
"transfer_stmt : unconditional_goto",
"transfer_stmt : assigned_goto",
"transfer_stmt : arithmetic_if_stmt",
"transfer_stmt : stop_stmt",
"transfer_stmt : return_stmt",
"nontransfer_stmt : assignment_stmt",
"nontransfer_stmt : assign_stmt",
"nontransfer_stmt : computed_goto",
"nontransfer_stmt : continue_stmt",
"nontransfer_stmt : pause_stmt",
"nontransfer_stmt : read_stmt",
"nontransfer_stmt : accept_stmt",
"nontransfer_stmt : write_stmt",
"nontransfer_stmt : print_stmt",
"nontransfer_stmt : type_output_stmt",
"nontransfer_stmt : rewind_stmt",
"nontransfer_stmt : backspace_stmt",
"nontransfer_stmt : endfile_stmt",
"nontransfer_stmt : open_stmt",
"nontransfer_stmt : close_stmt",
"nontransfer_stmt : inquire_stmt",
"nontransfer_stmt : call_stmt",
"restricted_stmt : restricted_nontransfer_stmt",
"restricted_stmt : else_or_endif_stmt",
"restricted_nontransfer_stmt : logical_if_stmt",
"restricted_nontransfer_stmt : block_if_stmt",
"restricted_nontransfer_stmt : do_stmt",
"restricted_nontransfer_stmt : enddo_stmt",
"else_or_endif_stmt : else_if_stmt",
"else_or_endif_stmt : else_stmt",
"else_or_endif_stmt : end_if_stmt",
"$$1 :",
"prog_stmt : tok_PROGRAM $$1 symbolic_name EOS",
"entry_stmt : tok_ENTRY symbolic_name EOS",
"entry_stmt : tok_ENTRY symbolic_name '(' dummy_argument_list ')' EOS",
"function_stmt : unlabeled_function_stmt",
"unlabeled_function_stmt : typed_function_handle symbolic_name EOS",
"unlabeled_function_stmt : typed_function_handle symbolic_name '(' dummy_argument_list ')' EOS",
"unlabeled_function_stmt : plain_function_handle symbolic_name EOS",
"unlabeled_function_stmt : plain_function_handle symbolic_name '(' dummy_argument_list ')' EOS",
"typed_function_handle : type_name function_keyword",
"plain_function_handle : function_keyword",
"function_keyword : tok_FUNCTION",
"type_name : arith_type_name",
"type_name : plain_char_type_name",
"type_name : char_type_name",
"subroutine_stmt : unlabeled_subroutine_stmt",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name EOS",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name '(' dummy_argument_list ')' EOS",
"subroutine_handle : tok_SUBROUTINE",
"dummy_argument_list :",
"dummy_argument_list : non_empty_arg_list",
"non_empty_arg_list : dummy_argument",
"non_empty_arg_list : non_empty_arg_list ',' dummy_argument",
"dummy_argument : symbolic_name",
"dummy_argument : '*'",
"block_data_stmt : block_data_handle EOS",
"block_data_stmt : block_data_handle symbolic_name EOS",
"block_data_handle : tok_BLOCK tok_DATA",
"block_data_handle : tok_BLOCKDATA",
"dimension_stmt : tok_DIMENSION array_declarator_list EOS",
"array_declarator_list : array_declarator",
"array_declarator_list : array_declarator_list ',' array_declarator",
"array_declarator : symbolic_name '(' dim_bound_list ')'",
"dim_bound_list : dim_bound_item",
"dim_bound_list : dim_bound_list ',' dim_bound_item",
"dim_bound_item : dim_bound_expr",
"dim_bound_item : dim_bound_expr ':' dim_bound_expr",
"dim_bound_item : '*'",
"dim_bound_item : dim_bound_expr ':' '*'",
"$$2 :",
"equivalence_stmt : tok_EQUIVALENCE $$2 equivalence_list EOS",
"equivalence_list : '(' equivalence_list_item ')'",
"equivalence_list : equivalence_list ',' '(' equivalence_list_item ')'",
"equivalence_list_item : equiv_entity ',' equiv_entity",
"equivalence_list_item : equivalence_list_item ',' equiv_entity",
"equiv_entity : symbolic_name",
"equiv_entity : array_equiv_name",
"equiv_entity : substring_equiv_name",
"array_equiv_name : symbolic_name '(' subscript_list ')'",
"substring_equiv_name : symbolic_name substring_interval",
"substring_equiv_name : array_equiv_name substring_interval",
"common_stmt : tok_COMMON common_variable_list EOS",
"common_stmt : tok_COMMON common_block_list EOS",
"common_stmt : tok_COMMON common_variable_list common_block_list EOS",
"common_block_list : labeled_common_block",
"common_block_list : common_block_list labeled_common_block",
"labeled_common_block : common_block_name common_variable_list",
"common_block_name : '/' symbolic_name '/'",
"common_block_name : '/' '/'",
"common_block_name : tok_concat",
"common_variable_list : common_list_item",
"common_variable_list : common_variable_list common_list_item",
"common_list_item : common_entity",
"common_list_item : common_entity ','",
"common_entity : symbolic_name",
"common_entity : array_declarator",
"namelist_stmt : tok_NAMELIST namelist_list EOS",
"namelist_list : namelist_decl",
"namelist_list : namelist_list namelist_decl",
"namelist_decl : namelist_name namelist_var_list",
"namelist_name : '/' symbolic_name '/'",
"namelist_var_list : namelist_item",
"namelist_var_list : namelist_var_list namelist_item",
"namelist_item : symbolic_name",
"namelist_item : symbolic_name ','",
"type_stmt : arith_type_name arith_type_decl_list EOS",
"type_stmt : plain_char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name ',' char_type_decl_list EOS",
"arith_type_name : sizeable_type_name",
"arith_type_name : sizeable_type_name '*' nonzero_unsigned_int_const",
"arith_type_name : unsizeable_type_name",
"sizeable_type_name : tok_INTEGER",
"sizeable_type_name : tok_REAL",
"sizeable_type_name : tok_COMPLEX",
"sizeable_type_name : tok_LOGICAL",
"unsizeable_type_name : tok_DOUBLE tok_PRECISION",
"unsizeable_type_name : tok_DOUBLEPRECISION",
"unsizeable_type_name : tok_DOUBLE tok_COMPLEX",
"unsizeable_type_name : tok_DOUBLECOMPLEX",
"unsizeable_type_name : tok_BYTE",
"plain_char_type_name : tok_CHARACTER",
"char_type_name : plain_char_type_name '*' len_specification",
"arith_type_decl_list : arith_type_decl_item",
"arith_type_decl_list : arith_type_decl_list ',' arith_type_decl_item",
"arith_type_decl_item : symbolic_name",
"arith_type_decl_item : array_declarator",
"char_type_decl_list : char_type_decl_item",
"char_type_decl_list : char_type_decl_list ',' char_type_decl_item",
"char_type_decl_item : symbolic_name",
"char_type_decl_item : symbolic_name '*' len_specification",
"char_type_decl_item : array_declarator",
"char_type_decl_item : array_declarator '*' len_specification",
"implicit_handle : tok_IMPLICIT",
"implicit_stmt : implicit_handle implicit_decl_list EOS",
"implicit_stmt : implicit_handle tok_NONE EOS",
"implicit_decl_list : implicit_decl_item",
"$$3 :",
"implicit_decl_list : implicit_decl_list ',' $$3 implicit_decl_item",
"$$4 :",
"implicit_decl_item : type_name '(' $$4 letter_list ')'",
"letter_list : letter_list_item",
"letter_list : letter_list ',' letter_list_item",
"letter_list_item : tok_letter",
"letter_list_item : tok_letter '-' tok_letter",
"len_specification : '(' '*' ')'",
"len_specification : nonzero_unsigned_int_const",
"len_specification : '(' int_constant_expr ')'",
"parameter_stmt : tok_PARAMETER '(' parameter_defn_list ')' EOS",
"parameter_defn_list : parameter_defn_item",
"parameter_defn_list : parameter_defn_list ',' parameter_defn_item",
"$$5 :",
"parameter_defn_item : symbolic_name $$5 '=' parameter_expr",
"external_stmt : tok_EXTERNAL external_name_list EOS",
"external_name_list : symbolic_name",
"external_name_list : external_name_list ',' symbolic_name",
"intrinsic_stmt : tok_INTRINSIC intrinsic_name_list EOS",
"intrinsic_name_list : symbolic_name",
"intrinsic_name_list : intrinsic_name_list ',' symbolic_name",
"save_stmt : tok_SAVE EOS",
"save_stmt : tok_SAVE save_list EOS",
"save_list : save_item",
"save_list : save_list ',' save_item",
"save_item : symbolic_name",
"save_item : '/' symbolic_name '/'",
"data_stmt : tok_DATA data_defn_list EOS",
"data_defn_list : data_defn_item",
"data_defn_list : data_defn_list data_defn_item",
"data_defn_list : data_defn_list ',' data_defn_item",
"$$6 :",
"$$7 :",
"data_defn_item : data_defn_assignee_list '/' $$6 data_value_list $$7 '/'",
"data_defn_assignee_list : data_defn_assignee",
"data_defn_assignee_list : data_defn_assignee_list ',' data_defn_assignee",
"data_defn_assignee : lvalue",
"data_defn_assignee : data_implied_do_list",
"data_value_list : data_value",
"data_value_list : data_value_list ',' data_value",
"data_value : data_constant_value",
"data_value : data_repeat_factor '*' data_constant_value",
"data_repeat_factor : nonzero_unsigned_int_const",
"data_repeat_factor : symbolic_name",
"data_constant_value : data_constant",
"data_constant_value : symbolic_name",
"data_dlist : data_dlist_item",
"data_dlist : data_dlist ',' data_dlist_item",
"data_dlist_item : array_element_lvalue",
"data_dlist_item : data_implied_do_list",
"data_implied_do_list : '(' data_dlist ',' symbolic_name '=' data_do_loop_bounds ')'",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr ',' int_constant_expr",
"$$8 :",
"$$9 :",
"assignment_stmt : lvalue '=' $$8 expr $$9 EOS",
"lvalue : variable_name",
"lvalue : array_element_lvalue",
"lvalue : substring_lvalue",
"lvalue : stmt_function_handle",
"assign_stmt : tok_ASSIGN pre_label label tok_TO variable_name EOS",
"unconditional_goto : goto pre_label label EOS",
"computed_goto : goto '(' goto_list ')' integer_expr EOS",
"computed_goto : goto '(' goto_list ')' ',' integer_expr EOS",
"assigned_goto : goto symbolic_name EOS",
"assigned_goto : goto symbolic_name '(' goto_list ')' EOS",
"assigned_goto : goto symbolic_name ',' '(' goto_list ')' EOS",
"goto : tok_GOTO",
"goto : tok_GO tok_TO",
"goto_list : pre_label label",
"goto_list : goto_list ',' pre_label label",
"arithmetic_if_stmt : if_handle pre_label label ',' pre_label label ',' pre_label label EOS",
"logical_if_stmt : if_handle executable_stmt",
"block_if_stmt : if_handle tok_THEN EOS",
"$$10 :",
"if_handle : tok_IF '(' $$10 expr ')'",
"else_if_stmt : tok_ELSE block_if_stmt",
"$$11 :",
"$$12 :",
"else_if_stmt : tok_ELSEIF '(' $$11 expr ')' $$12 tok_THEN EOS",
"else_stmt : tok_ELSE EOS",
"end_if_stmt : tok_ENDIF EOS",
"end_if_stmt : tok_END tok_IF EOS",
"do_stmt : do_handle variable_name '=' do_loop_bounds EOS",
"$$13 :",
"do_stmt : do_handle tok_WHILE '(' $$13 expr ')' EOS",
"$$14 :",
"do_stmt : tok_DOWHILE '(' $$14 expr ')' EOS",
"do_handle : tok_DO pre_label label",
"do_handle : tok_DO pre_label label ','",
"do_handle : tok_DO pre_label",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr ',' int_real_dp_expr",
"enddo_stmt : tok_END tok_DO EOS",
"enddo_stmt : tok_ENDDO EOS",
"continue_stmt : tok_CONTINUE EOS",
"stop_stmt : tok_STOP stop_info EOS",
"pause_stmt : tok_PAUSE stop_info EOS",
"stop_info :",
"stop_info : tok_integer_const",
"stop_info : symbolic_name",
"stop_info : tok_string",
"$$15 :",
"write_stmt : write_handle $$15 EOS",
"$$16 :",
"write_stmt : write_handle io_list $$16 EOS",
"$$17 :",
"write_handle : tok_WRITE $$17 '(' control_info_list ')'",
"read_stmt : read_handle '(' control_info_list ')' EOS",
"read_stmt : read_handle '(' control_info_list ')' io_list EOS",
"read_stmt : read_handle '(' control_info_list ')' ',' io_list EOS",
"read_stmt : read_handle format_id EOS",
"read_stmt : read_handle format_id ',' io_list EOS",
"read_handle : tok_READ",
"accept_stmt : tok_ACCEPT format_id EOS",
"accept_stmt : tok_ACCEPT format_id ',' io_list EOS",
"print_stmt : tok_PRINT format_id EOS",
"$$18 :",
"$$19 :",
"print_stmt : tok_PRINT format_id ',' $$18 io_list $$19 EOS",
"type_output_stmt : tok_TYPE format_id EOS",
"$$20 :",
"$$21 :",
"type_output_stmt : tok_TYPE format_id ',' $$20 io_list $$21 EOS",
"control_info_list : control_info_item",
"control_info_list : control_info_list ',' control_info_item",
"control_info_item : symbolic_name '=' unit_id",
"control_info_item : unit_id",
"open_info_list : unit_id",
"open_info_list : symbolic_name '=' unit_id",
"open_info_list : open_info_list ',' open_info_item",
"open_info_item : symbolic_name '=' unit_id",
"open_info_item : symbolic_name",
"io_list : io_item",
"io_list : io_list ',' io_item",
"io_item : expr",
"io_item : io_implied_do_list",
"io_implied_do_list : '(' io_list ',' variable_name '=' do_loop_bounds ')'",
"$$22 :",
"open_stmt : tok_OPEN $$22 '(' open_info_list ')' EOS",
"$$23 :",
"close_stmt : tok_CLOSE $$23 '(' control_info_list ')' EOS",
"$$24 :",
"inquire_stmt : tok_INQUIRE $$24 '(' control_info_list ')' EOS",
"backspace_stmt : backspace_handle unit_id EOS",
"backspace_stmt : backspace_handle '(' control_info_list ')' EOS",
"backspace_handle : tok_BACKSPACE",
"endfile_stmt : endfile_handle unit_id EOS",
"endfile_stmt : endfile_handle '(' control_info_list ')' EOS",
"endfile_handle : tok_ENDFILE",
"endfile_handle : tok_END tok_FILE",
"rewind_stmt : rewind_handle unit_id EOS",
"rewind_stmt : rewind_handle '(' control_info_list ')' EOS",
"rewind_handle : tok_REWIND",
"unit_id : expr",
"unit_id : '*'",
"format_id : char_expr",
"format_id : '*'",
"$$25 :",
"format_stmt : tok_FORMAT $$25 '(' format_spec ')' EOS",
"format_spec :",
"format_spec : nonempty_format_spec",
"nonempty_format_spec : fmt_spec_item",
"nonempty_format_spec : nonempty_format_spec fmt_spec_item",
"fmt_spec_item : repeatable_fmt_item",
"fmt_spec_item : unrepeatable_fmt_item",
"fmt_spec_item : fmt_item_separator",
"repeatable_fmt_item : '(' nonempty_format_spec ')'",
"repeatable_fmt_item : tok_edit_descriptor",
"unrepeatable_fmt_item : tok_string",
"unrepeatable_fmt_item : tok_hollerith",
"unrepeatable_fmt_item : repeat_spec",
"unrepeatable_fmt_item : variable_fmt_item",
"fmt_item_separator : ','",
"fmt_item_separator : '/'",
"fmt_item_separator : tok_concat",
"fmt_item_separator : ':'",
"fmt_item_separator : '.'",
"fmt_item_separator : nonstandard_fmt_item",
"nonstandard_fmt_item : '$'",
"repeat_spec : tok_integer_const",
"repeat_spec : '-' tok_integer_const",
"repeat_spec : '+' tok_integer_const",
"$$26 :",
"$$27 :",
"variable_fmt_item : '<' $$26 integer_expr $$27 '>'",
"stmt_function_handle : scalar_name '(' stmt_function_dummy_list ')'",
"stmt_function_dummy_list :",
"stmt_function_dummy_list : nonempty_stmt_fun_dummy_list",
"nonempty_stmt_fun_dummy_list : stmt_function_dummy_arg",
"nonempty_stmt_fun_dummy_list : nonempty_stmt_fun_dummy_list ',' stmt_function_dummy_arg",
"stmt_function_dummy_arg : variable_name",
"$$28 :",
"call_stmt : call_handle $$28 EOS",
"$$29 :",
"call_stmt : call_handle '(' ')' $$29 EOS",
"$$30 :",
"call_stmt : call_handle '(' expr_list ')' $$30 EOS",
"call_handle : tok_CALL symbolic_name",
"expr_list : expr",
"expr_list : '*' pre_label label",
"expr_list : expr_list ',' expr",
"expr_list : expr_list ',' '*' pre_label label",
"return_stmt : tok_RETURN EOS",
"return_stmt : tok_RETURN integer_expr EOS",
"function_reference : fun_or_substr_handle '(' fun_arg_list ')'",
"fun_or_substr_handle : scalar_name",
"fun_arg_list :",
"fun_arg_list : nonempty_fun_arg_list",
"nonempty_fun_arg_list : expr",
"nonempty_fun_arg_list : nonempty_fun_arg_list ',' expr",
"parameter_expr : expr",
"expr : log_expr",
"log_expr : log_disjunct",
"log_expr : expr tok_EQV log_disjunct",
"log_expr : expr tok_NEQV log_disjunct",
"log_disjunct : log_term",
"log_disjunct : log_disjunct tok_OR log_term",
"log_term : log_factor",
"log_term : log_term tok_AND log_factor",
"log_factor : log_primary",
"log_factor : tok_NOT log_primary",
"log_primary : arith_expr",
"log_primary : log_primary tok_relop log_primary",
"arith_expr : term",
"arith_expr : '-' term",
"arith_expr : '+' term",
"arith_expr : arith_expr '+' term",
"arith_expr : arith_expr '-' term",
"term : factor",
"term : term '/' factor",
"term : term '*' factor",
"factor : char_expr",
"factor : char_expr tok_power factor",
"char_expr : primary",
"char_expr : char_expr tok_concat primary",
"primary : variable_name",
"primary : array_element_name",
"primary : function_reference",
"primary : substring_name",
"primary : literal_const",
"primary : '(' expr ')'",
"literal_const : numeric_const",
"literal_const : tok_string",
"literal_const : tok_hollerith",
"literal_const : tok_logical_const",
"numeric_const : tok_integer_const",
"numeric_const : tok_real_const",
"numeric_const : tok_dp_const",
"numeric_const : tok_complex_const",
"numeric_const : tok_dcomplex_const",
"integer_expr : arith_expr",
"int_real_dp_expr : arith_expr",
"int_constant_expr : arith_expr",
"dim_bound_expr : arith_expr",
"array_element_lvalue : array_name '(' subscript_list ')'",
"array_element_name : array_name '(' subscript_list ')'",
"subscript_list : subscript",
"subscript_list : subscript_list ',' subscript",
"subscript : expr",
"substring_name : fun_or_substr_handle substring_interval",
"substring_name : array_element_name substring_interval",
"substring_lvalue : scalar_name substring_interval",
"substring_lvalue : array_element_lvalue substring_interval",
"substring_interval : '(' ':' ')'",
"substring_interval : '(' substr_index_expr ':' ')'",
"substring_interval : '(' ':' substr_index_expr ')'",
"substring_interval : '(' substr_index_expr ':' substr_index_expr ')'",
"substr_index_expr : arith_expr",
"variable_name : scalar_name",
"variable_name : array_name",
"scalar_name : tok_identifier",
"array_name : tok_array_identifier",
"symbolic_name : tok_identifier",
"symbolic_name : tok_array_identifier",
"data_constant : numeric_const",
"data_constant : '-' numeric_const",
"data_constant : '+' numeric_const",
"data_constant : tok_logical_const",
"data_constant : tok_string",
"data_constant : tok_hollerith",
"nonzero_unsigned_int_const : tok_integer_const",
"pre_label :",
"label : tok_integer_const",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 2575 "fortran.y"

char* get_module_name(){return (MODULE_NAME);}


void
init_parser()			/* Initialize various flags & counters */
{
	initial_flag = TRUE;	/* set flag for keyword test */
	implicit_flag=FALSE;	/* clear flags for IMPLICIT stmt */
	implicit_letter_flag = FALSE;
	implicit_type_given = FALSE;
	implicit_none = FALSE;
	global_save = FALSE;
	prev_token_class = EOS;
	complex_const_allowed = FALSE;
	stmt_sequence_no = 0;
	true_prev_stmt_line_num = 0;
}

		/* Propagate non-integer type if any of DO loop
		   bounds are non-integer. */
PRIVATE int
do_bounds_type(t1,t2,t3)
     Token *t1, *t2, *t3;
{
  int result_class;
       if(datatype_of(t1->class) != type_INTEGER) result_class = t1->class;
  else if(datatype_of(t2->class) != type_INTEGER) result_class = t2->class;
  else if(datatype_of(t3->class) != type_INTEGER) result_class = t3->class;
  else result_class = t1->class;
  return result_class;
}


/* Debugging routine: prints the expression list of various productions */

PRIVATE void
print_exprlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s arglist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
  	    while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
	    }
	}
}

PRIVATE void
print_comlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s varlist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
  	    while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
		}
	  }
}

/* After having parsed prog_stmt, function_stmt, subroutine_stmt,
   block_data_stmt, the stmt_sequence_no is set to the value SEQ_HEADER.
*/

void
check_seq_header(t)
     Token *t;
{
	if(stmt_sequence_no >= SEQ_HEADER) {
	   syntax_error("CRS_724", (t == (Token *) NULL? line_num: t->line_num),
			NO_COL_NUM,
			"missing END statement inserted");
	   msg_tail( (t == (Token *) NULL? "at end of file":
		      "prior to statement") );

	   END_processing(t);
	}
	stmt_sequence_no = SEQ_HEADER;
}

void
check_stmt_sequence(t,seq_num)
     Token *t;
     int seq_num;
{
    if(stmt_sequence_no > seq_num) {
	 syntax_error("CRS_725",t->line_num, NO_COL_NUM,
		      "Statement out of order.");
    }
    else {
	stmt_sequence_no = seq_num;
    }
}

	/* After having parsed end_stmt, common block lists and
	   subprogram argument lists are copied over into global symbol
	   table, the local symbol table is printed out and then cleared,
	   and stmt_sequence_no is set to zero for start of next module.
	*/

PRIVATE void
END_processing(t)
	Token *t;
{
  if(current_module_hash != -1) {
        if(exec_stmt_count == 0 &&
	   current_module_type != type_BLOCK_DATA) {
	  warning("CRS_230",t == (Token *)NULL? line_num: t->line_num, NO_COL_NUM,"Module contains no executable statements");
	}
	if(do_list && t != (Token *)NULL)
	    flush_line_out(t->line_num);
	check_loose_ends(current_module_hash);
	process_lists(current_module_hash);
	debug_symtabs();
	print_loc_symbols(current_module_hash);
	init_symtab();
  }
  exec_stmt_count = 0;
  stmt_sequence_no = 0;
  current_module_hash = -1;
  implicit_type_given = FALSE;
  implicit_none = FALSE;
  true_prev_stmt_line_num = 0;
  integer_context = FALSE;
  global_save = FALSE;
}

		/* Routine to add token t to the front of a token list. */
PRIVATE Token *
append_token(tlist,t)
     Token *tlist, *t;
{
	Token *tcopy;
	if((tcopy=new_token()) == (Token *)NULL){
	  oops_message(OOPS_FATAL,line_num,NO_COL_NUM,
#ifdef LARGE_MACHINE
"Out of token space\nRecompile me with larger TOKENSPACESZ value"
#else
"Out of token space\nRecompile me with LARGE_MACHINE option"
#endif
		       );
	}

	*tcopy = *t;		/* make permanent copy of token */
	tcopy->next_token = tlist; /* link it onto front of list */
	return tcopy;		/* return it as new tlist */
}
#line 1648 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 249 "fortran.y"
{
				/* Create id token for prog if unnamed. */
			  if(current_module_hash == -1) {
			    implied_id_token(&(yyvsp[0]),unnamed_prog);
			    def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[0]),(Token*)NULL);
			    current_module_hash =
			      def_curr_module(&(yyvsp[0]));
			    current_module_type = type_PROGRAM;
			  }

					/* Handle END statement */
			  if(curr_stmt_class == tok_END) {
			    if(prev_stmt_class != tok_RETURN)
			      do_RETURN(current_module_hash,&(yyvsp[0]));
			    END_processing(&(yyval));
			    goto_flag = prev_goto = FALSE;
			  }
			  prev_stmt_class = curr_stmt_class;
			  integer_context = FALSE;
			  true_prev_stmt_line_num = yyval.line_num;
			}
break;
case 10:
#line 285 "fortran.y"
{
#ifdef CHECK_LABELS
			  def_label(&(yyvsp[-1]));
#endif
			  if(executable_stmt)
			    prev_goto = goto_flag;
			}
break;
case 11:
#line 293 "fortran.y"
{
			  if(executable_stmt) {
			    if(prev_goto)
				syntax_error("CRS_701",yyvsp[0].line_num, NO_COL_NUM,
					"No path to this statement");
			    prev_goto = goto_flag;
			  }
			}
break;
case 12:
#line 304 "fortran.y"
{
			    exec_stmt_count = 0;
			    executable_stmt = FALSE;
			}
break;
case 13:
#line 309 "fortran.y"
{
			    executable_stmt = FALSE;
			}
break;
case 14:
#line 313 "fortran.y"
{	/* handle statement functions correctly */
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[0].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN) {
			    stmt_sequence_no = SEQ_STMT_FUN;
			    executable_stmt = FALSE;
			  }
			  else {
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
			    executable_stmt = TRUE;
			  }
			}
break;
case 15:
#line 326 "fortran.y"
{
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
			    executable_stmt = TRUE;
			}
break;
case 16:
#line 332 "fortran.y"
{
			    executable_stmt = TRUE;
			    if(stmt_sequence_no == 0)
			      stmt_sequence_no = SEQ_HEADER;
			    complex_const_allowed = FALSE; /* turn off flags */
			    inside_format=FALSE;
			    integer_context = FALSE;
			    in_assignment_stmt = FALSE;
			    yyval.line_num = prev_stmt_line_num; /* best guess */
			    yyerrok; /* (error message already given) */
			}
break;
case 17:
#line 346 "fortran.y"
{
			    current_module_type = type_PROGRAM;
			}
break;
case 18:
#line 350 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			}
break;
case 19:
#line 354 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			}
break;
case 20:
#line 358 "fortran.y"
{
			    current_module_type = type_BLOCK_DATA;
			}
break;
case 24:
#line 371 "fortran.y"
{
#ifdef ALLOW_INCLUDE
			  if(f77_standard) {
			      warning("CRS_200",yyvsp[-2].line_num,yyvsp[-2].col_num,"non standard:(INCLUDE interdit)");
			  }
 			  open_include_file(yyvsp[-1].value.string);
#else
			  syntax_error("CRS_702",yyvsp[-2].line_num,yyvsp[-2].col_num,
				"statement not permitted");
#endif
 			}
break;
case 25:
#line 390 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				stmt_sequence_no = SEQ_IMPLICIT;
			     }
			}
break;
case 26:
#line 396 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				   stmt_sequence_no = SEQ_IMPLICIT;
			     }
			     else if(stmt_sequence_no > SEQ_SPECIF) {
			       check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			     }
			}
break;
case 27:
#line 405 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_IMPLICIT);
			}
break;
case 28:
#line 409 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_STMT_FUN) {
				stmt_sequence_no = SEQ_STMT_FUN;
		 	     }
			}
break;
case 29:
#line 415 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			}
break;
case 30:
#line 421 "fortran.y"
{
			     goto_flag = prev_goto = FALSE;
			}
break;
case 40:
#line 441 "fortran.y"
{
			    goto_flag=TRUE;
			}
break;
case 41:
#line 445 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 64:
#line 478 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 65:
#line 482 "fortran.y"
{
			    prev_goto = goto_flag =FALSE;
			}
break;
case 68:
#line 491 "fortran.y"
{	/* Flag DO w/o label or DO WHILE forms here */
			  if(is_true(NONSTD_USAGE_FLAG,yyvsp[0].subclass))
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				warning("CRS_201",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(DO sans label)");
#else
			    syntax_error("CRS_703",yyvsp[0].line_num,yyvsp[0].col_num,"Nonstandard syntax: (DO sans label)");
#endif
			}
break;
case 69:
#line 502 "fortran.y"
{
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				warning("CRS_202",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(END DO)");
#else
			    syntax_error("CRS_704",yyvsp[0].line_num,yyvsp[0].col_num,
				    "Nonstandard syntax");
#endif
			}
break;
case 73:
#line 519 "fortran.y"
{check_seq_header(&(yyvsp[0]));}
break;
case 74:
#line 521 "fortran.y"
{
			     def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			     current_module_hash =
			       def_curr_module(&(yyvsp[-1]));
			}
break;
case 75:
#line 534 "fortran.y"
{
			  do_ENTRY(&(yyvsp[-1]),(Token*)NULL
				   ,current_module_hash);
			}
break;
case 76:
#line 539 "fortran.y"
{
			  do_ENTRY(&(yyvsp[-4]),&(yyvsp[-2])
				   ,current_module_hash);
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_exprlist("entry stmt",&(yyvsp[-2]));
#endif
			}
break;
case 78:
#line 555 "fortran.y"
{
			     if(f77_standard) {
				warning("CRS_203",yyvsp[-1].line_num,(unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))),"non standard:(fonction sans arguments)");
				msg_tail(": parentheses required");
			     }
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-1]),(Token*)NULL);
			 current_module_hash= def_curr_module(&(yyvsp[-1]));
			 MODULE_NAME=token_name(yyvsp[-1]);
			}
break;
case 79:
#line 568 "fortran.y"
{
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-4]),&(yyvsp[-2]));
			 current_module_hash= def_curr_module(&(yyvsp[-4]));
			 MODULE_NAME=token_name(yyvsp[-4]);
#ifdef DEBUG_PARSER
			 if(debug_parser)
			   print_exprlist("function stmt",&(yyvsp[-2]));
#endif
			}
break;
case 80:
#line 580 "fortran.y"
{
			     if(f77_standard) {
				warning("CRS_204",yyvsp[-1].line_num,(unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))),"non standard:(manque de parentheses)");
				msg_tail(": parentheses required");
			     }
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			 current_module_hash= def_curr_module(&(yyvsp[-1]));
			 MODULE_NAME=token_name(yyvsp[-1]);
			}
break;
case 81:
#line 592 "fortran.y"
{
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-4]),&(yyvsp[-2]));
			 current_module_hash= def_curr_module(&(yyvsp[-4]));
			 MODULE_NAME=token_name(yyvsp[-4]);
#ifdef DEBUG_PARSER
			 if(debug_parser)
			   print_exprlist("function stmt",&(yyvsp[-2]));
#endif
			}
break;
case 84:
#line 611 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 89:
#line 630 "fortran.y"
{
			  def_function( type_SUBROUTINE,size_DEFAULT, &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash= def_curr_module(&(yyvsp[-1]));
			 MODULE_NAME=token_name(yyvsp[-1]);
			}
break;
case 90:
#line 637 "fortran.y"
{
			  def_function(
				 type_SUBROUTINE,size_DEFAULT,&(yyvsp[-4]),&(yyvsp[-2]));
			  current_module_hash= def_curr_module(&(yyvsp[-4]));
			 MODULE_NAME=token_name(yyvsp[-4]);
#ifdef DEBUG_PARSER
			  if(debug_parser)
			    print_exprlist("subroutine stmt",&(yyvsp[-2]));
#endif
			}
break;
case 91:
#line 650 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 92:
#line 656 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			}
break;
case 94:
#line 663 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 95:
#line 667 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 96:
#line 673 "fortran.y"
{
			     def_arg_name(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 97:
#line 678 "fortran.y"
{
			     yyval.class = type_byte(class_LABEL,type_LABEL);
			     yyval.subclass = 0;
			}
break;
case 98:
#line 688 "fortran.y"
{
				  /* form name %DATnn */
			  ++block_data_number;
			  sprintf(unnamed_block_data+4,"%02d"
				  ,block_data_number%100);
			  implied_id_token(&(yyval),unnamed_block_data);

			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyval),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyval));
			}
break;
case 99:
#line 702 "fortran.y"
{
			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash= def_curr_module(&(yyvsp[-1]));
			 MODULE_NAME=token_name(yyvsp[-1]);
			}
break;
case 100:
#line 712 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 101:
#line 716 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 105:
#line 731 "fortran.y"
{
			     def_array_dim(&(yyvsp[-3]),&(yyvsp[-1]));
			}
break;
case 106:
#line 738 "fortran.y"
{
			     yyval.class = 1;
			     yyval.subclass = yyvsp[0].subclass;
			}
break;
case 107:
#line 743 "fortran.y"
{
			     yyval.class = yyvsp[-2].class + 1; /* one more dimension */
			     yyval.subclass = yyvsp[-2].subclass * yyvsp[0].subclass;
			}
break;
case 108:
#line 750 "fortran.y"
{
			      if( datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.subclass = yyvsp[0].value.integer;
			      else
				yyval.subclass = 0;
			}
break;
case 109:
#line 758 "fortran.y"
{	/* avoid getting 0 - 0 + 1 = 1 if bounds nonconstant */
			      if( datatype_of(yyvsp[-2].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[-2].subclass)
				 && datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.subclass = yyvsp[0].value.integer - yyvsp[-2].value.integer + 1;
			      else
				yyval.subclass = 0;
			}
break;
case 110:
#line 768 "fortran.y"
{
			     yyval.subclass = 0;
			}
break;
case 111:
#line 772 "fortran.y"
{
			     yyval.subclass = 0;
			}
break;
case 112:
#line 778 "fortran.y"
{equivalence_flag = TRUE;}
break;
case 113:
#line 779 "fortran.y"
{equivalence_flag = FALSE;}
break;
case 116:
#line 787 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			}
break;
case 117:
#line 791 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			}
break;
case 118:
#line 798 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 119:
#line 802 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 120:
#line 806 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 124:
#line 821 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval), &(yyvsp[-1]));
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
			   	syntax_error("CRS_705",
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("blank common",&(yyvsp[-1]));
#endif

			}
break;
case 125:
#line 835 "fortran.y"
{
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error("CRS_706",
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");

			}
break;
case 126:
#line 843 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval),&(yyvsp[-2]));
			     if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error("CRS_707",
					     yyvsp[-1].line_num,yyvsp[-1].col_num,
					     "trailing comma");
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("blank common",&(yyvsp[-2]));
#endif
			}
break;
case 127:
#line 861 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			}
break;
case 128:
#line 865 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			}
break;
case 129:
#line 873 "fortran.y"
{
			     def_com_block(&(yyvsp[-1]),&(yyvsp[0]));
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_comlist("labeled common",&(yyvsp[0]));
#endif
			}
break;
case 130:
#line 886 "fortran.y"
{
			     yyval = yyvsp[-1];
			}
break;
case 131:
#line 891 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			}
break;
case 132:
#line 895 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			}
break;
case 133:
#line 901 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 134:
#line 906 "fortran.y"
{
			    if(!is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error("CRS_708",
					yyvsp[0].line_num,yyvsp[0].col_num-1,
					"missing comma");
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			}
break;
case 135:
#line 919 "fortran.y"
{			   /* no comma */
			     yyval.subclass = yyvsp[0].subclass;
			     make_false(COMMA_FLAG,yyval.subclass);
			}
break;
case 136:
#line 924 "fortran.y"
{			   /* has comma */
			     yyval.subclass = yyvsp[-1].subclass;
			     make_true(COMMA_FLAG,yyval.subclass);
   			}
break;
case 137:
#line 931 "fortran.y"
{
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 138:
#line 936 "fortran.y"
{
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 139:
#line 949 "fortran.y"
{
			    if(is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error("CRS_709",yyvsp[-1].line_num,
				 (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))),
					"trailing comma");
			    if(f77_standard) {
				warning("CRS_205",yyvsp[-2].line_num,yyvsp[-2].col_num,"non standard:(NAMELIST)");
			    }
			}
break;
case 141:
#line 962 "fortran.y"
{
			    yyval = yyvsp[0];
			}
break;
case 142:
#line 968 "fortran.y"
{
			     def_namelist(&(yyvsp[-1]),&(yyvsp[0]));
			     yyval = yyvsp[0];
			}
break;
case 143:
#line 975 "fortran.y"
{
			    yyval = yyvsp[-1];
			}
break;
case 144:
#line 981 "fortran.y"
{
			     yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 145:
#line 985 "fortran.y"
{
			    if(!is_true(COMMA_FLAG,yyvsp[-1].subclass))
				syntax_error("CRS_710",
					yyvsp[0].line_num,yyvsp[0].col_num-1,
					"missing comma");
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			}
break;
case 146:
#line 998 "fortran.y"
{			   /* no comma */
			     def_namelist_item(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     make_false(COMMA_FLAG,yyval.subclass);
			}
break;
case 147:
#line 1004 "fortran.y"
{			   /* has comma */
			     def_namelist_item(&(yyvsp[-1]));
			     primary_id_expr(&(yyvsp[-1]),&(yyval));
			     make_true(COMMA_FLAG,yyval.subclass);
			}
break;
case 152:
#line 1019 "fortran.y"
{
			  current_typesize = size_DEFAULT;
			}
break;
case 153:
#line 1024 "fortran.y"
{
			    current_typesize = yyvsp[0].value.integer;
#if 0 /* defunct feature */
			    if(local_wordsize > 0) {
			      /*  recognize REAL*2w as DOUBLE PRECISION */
			      if(current_datatype == type_REAL
				 && yyvsp[0].value.integer == type_size[type_DP])
				current_datatype = type_DP;
			      /*  recognize COMPLEX*4w as DOUBLE COMPLEX */
			      if(current_datatype == type_COMPLEX
				 && yyvsp[0].value.integer==type_size[type_DCOMPLEX])
				current_datatype = type_DCOMPLEX;
			    }
#endif
			     if(f77_standard) {
				warning("CRS_206",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(declaration hors norme: REAL*8,...)");
			     }
			}
break;
case 155:
#line 1047 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     integer_context = TRUE;
			}
break;
case 156:
#line 1052 "fortran.y"
{
			     current_datatype = type_REAL;
			     integer_context = TRUE;
			}
break;
case 157:
#line 1057 "fortran.y"
{
			     current_datatype = type_COMPLEX;
			     integer_context = TRUE;
			}
break;
case 158:
#line 1062 "fortran.y"
{
			     current_datatype = type_LOGICAL;
			     integer_context = TRUE;
			}
break;
case 159:
#line 1069 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			}
break;
case 160:
#line 1074 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			}
break;
case 161:
#line 1079 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				warning("CRS_207",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(type DOUBLE COMPLEX)");
			     }
			}
break;
case 162:
#line 1087 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				warning("CRS_208",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(type DOUBLE COMPLEX)");
			     }
			}
break;
case 163:
#line 1095 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     current_typesize = 1;
			     if(f77_standard)
			       warning("CRS_209",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(type BYTE)");
			}
break;
case 164:
#line 1104 "fortran.y"
{
			     current_datatype = type_STRING;
			     current_typesize = 1;
			     integer_context = TRUE;
			}
break;
case 165:
#line 1112 "fortran.y"
{
			     current_typesize = yyvsp[0].value.integer;
			}
break;
case 168:
#line 1122 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 169:
#line 1127 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 172:
#line 1138 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 173:
#line 1143 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
			}
break;
case 174:
#line 1148 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 175:
#line 1153 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
			}
break;
case 176:
#line 1161 "fortran.y"
{implicit_flag=TRUE;}
break;
case 177:
#line 1165 "fortran.y"
{
			    implicit_flag=FALSE;
			    if(implicit_none) {
				syntax_error("CRS_711",yyvsp[-2].line_num,yyvsp[-2].col_num,
				     "conflicts with IMPLICIT NONE");
			    }
			    else {
				implicit_type_given = TRUE;
			    }
			}
break;
case 178:
#line 1177 "fortran.y"
{
			    implicit_flag=FALSE;
				if(implicit_type_given) {
				    syntax_error("CRS_712",yyvsp[-2].line_num,yyvsp[-2].col_num,
					 "conflicts with IMPLICIT statement");
				}
				else {
				    if(f77_standard)
				      warning("CRS_210",yyvsp[-1].line_num,yyvsp[-1].col_num,"non standard:(IMPLICIT NONE)");
				    implicit_none = TRUE;
				}
			}
break;
case 180:
#line 1192 "fortran.y"
{initial_flag = TRUE;}
break;
case 182:
#line 1198 "fortran.y"
{implicit_letter_flag = TRUE;}
break;
case 183:
#line 1199 "fortran.y"
{implicit_letter_flag = FALSE;}
break;
case 186:
#line 1207 "fortran.y"
{
			  int c1 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1))) {
			    warning("CRS_211",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(caracteres interdits)");
			    msg_tail(": nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
			     		c1,c1);
			}
break;
case 187:
#line 1219 "fortran.y"
{
			  int c1 = (int)yyvsp[-2].subclass,
			      c2 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1) || !isalpha(c2))) {
			    if(!isalpha(c1))
			      warning("CRS_212",yyvsp[-2].line_num,yyvsp[-2].col_num,"non standard:(caracteres interdits)");
			    else
			      warning("CRS_213",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(caracteres interdits)");
			    msg_tail("nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
					c1,c2);
			}
break;
case 188:
#line 1239 "fortran.y"
{yyval.value.integer = size_ADJUSTABLE;}
break;
case 189:
#line 1241 "fortran.y"
{yyval.value.integer = yyvsp[0].value.integer;}
break;
case 190:
#line 1243 "fortran.y"
{
			      if((yyval.value.integer = yyvsp[-1].value.integer) <= 0 ){
				warning("CRS_214",yyvsp[-1].line_num,yyvsp[-1].col_num,"invalid length specification");
				msg_tail(": substituting 1");
				yyval.value.integer = 1;
			      }
			    }
break;
case 194:
#line 1260 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 195:
#line 1262 "fortran.y"
{
			     def_parameter(&(yyvsp[-3]),&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[-3]),&(yyvsp[-3]));
			     assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-1]),&(yyvsp[0]));
			     complex_const_allowed = FALSE;
			}
break;
case 197:
#line 1275 "fortran.y"
{
			     def_ext_name(&(yyvsp[0]));
			}
break;
case 198:
#line 1279 "fortran.y"
{
			     def_ext_name(&(yyvsp[0]));
			}
break;
case 200:
#line 1289 "fortran.y"
{
			     def_intrins_name(&(yyvsp[0]));
			}
break;
case 201:
#line 1293 "fortran.y"
{
			     def_intrins_name(&(yyvsp[0]));
			}
break;
case 202:
#line 1300 "fortran.y"
{
			  global_save = TRUE;
			}
break;
case 206:
#line 1311 "fortran.y"
{
			     save_variable(&(yyvsp[0]));
			}
break;
case 207:
#line 1315 "fortran.y"
{
/***			     def_com_block(&($2),(Token*)NULL);***/
			     save_com_block(&(yyvsp[-1]));
			}
break;
case 212:
#line 1331 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 213:
#line 1333 "fortran.y"
{complex_const_allowed=FALSE;}
break;
case 217:
#line 1342 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			}
break;
case 224:
#line 1358 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			}
break;
case 226:
#line 1365 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			}
break;
case 229:
#line 1376 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			}
break;
case 231:
#line 1384 "fortran.y"
{
			    use_implied_do_index(&(yyvsp[-3]));
			}
break;
case 234:
#line 1395 "fortran.y"
{complex_const_allowed = TRUE;
				    in_assignment_stmt = TRUE;}
break;
case 235:
#line 1397 "fortran.y"
{
			  assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-2]),
					&(yyvsp[0]));
			  complex_const_allowed = FALSE;
			  in_assignment_stmt = FALSE;
			}
break;
case 236:
#line 1404 "fortran.y"
{
				/* Clear u-b-s flags spuriously set */
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[-5].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN)
			     stmt_function_stmt(&(yyvsp[-5]));
		        }
break;
case 241:
#line 1422 "fortran.y"
{
			    do_ASSIGN(&(yyvsp[-1]));
			}
break;
case 245:
#line 1439 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-1]));
			}
break;
case 246:
#line 1443 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-4]));
			}
break;
case 247:
#line 1447 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-5]));
			}
break;
case 248:
#line 1453 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 249:
#line 1457 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 252:
#line 1469 "fortran.y"
{
			  int t=datatype_of(yyvsp[-9].class);
			  if(t != type_INTEGER && t != type_REAL
			     && t != type_DP && t != type_ERROR ) {
			    syntax_error("CRS_713",yyvsp[-9].line_num,yyvsp[-9].col_num,
		  "integer, real, or double precision expression required");
			  }
			}
break;
case 253:
#line 1481 "fortran.y"
{
			  int t=datatype_of(yyvsp[-1].class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error("CRS_714",yyvsp[-1].line_num,yyvsp[-1].col_num,
					  "logical expression required");
			}
break;
case 254:
#line 1491 "fortran.y"
{
			  int t=datatype_of(yyvsp[-2].class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error("CRS_715",yyvsp[-2].line_num,yyvsp[-2].col_num,
					  "logical expression required");
			}
break;
case 255:
#line 1499 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 256:
#line 1500 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;	/* for is_keyword */
			    yyval = yyvsp[-1]; /* Inherit expr for type checking above */
			}
break;
case 258:
#line 1513 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 259:
#line 1514 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;
			}
break;
case 264:
#line 1544 "fortran.y"
{
			     use_lvalue(&(yyvsp[-3]));
			     use_variable(&(yyvsp[-3]));

				/* Check for non-integer DO index or bounds */
			     if(datatype_of(yyvsp[-3].class) == type_INTEGER
				&& datatype_of(yyvsp[-1].class) != type_INTEGER)
			       warning("CRS_215",yyvsp[-2].line_num,yyvsp[-2].col_num,"type mismatch between DO index and bounds");

			     else if(datatype_of(yyvsp[-3].class) != type_INTEGER)
			       if(datatype_of(yyvsp[-1].class) != type_INTEGER) {
				 if(port_check)
				   warning("CRS_216",yyvsp[-1].line_num,yyvsp[-1].col_num,"NP:non-integer DO loop bounds");
			       }
			       else {
				 if(trunc_check)
				   warning("CRS_217",yyvsp[-3].line_num,yyvsp[-3].col_num,"DO index is not integer");
			       }
			}
break;
case 265:
#line 1564 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 266:
#line 1565 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			}
break;
case 267:
#line 1573 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 268:
#line 1574 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			}
break;
case 271:
#line 1586 "fortran.y"
{
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			    integer_context=FALSE;
			}
break;
case 272:
#line 1593 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-2]),&(yyvsp[0]),&(yyvsp[0]));
			}
break;
case 273:
#line 1597 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-4]),&(yyvsp[-2]),&(yyvsp[0]));
			}
break;
case 281:
#line 1621 "fortran.y"
{
			     use_variable(&(yyvsp[0]));
			}
break;
case 283:
#line 1629 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 285:
#line 1631 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 287:
#line 1634 "fortran.y"
{control_item_count = 0;}
break;
case 288:
#line 1636 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 294:
#line 1649 "fortran.y"
{control_item_count = 0;}
break;
case 295:
#line 1653 "fortran.y"
{
			    if(f77_standard)
				warning("CRS_218",yyvsp[-2].line_num,yyvsp[-2].col_num,"non standard:(FORMAT)");
			}
break;
case 296:
#line 1658 "fortran.y"
{
			    if(f77_standard)
				warning("CRS_219",yyvsp[-4].line_num,yyvsp[-4].col_num,"non standard:(FORMAT)");
			}
break;
case 298:
#line 1667 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 299:
#line 1668 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 301:
#line 1672 "fortran.y"
{
			    if(f77_standard)
				warning("CRS_220",yyvsp[-2].line_num,yyvsp[-2].col_num,"non standard:(FORMAT)");
			}
break;
case 302:
#line 1677 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 303:
#line 1678 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 304:
#line 1679 "fortran.y"
{
			    if(f77_standard)
				warning("CRS_221",yyvsp[-6].line_num,yyvsp[-6].col_num,"non standard:(FORMAT)");
			}
break;
case 305:
#line 1687 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 306:
#line 1691 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 307:
#line 1700 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			}
break;
case 308:
#line 1704 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
					/* WRITE(string,...) means store
					   output in the string */
				if(curr_stmt_class == tok_WRITE
				 && control_item_count == 0
				 && datatype_of(yyvsp[0].class) == type_STRING)
				    use_lvalue(&(yyvsp[0]));
					/* READ/WRITE(..,namelist) means
					   I/O with variables of namelist. */
				else if( control_item_count == 1
				    && datatype_of(yyvsp[0].class) == type_NAMELIST)
				    ref_namelist(&(yyvsp[0]),curr_stmt_class);

				use_variable(&(yyvsp[0]));
			    }
			}
break;
case 309:
#line 1730 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    ++control_item_count;
			}
break;
case 310:
#line 1738 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			    ++control_item_count;
			}
break;
case 311:
#line 1743 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 312:
#line 1749 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			}
break;
case 313:
#line 1753 "fortran.y"
{
			    use_special_open_keywd(&(yyvsp[0]));
			}
break;
case 316:
#line 1764 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				if( curr_stmt_class == tok_READ ||
				    curr_stmt_class == tok_ACCEPT )
				    use_lvalue(&(yyvsp[0]));
				else
				    use_variable(&(yyvsp[0]));
			    }
			}
break;
case 318:
#line 1778 "fortran.y"
{
			     use_implied_do_index(&(yyvsp[-3]));
			}
break;
case 319:
#line 1784 "fortran.y"
{control_item_count = 0;}
break;
case 321:
#line 1789 "fortran.y"
{control_item_count = 0;}
break;
case 323:
#line 1794 "fortran.y"
{control_item_count = 0;}
break;
case 325:
#line 1800 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 327:
#line 1808 "fortran.y"
{control_item_count = 0;}
break;
case 328:
#line 1813 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 330:
#line 1821 "fortran.y"
{control_item_count = 0;}
break;
case 331:
#line 1822 "fortran.y"
{control_item_count = 0;}
break;
case 332:
#line 1827 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 334:
#line 1835 "fortran.y"
{control_item_count = 0;}
break;
case 337:
#line 1849 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
			}
break;
case 339:
#line 1858 "fortran.y"
{inside_format=TRUE;}
break;
case 340:
#line 1859 "fortran.y"
{
			  inside_format=FALSE;
			}
break;
case 359:
#line 1895 "fortran.y"
{
			  if(f77_standard)
			     warning("CRS_222",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(FORMAT)");
			}
break;
case 364:
#line 1910 "fortran.y"
{inside_format=FALSE;}
break;
case 365:
#line 1911 "fortran.y"
{inside_format=TRUE;}
break;
case 366:
#line 1912 "fortran.y"
{
			  if(f77_standard)
			     warning("CRS_223",yyvsp[-4].line_num,yyvsp[-4].col_num,"non standard:(FORMAT)");
			}
break;
case 367:
#line 1921 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[-3]),SEQ_STMT_FUN);

				def_stmt_function(&(yyvsp[-3]),&(yyvsp[-1]));
					/* make token info */
				primary_id_expr(&(yyvsp[-3]),&(yyval));
#ifdef DEBUG_PARSER
				if(debug_parser)
				  print_exprlist("stmt function",&(yyvsp[-1]));
#endif
			}
break;
case 368:
#line 1935 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			}
break;
case 370:
#line 1942 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 371:
#line 1947 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 373:
#line 1957 "fortran.y"
{
			     call_subr(&(yyvsp[0]),(Token*)NULL);
			     complex_const_allowed = FALSE;
			}
break;
case 375:
#line 1963 "fortran.y"
{
			     call_subr(&(yyvsp[-2]),(Token*)NULL);
			     complex_const_allowed = FALSE;
			}
break;
case 377:
#line 1969 "fortran.y"
{
			     call_subr(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
			     if(debug_parser)
				print_exprlist("call stmt",&(yyvsp[-1]));
#endif
			     complex_const_allowed = FALSE;
			}
break;
case 379:
#line 1980 "fortran.y"
{
			     complex_const_allowed = TRUE;
			     yyval = yyvsp[0];
			}
break;
case 380:
#line 1986 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 381:
#line 1994 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 382:
#line 1998 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 383:
#line 2006 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-4].next_token,&(yyvsp[0]));
			}
break;
case 384:
#line 2013 "fortran.y"
{
			     do_RETURN(current_module_hash,&(yyvsp[-1]));
			}
break;
case 385:
#line 2017 "fortran.y"
{
			     do_RETURN(current_module_hash,&(yyvsp[-2]));
			}
break;
case 386:
#line 2024 "fortran.y"
{
				   /* restore context */
				if(!is_true(COMPLEX_FLAG,yyvsp[-3].subclass))
				  complex_const_allowed=FALSE;
				if(is_true(IN_ASSIGN,yyvsp[-3].subclass))
				  in_assignment_stmt = TRUE;

				  /* Change empty arg list to no arg list */
				if(yyvsp[-1].next_token == NULL)
				  call_func(&(yyvsp[-3]),(Token *)NULL);
				else
				  call_func(&(yyvsp[-3]),&(yyvsp[-1]));
							/* make token info */
				func_ref_expr(&(yyvsp[-3]),&(yyvsp[-1]),&(yyval));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("function",&(yyvsp[-1]));
#endif
			}
break;
case 387:
#line 2046 "fortran.y"
{
			  if(complex_const_allowed)/* save context */
			    make_true(COMPLEX_FLAG,yyval.subclass);
			  complex_const_allowed=TRUE;
			  if(in_assignment_stmt)
			    make_true(IN_ASSIGN,yyval.subclass);
			  in_assignment_stmt = FALSE;
			}
break;
case 388:
#line 2056 "fortran.y"
{
				yyval.class = 0;
				yyval.next_token = NULL;
			}
break;
case 390:
#line 2064 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 391:
#line 2068 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 392:
#line 2076 "fortran.y"
{
			  int t=datatype_of(yyvsp[0].class);
			  if( t != type_ERROR){
			    if( ! is_const_type(t) ) {
			      syntax_error("CRS_716",yyvsp[0].line_num,yyvsp[0].col_num,
		      "arithmetic, char, or logical expression expected");
			    }
			    else {
			      if( !is_true(PARAMETER_EXPR,yyvsp[0].subclass) ) {
				syntax_error("CRS_717",yyvsp[0].line_num,yyvsp[0].col_num,
					   "constant expression expected");
			      }
			    /* Here we allow, with some warnings, expr
			       containing intrins func or **REAL in
			       PARAMETER defn. */
			      else if( !is_true(CONST_EXPR,yyvsp[0].subclass) ) {
				if(f77_standard) {
				  warning("CRS_224",yyvsp[0].line_num,yyvsp[0].col_num,"non standard:(fonctions interdites dans les PARAMETER)");
				  msg_tail(
			 "intrinsic function or **REAL in PARAMETER defn");
				}
			      }
			    }
			  }
			}
break;
case 393:
#line 2105 "fortran.y"
{
#ifdef DEBUG_PARSER
			    if(debug_parser) {
				fprintf(list_fd,
					"\nexpr: class=0x%x subclass=0x%x",
					yyvsp[0].class,
					yyvsp[0].subclass);
			    }
#endif
			}
break;
case 395:
#line 2120 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 396:
#line 2125 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 398:
#line 2134 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 400:
#line 2143 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 402:
#line 2152 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			}
break;
case 404:
#line 2160 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 406:
#line 2170 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			}
break;
case 407:
#line 2174 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			}
break;
case 408:
#line 2178 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 409:
#line 2183 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 411:
#line 2192 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    if(div_check &&
			       !is_true(CONST_EXPR,yyvsp[0].subclass)){
				warning("CRS_225",yyvsp[-1].line_num,yyvsp[-1].col_num,"Possible division by zero");
			    }
			}
break;
case 412:
#line 2201 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 414:
#line 2210 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 416:
#line 2219 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			}
break;
case 421:
#line 2234 "fortran.y"
{
			    yyval.subclass = 0;
			    make_true(CONST_EXPR,yyval.subclass);
			    make_true(PARAMETER_EXPR,yyval.subclass);
			    make_true(LIT_CONST,yyval.subclass);
			    make_true(EVALUATED_EXPR,yyval.subclass);
			}
break;
case 422:
#line 2242 "fortran.y"
{
			    yyval = yyvsp[-1];
				/* (identifier) becomes a non-identifier */
			    if(is_true(LVALUE_EXPR,yyvsp[-1].subclass)) {
				if(pretty_flag) {
				  ugly_code("CRS_226",yyvsp[-1].line_num,yyvsp[-1].col_num,"Extraneous parentheses");
				}
				use_variable(&(yyvsp[-1]));
				make_false(LVALUE_EXPR,yyval.subclass);
				make_false(ARRAY_ID_EXPR,yyval.subclass);
				make_false(ID_EXPR,yyval.subclass);
			    }
			}
break;
case 423:
#line 2260 "fortran.y"
{
			    /* (class is set in numeric_const productions) */
			    yyval.size = size_DEFAULT;
			}
break;
case 424:
#line 2265 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_STRING);
			    /* (size is set in get_string) */
			}
break;
case 425:
#line 2270 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_HOLLERITH);
			    /* (size is set in get_hollerith) */
			    if(port_check && hollerith_check) {
				warning("CRS_227",yyvsp[0].line_num,yyvsp[0].col_num,"hollerith constant may not be portable");
			    }
			}
break;
case 426:
#line 2278 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_LOGICAL);
			    yyval.size = size_DEFAULT;
			}
break;
case 427:
#line 2285 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_INTEGER);
			}
break;
case 428:
#line 2289 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_REAL);
			}
break;
case 429:
#line 2293 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DP);
			}
break;
case 430:
#line 2297 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_COMPLEX);
			}
break;
case 431:
#line 2301 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DCOMPLEX);
			}
break;
case 432:
#line 2308 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    if(datatype_of(yyvsp[0].class) != type_INTEGER) {
				syntax_error("CRS_718",
					yyvsp[0].line_num,yyvsp[0].col_num,
					"expression must be integer type");
			    }
			}
break;
case 433:
#line 2322 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    {
				int t=datatype_of(yyvsp[0].class);
				    if(t != type_INTEGER && t != type_REAL
					&& t != type_DP ) {
					syntax_error("CRS_719",
					  yyvsp[0].line_num,yyvsp[0].col_num,
		"expression must be integer, real, or double precision type");
			    	    }
			    }
			}
break;
case 434:
#line 2342 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    if( ! is_true(CONST_EXPR,yyvsp[0].subclass) ) {
				syntax_error("CRS_720",
					yyvsp[0].line_num,yyvsp[0].col_num,
					"constant expression expected");
			    }
			    else {
			      if(datatype_of(yyvsp[0].class) != type_INTEGER){
				syntax_error("CRS_721",
					yyvsp[0].line_num,yyvsp[0].col_num,
					"integer expression expected");
			      }
			      else {
				yyval.value.integer = int_expr_value(&(yyvsp[0]));
			      }
			    }
			}
break;
case 435:
#line 2366 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }

			    if( datatype_of(yyvsp[0].class) != type_INTEGER ){
				syntax_error("CRS_722",
					yyvsp[0].line_num,yyvsp[0].col_num,
					"integer dimension expected");
				yyval.value.integer = 0;
			    }
			    else {
			      if( is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.value.integer =
				  int_expr_value(&(yyvsp[0]));
			      else		/* must be dummy */
				yyval.value.integer = 0;
			    }
			}
break;
case 436:
#line 2392 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array lvalue",&(yyvsp[-1]));
#endif
					/* array now becomes scalar */
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			}
break;
case 437:
#line 2404 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array",&(yyvsp[-1]));
#endif
					/* array now becomes scalar */
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			}
break;
case 438:
#line 2416 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 439:
#line 2420 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 440:
#line 2426 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
				/* check subscript exprs for integer type */
			    if(datatype_of(yyvsp[0].class) != type_INTEGER)
			      if(trunc_check)
			         warning("CRS_228",yyvsp[0].line_num,yyvsp[0].col_num,"subscript is not integer");
			}
break;
case 441:
#line 2439 "fortran.y"
{
				   /* restore status of complex flag */
			    if(!is_true(COMPLEX_FLAG,yyvsp[-1].subclass))
				  complex_const_allowed=FALSE;
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 442:
#line 2447 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 443:
#line 2453 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 444:
#line 2457 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 445:
#line 2463 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=0; /* 0 means LEN */
			}
break;
case 446:
#line 2469 "fortran.y"
{
			    yyval.class=yyvsp[-2].value.integer;
			    yyval.subclass=0; /* 0 means LEN */
			}
break;
case 447:
#line 2474 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=yyvsp[-1].value.integer;
			}
break;
case 448:
#line 2479 "fortran.y"
{
			      yyval.class=yyvsp[-3].value.integer;
			      yyval.subclass=yyvsp[-1].value.integer;
			}
break;
case 449:
#line 2486 "fortran.y"
{
			  if(is_true(ID_EXPR,yyvsp[0].subclass)){
			    use_variable(&(yyvsp[0]));
			  }
				/* check validity and replace nonconst
				   value by size_UNKNOWN. */
			  if(is_true(CONST_EXPR,yyvsp[0].subclass)) {
			    if( (yyval.value.integer=int_expr_value(&(yyvsp[0]))) < 1) {
			      syntax_error("CRS_723",yyvsp[0].line_num,yyvsp[0].col_num,
					   "invalid substring index");
			    }
			  }
			  else  /* (no longer need ID hash index) */
			    yyval.value.integer=size_UNKNOWN;
			}
break;
case 452:
#line 2511 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 453:
#line 2518 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 462:
#line 2544 "fortran.y"
{
			  if(yyvsp[0].value.integer == 0) {
			    warning("CRS_229",yyvsp[0].line_num,yyvsp[0].col_num,"nonzero integer expected");
			    msg_tail(": substituting 1");
			    yyval.value.integer = 1;
			  }
			}
break;
case 463:
#line 2558 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 464:
#line 2565 "fortran.y"
{
				integer_context=FALSE;
				yyval.class = type_byte(class_LABEL,type_LABEL);
				yyval.subclass = 0;
			}
break;
#line 3958 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
