import os
import string
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Repertoire de reference de HOMARD sur la machine
#     2. Version de homard
#     3. Niveau d'information au sens ASTER
#     4, 5, 6, 7, 8 : Puis, pour chaque fichier parmi :
#              . maillage a l'etape n
#              . maillage a l'etape n+1
#              . solution a l'etape n
#              . solution a l'etape n+1
#              . indicateur d'erreur
#        . 0, si pas de fichier
#          numero d'unite logique aster correspondant au fichier, si fichier
#      9. rien, si version publique de HOMARD
#          -PERSO, si version personnelle
#     10. repertoire personnel HOMARD si version personnelle
#
#
def aster_homard_3 (arguments):
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Il manque des arguments.",
                      2 : "Il y a trop d'arguments.",
                      3 : "Les arguments sont mauvais.",
                      4 : "La variable d'environnement HOMARD_USER n'est pas dfinie." }
#
#  print blabla,arguments
  dict_arguments = {}
#
# 2. Decodage et stockage des arguments :
#
# 2.1. Verification du nombre
#
  nbarg = len(arguments)
  if nbarg < 8 :
    codret = 1
  else :
    codret = 0
#
  while codret == 0 :
#
# 2.2. Le repertoire de reference de HOMARD
#
    dict_arguments ["rep_refe_LOGICIEL"] = arguments[0]
#
# 2.3. La version de HOMARD
#
    dict_arguments ["nuvers"] = arguments[1]
#
# 2.4. Le niveau d'information
#
    dict_arguments ["nivinf"] = string.atoi(arguments[2])
#
# 2.5. Les unites logiques liees aux fichiers
#
    indice_argu = 2
    Liste = [ "CCMaiN__", "CCMaiNP1", "CCSolN__", "CCSolNP1", "CCIndica" ]
    for mot_cle in Liste :
      indice_argu = indice_argu + 1
      nro = string.atoi(arguments[indice_argu])
      dict_arguments [mot_cle+"nro"] = nro
#
# 2.6. Est-ce une version personnelle ?
#
    dict_arguments ["PERSO"] = "non"
#
    if len ( dict_arguments ["nuvers"] ) > 5 :
#
      if dict_arguments ["nuvers"][-6:] == ".PERSO" :
#
        dict_arguments ["PERSO"] = "oui"
        daux = os.environ
        if daux.has_key("HOMARD_USER"):
          dict_arguments ["rep_pers_LOGICIEL"] = daux["HOMARD_USER"]
        else :
          erreur = 4
          break
        dict_arguments ["nuvers"] = dict_arguments ["nuvers"][:-6]
#
    break
#
# 3. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
#
  dict_arguments ["code_de_retour"] = codret
  return dict_arguments
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  L1=["/homard", "2","V4.0","80","0","0","0","0"]
  L1_refe={'nuvers': 'V4.0', 'code_de_retour': 0, 'CCMaiN__nro': 80, 'PERSO': 'non', 'CCSolN__nro': 0, 'CCMaiNP1nro': 0, 'nivinf': 2, 'CCIndicanro': 0, 'rep_refe_LOGICIEL': '/homard', 'CCSolNP1nro': 0}
  L1_calc = aster_homard_3 (L1)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  L2=["/logiciels/trifou/HOMARD/HOMARD_PUBLIC", "2","V4.0","80","81","0","0","0"]
  L2_refe={'nuvers': 'V4.0', 'code_de_retour': 0, 'CCMaiN__nro': 80, 'PERSO': 'non', 'CCSolN__nro': 0, 'CCMaiNP1nro': 81, 'nivinf': 2, 'CCIndicanro': 0, 'rep_refe_LOGICIEL': '/logiciels/trifou/HOMARD/HOMARD_PUBLIC', 'CCSolNP1nro': 0}
  L2_calc=aster_homard_3 (L2)
  verif ("Test sur L2",L2_refe,L2_calc)
#
  L3=["/homard", "2","V4.n","80","81","0","0","0","-PERSO","/home/nicolas/HOMARD"]
  L3_refe={'rep_refe_LOGICIEL': '/homard', 'nuvers': 'V4.n', 'code_de_retour': 0, 'CCMaiN__nro': 80, 'PERSO': 'oui', 'CCSolN__nro': 0, 'CCMaiNP1nro': 81, 'nivinf': 2, 'CCIndicanro': 0, 'rep_pers_LOGICIEL': '/home/nicolas/HOMARD', 'CCSolNP1nro': 0}
  L3_calc=aster_homard_3 (L3)
  verif ("Test sur L3",L3_refe,L3_calc)
#
  L4=["/homard", "2","V4.n","80","81","0","0","0","-PERSO"]
  L4_refe={'nuvers': 'V4.n', 'code_de_retour': 1, 'CCMaiN__nro': 80, 'PERSO': 'oui', 'CCSolN__nro': 0, 'CCMaiNP1nro': 81, 'nivinf': 2, 'CCIndicanro': 0, 'rep_refe_LOGICIEL': '/homard', 'CCSolNP1nro': 0}
  L4_calc=aster_homard_3 (L4)
  verif ("Test sur L4",L4_refe,L4_calc)
