import os
import string
#
from aster_homard_utilitaires   import lien
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Repertoire de calcul pour ASTER
#     2. Dictionnaire des arguments generaux
#     3. Dictionnaire des variables de configuration
#
def aster_homard_5 (rep_calc_aster,dict_arguments,variables_conf) :
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Impossible de creer des liens symboliques sur les donnees.",
                      2 : "Impossible de creer des liens symboliques sur les resultats." }
#
#  print blabla,"\nrep_calc_aster :",rep_calc_aster,"\ndict_arguments :",dict_arguments,"\nvariables_conf :",variables_conf
  codret = 0
#
# 2. Liens symboliques sur les donnees
#
  Liste = [ "CCMaiN__", "CCSolN__", "CCIndica" ]
  for mot_cle in Liste :
    nro = dict_arguments [mot_cle+"nro"]
    if nro != 0 :
      fic = variables_conf [mot_cle+"_fic"]
      fic_depart = os.path.join(rep_calc_aster,"fort.%d"%nro)
      codret_partiel = lien (fic_depart,fic)
      if codret_partiel != 0 :
        codret = 1
        break
#
# 3. Liens symboliques sur les resultats
#
  Liste = [ "CCMaiNP1", "CCSolNP1" ]
  for mot_cle in Liste :
    nro = dict_arguments [mot_cle+"nro"]
    if nro != 0 :
      fic = variables_conf [mot_cle+"_fic"]
      fic_depart = os.path.join(rep_calc_aster,"fort.%d"%nro)
      codret_partiel = lien (fic_depart,fic,"oui")
      if codret_partiel != 0 :
        codret = 2
        break
#
# 4. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
    print "Fichier de depart :",fic_depart
    print "Fichier d'arrivee :",fic
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  A1={'CCMaiN__nro': 80, 'CCSolN__nro': 0, 'CCSolNP1nro': 0, 'CCIndicanro': 0, 'CCMaiNP1nro': 0}
  V1={'CCMaiN___fic': 'maill.n.MED' }
  L1_refe=0
  L1_calc=aster_homard_5 (".",A1,V1)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  A2={'CCMaiN__nro': 80, 'CCSolN__nro': 0, 'CCSolNP1nro': 0, 'CCIndicanro': 0, 'CCMaiNP1nro': 81}
  V2={'CCMaiN___fic': 'maill.n','CCMaiNP1_fic': 'maill.np1' }
  L2_refe=0
  L2_calc=aster_homard_5 ("/tmp",A2,V2)
  verif ("Test sur L2",L2_refe,L2_calc)