import os
#
from aster_homard_utilitaires   import exec_commande
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Dictionnaire de l'environnement
#     2. Dictionnaire des arguments generaux
#     3. Dictionnaire des variables de configuration
#
def aster_homard_6 (environnement,dict_arguments,variables_conf):
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      3 : "L'executable HOMARD est inconnu.",
                     10 : "Probleme d'execution de HOMARD" }
#
#  print blabla,"\nenvironnement :",environnement,"\ndict_arguments :",dict_arguments,"\nvariables_conf :",variables_conf
#
  nuvers          = dict_arguments["nuvers"]
  if dict_arguments["PERSO"] == "oui" :
    rep_base_LOGICIEL = dict_arguments["rep_pers_LOGICIEL"]
  else :
    rep_base_LOGICIEL = dict_arguments["rep_refe_LOGICIEL"]
#
# 2. Ajout du dictionnaire des types d'objet au fichier de configuration si cas personnel
#
  if dict_arguments["PERSO"] == "oui" :
#
    fic_conf = environnement["fic_conf"]
#
    fichier = open (fic_conf,'r')
    tout = fichier.read()
    fichier.close()
#
    fichier = open (fic_conf,'w')
    fichier.write(tout)
    ajout=os.path.join(rep_base_LOGICIEL,dict_arguments["nuvers"],"CONFIG","typobj.stu")
    ajout="DicoOSGM "+ajout+"\n"
    fichier.write(ajout)
    fichier.close()
#
# 3. Reperage de l'executable
#
  system = os.uname()[0]
  if dict_arguments["PERSO"] == "oui" :
    Exec=os.path.join(rep_base_LOGICIEL,nuvers,"Executables",system,"HOMARD.out")
  else :
    ajout="HOMARD_"+nuvers+".out"
    Exec=os.path.join(rep_base_LOGICIEL,system,ajout)
#
  if os.path.isfile(Exec) :
    codret = 0
  else :
    print "Ce fichier est inconnu : ", Exec
    codret = 3
#
# 4. Lancement
#
  if codret == 0 :
    commande = Exec
    ModeHOMA = variables_conf["ModeHOMA"]
    if ModeHOMA == 2 :
      commande = commande + "<" + environnement["fic_donn"]
    codret = exec_commande (commande)
    if codret != 0 :
      print "Erreur en execution de HOMARD : ",codret
      codret = 10
#
# 5. La fin
#
  if codret != 0 :
    print blabla, messages_erreur[codret]
#    print blabla
#    print codret
#
  return codret
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  E1={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A1={'PERSO': "non", 'nuvers': 'V6.n', 'rep_refe_LOGICIEL': '/logiciels/HOMARD/HOMARD_PUBLIC'}
  V1={'ModeHOMA': 2 }
  L1_refe=0
  L1_calc=aster_homard_6 (E1,A1,V1)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  E2={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A2={'PERSO': "non", 'nuvers': 'V6.n', 'rep_refe_LOGICIEL': '/logiciefou/HOMOMARD_PUBLIC'}
  V2={'ModeHOMA': 2 }
  L2_refe=3
  L2_calc=aster_homard_6 (E2,A2,V2)
  verif ("Test sur L2",L2_refe,L2_calc)
#
  E3={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A3={'PERSO': "oui", 'nuvers': 'V6.n', 'rep_pers_LOGICIEL': '/home/nicolas/HOMARD'}
  V3={'ModeHOMA': 1 }
  L3_refe=0
  L3_calc=aster_homard_6 (E3,A3,V3)
  verif ("Test sur L3",L3_refe,L3_calc)
