import os
import tempfile
import string
#
from aster_homard_utilitaires   import exec_commande
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Environnement : nom du fichier de configuration et nom du fichier de donnees
#     2. Dictionnaire des options produites par aster_homard
#     3. Code de retour de l'execution de HOMARD
#
def aster_homard_5 (environnement,dict_arguments,variables_conf) :
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                     10 : "Probleme a l'execution de HOMARD ; code de retour :"  }
#
#  print blabla,environnement,dict_arguments,variables_conf
  erreur = 0
#
  nbiter = string.atoi(variables_conf["NumeIter"])
  nbiterp1 = nbiter + 1
  rep_base_LOGICIEL = dict_arguments["rep_pers_LOGICIEL"]
  nuvers = dict_arguments["nuvers"]
#
# 2. Modification du fichier de configuration
#
  fic_conf=environnement["fic_conf"]
#
  fichier = open (fic_conf,'w')
  ajout=os.path.join(rep_base_LOGICIEL,nuvers,"CONFIG","typobj.stu")
  fichier.write("DicoOSGM "+ajout+"\n")
  fichier.write("ModeHOMA 2\n")
  fichier.write("CCAssoci HOMARD\n")
  fichier.write("HOMaiN__ "+variables_conf["HOMaiNP1"]+" "+variables_conf["HOMaiNP1_fic"]+"\n")
  fichier.write("CCSolN__ "+variables_conf["CCMaiNP1_fic"]+"\n")
  fichier.write("ListeStd Liste.%d.info\n"%nbiterp1)
  fichier.write("PPBasFic "+variables_conf["PPBasFic"]+"\n")
  fichier.close
#
# 3. Creation d'un fichier de donnees qui ne fait rien de special
#
  saux = " 0\n 2\n n\n 2\n 0\n q\n"
  saux = " 0\n 0\n q\n"
  fic_donn = tempfile.mktemp()
  fichier = open (fic_donn,'w')
  fichier.write(saux)
  fichier.close
#
# 4. Lancement de HOMARD
#
#  Exec=os.path.join(rep_base_LOGICIEL,nuvers,"Executables","HOMARD.out")
#  commande = Exec + "<" + fic_donn
#  print blabla,"appel de exec_commande pour",commande
#  erreur = exec_commande (commande)
#  print blabla,"retour de exec_commande pour",commande
#
# 5. La fin
#
  if erreur :
    print blabla, messages_erreur[10], erreur
    erreur = 10
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  E1={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A1={'nuvers': 'V4.n', 'rep_pers_LOGICIEL': '/home/nicolas/HOMARD'}
  V1={'NumeIter': '3','HOMaiNP1': 'MAI4', 'HOMaiNP1_fic': 'MAILL.4.HOM', 'CCMaiNP1_fic': 'MAILL.4.MED', 'PPBasFic': 'INFO', 'ListeStd': '/tmp/gabuzome'}
  L1_refe=0
  L1_calc=aster_homard_5 (E1,A1,V1)
  verif ("Test sur L1",L1_refe,L1_calc)
