import os
import sys
#
from aster_homard_1             import aster_homard_1
from aster_homard_2             import aster_homard_2
from aster_homard_3             import aster_homard_3
from aster_homard_4             import aster_homard_4
from aster_homard_5             import aster_homard_5
#
def aster_homard (Arguments) :
#
#   Arguments :
#     1. Repertoire de reference de HOMARD sur la machine
#     2. Sous-repertoire dans lequel aura lieu l'execution de homard
#     3. Version de HOMARD
#     4. Niveau d'information au sens ASTER
#     5. Nom du fichier de donnes en mode information, 0 sinon 
#     N. rien, si version publique de HOMARD
#        -PERSO, si version personnelle
#     N+1. repertoire de base HOMARD si version personnelle
#
#   Remarque : ces arguments sont transmis sous forme d'une chane de caractres
#
# 1. Initialisation
#
  message_erreur = None
#
  blabla = "\nDans " + sys.argv[0] + ", avant appel a aster_homard_"
#
  rep_calc_aster = os.getcwd()
#
#  constantes :
  environnement = { "fic_conf" : "HOMARD.Configuration",
                    "rep_calc_aster" : rep_calc_aster }
#
# 2. Decodage des Arguments
#
###  print blabla,"1, :","\nArguments :", Arguments
  dict_Arguments = aster_homard_1 (Arguments)
###  print "dans",__name__,"\ndict_Arguments = ", dict_Arguments
#
  erreur = dict_Arguments["code_de_retour"]
#
# 3. On passe dans le sous-repertoire de calcul pour homard
#
  if not erreur :
    rep_calc_LOGICIEL = dict_Arguments ["rep_calc_LOGICIEL"]
###    print "\nrep_calc_LOGICIEL :",rep_calc_LOGICIEL
    codret_partiel = [0]
    try :
      os.chdir(rep_calc_LOGICIEL)
    except os.error,codret_partiel :
      print "Code d'erreur de chdir : ",codret_partiel[0], ":",codret_partiel[1]
    if codret_partiel[0] != 0 :
      codret = 2
#
# 4. Recuperation des options dans le fichier de configuration
#
  if not erreur :
    fic_conf = environnement["fic_conf"]
###    print blabla,"2, :","\nfic_conf :",fic_conf
    variables_conf = aster_homard_2 (fic_conf)
    codret = variables_conf["code_de_retour"]
#
# 5. Execution
#
  if not erreur :
###    print blabla,"3, :","\nenvironnement :",environnement,"\ndict_Arguments :",dict_Arguments,"\nvariables_conf :",variables_conf
    code_retour_exec = aster_homard_3 (environnement,dict_Arguments,variables_conf)
#
# 6. Manipulation sur les resultats produits
#
  if not erreur :
#    print blabla,"4, :","\nenvironnement :",environnement,"\ndict_Arguments :",dict_Arguments,"\nvariables_conf :",variables_conf,"\ncode_retour_exec :",code_retour_exec
    erreur = aster_homard_4 (environnement,dict_Arguments,variables_conf,code_retour_exec)
    if code_retour_exec != 0 :
      erreur = 10
#
# 7. Apres une adaptation en mode perso, relance de HOMARD pour les figures
#
  if not erreur :
    if ( dict_Arguments["PERSO"] == "oui" ) and ( variables_conf["ModeHOMA"] == 1 ) :
###      print blabla,"5, :","\nenvironnement :",environnement,"\ndict_Arguments :",dict_Arguments,"\nvariables_conf :",variables_conf
      erreur = aster_homard_5 (environnement,dict_Arguments,variables_conf)
#
# 8. La fin
#
  os.chdir(rep_calc_aster)
#
  if erreur :
    message_erreur = str(erreur)
#
  return message_erreur
#
#
#=======================================================================================
#=======================================================================================
#
#
if __name__ == "__main__" :
#
  from aster_homard_utilitaires import verif
#
  import sys
#
# 1. ==> Rcupration des arguments
#
  T1 = "/tmp/q"
  T1_refe="1"
  message_erreur=aster_homard (T1)
  verif ("Test T1",T1_refe,message_erreur)
#
  sys.exit(message_erreur)
