import os
import string
#
########################## Debut de la fonction ##################################
#
#   Arguments obligatoires :
#     1. Repertoire de reference de HOMARD sur la machine
#     2. Sous-repertoire dans lequel aura lieu l'execution de homard
#     3. Version de HOMARD
#     4. Niveau d'information au sens ASTER
#     5. Nom du fichier de donnes en mode information, 0 sinon 
#
#   Remarque : ces arguments sont transmis sous forme d'une chane de caractres
#
def aster_homard_1 (Arguments):
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      1 : "Il manque des arguments.",
                      2 : "Il y a trop d'arguments.",
                      3 : "Le type de fonctionnement est mauvais.",
                      4 : "La variable d'environnement HOMARD_USER n'est pas dfinie." }
#
# 2. Decodage et stockage des arguments :
###  print blabla,Arguments
#
# 2.1. Verification du nombre
#
  L_Arguments = Arguments.split()
  nbarg = len(L_Arguments)
  if nbarg < 5 :
    erreur = 1
  elif nbarg > 7 :
    erreur = 2
  else :
    erreur = 0
###  print L_Arguments
#
  dict_arguments = {}
#
  while not erreur :
#
# 2.2. Repertoire de reference de HOMARD sur la machine
#
    dict_arguments ["rep_refe_LOGICIEL"] = L_Arguments[0]
#
# 2.3. Sous-repertoire dans lequel aura lieu l'execution de homard
#
    dict_arguments ["rep_calc_LOGICIEL"] = L_Arguments[1]
#
# 2.4. Version de HOMARD
#
    dict_arguments ["nuvers"] = L_Arguments[2]
#
# 2.5. Niveau d'information au sens ASTER
#
    dict_arguments ["nivinf"] = string.atoi(L_Arguments[3])
#
# 2.6. Nom du fichier de donnes, ou '0' si c'est sans objet
#
    dict_arguments ["fic_donn"] = L_Arguments[4]
#
# 2.7. Est-ce une version personnelle ?
#
    dict_arguments ["PERSO"] = "non"
#
    if len ( dict_arguments ["nuvers"] ) > 5 :
      if dict_arguments ["nuvers"][-6:] == ".PERSO" :
#
        dict_arguments ["PERSO"] = "oui"
        daux = os.environ
        if daux.has_key("HOMARD_USER"):
          dict_arguments ["rep_pers_LOGICIEL"] = daux["HOMARD_USER"]
        else :
          erreur = 4
          break
        dict_arguments ["nuvers"] = dict_arguments ["nuvers"][:-6]
#
    break
#
# 3. La fin
#
  if erreur :
    print blabla, messages_erreur[erreur]
#
  dict_arguments ["code_de_retour"] = erreur
###  print dict_arguments
  return dict_arguments
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
#
  L1="1"
  L1_refe={"code_de_retour": 1}
  L1_calc=aster_homard_1 (L1)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  L2="/tmp /tmp/tmp V7.n 1 toto" 
  L2_refe={"rep_refe_LOGICIEL": "/tmp", "fic_donn": "toto", "PERSO": "non", "rep_calc_LOGICIEL": "/tmp/tmp", "code_de_retour": 0, "nivinf": 1, "nuvers": "V7.n"}
  L2_calc=aster_homard_1 (L2)
  verif ("Test sur L2",L2_refe,L2_calc)
#
  L3="/tmp /tmp/tmp V7.n 1 toto -PERSO /tmp/tmpperso" 
  L3_refe={"rep_refe_LOGICIEL": "/tmp", "fic_donn": "toto", "rep_pers_LOGICIEL": "/tmp/tmpperso", "PERSO": "oui", "rep_calc_LOGICIEL": "/tmp/tmp", "code_de_retour": 0, "nivinf": 1, "nuvers": "V7.n"}
  L3_calc=aster_homard_1 (L3)
  verif ("Test sur L3",L3_refe,L3_calc)
#
  L4="/tmp /tmp/tmp V7.n 1 toto -PERSO /tmp/tmpperso gabuzome"
  L4_refe={"code_de_retour": 2}
  L4_calc=aster_homard_1 (L4)
  verif ("Test sur L4",L4_refe,L4_calc)
