import os
import string
import shutil
#
########################## Debut de la fonction ##################################
#
#   Arguments :
#     1. Dictionnaire de l'environnement
#     2. Dictionnaire des arguments generaux
#     3. Dictionnaire des variables de configuration
#     4. Code de retour de l'execution de HOMARD
#
def aster_homard_4 (environnement,dict_arguments,variables_conf,code_retour_exec) :
#
# 1. code de retour :
  blabla = "\nDans " + __name__ + " :"
  messages_erreur = { 0 : "Tout va bien",
                      2 : "Probleme de copie de fichier." }

#
#  print blabla,environnement,dict_arguments,variables_conf,code_retour_exec
  erreur = 0
  ModeHOMA = variables_conf["ModeHOMA"]
  nivinf = dict_arguments ["nivinf"]
  fic_conf = environnement["fic_conf"]
#
# 2. Archivage des fichiers
# 2.1. Concatenation dans le fichier de message
#      . de la liste standard    si le niveau d'information est 2
#                             ou si il y a eu un probleme a l'execution
#      . des fichiers de bilan
#      . du fichier de configuration si il y a eu un probleme a l'execution
#      Remarque : je ne sais pas mieux faire que de tout lire et d'imprimer ensuite ...
#
  nbiter = string.atoi(variables_conf["NumeIter"])
  aux_nbiter = variables_conf["NumeIter"]
  if nbiter < 10 :
    aux_nbiter = "0" + aux_nbiter
#
  nbiterp1 = nbiter + 1
  aux_nbiterp1 = str(nbiterp1)
  if nbiterp1 < 10 :
    aux_nbiterp1 = "0" + aux_nbiterp1
#
  if ( nivinf == 2 or code_retour_exec != 0 ) :
    ecrire_ListeStd = 1
    Liste = [variables_conf["ListeStd"]]
  else :
    ecrire_ListeStd = 0
    Liste = [ ]
  saux = variables_conf["PPBasFic"]+"."+aux_nbiter
  if ( nbiter == 0 ) :
    Liste.append(saux+".bilan")
  Liste.append(saux+".indic")
  Liste.append(variables_conf["PPBasFic"]+"."+aux_nbiterp1+".bilan")
  if ( code_retour_exec != 0 ) :
    Liste.append(fic_conf)
#  print Liste
#
  for fic in Liste :
    if os.path.isfile (fic) :
      fichier = open (fic,'r')
      tout = fichier.read()
      fichier.close()
      print tout
#
# 2.2. Affichage des mesures de temps de calcul, si le fichier complet n'a pas dej t crit
#
  if not ecrire_ListeStd :
    Message="\n.......................................................................\n"
    fic = variables_conf["ListeStd"]
    if os.path.isfile (fic) :
      fichier = open (fic,'r')
      tout = fichier.readlines()
      fichier.close()
      for ligne in tout :
        chaines = string.split(ligne)
        jaux = len(chaines)
        if jaux >= 8 :
          if chaines[1] == 'Temps' or chaines[1] == 'Soit' :
            Message = Message + ligne
    Message = Message + ":.....................................................................:\n"
    print Message
#
# 2.3. Archivage du fichier de configuration
#      Remarque : il faut copier et non pas renommer car on en a encore besoin
#
  if dict_arguments["PERSO"] == "oui" :
    if ModeHOMA == 1 :
      saux = ".vers."+aux_nbiterp1
    else :
      saux = ".info"
    codret_partiel = [0]
    try :
      fic = fic_conf+"."+aux_nbiter+saux
      shutil.copyfile(fic_conf,fic)
    except os.error,codret_partiel :
      print "Probleme pour copier le fichier",fic_conf,"dans",fic
      print "Code d'erreur de copyfile : ",codret_partiel[0], ":",codret_partiel[1]
      erreur = 2
#
# 4. La fin
#
  if erreur :
    print blabla, messages_erreur[erreur]
#
  return erreur
#
##########################  Fin de la fonction  ##################################
#
##########################       Auto-test      ##################################
#
if __name__ == '__main__' :
#
  from aster_homard_utilitaires import verif
  import os
  import tempfile
#
  E1={ "fic_donn" : "DONN", "fic_conf" : "HOMARD.Configuration" }
  A1={'PERSO': "non", 'nivinf': 2 }
  V1={'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'aster_homard_5.py' }
  L1_refe=0
  L1_calc=aster_homard_4 (E1,A1,V1,0)
  verif ("Test sur L1",L1_refe,L1_calc)
#
  fic_conf = "HOMARD.Configuration"
  fichier = open (fic_conf,'w')
  s = "ModeHOMA 1\n"
  fichier.write(s)
  fichier.close()
  E2={ "fic_donn" : "DONN", "fic_conf" : fic_conf }
  A2={'PERSO': "oui", 'nivinf': 1 }
  V2={'NumeIter': '3', 'PPBasFic': 'INFO', 'ModeHOMA': 2, 'ListeStd': 'gabuzome' }
  L2_refe=0
  L2_calc=aster_homard_4 (E2,A2,V2,8)
  verif ("Test sur L2",L2_refe,L2_calc)
  os.remove(fic_conf)
  os.remove(fic_conf+".3.info")
