import os
import shutil
import tempfile
import string
#
from Utilitaires import tue_rep
#
class Installation :
  """
  Classe de l'installation de HOMARD.
  """
#
#
#====
# 0. Les dfauts
#====   
#
# 0.1. ==> Le franais par dfaut
#
  langue_defaut = "fr"
#
# 0.2. ==> Les messages en francais
#
  Texte_fr = {}
#
  Texte_fr["Aide"]                     = ["Cette procdure sert  installer HOMARD.\n"]
  Texte_fr["Aide_Fichier"]             = "A_Lire.txt"
#
  Texte_fr["Repertoire_Lire"]          = "Dans quel rpertoire doit-on installer HOMARD ?\n"
  Texte_fr["Repertoire_Nom"]           = "Nom du rpertoire : "
  Texte_fr["Repertoire_Absent"]        = "Ce rpertoire n'existe pas."
  Texte_fr["Repertoire_Creation"]      = "Voulez-vous le crer ? (o/n) \n"
  Texte_fr["Repertoire_Interdit"]      = "Ecriture interdite."
  Texte_fr["Repertoire_remove"]        = "A la destruction de ce rpertoire"
  Texte_fr["Repertoire_mkdir"]         = "A la cration de ce rpertoire"
  Texte_fr["Repertoire_chdir"]         = "Au changement de rpertoire"
#
  Texte_fr["Fichier_Nom"]              = "Nom du fichier : "
  Texte_fr["Fichier_Absent"]           = "Ce fichier est inconnu.\n"
  Texte_fr["Fichier_ar"]               = "Probleme  la constitution de l'archive."
  Texte_fr["Fichier_detar"]            = "Probleme  l'extraction de l'archive."
  Texte_fr["Fichier_chmod"]            = "Probleme au changement de droits."
#
  Texte_fr["Python_Lire"]              = "Nom de l'excutable python utilis pour Code_ASTER ?\n"
#
  Texte_fr["HOMARD_Exec_Inconnu"]      = "L'excutable HOMARD est inconnu dans "
  Texte_fr["HOMARD_Adaptation"]        = ". Adaptation du maillage numro "
  Texte_fr["HOMARD_Vers"]              = " vers le maillage numro "
  Texte_fr["HOMARD_Erreur"]            = "Erreur  l'excution de HOMARD."
#
  Texte_fr["Cas_Test_Nom"]             = "\nCas test : "
  Texte_fr["Cas_Test_Bilan_nblg"]      = "Les fichiers de bilan n'ont pas la mme longueur."
  Texte_fr["Cas_Test_Bilan_lg_ref"]    = "Ligne dans la rfrence :     "
  Texte_fr["Cas_Test_Bilan_lg"]        = "Ligne dans le calcul courant :"
  Texte_fr["Cas_Test_Bilan_diff"]      = "Les fichiers de bilan diffrent."
  Texte_fr["Cas_Test_OK"]              = "Cas test pass avec succs."
#
  Texte_fr["Erreur_Numero"]            = ", erreur numro "
#
  Texte_fr["Installation_OK"]          = "\nL'installation est russie.\n"
  Texte_fr["Installation_Pb"]          = "\nL'installation a chou.\n"
  Texte_fr["Installation_En_tete"]     = "\nInstallation de HOMARD version"
  Texte_fr["Installation_HOMARD_Exec"] = "\n. Installation de l'excutable HOMARD"
  Texte_fr["Installation_Couplage"]    = "\n. Installation des procdures de couplage ASTER-HOMARD"
  Texte_fr["Installation_Cas_Test"]    = "\n. Installation des cas tests"
#
# 0.3. ==> Les messages en anglais
#   
  Texte_en = {}
#
  Texte_en["Aide"]                     = ["This setup is used to install HOMARD.\n"]
  Texte_en["Aide_Fichier"]             = "Readme.txt"
#
  Texte_en["Repertoire_Lire"]          = "What is the directory for HOMARD installation ?\n"
  Texte_en["Repertoire_Nom"]           = "Name of the directory : "
  Texte_en["Repertoire_Absent"]        = "This directory does not exist."
  Texte_en["Repertoire_Creation"]      = "Do you want creation ? (y/n) \n"
  Texte_en["Repertoire_Interdit"]      = "No rights for writing."
  Texte_en["Repertoire_remove"]        = "When removing this directory"
  Texte_en["Repertoire_mkdir"]         = "When creating this directory"
  Texte_en["Repertoire_chdir"]         = "When changing"
#
  Texte_en["Fichier_Nom"]              = "Name of the file : "
  Texte_en["Fichier_Absent"]           = "This file does not exist.\n"
  Texte_en["Fichier_ar"]               = "Problem while creating archive file."
  Texte_en["Fichier_detar"]            = "Problem while extracting from the archive file"
#
  Texte_en["Python_Lire"]              = "Name of the python program which is used for Code_ASTER ?\n"
#
  Texte_en["Cas_Test_Nom"]             = "\nTest case : "
#
  Texte_en["HOMARD_Exec_Inconnu"]      = "The HOMARD programm is unknown in "
  Texte_en["HOMARD_Adaptation"]        = ". Adaptation from mesh # "
  Texte_en["HOMARD_Vers"]              = " to mesh # "
  Texte_en["HOMARD_Erreur"]            = "Error when HOMARD was running."
#
  Texte_en["Cas_Test_Nom"]             = "\nTest case : "
  Texte_en["Cas_Test_Bilan_nblg"]      = "The lengths of the result files are not the same."
  Texte_en["Cas_Test_Bilan_lg_ref"]    = "Line in reference :              "
  Texte_en["Cas_Test_Bilan_lg"]        = "Line in the current computation :"
  Texte_en["Cas_Test_Bilan_diff"]      = "Result files are not the same."
  Texte_en["Cas_Test_OK"]              = "Test case passed."
#
  Texte_en["Erreur_Numero"]            = ", error # "
#
  Texte_en["Installation_OK"]          = "\nInstallation succeeded.\n"
  Texte_en["Installation_Pb"]          = "\nInstallation failed.\n"
  Texte_en["Installation_En_tete"]     = "\nInstallation of HOMARD release"
  Texte_en["Installation_HOMARD_Exec"] = "\n. Install of HOMARD programm"
  Texte_en["Installation_Couplage"]    = "\n. Install of HOMARD programm"
  Texte_en["Installation_Cas_Test"]    = "\n. Install of test cases"
#
# 0.4. ==> Les messages generaux
#
  Mess = {}
  Mess["Ligne"] = "\n========================================================\n"
  Mess["Copyright"] = "\nCopyright Electricit de France - R&D - 1996, 1997, 2003\n"
#
# 0.5. Le systeme
#
  systeme=os.uname()[0]
#
#
#====
# 1. Le constructeur
#====
#
#
  def __init__ (self, Liste_Option ) :
#
# 1.1. ==> Les options de base
#   
    langue = self.langue_defaut
    if "-en" in Liste_Option :
      langue = "en"
    self.langue = langue
#
    if "-v" in Liste_Option :
      self.option_ar    = "-cvf"
      self.option_detar = "-xvf"
    else :
      self.option_ar    = "-cf"
      self.option_detar = "-xf"
#
# 1.2. ==> Les messages
#
    if self.langue == "fr" :
      self.Message = self.Texte_fr
    else :
      self.Message = self.Texte_en
    for cle in self.Mess.keys() :
      self.Message[cle] = self.Mess[cle]
#
    self.Rep_Base = os.getcwd()
#
#   
#====
# 2. L'aide
#====
#
#
  def aide (self) :
#
    """
    Afficher les informations d'aide
    """
#
    Fic_Aide = os.path.join(os.getcwd(),self.Message["Aide_Fichier"])
    if os.path.isfile(Fic_Aide) :
      fic = open (Fic_Aide, 'r' )
      Aide = fic.readlines()
      fic.close()
    else :
      Aide = self.Message["Aide"]
      Aide.append(self.Message["Copyright"])
    print self.Message["Ligne"]
    for ligne in Aide :
      print ligne[0:-1]
    print self.Message["Ligne"]
#
#   
#====
# 3. Les donnes pour installer HOMARD
#====
#
#
  def data (self) :
#
    """
    Lit les donnes pour installer HOMARD
    """
#
# 3.1. ==> Les informations particulires
#
    self.HOMARD_VERSION = "V7.1"
    self.L_Rep_Proc_Couplage = [ "aster_homard_py ", "aster_homard_V5x_py ", "aster_homard_V6x_py "]
#
    print self.Message["Installation_En_tete"], self.HOMARD_VERSION
#
# 3.2. ==> Le rpertoire gnral de l'installation
#
    print self.Message["Ligne"]
#
    encore = 1
    while encore :
      Rep = raw_input(self.Message["Repertoire_Lire"])
      if len(Rep) > 0 :
        aux = string.lstrip(Rep)
        Rep = string.rstrip(aux)
        err=[0]
        if not os.path.isdir(Rep) :
          print self.Message["Repertoire_Nom"], Rep
          print self.Message["Repertoire_Absent"]
          var = raw_input(self.Message["Repertoire_Creation"])
          if ( var == "o" or var == "y" ) :
            try :
              os.mkdir(Rep)
            except os.error,err :
              print self.Message["Repertoire_mkdir"], self.Message["Erreur_Numero"], err[0], ":", err[1]
        if not err[0] :
          if os.access(Rep,os.W_OK) and os.access(Rep,os.X_OK) :
            encore = 0
          else  :
            print self.Message["Repertoire_Nom"], Rep
            print self.Message["Repertoire_Interdit"]
#
    Rep_bis = os.path.join(self.Rep_Base,Rep)
    if os.path.isdir(Rep_bis) :
      Rep = Rep_bis
    self.Rep_Install_HOMARD = os.path.normpath(Rep)
#
# 3.3. ==> Nom du python utilis pas Code_Aster
#
    print self.Message["Ligne"]
#
    encore = 1
    while encore :
      Fic = raw_input(self.Message["Python_Lire"])
      if len(Fic) > 0 :
        aux = string.lstrip(Fic)
        Fic = string.rstrip(aux)
        if os.path.isfile(Fic) :
          encore = 0
        else :
          print self.Message["Fichier_Nom"], Fic
          print self.Message["Fichier_Absent"]
    Fic_bis = os.path.join(self.Rep_Base,Fic)
    if os.path.isfile(Fic_bis) :
      Fic = Fic_bis
    self.PYTHON_EXE = os.path.normpath(Fic)
#
    print self.Message["Ligne"]
#
#
#====
# 4. Installation proprement dite
#====
#
#
  def installation (self) :
    """
    Installer HOMARD
    """
#
# 4.0. ==> Initialisation
#
    Fic_tar = tempfile.mktemp()
#
    self.Nom_Transfert = "HOMARD_" + self.HOMARD_VERSION + "." + self.systeme
    self.Rep_Arch = os.path.join ( self.Rep_Base , self.Nom_Transfert )
#
    message_erreur = None
    encore = 1
#
    while encore :
#
# 4.1. ==> Transfert de l'excutable
#          Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                      si les fichiers ne sont pas sur les memes disques. On passe
#                      donc par un fichier d'archive tampon.
#
      print self.Message["Installation_HOMARD_Exec"]
#
      self.HOMARD_Exe_loc = "HOMARD_" + self.HOMARD_VERSION + ".out"
#
# 4.1.1. ==> Le rpertoire o sera mis l'excutable.
#            . S'il n'existe pas, on le cre.
#            . S'il existe, on vrifie que l'on peut y aller et y crire. On ne le dtruit surtout pas,
#              car il peut contenir d'autres versions de HOMARD  conserver.
#
      Rep = os.path.join(self.Rep_Install_HOMARD,self.systeme)
      err=[0]
      if not os.path.isdir(Rep) :
        try :
          os.mkdir(Rep)
        except os.error,err :
          print self.Message["Repertoire_Nom"], Rep
          message_erreur = self.Message["Repertoire_mkdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
      if err[0] :
        break
#
      if not os.access(Rep,os.W_OK) or not os.access(Rep,os.X_OK) :
        print self.Message["Repertoire_Nom"], Rep
        print self.Message["Repertoire_Interdit"]
        break
#
      self.Rep_Install_Exec = Rep
#
# 4.1.2. ==> Archivage du point de depart
#
      err=[0]
      try :
        os.chdir(self.Rep_Arch)
      except os.error,err :
        print self.Message["Repertoire_Nom"], self.Rep_Arch
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + Fic_tar + " " + self.HOMARD_Exe_loc
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_ar"]
        break
#
# 4.1.3. ==> Extraction
#
      err=[0]
      try :
        os.chdir(self.Rep_Install_Exec)
      except os.error,err :
        print self.Message["Repertoire_Nom"], self.Rep_Install_Exec
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + Fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_detar"]
        break
#
      self.HOMARD_Exe = os.path.join(self.Rep_Install_Exec,self.HOMARD_Exe_loc)
#
# 4.1.4. ==> Droit d'excution
#
      err=[0]
      try :
        os.chmod  (self.HOMARD_Exe,0755)
      except os.error,err :
        print self.Message["Fichier_Nom"], self.HOMARD_Exe
        message_erreur = self.Message["Fichier_chmod"]
        break
#
# 4.2. ==> Transfert des procdures de couplage avec Code_Aster
#          Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                      si les rpertoires ne sont pas sur les memes disques. On passe
#                      donc par un fichier d'archive tampon.
#
#
      print self.Message["Installation_Couplage"]
#
# 4.2.1. ==> Les rpertoires o seront mises les procdures de couplage
#            . Si le rpertoire existe dj, on le supprime.
#
      Nom_des_rep = " "
      for Rep in self.L_Rep_Proc_Couplage :
#
        Nom_des_rep = Nom_des_rep + " " + Rep
        erreur = 0
        Rep_Install_Couplage = os.path.join(self.Rep_Install_HOMARD,Rep)
#
        if os.path.isdir(Rep_Install_Couplage) :
          erreur = tue_rep ( Rep_Install_Couplage )
        if erreur :
          print self.Message["Repertoire_Nom"], Rep_Install_Couplage
          message_erreur = self.Message["Repertoire_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
          break
#
      if erreur :
        break
#
# 4.2.2. ==> Archivage du point de depart
#
      err=[0]
      try :
        os.chdir(self.Rep_Arch)
      except os.error,err :
        print self.Message["Repertoire_Nom"], self.Rep_Arch
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + Fic_tar + " " + Nom_des_rep
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_ar"]
        break
#
# 4.2.3. ==> Extraction
#
      err=[0]
      try :
        os.chdir(self.Rep_Install_HOMARD)
      except os.error,err :
        print self.Message["Repertoire_Nom"], self.Rep_Install_HOMARD
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + Fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_detar"]
        break
#
# 4.3. ==> Mise  jour du script de couplage avec Code_Aster
#
# 4.3.1. ==> Lecture de la base
#
      Lance_HOMARD_base = os.path.join ( self.Rep_Base , "homard_base" )
      fic = open (Lance_HOMARD_base, 'r' )
      Lignes = fic.readlines()
      fic.close()
#
# 4.3.2. ==> On crit toutes les lignes  l'identique, sauf :
#            . la premire o on doit mettre le bon python
#            . les deux pour les noms de rpertoires
#
      Lance_HOMARD = os.path.join ( self.Rep_Install_HOMARD , "homard" )
#
      err=[0]
      if os.path.isfile(Lance_HOMARD) :
        try :
          os.remove(Lance_HOMARD)
        except os.error,err :
          print self.Message["Fichier_Nom"], Lance_HOMARD
          message_erreur = self.Message["Fichier_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
      if err[0] :
        break
#
      fic = open (Lance_HOMARD, "w" )
#
      ligne = "#!" + self.PYTHON_EXE + "\n"
      fic.write(ligne)
      for ligne in Lignes[1:] :
#
        if "P" in ligne :
          L = ligne.split()
          if L[1] == "=" :
            if L[0] == "self.HOMARD_REP_EXE" :
              mot = self.Rep_Install_HOMARD
              ligne = ligne.replace( L[2][1:-1] , mot )
#
        fic.write(ligne)
#
# 4.3.3. ==> Fin
#
      fic.close()
#
      os.chmod(Lance_HOMARD_base,0644)
      os.remove(Lance_HOMARD_base)
#
      os.chmod(Lance_HOMARD,0755)
      self.Lance_HOMARD = Lance_HOMARD
#
# 4.4. ==> C'est fini
#
      encore = 0
#
    if os.path.isfile(Fic_tar) :
      os.chmod(Fic_tar,0644)
      err=[0]
      try :
        os.remove(Fic_tar)
      except os.error,err :
        print self.Message["Fichier_Nom"], Fic_tar
        message_erreur = self.Message["Fichier_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
#
    os.chdir(self.Rep_Base)
#
    if message_erreur is None :
      message_bis = self.Message["Installation_OK"]
    else :
      message_bis = self.Message["Installation_Pb"]
    return message_erreur, message_bis
#
#
#====
# 5. Lancement des cas-tests
#====
#
#
  def cas_test (self) :
    """
    Lancement des cas_tests de vrification de l'installation HOMARD
    """
#
# 5.0. ==> Initialisation
#
    print self.Message["Installation_Cas_Test"]
#
    Fic_tar = tempfile.mktemp()
#
    message_erreur = None
    encore = 1
#
    while encore :
#
# 5.1. ==> Transfert du rpertoire des cas_tests par renommage du rpertoire
#
      Rep_Cas_Test_depart = os.path.join(self.Rep_Arch,"CAS_TESTS")
      Rep_Cas_Test = os.path.join(self.Rep_Install_HOMARD,"CAS_TESTS",self.HOMARD_VERSION)
#
# 5.1.1. ==> Cration ventuelle du rpertoire gnral des cas-tests
#
      Rep = os.path.join(self.Rep_Install_HOMARD,"CAS_TESTS")
      err=[0]
      if not os.path.isdir(Rep) :
        try :
          os.mkdir(Rep)
        except os.error,err :
          print self.Message["Repertoire_Nom"], Rep
          message_erreur = self.Message["Repertoire_mkdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
      if err[0] :
        break
#
# 5.1.2. ==> Si le rpertoire des cas-tests de la version  installer existe dj, on le supprime, puis on le cree
#
      erreur = 0
      if os.path.isdir(Rep_Cas_Test) :
        erreur = tue_rep ( Rep_Cas_Test )
      if erreur :
        print self.Message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.Message["Repertoire_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      err=[0]
      try :
        os.mkdir(Rep_Cas_Test)
      except os.error,err :
        print self.Message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.Message["Repertoire_mkdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
# 5.1.3. ==> Transfert
#            Attention : on ne peut pas procder par renommage car cela ne fonctionne pas
#                        si les rpertoires ne sont pas sur les memes disques. On passe
#                        donc par un fichier d'archive tampon.
# 5.1.3.1. ==> Archivage du point de depart
#
      err=[0]
      try :
        os.chdir(Rep_Cas_Test_depart)
      except os.error,err :
        print self.Message["Repertoire_Nom"], Rep_Cas_Test_depart
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_ar + " " + Fic_tar + " *"
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_ar"]
        break
#
# 5.1.3.2. ==> Extraction
#
      err=[0]
      try :
        os.chdir(Rep_Cas_Test)
      except os.error,err :
        print self.Message["Repertoire_Nom"], Rep_Cas_Test
        message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
        break
#
      commande = "tar " + self.option_detar + " " + Fic_tar
      erreur = os.system (commande)
      if erreur :
        message_erreur = self.Message["Fichier_detar"]
        break
#
# 5.2. ==> Lancement des tests
#
      Liste_cas = os.listdir ( os.getcwd() )
#
      for cas in Liste_cas :
#
# 5.2.1. ==> Passage dans le rpertoire de calcul
#
        print self.Message["Cas_Test_Nom"], cas
        Rep_Cas_Test_Resultat = os.path.join(Rep_Cas_Test,cas,"resultats")
        err=[0]
        try :
          os.chdir(Rep_Cas_Test_Resultat)
        except os.error,err :
          print self.Message["Repertoire_Nom"], Rep_Cas_Test_Resultat
          message_erreur = self.Message["Repertoire_chdir"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
          break
        Rep_Cas_Test_Resultat_Ref = os.path.join(Rep_Cas_Test,cas,"resultats_ref")
#
# 5.2.2. ==> Initialisations
#
        fic_conf = os.path.join(Rep_Cas_Test_Resultat,"HOMARD.Configuration")
#
# 5.2.3. ==> Boucle sur toutes les adaptations possibles
#
        encore_bis = 1
        nbiterp1 = 0
        while encore_bis :
          nbiter = nbiterp1
          nbiterp1 = nbiter + 1
#
# 5.2.3.1. ==> Cration du fichier de configuration
#
          aux_nbiter = str(nbiter)
          if nbiter < 10 :
            aux_nbiter = "0" + aux_nbiter
          aux_nbiterp1 = str(nbiterp1)
          if nbiterp1 < 10 :
            aux_nbiterp1 = "0" + aux_nbiterp1
          suffixe = aux_nbiter + ".vers." + aux_nbiterp1
          fic_conf_spec = os.path.join(Rep_Cas_Test_Resultat_Ref,"HOMARD.Configuration." + suffixe)
          if not os.path.isfile(fic_conf_spec) :
            break
#
          shutil.copyfile(fic_conf_spec,fic_conf)
#
# 5.2.3.2. ==> Lancement de l'adaptation de nbiter vers nbiter+1
#
          print self.Message["HOMARD_Adaptation"] + aux_nbiter + self.Message["HOMARD_Vers"] + aux_nbiterp1
          erreur = os.system (self.HOMARD_Exe)
          if erreur :
            message_erreur = self.Message["HOMARD_Erreur"]
            break
#
# 5.2.4. ==> Sortie prmature en cas d'erreur violente
#
        if message_erreur is not None :
          break
#
# 5.2.5. ==> Comparaisons :
#            Attention, il faut les faire seulement quand tout est fini, sinon
#                       il y a des incoherences de message qui ne sont pas des erreurs
#
        nbiter_max = nbiter
        for nbiter in range(nbiter_max) :
          nbiterp1 = nbiter + 1
          aux_nbiterp1 = str(nbiterp1)
          if nbiterp1 < 10 :
            aux_nbiterp1 = "0" + aux_nbiterp1
          suffixe =  aux_nbiterp1 + ".bilan"
#
          Fic_Bilan_ref = os.path.join(Rep_Cas_Test_Resultat    ,"info." + suffixe)
          fic = open (Fic_Bilan_ref, 'r' )
          Bilan_Ref = fic.readlines()
          fic.close()
#
          Fic_Bilan     = os.path.join(Rep_Cas_Test_Resultat_Ref,"info." + suffixe)
          if not os.path.isfile(Fic_Bilan) :
            print self.Message["Fichier_Nom"], Fic_Bilan
            message_erreur = self.Message["Fichier_Absent"]
            break
          fic = open (Fic_Bilan, 'r' )
          Bilan = fic.readlines()
          fic.close()
#
          nbligne = len(Bilan)
          if ( nbligne != len(Bilan_Ref) ) :
            message_erreur = self.Message["Cas_Test_Bilan_nblg"]
            break
#
          for num_ligne in range(nbligne) :
            if Bilan[num_ligne] != Bilan_Ref[num_ligne] :
              if (     Bilan[num_ligne][5:9] == "Date" and     Bilan[num_ligne][13:21] == "creation" and
                   Bilan_Ref[num_ligne][5:9] == "Date" and Bilan_Ref[num_ligne][13:21] == "creation" ) :
                pass
              else :
                print self.Message["Cas_Test_Bilan_lg_ref"], Bilan_Ref[num_ligne][0:-1]
                print self.Message["Cas_Test_Bilan_lg"],     Bilan[num_ligne][0:-1]
                message_erreur = self.Message["Cas_Test_Bilan_diff"]
#
# 5.2.4. ==> Bilan, avec sortie prmature en cas de diffrences
#
        if message_erreur is None :
          print self.Message["Cas_Test_OK"]
        else :
          break
#
# 5.3. ==> C'est fini
#
      encore = 0
#
    if os.path.isfile(Fic_tar) :
      os.chmod(Fic_tar,0644)
      err=[0]
      try :
        os.remove(Fic_tar)
      except os.error,err :
        print self.Message["Fichier_Nom"], Fic_tar
        message_erreur = self.Message["Fichier_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
#
    os.chdir(self.Rep_Base)
#
    if message_erreur is None :
      message_bis = self.Message["Installation_OK"]
    else :
      message_bis = self.Message["Installation_Pb"]
    return message_erreur, message_bis
#
#
#====
# 6. Menage
#====
#
#
  def menage (self) :
    """
    Supprimer le reprtoire issu du tar
    """
#
    erreur = tue_rep ( self.Rep_Arch )
#
    if erreur :
      print self.Message["Repertoire_Nom"], self.Rep_Arch
      message_erreur = self.Message["Repertoire_remove"] + self.Message["Erreur_Numero"] + str(err[0]) + " : " + str(err[1])
    else :
      message_erreur = None
#
    return message_erreur
#
#
#
#=======================================================================================
#=======================================================================================
#
#
if __name__ == "__main__" :
#
  import sys
#
# 1. Rcupration des arguments
#
  Liste_Option=sys.argv[1:]
#
  Liste_aide=[ "-h", "-help", "-aide" ]
  aide = 0
  for mot_cle in Liste_aide :
    if mot_cle in Liste_Option :
      aide = 1
#
# 2. Cration de la classe
#
  installation = Installation(Liste_Option)
#
# 3. Fait-on une demande d'aide ? ou est-ce le traitement standard ?
#
  message_erreur = None
  message_bis = " "
  if aide :
    installation.aide()
  else :
    installation.data()
    message_erreur, message_bis = installation.installation()
    if message_erreur is None :
      message_erreur, message_bis = installation.cas_test()
    if message_erreur is None :
      message_erreur = installation.menage()
#
  if message_erreur is None :
    print message_bis
  else :
    print "\n", message_erreur
    message_erreur = message_bis
  sys.exit(message_erreur)
