      LOGICAL FUNCTION LSAME( CA, CB )
C----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGELINE  DATE 12/12/2002   AUTEUR MCOURTOI M.COURTOIS 
C ======================================================================
C COPYRIGHT (C) LAPACK
C ======================================================================
C TOLE CRP_6
C 
C     SUBROUTINE LAPACK COMPARANT DEUX CARACTERES.
C-----------------------------------------------------------------------
C  -- LAPACK AUXILIARY ROUTINE (VERSION 2.0) --
C     UNIV. OF TENNESSEE, UNIV. OF CALIFORNIA BERKELEY, NAG LTD.,
C     COURANT INSTITUTE, ARGONNE NATIONAL LAB, AND RICE UNIVERSITY
C     SEPTEMBER 30, 1994
C
C  PURPOSE
C  =======
C
C  LSAME RETURNS .TRUE. IF CA IS THE SAME LETTER AS CB REGARDLESS OF
C  CASE.
C
C  ARGUMENTS
C  =========
C
C  CA      (INPUT) CHARACTER*1
C  CB      (INPUT) CHARACTER*1
C          CA AND CB SPECIFY THE SINGLE CHARACTERS TO BE COMPARED.
C
C  INTRINSIC FUNCTIONS
C     ICHAR.
C-----------------------------------------------------------------------
C ASTER INFORMATION
C 14/01/2000 TOILETTAGE DU FORTRAN SUIVANT LES REGLES ASTER,
C            REMPLACEMENT DE RETURN PAR GOTO 1000,
C            IMPLICIT NONE.
C-----------------------------------------------------------------------
C CORPS DU PROGRAMME
      IMPLICIT NONE
C
C     .. SCALAR ARGUMENTS ..
      CHARACTER*1        CA, CB
C     ..
C     .. LOCAL SCALARS ..
      INTEGER          INTA, INTB, ZCODE
C     ..
C     .. EXECUTABLE STATEMENTS ..
C
C     TEST IF THE CHARACTERS ARE EQUAL
C
      LSAME = CA.EQ.CB
      IF( LSAME )
     $   GOTO 1000
C
C     NOW TEST FOR EQUIVALENCE IF BOTH CHARACTERS ARE ALPHABETIC.
C
      ZCODE = ICHAR( 'Z' )
C
C     USE 'Z' RATHER THAN 'A' SO THAT ASCII CAN BE DETECTED ON PRIME
C     MACHINES, ON WHICH ICHAR RETURNS A VALUE WITH BIT 8 SET.
C     ICHAR('A') ON PRIME MACHINES RETURNS 193 WHICH IS THE SAME AS
C     ICHAR('A') ON AN EBCDIC MACHINE.
C
      INTA = ICHAR( CA )
      INTB = ICHAR( CB )
C
      IF( ZCODE.EQ.90 .OR. ZCODE.EQ.122 ) THEN
C
C        ASCII IS ASSUMED - ZCODE IS THE ASCII CODE OF EITHER LOWER OR
C        UPPER CASE 'Z'.
C
         IF( INTA.GE.97 .AND. INTA.LE.122 ) INTA = INTA - 32
         IF( INTB.GE.97 .AND. INTB.LE.122 ) INTB = INTB - 32
C
      ELSE IF( ZCODE.EQ.233 .OR. ZCODE.EQ.169 ) THEN
C
C        EBCDIC IS ASSUMED - ZCODE IS THE EBCDIC CODE OF EITHER LOWER OR
C        UPPER CASE 'Z'.
C
         IF( INTA.GE.129 .AND. INTA.LE.137 .OR.
     $       INTA.GE.145 .AND. INTA.LE.153 .OR.
     $       INTA.GE.162 .AND. INTA.LE.169 ) INTA = INTA + 64
         IF( INTB.GE.129 .AND. INTB.LE.137 .OR.
     $       INTB.GE.145 .AND. INTB.LE.153 .OR.
     $       INTB.GE.162 .AND. INTB.LE.169 ) INTB = INTB + 64
C
      ELSE IF( ZCODE.EQ.218 .OR. ZCODE.EQ.250 ) THEN
C
C        ASCII IS ASSUMED, ON PRIME MACHINES - ZCODE IS THE ASCII CODE
C        PLUS 128 OF EITHER LOWER OR UPPER CASE 'Z'.
C
         IF( INTA.GE.225 .AND. INTA.LE.250 ) INTA = INTA - 32
         IF( INTB.GE.225 .AND. INTB.LE.250 ) INTB = INTB - 32
      END IF
      LSAME = INTA.EQ.INTB
C
C
C     END OF LSAME
C
 1000 CONTINUE
      END
