      SUBROUTINE CFSUPM(NOMA,JAPPAR,JNOCO,JAPMEM,
     &                  ISUPP,POSSUP,TYPSUP,NESMAX)

C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      CHARACTER*8  NOMA
      INTEGER      JAPPAR
      INTEGER      JNOCO
      INTEGER      JAPMEM
      INTEGER      POSSUP
      INTEGER      ISUPP
      INTEGER      NESMAX
      INTEGER      TYPSUP
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : CHMANO
C ----------------------------------------------------------------------
C
C SUPPRESSION DANS RESOCO DES INFOS APRES ELIMINATION DE CERTAINS NOEUDS
C ESCLAVES (PIVOTS NULS POUR APPARIEMENT SYMETRIQUE)
C
C IN  NOMA   : NOM DU MAILLAGE
C IN  JAPPAR : POINTEUR VERS RESOCO(1:14)//'.APPARI'
C IN  JNOCO  : POINTEUR VERS DEFICO(1:16)//'.NOEUCO'
C IN  JAPMEM : POINTEUR VERS RESOCO(1:14)//'.APMEMO'
C IN  POSSUP : POSITION DU NOEUD A SUPPRIMER DANS CONTNO
C IN  ISUPP  : INDICE DU NOEUD A SUPPRIMER DANS APPARI
C IN  TYPSUP : RAISON DE LA SUPPRESSION DU NOEUD ESCLAVE
C               -1 : FAIT PARTIE DE SANS_GROUP_NO OU SANS_NOEUD
C               -2 : PIVOT NUL DANS APPARIEMENT SYMETRIQUE
C               -3 : PROJECTION HORS DE LA MAILLE INTERDITE
C              -10 : AUTRES RAISONS
C IN  NESMAX : NOMBRE MAX DE NOEUDS ESCLAVES
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      CHARACTER*32 JEXNUM
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      ZAPPAR
      PARAMETER    (ZAPPAR=3)
      INTEGER      ZAPMEM
      PARAMETER    (ZAPMEM=4)
      INTEGER      K,IREAD,IWRITE,IFM,NIV
      INTEGER      NUMSUP
      CHARACTER*8  NOMSUP
C ----------------------------------------------------------------------
      CALL JEMARQ()
C
      CALL INFNIV(IFM,NIV)
C
      ZI(JAPMEM+ZAPMEM*(POSSUP-1)) = TYPSUP
C
      IF (NIV.GE.2) THEN
        NUMSUP = ZI(JNOCO+POSSUP-1)
        CALL JENUNO(JEXNUM(NOMA//'.NOMNOE',NUMSUP),NOMSUP)
        IF (TYPSUP.EQ.-3) THEN
          WRITE (IFM,1000) NOMSUP
        ELSEIF (TYPSUP.EQ.-2) THEN
          WRITE (IFM,1001) NOMSUP
        ELSEIF (TYPSUP.EQ.-1) THEN
          WRITE (IFM,1002) NOMSUP
        ELSEIF (TYPSUP.EQ.-10) THEN
          WRITE (IFM,1010) NOMSUP
        ENDIF
      ENDIF 
C
C --- LA SUPPRESSION DES NOEUDS ESCLAVES POUR LEUR APPARTENANCE
C --- AU GROUP_MA 'SANS_NO' ET 'SANS-GROUP_NO' SE FAIT AVANT LEUR
C --- APPARIEMENT DANS RESOCO(1:14)//'.APPARI'
C --- IL N'EST DONC PAS NECESSAIRE DE DECALER LES VALEURS DE CE 
C --- DERNIER
C
      IF (TYPSUP.NE.-1) THEN
C
        ZI(JAPPAR) = ZI(JAPPAR) -1    
C          
        DO 40 K = ISUPP,NESMAX
C
C --- ON LIT LE IREAD-IEME NOEUD ESCLAVE
C --- ON ECRIT DANS LE IWRITE-IEME NOEUD ESCLAVE
C
          IREAD  = K+1
          IWRITE = K

          ZI(JAPPAR+ZAPPAR*(IWRITE-1)+1) = ZI(JAPPAR+ZAPPAR*(IREAD-1)+1)
          ZI(JAPPAR+ZAPPAR*(IWRITE-1)+2) = ZI(JAPPAR+ZAPPAR*(IREAD-1)+2)
          ZI(JAPPAR+ZAPPAR*(IWRITE-1)+3) = ZI(JAPPAR+ZAPPAR*(IREAD-1)+3)

 40     CONTINUE
      ENDIF
C
C ----------------------------------------------------------------------
C
      CALL JEDEMA()
1000  FORMAT ('<CONTACT> <> <> APPARIEMENT M/E INTERDIT POUR ',A8,
     &        ' (HORS MAILLE)')
1001  FORMAT ('<CONTACT> <> <> APPARIEMENT M/E INTERDIT POUR ',A8,
     &        ' (PIVOT NUL)')
1002  FORMAT ('<CONTACT> <> <> APPARIEMENT M/E INTERDIT POUR ',A8,
     &        ' (SANS_GROUP_NO)')
1010  FORMAT ('<CONTACT> <> <> APPARIEMENT M/E INTERDIT POUR ',A8,
     &        ' (RAISON INCONNUE)')

      END
