      SUBROUTINE CONDT(OPTION,PHI,SAT,T,P2,R,MAMOLV,MAMOLG
     &                ,DT,RV00,VINTM,VINTP,NVIMEC,NVITH,ADVITH
     &                ,AVSR,BVN,EVT,AASR,BAN,EAT,HENRY
     &                ,RV0,HUMR,RHO12,RHO21)
C
C     CETTE ROUTINE CALCULE LES RHO21,RHO12 
C     ET LES TERMES AUXILIAIRES POUR LA MODELISATION DE 
C     THM NON SATURE DE B. GATMIRI (CERMES)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/10/2000   AUTEUR UFBHHLL C.CHAVANT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C TOLE CRP_21
      IMPLICIT NONE
C
      CHARACTER*16   OPTION
      INTEGER        NVIMEC,NVITH,ADVITH
      REAL*8         VINTM(NVIMEC+NVITH),VINTP(NVIMEC+NVITH)
      REAL*8   T,P2,PHI,SAT,SATG,UWT,RV0,AX1,AX,HUMR
      REAL*8   RHO12,RHO21,MAMOLV,MAMOLG,R,RV00,DT
      REAL*8   PVP ,VARIA
      REAL*8   DRV0DT,DHDSR,DHDN,DHDT,HENRY
      REAL*8   AVSR,BVN,EVT,AASR,BAN,EAT
C
C      IF(SAT.LT.0.D0) SAT=1.D-2
C      IF(SAT.GT.1.D0) SAT=1.D0
      SATG=1.D0-SAT
C      TT1=T-DT
C
      IF ((OPTION(1:9).EQ.'RAPH_MECA').OR.
     &   (OPTION(1:9).EQ.'FULL_MECA')) THEN
       VARIA=4975.9D0/T/T*DT
       VINTP(ADVITH+2)=(RV00+VINTM(ADVITH+2))*EXP(VARIA)-RV00
      ENDIF
      IF (OPTION(1:16).EQ.'RIGI_MECA_TANG') THEN
         RV0=VINTM(ADVITH+2)+RV00 
      ELSE
         RV0=VINTP(ADVITH+2)+RV00
      ENDIF
C           
C     CALCUL DE HUMR: HUMIDITE RELATIVE ET SES DERIVEES
C
      UWT=PHI*SAT
      HUMR=(1.D0+(UWT/(.04D0*RV0))**(-4.27D0))**(-.42D0)
      RHO12=RV0*HUMR
      PVP=RHO12*R*T/MAMOLV
      RHO21=MAMOLG*(P2-PVP)/R/T
      AX1=UWT/(.04D0*RV0)
      AX=44.835D0*(AX1)**(-5.27D0)*(1.D0+(AX1)**(-4.27D0))**(-1.42D0)
      DHDSR = PHI*AX/RV0 
      DHDN = SAT*AX/RV0
      DHDT = -4975.9D0*UWT*AX/RV0
      DRV0DT=(4975.9D0*RV0)/(T*T)
      AVSR= SATG*DHDSR/HUMR-1.D0
      BVN= PHI*DHDN/HUMR+1.D0
      EVT= HUMR*DRV0DT+RV0*DHDT
      AASR= (1.D0-HENRY)+(1.D0-(1.D0-HENRY)*SAT)*DHDSR*RV0/RHO21
      BAN=(1.D0-(1.D0-HENRY)*SAT)*(1.D0-PHI*DHDN*RV0/RHO21) 
      EAT= HUMR*DRV0DT+RV0*DHDT+P2*MAMOLG/R/T/T
      END
