      SUBROUTINE INSNAT ( SIGF, NMAT, MATERF, SEQF , SEUIL )
      IMPLICIT REAL*8 (A-H,O-Z)
C       -----------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 09/02/2004   AUTEUR REZETTE C.REZETTE 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C       -----------------------------------------------------------
C       NADAI_B :  CRITERE DE FISSURATION (NADAI-TRACTION)
C                  F   =  ( TOCT + C * SOCT ) / D  - LCS = SEQF - LCS
C       IN  :  SIGF = CONTRAINTE A T+DT  (INTEGRATION ELASTIQUE SUR DT)
C              LCS  = RESISTANCE EN COMPRESSION UNIAXIALE
C              LTR  = RESISTANCE EN TRACTION UNIAXIALE
C
C       OUT :  SEUIL =  SEUIL CRITERE NADAI-TRACTION
C              SEQF  =  CONTRAINTE EQUIVALENTE EN TRACTION 
C       ------------------------------------------------------------
      INTEGER   NMAT
      REAL*8    UN , DEUX , TROIS
      PARAMETER       ( UN     = 1.D0   )
      PARAMETER       ( DEUX   = 2.D0   )
      PARAMETER       ( TROIS  = 3.D0   )
      REAL*8    SIGF(6) , DEV(6) , S , TOCT , SOCT , LCNRTS
      REAL*8    SEUIL , SEQF, LCS, LTR , ALFA , C , D
      REAL*8    MATERF(NMAT,2)
C
       LCS  = MATERF(1,2)
       LTR  = MATERF(2,2)
       ALFA = LTR / LCS
       CALL LCDEVI (SIGF, DEV)
       CALL LCHYDR (SIGF, SOCT)
       S    = LCNRTS ( DEV )
       TOCT = SQRT(2.D0/9.D0) * S
       C = SQRT(DEUX) * ( UN - ALFA ) / ( UN + ALFA )
       D = SQRT(DEUX) *  DEUX * ALFA  / TROIS / ( UN + ALFA )
       SEQF  =  ( TOCT + C * SOCT ) / D
       SEUIL =  SEQF  - LCS
C
       END
