      SUBROUTINE NMASSG (ICODMA,
     &                   TYPPAR,INST,TEMP,
     &                   COEFGR)
C ----------------------------------------------------------------------
      IMPLICIT NONE
      INTEGER     ICODMA
      CHARACTER*2 TYPPAR
      REAL*8      INST,TEMP
      INTEGER      NCOEFG
      PARAMETER   (NCOEFG = 3)
      REAL*8      COEFGR(NCOEFG)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 15/06/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     RECUPERATION DES CARACTERISTIQUES DE GRANDISSEMENT
C     POUR LES ELEMENTS DE POUTRE DANS LE CAS DES COMPORTEMENTS
C     D'ASSEMBLAGE COMBUSTIBLE.
C ----------------------------------------------------------------------
C
C IN  ICODMA  : ADRESSE DU MATERIAU CODE
C IN  TYPPAR  : TYPE DE PARAMETRE SCRUTE
C               '  ' (DEUX BLANCS): PAS DE PARAMETRES
C               'T ' (T/BLANC):     TEMPS MAIS PAS DE TEMPERATURE
C               ' T' (BLANC/T):     TEMPERATURE MAIS PAS DE TEMPS
C               'TT' (T/T):         TEMPERATURE ET TEMPS
C IN  INST    : INSTANT CONSIDERE
C IN  TEMP    : TEMPERATURE CONSIDEREE
C OUT COEFGR  : COEFFICIENTS CONSTANTS POUR LE GRANDISSEMENT DES TUBES
C
C *************** DECLARATION DES VARIABLES LOCALES ********************
C
      INTEGER      NBVAL, NBPAR
      PARAMETER    (NBVAL = 14)
      REAL*8       VALPAR(3),VALRES(NBVAL)
      CHARACTER*2  CODRES(NBVAL)
      CHARACTER*8  NOMPAR(3),NOMGRD(3)
C
C *********** FIN DES DECLARATIONS DES VARIABLES LOCALES ***************
C
C ****************************** DATA  *********************************
C
      DATA NOMGRD / 'A','B','S' /
C
C ********************* DEBUT DE LA SUBROUTINE *************************
C
C --- INITIALISATIONS
C
      CALL R8INIR (NCOEFG,0.D0,COEFGR,1)
      CALL R8INIR (NBVAL,0.D0,VALRES,1)

C INIT DES PARAMETRES
      NBPAR  = 0
      NOMPAR(1) = ' '
      NOMPAR(2) = ' '
      IF (TYPPAR(1:1).EQ.'T') THEN
       NBPAR = NBPAR +1
       NOMPAR(1) = 'INST'
       VALPAR(1) = INST
      ENDIF
      IF (TYPPAR(2:2).EQ.'T') THEN
       NBPAR = NBPAR +1
       NOMPAR(2) = 'TEMP'
       VALPAR(2) = TEMP
      ENDIF
C
C --- CARACTERISTIQUES D'UN ASSEMBLAGE COMBUSTIBLE
C
C
C    - GRANDISSEMENT
C
         CALL RCVALA(ICODMA,' ','GRAN_IRRA',NBPAR,NOMPAR,VALPAR,
     &              1,NOMGRD(1),VALRES(1),CODRES(1), 'FM' )
C
         CALL RCVALA(ICODMA,' ','GRAN_IRRA',NBPAR,NOMPAR,VALPAR,
     &              1,NOMGRD(2),VALRES(2),CODRES(2), 'FM' )
C
         CALL RCVALA(ICODMA,' ','GRAN_IRRA',NBPAR,NOMPAR,VALPAR,
     &              1,NOMGRD(3),VALRES(3),CODRES(3), '  ' )
         IF (CODRES(3).NE.'OK') THEN 
           VALRES(3) = 1.D0
         ENDIF
         CALL R8COPY (NCOEFG,VALRES,1,COEFGR,1)
C
      END
