      SUBROUTINE NMVCFO(MODELE, NUMEDD, MATE  , CARELE, COMREF,
     &                  COMPLU, CNVCFO)

C MODIF ALGORITH  DATE 04/05/2004   AUTEUR SMICHEL S.MICHEL-PONNELLE 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PBADEL P.BADEL

      IMPLICIT NONE
      CHARACTER*8   MODELE
      CHARACTER*19  CNVCFO
      CHARACTER*24  NUMEDD, MATE, COMREF, CARELE
      CHARACTER*24  COMPLU

C ----------------------------------------------------------------------
C    ESTIMATION D'UNE FORCE DE REFERENCE LIEE A L'ACTION DES V. COM.
C ----------------------------------------------------------------------
C
C IN       MODELE K8  MODELE
C IN       NUMEDD K24 NUME_DDL
C IN       MATE   K24 CHAMP MATERIAU
C IN       CARELE K24 CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN       COMREF K24 VARI_COM DE REFERENCE
C IN       COMPLU K24 VARI_COM EN T+ (TEMPERATURE POUR LES POUTRES)
C IN/JXOUT CNVCFO K19 FORCE DE REFERENCE (DFINT/DA * A)
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      LOGICAL      EXITEM, EXIHYD, EXISEC, EXIEPA, EXIPHA
      LOGICAL      EXIGEO, EXICAR
      INTEGER      NBRENV, NBR, IRET, IBID
      INTEGER      JVCP
      CHARACTER*6  MASQUE
      CHARACTER*8  VECEL, LPAIN(18), LPAOUT(1), PARTPP, NOMGD, K8BID
      CHARACTER*16 OPTION
      CHARACTER*24 CHTREF, CHSREF
      CHARACTER*24 TEMPLU, HYDPLU, SECPLU, PHAPLU, EPAPLU, INSPLU
      CHARACTER*24 LIGRMO, CHGEOM, CHCARA(17), LCHIN(18), LCHOUT(1)

      DATA  VECEL /'&&VEVCFO'/
C ----------------------------------------------------------------------


      CALL JEMARQ()


C -- PREPARATION DES VECT_ELEM

      NBRENV = 4
      MASQUE = '.VEXXX'
      CALL JEEXIN(VECEL // '.LISTE_RESU',IRET)
      IF (IRET.EQ.0) THEN
        CALL MEMARE('V',VECEL,MODELE,MATE,CARELE,'CHAR_MECA')
        CALL WKVECT(VECEL // '.LISTE_RESU','V V K24',NBRENV,JVCP)
      ELSE
        CALL JEVEUO(VECEL // '.LISTE_RESU','E',JVCP)
      END IF


C -- EXTRACTION DES VARIABLES DE COMMANDE

      CALL NMVCEX('TEMP',COMREF,CHTREF)      
      CALL NMVCEX('SECH',COMREF,CHSREF)
      CALL NMVCEX('TEMP',COMPLU,TEMPLU)
      CALL NMVCEX('HYDR',COMPLU,HYDPLU)
      CALL NMVCEX('SECH',COMPLU,SECPLU)
      CALL NMVCEX('PHAS',COMPLU,PHAPLU)
      CALL NMVCEX('EPAN',COMPLU,EPAPLU)
      CALL NMVCEX('INST',COMPLU,INSPLU)
      
C    VARIABLES DE COMMANDE PRESENTES
      EXITEM = TEMPLU .NE. ' '
      IF (EXITEM) CALL NMVCDE('TEMP',COMPLU,EXITEM)
      EXIHYD = HYDPLU .NE. ' '
      IF (EXIHYD) CALL NMVCDE('HYDR',COMPLU,EXIHYD)
      EXISEC = SECPLU.NE.' '
      IF (EXISEC) CALL NMVCDE('SECH',COMPLU,EXISEC)
      EXIEPA = EPAPLU .NE. ' '
     
C -- ON TESTE LA NATURE DU CHAMP DE TEMPERATURE (FONCTION OU CHAMP)

      CALL DISMOI('F','NOM_GD',TEMPLU,'CHAMP',IBID,NOMGD,IRET)
      IF (NOMGD.EQ.'TEMP_R') THEN
         PARTPP  = 'PTEMPER'
      ELSE IF (NOMGD.EQ.'TEMP_F') THEN
         PARTPP  = 'PTEMPEF'
      ELSE
         CALL UTMESS('F','NMVCFO','TEMPERATURE : GRANDEUR INCONNUE')
      END IF


C -- CHAMPS DES OPTIONS

      LIGRMO = MODELE //'.MODELE'
      CALL MEGEOM(MODELE,' ' , EXIGEO, CHGEOM)
      CALL MECARA(CARELE(1:8), EXICAR, CHCARA)

      LPAIN(1)  = 'PTEREF'
      LCHIN(1)  =  CHTREF
      LPAIN(2)  = 'PGEOMER'
      LCHIN(2)  =  CHGEOM
      LPAIN(3)  = 'PMATERC'
      LCHIN(3)  =  MATE
      LPAIN(4)  = 'PCACOQU'
      LCHIN(4)  =  CHCARA(7)
      LPAIN(5)  = 'PCAGNPO'
      LCHIN(5)  =  CHCARA(6)
      LPAIN(6)  = 'PCAORIE'
      LCHIN(6)  =  CHCARA(1)
      LPAIN(7)  = 'PCAGNBA'
      LCHIN(7)  =  CHCARA(11)
      LPAIN(8)  = 'PCAARPO'
      LCHIN(8)  =  CHCARA(9)
      LPAIN(9)  = 'PCAMASS'
      LCHIN(9)  =  CHCARA(12)
      LPAIN(10) = 'PCAGEPO'
      LCHIN(10) =  CHCARA(5)
      LPAIN(11)  = 'PTEMPSR'
      LCHIN(11)  =  INSPLU
      LPAIN(12)  =  PARTPP
      LCHIN(12)  =  TEMPLU
      LPAIN(13)  = 'PHYDRER'
      LCHIN(13)  =  HYDPLU
      LPAIN(14)  = 'PSECHER'
      LCHIN(14)  =  SECPLU
      LPAIN(15)  = 'PPHASRR'
      LCHIN(15)  =  PHAPLU
      LPAIN(16)  = 'PDEFAPR'
      LCHIN(16)  =  EPAPLU
      LPAIN(17)  = 'PNBSP_I'
      LCHIN(17)  = CHCARA(1) (1:8)//'.CANBSP'
      LPAIN(18)  = 'PSECREF'
      LCHIN(18)  =  CHSREF


C -- CALCUL DES OPTIONS EN T+

      NBR = 0

C    THERMIQUE
      IF (EXITEM) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL // MASQUE
        OPTION = 'CHAR_MECA_TEMP_R'
       CALL CALCUL('S',OPTION,LIGRMO,18,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    HYDRATATION
      IF (EXIHYD) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL // MASQUE
        OPTION = 'CHAR_MECA_HYDR_R'
       CALL CALCUL('S',OPTION,LIGRMO,18,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    SECHAGE
      IF (EXISEC) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL // MASQUE
        OPTION = 'CHAR_MECA_SECH_R'
       CALL CALCUL('S',OPTION,LIGRMO,18,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    DEFORMATION ANELASTIQUE
      IF (EXIEPA) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL // MASQUE
        OPTION = 'CHAR_MECA_EPSA_R'
       CALL CALCUL('S',OPTION,LIGRMO,18,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF


C -- ASSEMBLAGE

      CALL JEECRA(VECEL // '.LISTE_RESU','LONUTI',NBR,K8BID)
      CALL ASSVEC ('V',CNVCFO,1,VECEL,1.D0,NUMEDD,' ','ZERO',1)


      CALL JEDEMA()
      END
