      SUBROUTINE NMVCLE(MODELZ,MATZ,LISCHZ,INSTAN,COMZ)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 25/03/2004   AUTEUR OUGLOVA A.OUGLOVA 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE

      CHARACTER*(*) MODELZ, MATZ, LISCHZ, COMZ
      REAL*8        INSTAN

      CHARACTER*8   MODELE, MATE
      CHARACTER*19  LISCHA
      CHARACTER*14  COM

C ----------------------------------------------------------------------
C  LECTURE DES VARIABLES DE COMMANDE
C ----------------------------------------------------------------------
C IN/JXIN   MODELE  K8  SD MODELE
C IN/JXIN   MATE    K8  SD MATERIAU
C IN/JXIN   LISCHA  K19 SD L_CHARGES
C IN        INSTAN   R  INSTANT D'EVALUATION
C IN/JXOUT  COM     K14 SD VARI_COM
C ----------------------------------------------------------------------

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      LOGICAL      EXITMP, EXIHYD, EXISEC,EXIIRR
      CHARACTER*24 CHARGE, INFOCH
      CHARACTER*19 TEMP, HYDR, SECH, CTPS
      CHARACTER*19 PHAS, EPAN, IRRA, CORR,CORR2
      INTEGER      IBID, IEX
      INTEGER TYPESE
      CHARACTER*8 NOPASE
      CHARACTER*8  K8BID
      CHARACTER*24 STYPSE
      COMPLEX*16   CBID
      LOGICAL       LCORR, GETEXM


      CALL JEMARQ()
      COM    = COMZ
      MODELE = MODELZ
      MATE   = MATZ
      LISCHA = LISCHZ


C    SUPPRESSION DE L'OBJET S'IL EXISTE DEJA
      CALL DETRSD('VARI_COM',COM)


C    INITIALISATION
      CHARGE = LISCHA // '.LCHA'
      INFOCH = LISCHA // '.INFC'
      TYPESE = 0
      NOPASE = '        '


C    LISTE DES VARIABLES DE COMMANDE
      TEMP =  COM // '.TEMP'
      HYDR =  COM // '.HYDR'
      SECH =  COM // '.SECH'
      PHAS =  COM // '.PHAS'
      EPAN =  COM // '.EPAN'
      CTPS =  COM // '.INST'
      IRRA =  COM // '.IRRA'
      CORR =  COM // '.CORR'


C    CREATION DE LA SD VARI_COM

C    DETERMINATION DU CHAMP DE TEMPERATURE
      CALL NMDETE ( MODELE, MATE, CHARGE, INFOCH, INSTAN,
     >              TYPESE, STYPSE, NOPASE,
     >              TEMP, EXITMP )

C    DETERMINATION DES CHAMPS SECHAGE ET HYDRATATION
      CALL NMDEHY (MODELE,LISCHA,INSTAN,HYDR,EXIHYD,SECH,EXISEC)

C    DETERMINATION DU CHAMP D'IRRADIATION
      CALL NMDEIR (MODELE,INSTAN,IRRA,EXIIRR)

C    DETERMINATION DU CHAMP DE PHASE METALLURGIQUE
      CALL NMDEZE (LISCHA,INSTAN,PHAS)

C    DETERMINATION DU CHAMP DE DEFORMATION ANELASTIQUE
      CALL NMDEAN (LISCHA,INSTAN,EPAN)

C    DETERMINATION DU CHAMP DE CORROSION
C     CALL NMDECO (CORRO)  : POUR L'INSTANT : TRIVIAL
      LCORR = GETEXM('VARI_COMM','CORROSION')
      IF( LCORR ) THEN
        CORR2=' '
        CALL GETVID('VARI_COMM','CORROSION',1,1,1,CORR2,IBID)
        IF (IBID.EQ.1) THEN
           CALL COPISD('CHAMP_GD','V',CORR2,CORR)
        ELSE  
          CALL MECACT('V',CORR,'MODELE',MODELE,'CORR_R',1,'CORR',
     +                    IBID,0.D0,CBID,K8BID)    
        END IF
      END IF


C    CARTE DE L'INSTANT COURANT
      CALL MECACT('V', CTPS, 'MODELE', MODELE(1:8)//'.MODELE',
     &            'INST_R', 1, 'INST', IBID, INSTAN, CBID, K8BID)

C    CHAMPS REELS (TRUE) OU PAR DEFAUT (FALSE)
      CALL WKVECT(COM//'.EXISTENCE','V V L ',3,IEX)
      ZL(IEX+0) = EXITMP
      ZL(IEX+1) = EXIHYD
      ZL(IEX+2) = EXISEC


      CALL JEDEMA()
      END
