      SUBROUTINE NMVCPR(MODELE, NUMEDD, MATE  , CARELE, COMREF,
     &                  COMPOR, VALMOI, COMPLU, CNVCPR)

C MODIF ALGORITH  DATE 04/05/2004   AUTEUR SMICHEL S.MICHEL-PONNELLE 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C RESPONSABLE PBADEL P.BADEL

      IMPLICIT NONE
      CHARACTER*8   MODELE
      CHARACTER*19  CNVCPR
      CHARACTER*24  NUMEDD, MATE, COMREF, CARELE, COMPOR, VALMOI
      CHARACTER*24  COMPLU

C ----------------------------------------------------------------------
C         SECOND MEMBRE : VARIATION DES VARIABLES DE COMMANDE
C ----------------------------------------------------------------------
C
C IN       MODELE K8  MODELE
C IN       NUMEDD K24 NUME_DDL
C IN       MATE   K24 CHAMP MATERIAU
C IN       CARELE K24 CARACTERISTIQUES DES ELEMENTS DE STRUCTURE
C IN       COMREF K24 VARI_COM DE REFERENCE
C IN       COMPOR K24 COMPORTEMENT
C IN       VALMOI K24 ETAT EN T-
C IN       COMPLU K24 VARI_COM EN T+ (TEMPERATURE POUR LES POUTRES)
C IN/JXOUT CNVCPR K19 VARIATION F_INT PAR RAPPORT AUX VARI_COM
C
C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------
C
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      LOGICAL      EXITEM, EXIHYD, EXISEC, EXIEPA, EXIPHA
      LOGICAL      EXIGEO, EXICAR
      INTEGER      NBRENV, NBR, IRET, IBID
      INTEGER      JVCP, JVCM
      REAL*8       X(2)
      CHARACTER*6  MASQUE
      CHARACTER*8  VECEL(2), LPAIN(24), LPAOUT(1), PARTPM, PARTPP, NOMGD
      CHARACTER*8  K8BID
      CHARACTER*16 OPTION
      CHARACTER*24 DEPMOI, SIGMOI, VARMOI, COMMOI, CHTREF, CHSREF
      CHARACTER*24 TEMPLU, HYDPLU, SECPLU, PHAPLU, EPAPLU, INSPLU
      CHARACTER*24 TEMMOI, HYDMOI, SECMOI, PHAMOI, EPAMOI, INSMOI
      CHARACTER*24 LIGRMO, CHGEOM, CHCARA(16), LCHIN(24), LCHOUT(1)
      CHARACTER*24 K24BID

      DATA  VECEL /'&&VEVCOM','&&VEVCOP'/
C ----------------------------------------------------------------------


      CALL JEMARQ()
      CALL DESAGG (VALMOI, DEPMOI, SIGMOI, VARMOI, COMMOI,
     &                     K24BID, K24BID, K24BID, K24BID)


C -- PREPARATION DES VECT_ELEM

      NBRENV = 5
      MASQUE = '.VEXXX'
      CALL JEEXIN(VECEL(1) // '.LISTE_RESU',IRET)
      IF (IRET.EQ.0) THEN
        CALL MEMARE('V',VECEL(1),MODELE,MATE,CARELE,'CHAR_MECA')
        CALL MEMARE('V',VECEL(2),MODELE,MATE,CARELE,'CHAR_MECA')
        CALL WKVECT(VECEL(1) // '.LISTE_RESU','V V K24',NBRENV,JVCP)
        CALL WKVECT(VECEL(2) // '.LISTE_RESU','V V K24',NBRENV,JVCM)
      ELSE
        CALL JEVEUO(VECEL(1) // '.LISTE_RESU','E',JVCP)
        CALL JEVEUO(VECEL(2) // '.LISTE_RESU','E',JVCM)
      END IF


C -- EXTRACTION DES VARIABLES DE COMMANDE

      CALL NMVCEX('TEMP',COMREF,CHTREF)
      CALL NMVCEX('SECH',COMREF,CHSREF)

      CALL NMVCEX('TEMP',COMPLU,TEMPLU)
      CALL NMVCEX('HYDR',COMPLU,HYDPLU)
      CALL NMVCEX('SECH',COMPLU,SECPLU)
      CALL NMVCEX('PHAS',COMPLU,PHAPLU)
      CALL NMVCEX('EPAN',COMPLU,EPAPLU)
      CALL NMVCEX('INST',COMPLU,INSPLU)

      CALL NMVCEX('TEMP',COMMOI,TEMMOI)
      CALL NMVCEX('HYDR',COMMOI,HYDMOI)
      CALL NMVCEX('SECH',COMMOI,SECMOI)
      CALL NMVCEX('PHAS',COMMOI,PHAMOI)
      CALL NMVCEX('EPAN',COMMOI,EPAMOI)
      CALL NMVCEX('INST',COMMOI,INSMOI)

C    VARIABLES DE COMMANDE PRESENTES
      EXITEM = TEMPLU .NE. ' '
      IF (EXITEM) CALL NMVCDE('TEMP',COMPLU,EXITEM)
      EXIHYD = HYDPLU .NE. ' '
      IF (EXIHYD) CALL NMVCDE('HYDR',COMPLU,EXIHYD)
      EXISEC = SECPLU.NE.' '
      IF (EXISEC) CALL NMVCDE('SECH',COMPLU,EXISEC)
      EXIPHA = EXITEM .AND. PHAPLU .NE. ' ' .AND. PHAMOI.NE.' '
      EXIEPA = EPAPLU .NE. ' '


C -- LECTURE DES CHAMPS COMMUNS AUX OPTIONS

      LIGRMO = MODELE //'.MODELE'
      CALL MEGEOM(MODELE,' ' , EXIGEO, CHGEOM)
      CALL MECARA(CARELE(1:8), EXICAR, CHCARA)

      LPAIN(1)  = 'PTEREF'
      LCHIN(1)  =  CHTREF
      LPAIN(2)  = 'PSECREF'
      LCHIN(2)  =  CHSREF
      LPAIN(3)  = 'PGEOMER'
      LCHIN(3)  =  CHGEOM
      LPAIN(4)  = 'PMATERC'
      LCHIN(4)  =  MATE
      LPAIN(5)  = 'PCACOQU'
      LCHIN(5)  =  CHCARA(7)
      LPAIN(6)  = 'PCAGNPO'
      LCHIN(6)  =  CHCARA(6)
      LPAIN(7)  = 'PCADISM'
      LCHIN(7)  =  CHCARA(3)
      LPAIN(8)  = 'PCAORIE'
      LCHIN(8)  =  CHCARA(1)
      LPAIN(9)  = 'PCAGNBA'
      LCHIN(9)  =  CHCARA(11)
      LPAIN(10)  = 'PCAARPO'
      LCHIN(10)  =  CHCARA(9)
      LPAIN(11) = 'PCAMASS'
      LCHIN(11) =  CHCARA(12)
      LPAIN(12) = 'PCAGEPO'
      LCHIN(12) =  CHCARA(5)
      LPAIN(13) = 'PPHASMR'
      LCHIN(13) =  PHAMOI
      LPAIN(14) = 'PPHASPR'
      LCHIN(14) =  PHAPLU
      LPAIN(15) = 'PCONTMR'
      LCHIN(15) =  SIGMOI
      LPAIN(16) = 'PVARIPR'
      LCHIN(16) =  VARMOI
      LPAIN(17) = 'PCOMPOR'
      LCHIN(17) =  COMPOR


C -- ON TESTE LA NATURE DU CHAMP DE TEMPERATURE (FONCTION OU CHAMP)

      CALL DISMOI('F','NOM_GD',TEMMOI,'CHAMP',IBID,NOMGD,IRET)
      IF (NOMGD.EQ.'TEMP_R') THEN
         PARTPM  = 'PTEMPER'
      ELSE IF (NOMGD.EQ.'TEMP_F') THEN
         PARTPM  = 'PTEMPEF'
      ELSE
         CALL UTMESS('F','NMVCPR','TEMPERATURE : GRANDEUR INCONNUE')
      END IF

      CALL DISMOI('F','NOM_GD',TEMPLU,'CHAMP',IBID,NOMGD,IRET)
      IF (NOMGD.EQ.'TEMP_R') THEN
         PARTPP  = 'PTEMPER'
      ELSE IF (NOMGD.EQ.'TEMP_F') THEN
         PARTPP  = 'PTEMPEF'
      ELSE
         CALL UTMESS('F','NMVCPR','TEMPERATURE : GRANDEUR INCONNUE')
      END IF


C -- CALCUL DES OPTIONS EN T+

      NBR = 0

      LPAIN(18)  = 'PTEMPSR'
      LCHIN(18)  =  INSPLU
      LPAIN(19)  =  PARTPP
      LCHIN(19)  =  TEMPLU
      LPAIN(20)  = 'PHYDRER'
      LCHIN(20)  =  HYDPLU
      LPAIN(21)  = 'PSECHER'
      LCHIN(21)  =  SECPLU
      LPAIN(22)  = 'PPHASRR'
      LCHIN(22)  =  PHAPLU
      LPAIN(23)  = 'PDEFAPR'
      LCHIN(23)  =  EPAPLU
      LPAIN(24)  =  'PNBSP_I'
      LCHIN(24)  =  CHCARA(1) (1:8)//'.CANBSP'

C    THERMIQUE
      IF (EXITEM) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(1) // MASQUE
        OPTION = 'CHAR_MECA_TEMP_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    HYDRATATION
      IF (EXIHYD) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(1) // MASQUE
        OPTION = 'CHAR_MECA_HYDR_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    SECHAGE
      IF (EXISEC) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(1) // MASQUE
        OPTION = 'CHAR_MECA_SECH_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    DEFORMATION ANELASTIQUE
      IF (EXIEPA) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(1) // MASQUE
        OPTION = 'CHAR_MECA_EPSA_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

C    PHASE (DEJA INCREMENTAL)
      IF (EXIPHA) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(1) // MASQUE
        OPTION = 'CHAR_MECA_META_Z'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCP-1 + NBR) = LCHOUT(1)
      END IF

      CALL JEECRA(VECEL(1) // '.LISTE_RESU','LONUTI',NBR,K8BID)


C -- CALCUL DES OPTIONS EN T-

      NBR = 0

      LPAIN(18)  = 'PTEMPSR'
      LCHIN(18)  =  INSMOI
      LPAIN(19)  =  PARTPM
      LCHIN(19)  =  TEMMOI
      LPAIN(20)  = 'PHYDRER'
      LCHIN(20)  =  HYDMOI
      LPAIN(21)  = 'PSECHER'
      LCHIN(21)  =  SECMOI
      LPAIN(22)  = 'PPHASRR'
      LCHIN(22)  =  PHAMOI
      LPAIN(23)  = 'PDEFAPR'
      LCHIN(23)  =  EPAMOI
      LPAIN(24)  =  'PNBSP_I'
      LCHIN(24)  =  CHCARA(1) (1:8)//'.CANBSP'

C    THERMIQUE
      IF (EXITEM) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(2) // MASQUE
        OPTION = 'CHAR_MECA_TEMP_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCM-1 + NBR) = LCHOUT(1)
      END IF

C    HYDRATATION
      IF (EXIHYD) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(2) // MASQUE
        OPTION = 'CHAR_MECA_HYDR_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCM-1 + NBR) = LCHOUT(1)
      END IF

C    SECHAGE
      IF (EXISEC) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(2) // MASQUE
        OPTION = 'CHAR_MECA_SECH_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCM-1 + NBR) = LCHOUT(1)
      END IF

C    DEFORMATION ANELASTIQUE
      IF (EXIEPA) THEN
        NBR = NBR+1
        CALL CODENT (NBR,'D0',MASQUE(4:6))
        LPAOUT(1) = 'PVECTUR'
        LCHOUT(1) =  VECEL(2) // MASQUE
        OPTION = 'CHAR_MECA_EPSA_R'
       CALL CALCUL('S',OPTION,LIGRMO,24,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')
        ZK24(JVCM-1 + NBR) = LCHOUT(1)
      END IF
      CALL JEECRA(VECEL(2) // '.LISTE_RESU','LONUTI',NBR,K8BID)


C -- ASSEMBLAGE

      X(1) =  1
      X(2) = -1
      CALL ASSVEC ('V',CNVCPR,2,VECEL,X,NUMEDD,' ','ZERO',1)

      CALL JEDEMA()
      END
