      SUBROUTINE QCONDT(PHI,SAT,T,P2,R,MAMOLV,MAMOLG,ATMP,J1F,J2,HFG
     &               ,TLANV,TLANW,DTALE,DTALP1,DTALP2,DTALT,J1D,RV0)
C
C     CETTE ROUTINE CALCULE LES DTALE,DTALP1,DTALP2,DTALT 
C     POUR LA MODELISATION DE THM NON SATURE DE B. GATMIRI (CERMES)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 03/10/2000   AUTEUR UFBHHLL C.CHAVANT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
      IMPLICIT NONE
C
      REAL*8   T,P2,PHI,SAT,SATG,TT1,UWT,RV0,AX1,AX,HUMR
      REAL*8   RHO12,RHO21,MAMOLV,MAMOLG,R,PVP,RHO11
      REAL*8   DRV0DT,DHDSR,DHDN,DHDT,ATMP
      REAL*8   DRVDTT,FACTOR,DFACP2,DFACT
      REAL*8   DATM,DDATT,DDATP2,TLANV,TLANW,TLANA
      REAL*8   J1F,J2,J1D
      REAL*8   HFG,DTALE,DTALP1,DTALP2,DTALT
C
      IF(SAT.LT.0.D0) SAT=0.D0
      IF(SAT.GT.1.D0) SAT=1.D0
      TT1=T
      UWT=PHI*SAT
C     
C     CALCUL DE HUMR: HUMIDITE RELATIVE ET SES DERIVEES
C
      AX1=UWT/(.04D0*RV0)
      AX=44.835D0*(AX1)**(-5.27D0)*(1.D0+(AX1)**(-4.27D0))**(-1.42D0)
      HUMR=(1.D0+(UWT/(.04D0*RV0))**(-4.27D0))**(-.42D0)
      DHDN = SAT*AX/RV0
      DHDT = -4975.9D0*UWT*AX/RV0
C
      DRV0DT=(4975.9D0*RV0)/TT1/TT1
      RHO12=RV0*HUMR
      PVP=RHO12*R*T/MAMOLV
C 
      DRVDTT=-2.D0*(4975.9D0*RV0)/(TT1**2.D0)/TT1
      FACTOR=P2/(P2-PVP)
      DFACP2=-PVP/(P2-PVP)/(P2-PVP)
      FACTOR=1.D0
      DFACP2=0.D0
      DATM=(5.893D-6*TT1**2.3D0)/(P2+ATMP)
      DDATT=(5.893D-6*2.3D0*TT1**1.3D0)/(P2+ATMP)
      DDATP2=-(5.893D-6*TT1**2.3D0)/(P2+ATMP)/(P2+ATMP)
      TLANV=DATM*HUMR*HFG*DRV0DT*FACTOR 
      DTALE=DATM*DRV0DT*HFG*FACTOR*DHDN*J1D
      DTALP1=DATM*DRV0DT*HFG*FACTOR*DHDN*(J1F-J2)
      DTALP2=DATM*DRV0DT*HFG*FACTOR*DHDN*(J2-J1F)+
     &       DDATP2*DRV0DT*HFG*FACTOR*HUMR+DFACP2*DATM*DRV0DT*HFG*HUMR
      DTALT=DDATT*DRV0DT*HFG*FACTOR*HUMR+DATM*DRV0DT*HFG*FACTOR*DHDT
     &      +DATM*DRV0DT*HFG*HUMR*DRVDTT 
C
      END
