      SUBROUTINE VECZAC(MODELZ,NUMEDD,MATE,TEMZAC,ALPHA,CNCHAN)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 11/09/2002   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================

      IMPLICIT NONE
      CHARACTER*8 MODELE
      CHARACTER*24 MATE
      CHARACTER*(*) MODELZ,NUMEDD,CNCHAN,ALPHA,TEMZAC

C ----------------------------------------------------------------------
C     CALCUL DES VECTEURS ELEMENTAIRES DES CHARGEMENTS METHODE ZAC
C     CONDITIONS AUX LIMITES HOMOGENES POUR LE RESTE DU PROBLEME
C ----------------------------------------------------------------------

C IN       MODELE  K8 : NOM DU MODELE
C IN       NUMEDD     : NUME_DDL
C IN       MATE   K24 : CHAMP DE MATERIAU
C IN       TEMZAC K19 : TEMPERATURE
C IN       ALPHA  K19 : CHAMP ALPHA DE DEFORMATIONS INITIALES
C IN/JXOUT CNCHAN K19 : SECOND MEMBRE ASSOCIE A LA METHODE ZAC

C --- DEBUT DECLARATIONS NORMALISEES JEVEUX ----------------------------

      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)

C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

      CHARACTER*8 VEZAC,LPAIN(4),LPAOUT(1),K8BID
      CHARACTER*16 OPTION
      CHARACTER*24 CHGEOM
      CHARACTER*24 LIGRMO,LCHIN(4),LCHOUT(1)
      INTEGER IRET,JLVE
      LOGICAL EXIGEO

      DATA VEZAC/'&&VEZAC'/
C ----------------------------------------------------------------------



      CALL JEMARQ()
      MODELE = MODELZ

C -- LECTURE OU CREATION DU VECT_ELEM

      CALL JEEXIN(VEZAC//'.LISTE_RESU',IRET)
      IF (IRET.EQ.0) THEN
        CALL MEMARE('V',VEZAC,MODELE(1:8),MATE,' ','CHAR_MECA')
        CALL WKVECT(VEZAC//'.LISTE_RESU','V V K24',1,JLVE)
      ELSE
        CALL JEVEUO(VEZAC//'.LISTE_RESU','E',JLVE)
      END IF


C -- LECTURE DE LA GEOMETRIE ET DU LIGREL

      CALL MEGEOM(MODELE(1:8),' ',EXIGEO,CHGEOM)
      LIGRMO = MODELE(1:8)//'.MODELE'


C -- CALCUL DE L'OPTION

      OPTION = 'CHAR_ALPH_ZAC'

      LPAIN(1) = 'PGEOMER'
      LCHIN(1) = CHGEOM
      LPAIN(2) = 'PTEMPER'
      LCHIN(2) = TEMZAC
      LPAIN(3) = 'PALPHAR'
      LCHIN(3) = ALPHA
      LPAIN(4) = 'PMATERC'
      LCHIN(4) = MATE

      LPAOUT(1) = 'PVECTUR'
      LCHOUT(1) = VEZAC//'.VE001'

      CALL CALCUL('S',OPTION,LIGRMO,4,LCHIN,LPAIN,1,LCHOUT,LPAOUT,'V')


C -- ASSEMBLAGE DU VECT_ELEM

      ZK24(JLVE) = LCHOUT(1)
      CALL JEECRA(VEZAC//'.LISTE_RESU','LONUTI',1,K8BID)
      CALL ASSVEC('V',CNCHAN,1,VEZAC,1.D0,NUMEDD,' ','ZERO',1)


      CALL JEDEMA()
      END
