      SUBROUTINE  XMEL3D(NNO, NPG, IPOIDS, IVF, IDFDE,NDDLE,
     &             IGEOM, TYPMOD, OPTION, IMATE, COMPOR, LGPG, CRIT, T,
     &             LSN,HYDR, SECH, TREF, DEPL, DFDI, PFF, DEF, SIG, VI,
     &             MATUU, VECTU, CODRET )

C            
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ALGORITH  DATE 05/07/2004   AUTEUR GENIAUT S.GENIAUT 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C RESPONSABLE GENIAUT S.GENIAUT
C TOLE CRP_21
C
       IMPLICIT NONE
C
       INTEGER       NNO,NPG,IMATE,LGPG,CODRET,IPOIDS,IVF,IDFDE,IGEOM
       INTEGER       NDDLE
       CHARACTER*8   TYPMOD(*)
       CHARACTER*16  OPTION, COMPOR(4)
       REAL*8        GEOM(3,NNO), CRIT(3), T(NNO), TREF
       REAL*8        LSN(NNO),HYDR(NNO), SECH(NNO)
       REAL*8        DEPL(1:3+NDDLE,1:NNO), DFDI(NNO,3)
       REAL*8        PFF(6,NNO,NNO),  DEF(6,NNO,3+NDDLE)
       REAL*8        SIG(6,NPG), VI(LGPG,NPG),SIGP(6)
       REAL*8        MATUU(*), VECTU(3+NDDLE,NNO)
       LOGICAL       DEFANE,MATSYM
C
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
C
      INTEGER  ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
C
C.......................................................................
C
C     BUT:  PRLIMINAIRES AU CALCUL DES OPTIONS RIGI_MECA_TANG, 
C           RAPH_MECA ET FULL_MECA  EN HYPER-ELASTICITE AVEC X-FEM
C.......................................................................
C IN  NNO     : NOMBRE DE NOEUDS DE L'ELEMENT
C IN  NPG     : NOMBRE DE POINTS DE GAUSS
C IN  POIDSG  : POIDS DES POINTS DE GAUSS
C IN  VFF     : VALEUR  DES FONCTIONS DE FORME
C IN  DFDE    : DERIVEE DES FONCTIONS DE FORME ELEMENT DE REFERENCE
C IN  NDDLE   : NOMBRE DE DDLS ENRICHIS
C IN  GEOM    : COORDONEES DES NOEUDS
C IN  TYPMOD  : TYPE DE MODELISATION
C IN  OPTION  : OPTION DE CALCUL
C IN  IMATE   : MATERIAU CODE
C IN  COMPOR  : COMPORTEMENT
C IN  LGPG  : "LONGUEUR" DES VARIABLES INTERNES POUR 1 POINT DE GAUSS
C              CETTE LONGUEUR EST UN MAJORANT DU NBRE REEL DE VAR. INT.
C IN  CRIT    : CRITERES DE CONVERGENCE LOCAUX
C IN  T       : TEMPERATURE AUX NOEUDS
C IN  LSN     : LEVEL SET NORMALE
C IN  HYDR    : HYDRATATION AUX POINTS DE GAUSS
C IN  SECH    : SECHAGE AUX NOEUDS
C IN  TREF    : TEMPERATURE DE REFERENCE
C IN  DEPL    : DEPLACEMENT A PARTIR DE LA CONF DE REF
C OUT DFDI    : DERIVEE DES FONCTIONS DE FORME  AU DERNIER PT DE GAUSS
C OUT PFF     : PRODUIT DES FCT. DE FORME       AU DERNIER PT DE GAUSS
C OUT DEF     : PRODUIT DER. FCT. FORME PAR F   AU DERNIER PT DE GAUSS
C OUT SIG     : CONTRAINTES DE CAUCHY (RAPH_MECA ET FULL_MECA)
C OUT VI      : VARIABLES INTERNES    (RAPH_MECA ET FULL_MECA)
C OUT MATUU   : MATRICE DE RIGIDITE PROFIL (RIGI_MECA_TANG ET FULL_MECA)
C OUT VECTU   : FORCES NODALES (RAPH_MECA ET FULL_MECA)
C..............................................................
C----------------------------------------------------------------
      CHARACTER*8   ELREFP ,TYPMAD,TYPMAA
      INTEGER       CONNEC(6,4),NINTER,NPTS,NSE,NAJ(NNO),CNSE(6,4)
      INTEGER       IT,ISE,INO,J,KPG
      CHARACTER*24  COORSE,PINTER,AINTER,HEAV
      REAL*8        SIGNO(6,NNO)

      CALL ELREF1(ELREFP)


C     -------------------------------------------------------

C            POUR L'INSTANT, SEULEMENT POUR DES HEXA4

C     -------------------------------------------------------


C     INITIALISATIONS
C     CONTRAINTES AUX NOEUDS PARENTS : SIGNO
      CALL MATINI(6,NNO,0.D0,SIGNO) 
      DO 10 INO=1,NNO
        NAJ(INO)=0
 10   CONTINUE

C     ON SUBDIVISE L'HEXA EN 6 TETRAS 
      TYPMAD='HEXA8'
      TYPMAA='TETRA4'
      CALL XDIVTE(TYPMAD,TYPMAA,CONNEC)

C     BOUCLE SUR LES 6 TETRAS
      DO 100 IT=1,6

C       DCOUPAGE EN NSE SOUS-LMENTS 
        PINTER='&&XMEL3D.PTINTER'
        AINTER='&&XMEL3D.ATINTER'
        CALL XDECOU(IT,CONNEC,LSN,IGEOM,PINTER,NINTER,NPTS,AINTER)
        COORSE='&&XMEL3D.COORSE'
        HEAV='&&XMEL3D.HEAV'
        CALL XDECOV(IT,CONNEC,IGEOM,LSN,NINTER,PINTER,NPTS,
     &                                    AINTER,NSE,CNSE,COORSE,HEAV)
      
C       INTGRATION SUR LES NSE SOUS-LMENTS
        DO 110 ISE=1,NSE
          CALL XXEL3D(ISE,ELREFP,COORSE,IGEOM,HEAV,NDDLE,CNSE,NAJ,
     &             NNO,NPG,TYPMOD,OPTION,IMATE,COMPOR,LGPG,CRIT,T,
     &             HYDR,SECH,TREF,DEPL,DFDI,PFF,DEF,SIGNO,VI,
     &             MATUU,VECTU,CODRET )
 110    CONTINUE

        CALL JEDETR(PINTER)
        CALL JEDETR(AINTER)
        CALL JEDETR(COORSE)
        CALL JEDETR(HEAV)

 100  CONTINUE

      IF (OPTION(1:9).EQ.'FULL_MECA'.OR.OPTION(1:9).EQ.'RAPH_MECA') THEN

C      ON MOYENNE SIGNO    (VOIR BOOK III 11/05/2004)
       DO 200 INO=1,NNO
         DO 210 J=1,6
           SIGNO(J,INO)=SIGNO(J,INO)/NAJ(INO)
 210     CONTINUE  
 200   CONTINUE      

C     PASSAGE DE SIGNO AUX POINTS DE GAUSS PARENT : SIG
      CALL MATINI(6,NPG,0.D0,SIG)
      DO 300 KPG=1,NPG
        DO 310 J=1,6
          DO 320 INO=1,NNO
            SIG(J,KPG)=SIG(J,KPG)+ZR(IVF-1+NNO*(KPG-1)+INO)*SIGNO(J,INO)
 320      CONTINUE
 310     CONTINUE      
 300   CONTINUE      

      ENDIF

      END
