      SUBROUTINE PTEEQU(PRCHNO,NEQ,GDS)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ASSEMBLA  DATE 14/01/98   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
C     ARGUMENTS:
C     ----------
      CHARACTER*19 PRCHNO
      INTEGER NEQ,GDS
C ----------------------------------------------------------------------
C     BUT : CREER L'OBJET .DEEQ POUR UN PROF_CHNO CREE PAS L'OPERATEUR
C           AFFE_CHAM_NO DANS LE CAS OU IL N'Y A QUE LE MAILLAGE :
C           LE REPERTOIRE LILI EST REDUIT A : ( &MAILLA )
C           ON NE PEUT DONC PAS AVOIR D'EQUATION PROVENANT DE MAILLE
C           OU DE NOEUD TARDIF
C     IN:
C     PRCHNO : NOM D'UN PROF_CHNO
C     NEQ    : NOMBRE D'EQUATIONS (OU DE DDL) DU PROF_CHNO
C     GDS    : NUMERO DE LA GRANDEUR SIMPLE ASSOCIEE AU CHAMP.
C
C     OUT:
C     PRCHNO EST COMPLETE DE L'OBJET ".DEEQ" V(I) DIM=2*NEQ
C         (CET OBJET EST DETRUIT S'IL EXISTE DEJA).
C     V((IDDL-1)*2+1)--> SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST PHYS.:
C                           +NUMERO DU NOEUD
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE BLOCAGE :
C                           +NUMERO DU NOEUD PHYS. BLOQUE
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE LIAISON :
C                            0
C     V((IDDL-1)*2+2)--> SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST PHYS.:
C                           + NUM. DANS L'ORDRE DU CATAL. DES GRAND.
C                           DE LA CMP CORRESPONDANT A L'EQUATION IDDL.
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE BLOCAGE :
C                           - NUM. DANS L'ORDRE DU CATAL. DES GRAND.
C                           DE LA CMP CORRESPONDANT AU BLOCAGE.
C                        SI LE NOEUD SUPPORT DE L'EQUA. IDDL EST UN
C                        LAGRANGE DE LIAISON :
C                            0
C ----------------------------------------------------------------------
C
C     FONCTIONS EXTERNES:
C     -------------------
      LOGICAL EXISDG
      INTEGER NBEC
C
C     VARIABLES LOCALES:
C     ------------------
C
C --------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR,JEXR8
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8,K8BID
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24,LIGREL
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      CHARACTER*1  K1BID
C ---------------- FIN COMMUNS NORMALISES  JEVEUX  --------------------
C
C
C     - ALLOCATION DE ".DEEQ":
      CALL JEMARQ()
      CALL JEEXIN(PRCHNO(1:19)//'.DEEQ',IRET)
      IF (IRET.GT.0) CALL JEDETR(PRCHNO(1:19)//'.DEEQ')
      CALL WKVECT(PRCHNO(1:19)//'.DEEQ','G V I',2*NEQ,IADEEQ)
C
      CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',GDS),'LONMAX',NCMPMX,K1BID)
      NEC = NBEC(GDS)
      IF (NCMPMX.EQ.0) CALL UTMESS('F','PTEEQU_1','LE NOMBRE MAXI DE'
     +                 //' COMPOSANTE DE LA GRANDEUR EST NUL')
      IF (NEC.EQ.0) CALL UTMESS('F','PTEEQU_2','LE NOMBRE D"ENTIERS'
     +                 //' CODES EST NUL')
C
      CALL JEVEUO(PRCHNO(1:19)//'.NUEQ','L',IANUEQ)
C
      CALL JELIRA(PRCHNO(1:19)//'.PRNO','NMAXOC',NBLIGR,K1BID)
      IF (NBLIGR.NE.1) CALL UTMESS('F','PTEEQU_3','LE .PRNO EST '
     +                          //'CONSTRUIT SUR PLUS QUE LE MAILLAGE')
C
      CALL JELIRA(JEXNUM(PRCHNO(1:19)//'.PRNO',1),'LONMAX',N1,K1BID)
      IF (N1.LE.0) CALL UTMESS('F','PTEEQU_4','LE .PRNO EST '
     +                         //'DE DIMENSION NULLE')
      CALL JEVEUO(JEXNUM(PRCHNO(1:19)//'.PRNO',1),'L',IAPRNO)
      NBNO = N1/ (NEC+2)
      DO 1 J = 1,NBNO
C
C---- J : NUMERO DU NOEUD DU MAILLAGE
        IDDL = ZI(IAPRNO-1+ (J-1)* (NEC+2)+1) - 1
        IADG = IAPRNO - 1 + (J-1)* (NEC+2) + 3
        DO 2 K = 1,NCMPMX
          IF (EXISDG(ZI(IADG),K)) THEN
            IDDL = IDDL + 1
            IEQ = ZI(IANUEQ-1+IDDL)
            ZI(IADEEQ-1+2* (IEQ-1)+1) = J
            ZI(IADEEQ-1+2* (IEQ-1)+2) = K
          END IF
2       CONTINUE
1     CONTINUE
      CALL JEDEMA()
      END
