      SUBROUTINE ALRSLT(IOPT,LIGREL,NOUT,LCHOUT,LPAOUT,BASE)
      IMPLICIT NONE

C MODIF CALCULEL  DATE 30/01/2002   AUTEUR VABHHTS J.TESELET 
C ======================================================================
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C RESPONSABLE                            VABHHTS J.PELLET

C     ARGUMENTS:
C     ----------
      INTEGER IOPT,NOUT
      CHARACTER*19 LIGREL
      CHARACTER*(*) BASE,LCHOUT(*)
      CHARACTER*8 LPAOUT(*)
C ----------------------------------------------------------------------
C     ENTREES:
C      IOPT : OPTION
C     LIGREL : NOM DE LIGREL
C     LCHOUT : LISTE DES NOMS DES CHAMPS DE SORTIE
C     LPAOUT : LISTE DES PARAMETRES ASSOCIES AUX CHAMPS DE SORTIE
C       NOUT : NOMBRE DE CHAMPS DE SORTIE
C       BASE : 'G', 'V' OU 'L'

C     SORTIES:
C      CREATION DES CHAMPS GLOBAUX RESULTATS

C ----------------------------------------------------------------------
      COMMON /CAII05/IANOOP,IANOTE,NBOBTR,IAOBTR,NBOBMX
      COMMON /CAII07/IACHOI,IACHOK

C     FONCTIONS EXTERNES:
C     -------------------
      INTEGER GRDEUR,IANOOP,IANOTE,NBOBTR,IAOBTR,NBOBMX,IACHOI,IACHOK
      CHARACTER*1 BAS2
      CHARACTER*32 JEXNUM

C     VARIABLES LOCALES:
C     ------------------
      INTEGER GD,DESCGD,CODE,I,IRET1,IRET2,IBID,IANOLI,IRET
      CHARACTER*19 NOCHOU,DCEL
      CHARACTER*8 NOMPAR
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8,KBI1,KBI2
      CHARACTER*16 ZK16,NOMOPT
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80


      CALL JENUNO(JEXNUM('&CATA.OP.NOMOPT',IOPT),NOMOPT)


C     -----ALLOCATION DES CHAMPS RESULTATS :
      DO 10 I = 1,NOUT
        NOMPAR = LPAOUT(I)
        NOCHOU = LCHOUT(I)
        GD = GRDEUR(NOMPAR)
        CALL JEVEUO(JEXNUM('&CATA.GD.DESCRIGD',GD),'L',DESCGD)
        CODE = ZI(DESCGD-1+1)

C        --SI LE CHAMP RESULTAT EXISTE DEJA, ON LE DETRUIT :
        CALL DETRSD('CHAMP_GD',NOCHOU)

C        --SI GD EST 1 GRANDEUR_SIMPLE --> CHAM_ELEM
        IF (CODE.EQ.1 .OR. CODE.EQ.2) THEN

          CALL JEEXIN(NOCHOU//'.NBVA',IRET)
          IF (IRET.GT.0) CALL UTMESS('F','ALRSLT','STOP 1')

          CALL EXISD('CHAM_ELEM_S',NOCHOU,IRET)
          IF (IRET.GT.0) THEN
            DCEL = NOCHOU
          ELSE
            DCEL = ' '
          END IF

          CALL ALCHML(LIGREL,NOMOPT,NOMPAR,BASE,NOCHOU,IRET,DCEL)
        ELSE
          CALL ALRESL(IOPT,LIGREL,NOCHOU,NOMPAR,BASE)
        END IF
   10 CONTINUE

   20 CONTINUE

C     --MISE A JOUR DE CAII07 :
      CALL WKVECT('&&CALCUL.LCHOU_I','V V I',MAX(2*NOUT,2),IACHOI)
      NBOBTR = NBOBTR + 1
      ZK24(IAOBTR-1+NBOBTR) = '&&CALCUL.LCHOU_I'
      CALL WKVECT('&&CALCUL.LCHOU_K8','V V K8',MAX(2*NOUT,2),IACHOK)
      NBOBTR = NBOBTR + 1
      ZK24(IAOBTR-1+NBOBTR) = '&&CALCUL.LCHOU_K8'

      DO 30 I = 1,NOUT
        NOCHOU = LCHOUT(I)
        CALL JEEXIN(NOCHOU//'.DESC',IRET1)
        CALL JEEXIN(NOCHOU//'.CELD',IRET2)
        IF ((IRET1+IRET2).EQ.0) GO TO 30

        CALL DISMOI('F','NOM_GD',NOCHOU,'CHAMP',IBID,KBI1,IBID)
        CALL DISMOI('F','TYPE_SCA',KBI1,'GRANDEUR',IBID,KBI2,IBID)
        ZK8(IACHOK-1+2* (I-1)+2) = KBI2
        CALL DISMOI('F','TYPE_CHAMP',NOCHOU,'CHAMP',IBID,KBI1,IBID)
C        -- SI C'EST UN CHAM_ELEM:
C           ON DOIT FAIRE UN JEVEUO EN ECRITURE POUR RECUPERER
C           L'ADRESSE DU .CELV
        IF (KBI1(1:2).EQ.'EL') THEN
          CALL JEVEUO(NOCHOU//'.CELD','E',ZI(IACHOI-1+2* (I-1)+1))
          CALL JEVEUO(NOCHOU//'.CELV','E',ZI(IACHOI-1+2* (I-1)+2))
          ZK8(IACHOK-1+2* (I-1)+1) = 'CHML'
        ELSE
          CALL JEVEUO(NOCHOU//'.DESC','E',ZI(IACHOI-1+2* (I-1)+1))
          ZK8(IACHOK-1+2* (I-1)+1) = 'RESL'
        END IF
   30 CONTINUE

   40 CONTINUE
      END
