      SUBROUTINE MERIAC (MODELZ,NCHAR,LCHAR,MATE,MATELZ)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER                   NCHAR
      CHARACTER*8                     LCHAR(*),  MATELZ
      CHARACTER*(*)      MODELZ,            MATE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 17/01/97   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     CALCUL DES MATRICES ELEMENTAIRES DE RIGIDITE ACOUSTIQUE
C      MATEL:
C            ( ISO     , 'RIGIDI_AC'  )
C
C     ENTREES:
C
C     LES NOMS QUI SUIVENT SONT LES PREFIXES UTILISATEUR K8:
C        MODELZ : NOM DU MODELE
C        NCHAR  : NOMBRE DE CHARGES
C        LCHAR  : LISTE DES CHARGES
C        MATE   : CARTE DE MATERIAU CODE
C        MATELZ  : NOM  DU  MATELE (N RESUELEM) PRODUIT
C                  ( ISO      , 'RIGIDI_AC'             )
C
C     SORTIES:
C        MATELZ    : LE MATELE EST REMPLI.
C
C ----------------------------------------------------------------------
C
C     FONCTIONS EXTERNES:
C     -------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
C
C     VARIABLES LOCALES:
C     ------------------
      CHARACTER*8  MODELE,MATEL
C
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24,NOMCH,NOMPR,V
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      CHARACTER*8 K8BID
C
C
      CALL JEMARQ()
      MODELE = MODELZ
      MATEL  = MATELZ
C
C     -- RIGIDITE CORRESPONDANT AUX ELEMENTS ISO
      CALL MERIA1(MODELE,NCHAR,LCHAR,MATE,'&MERIAC1',MATEL)
C
C     -- ON RECOPIE LES LISTE_RESU DE &MERIAC1 DANS MATEL.
C
      CALL JELIRA('&MERIAC1.LISTE_RESU','LONUTI',LONG1,K8BID)
      CALL JEVEUO('&MERIAC1.LISTE_RESU','L',JLIRE1)
C
      CALL JEEXIN(MATEL//'.REFE_RESU',IRET)
      IF (IRET.GT.0) THEN
        CALL JEDETR(MATEL//'.REFE_RESU')
        CALL JEDETR(MATEL//'.LISTE_RESU')
      END IF

      CALL MEMARE('G',MATEL,MODELE,MATE,' ','RIGI_ACOU')
      CALL JECREO(MATEL//'.LISTE_RESU','G V K24')
      CALL JEECRA(MATEL//'.LISTE_RESU','LONMAX',LONG1,' ')
      CALL JEECRA(MATEL//'.LISTE_RESU','LONUTI',LONG1,' ')
      CALL JEVEUO(MATEL//'.LISTE_RESU','E',JLIRES)
      DO 1,I = 1,LONG1
        ZK24(JLIRES-1+I) = ZK24(JLIRE1-1+I)
    1 CONTINUE
 9999 CONTINUE
      CALL JEDETC('G','&MERIAC1',1)
C
      MATELZ = MATEL
      CALL JEDEMA()
      END
