      SUBROUTINE MERITH(MODELZ,NCHAR,LCHAR,MATE,CARAZ,TIMEZ,DECENZ,
     &                  MATELZ,NH,BASEZ)
      IMPLICIT REAL*8 (A-H,O-Z)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 17/01/97   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     ARGUMENTS:
C     ----------
      CHARACTER*(*) LCHAR(*), MATE
      CHARACTER*(*) MODELZ,CARAZ,MATELZ,DECENZ,BASEZ,TIMEZ
      CHARACTER*8 MODELE,CARA,MATEL,DECENT
      CHARACTER*1 BASE
      CHARACTER*24 TIME
      INTEGER NCHAR
C ----------------------------------------------------------------------
C
C     CALCUL DES MATRICES ELEMENTAIRES DE RIGIDITE THERMIQUE
C      MATEL:
C            ( ISO     , 'RIGIDI_TH'  )
C            ( CAL_TI  , 'DDLMUR_THER')
C            ( ISO_FACE, 'RIGITH_COEFR/F' )
C
C     ENTREES:
C
C     LES NOMS QUI SUIVENT SONT LES PREFIXES UTILISATEUR K8:
C        MODELZ : NOM DU MODELE
C        NCHAR  : NOMBRE DE CHARGES
C        LCHAR  : LISTE DES CHARGES
C        MATE   : CHAMP DE MATERIAUX
C        CARAZ  : CHAMP DE CARAC_ELEM
C        TIMEZ  : CHAMPS DE TEMPSR
C        MATELZ : NOM  DU  MATELE (N RESUELEM) PRODUIT
C                  ( ISO      , 'RIGIDI_TH'             )
C                  ( CAL_TI   , 'DDLMUR_THER'           )
C                  ( ISO_FACE , 'RIGIDI_TH_COEFHR/F'    )
C        NH     : NUMERO DE L'HARMONIQUE DE FOURIER(SI PAS FOURIER NH=0)
C
C     SORTIES:
C        MATELZ   : LE MATELE EST REMPLI.
C
C ----------------------------------------------------------------------
C
C     FONCTIONS EXTERNES:
C     -------------------
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
C
C     VARIABLES LOCALES:
C     ------------------
C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24,NOMCH,NOMPR,V
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      CHARACTER*8  K8BID
      CALL JEMARQ()
      MODELE = MODELZ
      CARA   = CARAZ
      TIME   = TIMEZ
      BASE   = BASEZ
      DECENT = DECENZ
      MATEL  = MATELZ
C
C     -- RIGIDITE CORRESPONDANT AUX ELEMENTS ISO ET AUX ELEMENTS CAL_TI:
      CALL MERIT1(MODELE,NCHAR,LCHAR,MATE,CARA,TIME,'&MERITH1',NH,MATEL,
     +            0,BASE)
      CALL JELIRA('&MERITH1.LISTE_RESU','LONUTI',LONG1,K8BID)
      CALL JEVEUO('&MERITH1.LISTE_RESU','L',JLIRE1)
C
C     -- RIGIDITE CORRESPONDANT AUX ELEMENTS D'ECHANGE:
      CALL MERIT2(MODELE,NCHAR,LCHAR,CARA,TIME,'&MERITH2',MATEL,LONG1,
     +            BASE)
      CALL JELIRA('&MERITH2.LISTE_RESU','LONUTI',LONG2,K8BID)
      CALL JEVEUO('&MERITH2.LISTE_RESU','L',JLIRE2)
C
C     -- OPERATEUR ELEMENTAIRE DE CONVECTION NATURELLE:
      NUMOR3 = LONG1 + LONG2
      CALL MERIT3(MODELE,NCHAR,LCHAR,MATE,CARA,TIME,DECENT,'&MERITH3',
     +            MATEL,NUMOR3,BASE)
      CALL JELIRA('&MERITH3.LISTE_RESU','LONUTI',LONG3,K8BID)
      CALL JEVEUO('&MERITH3.LISTE_RESU','L',JLIRE3)
C
C
C     -- ON RECOPIE LES LISTE_RESU DE &MERITH1, &MERITH2 ET
C     -- &MERITH3 DANS MATEL.
C
      CALL JEEXIN(MATEL//'.REFE_RESU',IRET)
      IF (IRET.GT.0) THEN
        CALL JEDETR(MATEL//'.REFE_RESU')
        CALL JEDETR(MATEL//'.LISTE_RESU')
      END IF

      CALL MEMARE(BASE,MATEL,MODELE,MATE,CARA,'RIGI_THER')
      CALL JECREO(MATEL//'.LISTE_RESU',BASE//' V K24')
      CALL JEECRA(MATEL//'.LISTE_RESU','LONMAX', (LONG1+LONG2+LONG3),
     +            ' ')
      CALL JEECRA(MATEL//'.LISTE_RESU','LONUTI', (LONG1+LONG2+LONG3),
     +            ' ')
      CALL JEVEUO(MATEL//'.LISTE_RESU','E',JLIRES)
      DO 1,I = 1,LONG1
        ZK24(JLIRES-1+I) = ZK24(JLIRE1-1+I)
    1 CONTINUE
      DO 2,I = 1,LONG2
        ZK24(JLIRES-1+LONG1+I) = ZK24(JLIRE2-1+I)
    2 CONTINUE
      DO 3,I = 1,LONG3
        ZK24(JLIRES-1+LONG1+LONG2+I) = ZK24(JLIRE3-1+I)
    3 CONTINUE
C
 9999 CONTINUE
      CALL JEDETC(BASE,'&MERITH',1)
C
      MATELZ = MATEL
      CALL JEDEMA()
      END
