      SUBROUTINE PASNOE(CHAMEL,CHAMNO,BASE)
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*(*) CHAMEL,CHAMNO,BASE
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 06/04/2004   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C ----------------------------------------------------------------------
C IN  : CHAMEL : CHAM_ELEM AU NOEUDS
C OUT : CHAMNO : CHAM_NO RESULTAT
C IN  : BASE   : BASE SUR LAQUELLE ON CREE LE CHAM_NO
C ----------------------------------------------------------------------

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------

      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM,JEXR8,JEXATR
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------

C ----------------------------------------------------------------------
      CHARACTER*1 TYPVAL
      CHARACTER*8 K8B,NOMA,GRAN,NOMNO,NOMEL
      CHARACTER*19 CHAME,CHAMN
      CHARACTER*24 REFE,VALE,PRNO,NUEQ,PRCHNO,NOLILI
      COMPLEX*16 CBID
      CHARACTER*1 K1BID
C ----------------------------------------------------------------------

      CALL JEMARQ()
      CHAME = CHAMEL

C     --- TYPE DE VALEURS DU CHAM_ELEM ---

      CALL JELIRA(CHAME//'.CELV','TYPE',IBID,TYPVAL)
      IF (TYPVAL.EQ.'R') THEN
      ELSE IF (TYPVAL.EQ.'C') THEN
      ELSE
        CALL UTMESS('F','PASNOE','ON NE CONNAIT PAS CE TYPE DE '//
     +              'VALEURS "'//TYPVAL//'", VRAIMENT DESOLE!')
      END IF
      CALL JEVEUO(CHAME//'.CELV','L',IAVALE)

C     --- NOM DU MAILLAGE DU CHAM_ELEM ---

      CALL JEVEUO(CHAME//'.CELK','L',IACELK)
      NOLILI = ZK24(IACELK)
      CALL JEVEUO(NOLILI(1:19)//'.NOMA','L',IANOMA)
      NOMA = ZK8(IANOMA)
      CALL DISMOI('F','NB_NO_MAILLA',NOMA,'MAILLAGE',NBNOEU,K8B,IE)
      CALL JEVEUO(NOLILI(1:19)//'.LIEL','L',JLIGR)
      CALL JELIRA(NOLILI(1:19)//'.LIEL','NUTIOC',NBGREL,K1BID)
      CALL JEVEUO(JEXATR(NOLILI(1:19)//'.LIEL','LONCUM'),'L',JLONGR)

C     --- GRANDEUR DU CHAM_ELEM ---


C     -- ON VERIFIE QUE LE CHAM_ELEM N'EST PAS TROP DYNAMIQUE :
      CALL CELVER(CHAME,'NBVARI_CST','STOP',IBID)
      CALL CELVER(CHAME,'NBSPT_1','STOP',IBID)

      CALL JEVEUO(CHAME//'.CELD','L',JCELD)
      NUMGD = ZI(JCELD-1+1)
      CALL JENUNO(JEXNUM('&CATA.GD.NOMGD',NUMGD),GRAN)

      IF (GRAN.EQ.'VARI_R') THEN
        GRAN = 'VAR2_R'
        CALL JENONU(JEXNOM('&CATA.GD.NOMGD',GRAN),NUMGD)
      END IF

      CALL JEVEUO(JEXNUM('&CATA.GD.NOMCMP',NUMGD),'L',IAD)
      CALL JELIRA(JEXNUM('&CATA.GD.NOMCMP',NUMGD),'LONMAX',NCMPMX,K1BID)
      CALL WKVECT('&&PASNOE.NUM_CMP','V V I',NCMPMX,JNCMP)

C     --- NOMBRE D'ELEMENTS DU CHAM_ELEM ---
C     --- NOMBRE DE NOEUDS PAR MAILLE ---

      CALL JELIRA(NOMA//'.NOMMAI','NOMMAX',NBELEM,K1BID)
      CALL JEVEUO(NOMA//'.CONNEX','L',JCNX)
      CALL JEVEUO(JEXATR(NOMA//'.CONNEX','LONCUM'),'L',JPNT)


      IF (TYPVAL.EQ.'R') THEN
        CALL PASNOR(NBELEM,ZI(JLIGR),NBGREL,ZI(JLONGR),NCMPMX,
     +              ZR(IAVALE),ZK8(IAD),ZI(JCELD),ZI(JCNX),ZI(JPNT),
     +              NOLILI(1:19),NBNOEU,BASE,GRAN,NOMA,CHAMNO)
      ELSE
        CALL PASNOC(NBELEM,ZI(JLIGR),NBGREL,ZI(JLONGR),NCMPMX,
     +              ZC(IAVALE),ZK8(IAD),ZI(JCELD),ZI(JCNX),ZI(JPNT),
     +              NOLILI(1:19),NBNOEU,BASE,GRAN,NOMA,CHAMNO)
      END IF

      CALL JEDETR('&&PASNOE.NUM_CMP')

      CALL JEDEMA()
      END
