      SUBROUTINE PREDIV(NH,NITER,NOM,IDNO,IDMA,IDDIME,IDPAN,
     &                  IDPANO,IDDANS,IDPILE,IDLPAN,NLPAN)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF CALCULEL  DATE 02/04/2002   AUTEUR RATEAU G.RATEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C                                                                       
C                                                                       
C ======================================================================
C ----------------------------------------------------------------------
C  ALLOCATIONS DES OBJETS POUR LE DECOUPAGE EN SOUS-MAILLE (CF DIVISE)
C ----------------------------------------------------------------------
C VARIABLES D'ENTREE
C INTEGER      NH     : NOMBRE DE POINTS D'ECHANTILLONAGE SUR UNE ARETE 
C INTEGER      NITER  : NOMBRE MAX D'ITERATION DE DECOUPAGE
C CHARACTER*8  NOM    : SD DECOUPAGE
C 
C VARIABLES DE SORTIE
C INTEGER      IDNO   : ADRESSE DANS ZR DE NOM.DENO
C INTEGER      IDMA   : ADRESSE DANS ZI DE NOM.DEMA
C INTEGER      IDDIME : ADRESSE DANS ZI DE NOM.DEDIME
C INTEGER      IDPAN  : ADRESSE DANS ZR DE NOM.DEPAN
C INTEGER      IDPANO : ADRESSE DANS ZI DE NOM.DEPANO
C INTEGER      IDDANS : ADRESSE DANS ZL DE NOM.NODANS
C INTEGER      IDPILE : ADRESSE DANS ZI DE NOM.DEPILE
C INTEGER      IDLPAN : ADRESSE DANS ZI DE NOM.DELPAN
C INTEGER      NLPAN  : ADRESSE DANS NOM.DELPAN POUR LE TRANSFERT
C
C SD PRODUITE
C NOM.DENO   : COORD NOEUDS DES SOUS-MAILLES
C NOM.DEMA   : CONNECTIVITE DES SOUS-MAILLES
C NOM.DEDIME : NOMBRE DE NOEUDS DES SOUS-MAILLES
C NOM.DEPAN  : EQUATIONS DES PANS PRODUITS PAR L'ECHANTILLONAGE ET 
C              LE DECOUPAGE
C NOM.DEPANO : NOEUDS DE NOM.DENO DEFINISSANT LES PANS DE NOM.DEPAN
C NOM.NODANS : POSITION DES POINTS D'ECHANTILLONAGE
C NOM.DEPILE : PILE DES SOUS-MAILLES A DECOUPER
C NOM.DELPAN : LISTES DES PANS DE DECOUPE NON-UTILISES
C ----------------------------------------------------------------------

      IMPLICIT NONE

C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      CHARACTER*32       JEXNUM , JEXNOM , JEXR8 , JEXATR
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --- FIN DECLARATIONS NORMALISEES JEVEUX ------------------------------

C --- VARIABLES
      CHARACTER*8 NOM
      INTEGER  IDNO,IDMA,IDDIME,IDPAN,IDPANO,IDDANS,IDPILE,IDLPAN
      INTEGER  NH,NITER,DIM,NNO,NMA,MAN,NPAN,NDANS,NPILE,NLPAN

      DIM = 3
      MAN = 8
      NPAN = 6*(NH-1)*(NH-1)
      NDANS = 2*NH*NH
      NNO = 6*(NDANS+NITER) + MAN
      NMA = 12 + 5*NITER
      NPILE = NMA
      NLPAN = NPAN + 10*NH*NITER

      CALL WKVECT(NOM//'.DENO','V V R',DIM*NNO,IDNO)
      CALL WKVECT(NOM//'.DEMA','V V I',MAN*NMA,IDMA)
      CALL WKVECT(NOM//'.DEDIME','V V I',NMA,IDDIME)
      CALL WKVECT(NOM//'.DEPAN','V V R',(DIM+1)*NPAN,IDPAN)
      CALL WKVECT(NOM//'.DEPANO','V V I',DIM*NPAN,IDPANO)
      CALL WKVECT(NOM//'.NODANS','V V L',NDANS,IDDANS)
      CALL WKVECT(NOM//'.DEPILE','V V I',4*NPILE,IDPILE)
      CALL WKVECT(NOM//'.DELPAN','V V I',NLPAN+NPAN,IDLPAN)
      
      END
