      SUBROUTINE DICOR6 (K0,SIM,P2,DP2,DBAR2,DUR,DRYR,NU2,MU2,
     &                   DXU2,DRYU2,VARIP3,DNSDU,DMSDT,DNSDT,
     &                   DNSDU2,DMSDT2,DNSDT2)
C ----------------------------------------------------------------------
      IMPLICIT NONE
      REAL*8 K0(78),SIM(12)
      REAL*8 P2,DP2,DBAR2,DUR,DRYR,NU2,MU2,DXU2,DRYU2
      REAL*8 VARIP3,DNSDU,DMSDT,DNSDT,DNSDU2,DMSDT2,DNSDT2
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 10/01/95   AUTEUR D6BHHIV I.VAUTIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C     UTILITAIRE POUR LE COMPORTEMENT CORNIERE.
C
C ----------------------------------------------------------------------
C
C IN  : K0     : COEFFICIENTS DE RAIDEUR TANGENTE
C       SIM    : EFFORTS GENERALISES PRECEDENTS
C       P2     : VARIABLE INTERNE COURANTE MECANISME 2
C       DP2    : INCREMENT DE P2
C       DBAR2  : COEFFICIENT DE LA RELATION DU MECANISME 2
C       DUR    : INCREMENT DE DEPLACEMENT
C       DRYR   : INCREMENT DE ROTATION
C       NU2    : EFFORT ULTIME POUR LE MECANISME 2
C       MU2    : MOMENT ULTIME POUR LE MECANISME 2
C       DXU2   : DEPLACEMENT ULTIME POUR LE MECANISME 2
C       DRYU2  : ROTATION ULTIME POUR LE MECANISME 2
C
C OUT : VARIP3 : VARIABLE INTERNE ACTUALISEE
C       DNSDU  :
C       DMSDT  :
C       DNSDT  :
C       DNSDU2 :
C       DMSDT2 :
C       DNSDT2 :
C
C**************** DECLARATION DES VARIABLES LOCALES ********************
C
      REAL*8 G2,RG2,RGP2,DUN,DUM
C
C************ FIN DES DECLARATIONS DES VARIABLES LOCALES ***************
C
      VARIP3 = 2.D0
      P2 = P2 + DP2
      G2 = DBAR2*P2
      RG2 = 0.5D0*(-G2+SQRT(G2**2 + 4.D0*G2))
      RGP2 = (1.D0-RG2)**2/RG2/(2.D0-RG2)
      IF (DUR.NE.0.D0) DNSDU = RG2*NU2/DXU2/DP2-SIM(7)/DUR
      IF (DUR.EQ.0.D0) DNSDU = K0(1)
      IF (DRYR.NE.0.D0) DMSDT = RG2*MU2/DRYU2/DP2-SIM(11)/DRYR
      IF (DRYR.EQ.0.D0) DMSDT = K0(15)
      DNSDT = 0.D0
      DUN = DUR/DXU2
      DUM = DRYR/DRYU2
      DNSDU2 = (NU2/DXU2)*(RG2/DP2-DUN**2*RG2/DP2**3
     &       + DBAR2*RGP2*DUN**2/DP2**2)
      IF (DUR.EQ.0.D0) DNSDU2 = K0(1)
      DMSDT2 = (MU2/DRYU2)*(RG2/DP2-DUM**2*RG2/DP2**3
     &       + DBAR2*RGP2*DUM**2/DP2**2)
      IF (DRYR.EQ.0.D0) DMSDT2 = K0(15)
      DNSDT2 = (NU2/DRYU2)*(-DUN*DUM*RG2/DP2**3
     &       + DBAR2*RGP2*DUM*DUN/DP2**2)
      IF (DUR.EQ.0.D0.OR.DRYR.EQ.0.D0) DNSDT2 = 0.D0
C ----------------------------------------------------------------------
C
 9999 CONTINUE
      END
