      SUBROUTINE DNCUDI(NBN,DEPS,NCRIT,NBNNEW,DCURVP,DDISIP,MP1,MP2,
     &                  DC1,DC2,DTG,ZEROG,ZERO)
      IMPLICIT NONE
      COMMON /TDIM/ N,ND
      REAL*8 NBN(6),   DEPS(6),    MP1(3),    MP2(3)
      REAL*8 DC1(3,3), DC2(3,3),   DTG(6,6)
      REAL*8 ZERO,     MATMP(3,6), TMP3(3),   TMP6(6)
      REAL*8 ZEROG,    NBNNEW(6),  DCURVP(3), DDISIP
      REAL*8 DCP(3,2), DEPSP(6),   TMP(3),    S
      INTEGER NCRIT,I,J, N, ND
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 18/10/2004   AUTEUR LEBOUVIE F.LEBOUVIER 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C-----------------------------------------------------------------------
C     BUT    :  SELON LE CRITERE DE PLASTICITE CALCUL :
C                 - DU MOMENT DE RAPPEL 
C                 - DE LA COURBURE PLASTIQUE 
C                 - DE LA DISSIPATION PLASTIQUE
C
C IN    R  NBN    : MEMENT DE RAPPEL = ( N, M-BACKM )
C       R  DC1    : MATRICE ELASTIQUE + CONSTANTE DE PRAGER (FLEXION +)
C       R  DC2    : MATRICE ELASTIQUE + CONSTANTE DE PRAGER (FLEXION -)
C       R  MP1    : MOMENT LIMITE ELASTIQUE EN FLEXION POSITIVE
C       R  MP2    : MOMENT LIMITE ELASTIQUE EN FLEXION NEGATIVE
C       R  DTG    : MATRICE TANGENTE
C       I  NCRIT  : NUMERO DU CRITERE DE PLASTICITE
C        
C OUT   R  NBNNEW : NOUVEAUX MOMMENTS DE RAPPEL
C       R  DCURVP : INCREMENT DE COURBURE PLASTIQUE
C       R  DDISIP : INCREMENT DE DISSIPATION PLASTIQUE
C-----------------------------------------------------------------------
C
       IF( NCRIT.EQ.0) THEN
C
         CALL INITVE(3,DCURVP)
         DDISIP = 0.D0
C
         CALL EXTMAT(DTG,6,3,6,'IG',MATMP)
         CALL PRMRVE(MATMP,3,6,DEPS,TMP)
C
         DO 10 I=1,3
            NBNNEW(I+3)=NBN(I+3)+TMP(I)
 10     CONTINUE
C
      ELSE IF(NCRIT.EQ.1) THEN
         CALL DCPL1C(NBN(4),DEPS,MP1,DC1,DTG,ZEROG,DCURVP)
C        MP1(3)=0
         DDISIP=DCURVP(1)*MP1(1)+DCURVP(2)*MP1(2)
C        
         CALL EXTMAT(DTG,6,3,6,'IG',MATMP)
         CALL PRMRVE(MATMP,3,6,DEPS,TMP)
C
         N=3
         CALL PMAVEC('ZERO',3,DC1,DCURVP,TMP3)
         DO 30 I=1,3
            NBNNEW(I+3)=NBN(I+3)+TMP(I)-TMP3(I)
 30     CONTINUE
C
      ELSE IF(NCRIT.EQ.2) THEN
         CALL DCPL1C(NBN(4),DEPS,MP2,DC2,DTG,ZEROG,DCURVP)
C        MP2(3)=0
         DDISIP=DCURVP(1)*MP2(1)+DCURVP(2)*MP2(2)
C       
         CALL EXTMAT(DTG,6,3,6,'IG',MATMP)
         CALL PRMRVE(MATMP,3,6,DEPS,TMP)
C
         N=3
         CALL PMAVEC('ZERO',3,DC2,DCURVP,TMP3)
         DO 50 I=1,3
            NBNNEW(I+3)=NBN(I+3)+TMP(I)-TMP3(I)
 50     CONTINUE
C
      ELSE IF(NCRIT.EQ.12) THEN
         CALL DCPL2C(NBN(4),DEPS,MP1,MP2,DC1,DC2,DTG,ZEROG,DCP,ZERO)
         DO 70 I=1,3
            DCURVP(I)=DCP(I,1)+DCP(I,2)
 70     CONTINUE
C        MP1(3)=0,MP2(3)=0
         DDISIP=DCP(1,1)*MP1(1)+DCP(2,1)*MP1(2)+
     &        DCP(1,2)*MP2(1)+DCP(2,2)*MP2(2)
C     
         CALL EXTMAT(DTG,6,3,6,'IG',MATMP)
         CALL PRMRVE(MATMP,3,6,DEPS,TMP)
         DO 80 I=1,3
            S=0.D0
            DO 90 J=1,3
               S=S+DC1(I,J)*DCP(J,1)
 90        CONTINUE
            DO 100 J=1,3
               S=S+DC2(I,J)*DCP(J,2)
 100        CONTINUE
            NBNNEW(I+3)=NBN(I+3)+TMP(I)-S
 80     CONTINUE
      ELSE
         CALL UTMESS('F','DNCUDI','CRITERE PLASTIQUE INCONNU')
      ENDIF
C
      DO 110 I=1,3
         DEPSP(I)=0.D0
         DEPSP(I+3)=DCURVP(I)
 110  CONTINUE
C
      N = 6
      CALL LCDIVE(DEPS,DEPSP,TMP6)    
      CALL EXTMAT(DTG,6,3,6,'SG',MATMP)
      CALL PRMRVE(MATMP,3,6,TMP6,TMP)
C
      DO 120 I=1,3
         NBNNEW(I)=NBN(I)+TMP(I)
 120  CONTINUE
C
      END
