      SUBROUTINE EFDF21(NDIM,AXI,GEOM,KPG,IPOIDS,NNO2,IVF2,IDFDE2,
     &                  NNO1,DFDE1,DFDN1,DFDK1,POIDS,DFDI21,R)

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 30/03/2004   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================

      IMPLICIT NONE
      LOGICAL AXI
      INTEGER NDIM,NNO1,NNO2,KPG,IPOIDS,IVF2,IDFDE2
      REAL*8  POIDS,R,GEOM(NDIM,NNO2),DFDI21(NNO1,NDIM)
      REAL*8  DFDE1(*),DFDN1(*),DFDK1(*)
C.......................................................................

C    DERIVEE DES FONCTIONS DE FORME P1 PAR RAPPORT A UNE GEOMETRIE P2
C.......................................................................

C IN  NDIM    : DIMENSION DE L'ESPACE
C IN  AXI     : INDICATEUR SI AXISYMETRIQUE
C IN  GEOM    : COORDONEES DES NOEUDS
C IN  KPG     : NUMERO DU POINT DE GAUSS (POUR L'ACCES AUX FCT. FORMES)
C IN  POIDSG  : POIDS DU POINT DE GAUSS DE L'ELEMENT DE REFERENCE
C IN  NNO     : NOMBRE DE NOEUDS (P2 OU P1)
C IN  VFF     : VALEUR DES FONCTIONS DE FORME (P2 OU P1)
C IN  DFDE    : DERIVEE DES FONCTIONS DE FORME DE REFERENCE (P2 OU P1)
C IN  DFDN    : DERIVEE DES FONCTIONS DE FORME DE REFERENCE (P2 OU P1)
C IN  DFDK    : DERIVEE DES FONCTIONS DE FORME DE REFERENCE (P2 OU P1)
C OUT POIDS   : POIDS D'INTEGRATION (*R EN AXI)
C OUT DFDI21  : DERIVEE DES FONCTIONS DE FORME
C OUT R       : DISTANCE DU POINT DE GAUSS A L'AXE (EN AXISYMETRIQUE)
C......................................................................
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      INTEGER N,KK1


C -- DERIVEE DES FONCTIONS DE FORME

      IF (NDIM.EQ.3) THEN
        KK1 = (KPG-1)*NNO1*3 + 1
        CALL EFDF3D( IPOIDS, KPG, NNO2,IDFDE2,
     &               NNO1, DFDE1(KK1), DFDN1(KK1), DFDK1(KK1),
     &               GEOM, DFDI21(1,1),
     &               DFDI21(1,2), DFDI21(1,3), POIDS )
      ELSE
        KK1 = (KPG-1)*NNO1 + 1
        CALL EFDF2D(IPOIDS,KPG,NNO2,IDFDE2,NNO1,DFDE1(KK1),DFDK1(KK1),
     &              GEOM,DFDI21(1,1),DFDI21(1,2),POIDS)
      END IF


C -- DISTANCE A L'AXE (AXISYMETRIQUE)

      IF (AXI) THEN
        R = 0.D0
        DO 10 N = 1,NNO2
          R = R + ZR(IVF2+N+(KPG-1)*NNO2-1)*GEOM(1,N)
   10   CONTINUE
        POIDS = POIDS*R
      END IF

      END
