      SUBROUTINE FETCRL(VLIMA,NBMA,VLIGR,NBLIGR,VKLIMA)
C-----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 05/05/2004   AUTEUR BOITEAU O.BOITEAU 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C-----------------------------------------------------------------------
C    - FONCTION REALISEE:  CREATION DES STRUCTURE DE DONNEES LIGREL
C      DE CHARGE EVENTUELLES QUI PEUVENT ETRE ASSOCIEES AU SOUS
C      DOMAINE I
C
C IN VLIMA : LISTE DES NUMEROS DE MAILLES CONSTITUANT LE SOUS-DOMAINE
C IN NBMA  : TAILLE DE CETTE LISTE
C IN VLIGR : LISTE DES NOMS DES LIGRELS
C IN NBLIGR: TAILLE DE CETTE LISTE
C IN/OUT VKLIMA: LISTE DES NOMS DE CES MAILLES          
C   -------------------------------------------------------------------
C     SUBROUTINES APPELLEES:
C       MESSAGE:UTDEBM,UTFINM,UTIMPI/K.
C       JEVEUX:JEMARQ,JEDEMA,JEVEUO,JENUNO,JEXNUM.
C
C     FONCTIONS INTRINSEQUES:
C       NONE.
C   -------------------------------------------------------------------
C     ASTER INFORMATIONS:
C       20/11/03 (OB): CREATION.
C----------------------------------------------------------------------
C RESPONSABLE BOITEAU O.BOITEAU
C CORPS DU PROGRAMME
      IMPLICIT NONE

C DECLARATION PARAMETRES D'APPELS
      INTEGER      NBMA,NBLIGR
      INTEGER      VLIMA(NBMA)
      CHARACTER*8  VKLIMA(NBMA)
      CHARACTER*24 VLIGR(NBLIGR)
      
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      
C DECLARATION VARIABLES LOCALES
      INTEGER I,INT1,IMAIL
      CHARACTER*8 MAIL,NOMAIL
      CHARACTER*24 MAILMA
      CHARACTER*32 JEXNUM
      
C CORPS DU PROGRAMME
      CALL JEMARQ()

C NOM DU MAILLAGE SOUS-JACENT AU MODELE
      CALL JEVEUO(VLIGR(1)(1:19)//'.NOMA','L',IMAIL)
      MAIL=ZK8(IMAIL)
      MAILMA=MAIL//'.NOMMAI'
        
C ADDRESSE JEVEUX DU .REPE DU LIGREL DU MODELE DONNE AU CALCUL
C     CALL JEVEUO(VLIGR(1)(1:19)//'.REPE','L',IREPE)

      DO 20 I=1,NBMA
C NUMERO GLOBAL DE LA IEME MAILLE DU SOUS-DOMAINE NUMSD      
        INT1=VLIMA(I)

C TEST DESACTIVE CAR EFFECTUE DANS EXLIM1
C VERIFICATION DE L'APPARTENANCE DES MAILLES DU SOUS-DOMAINES AU MODELE 
C       INT2=ZI(IREPE+2*(INT1-1)+1)
C       IF (INT2.EQ.0) THEN
C MAILLE DU MODELE NON AFFECTEE 
C          CALL UTDEBM('F','FETCRL','LA MAILLE ')
C          CALL UTIMPI('S','DE NUMERO ',1,INT1)
C          CALL UTIMPI('L','APPARTENANT AU SOUS-DOMAINE ',1,NUMSD)
C          CALL UTIMPI('L','(C''EST SA ',1,I)
C          CALL UTIMPI('S',' IEME MAILLE)',0,I)
C          CALL UTIMPK('L','N''EST PAS ACTIVEE DANS LE MODELE ',1,
C     &      VLIGR(1)(1:8))
C          CALL UTIMPI('S',' FOURNI A L''OPERATEUR',0,I)
C          CALL UTFINM()        
C       ENDIF
        
C ENRICHISSEMENT DE LA LISTE DES NOMS DE MAILLES DU SOUS-DOMAINE        
        CALL JENUNO(JEXNUM(MAILMA,INT1),NOMAIL)
        VKLIMA(I)=NOMAIL           
   20 CONTINUE
 
      CALL JEDEMA()
      END
