      SUBROUTINE Q4GMAS ( NOMTE, XYZL, OPTION, PGL, MAS, ENER )
      IMPLICIT NONE
      REAL*8         XYZL(3,*), PGL(*), MAS(*), ENER(*)
      CHARACTER*16   OPTION , NOMTE
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 21/01/2004   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.				 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C     ------------------------------------------------------------------
C     MATRICE MASSE DE L'ELEMENT DE PLAQUE Q4GAMMA (W LINEAIRE)
C     ------------------------------------------------------------------
C     IN  XYZL   : COORDONNEES LOCALES DES QUATRE NOEUDS
C     IN  OPTION : OPTION RIGI_MECA OU EPOT_ELEM_DEPL
C     IN  PGL    : MATRICE DE PASSAGE GLOBAL/LOCAL
C     OUT MAS    : MATRICE DE RIGIDITE
C     OUT ENER   : TERMES POUR ENER_CIN (ECIN_ELEM_DEPL)
C     ------------------------------------------------------------------
C --------- DEBUT DECLARATIONS NORMALISEES  JEVEUX ---------------------
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C --------- FIN  DECLARATIONS  NORMALISEES  JEVEUX ---------------------
      INTEGER  I, J, K, LZR, INT, JCOQU, JDEPG, II(8),JJ(8),LL(16)
      REAL*8   FLEX(12,12),BC(2,12)
      REAL*8   MEMB(8,8), AMEMB(64), MEFL(8,12)
      REAL*8   WQ4(12), DEPL(24), MASLOC(300), MASGLO(300)
      REAL*8   RHO,EPAIS,ROE,CTOR,EXCENT,DETJ,WGT,ZERO,COEFM

C     ------------------ PARAMETRAGE QUADRANGLE ------------------------
      INTEGER NPG,NC,NNO
      INTEGER LDETJ,LJACO,LTOR,LQSI,LETA,LWGT,LXYC,LCOTE,LCOS,LSIN,LAIRE
      PARAMETER (NPG=4)
      PARAMETER (NNO=4)
      PARAMETER (NC=4)
      PARAMETER (LDETJ=1)
      PARAMETER (LJACO=2)
      PARAMETER (LTOR=LJACO+4)
      PARAMETER (LQSI=LTOR+1)
      PARAMETER (LETA=LQSI+NPG+NNO+2*NC)
      PARAMETER (LWGT=LETA+NPG+NNO+2*NC)
      PARAMETER (LXYC=LWGT+NPG)
      PARAMETER (LCOTE=LXYC+2*NC)
      PARAMETER (LCOS=LCOTE+NC)
      PARAMETER (LSIN=LCOS+NC)
      PARAMETER (LAIRE=LSIN+NC)
C     ------------------------------------------------------------------
      DATA (II(K),K=1,8)/1,10,19,28,37,46,55,64/
      DATA (JJ(K),K=1,8)/5,14,23,32,33,42,51,60/
      DATA (LL(K),K=1,16)/3,7,12,16,17,21,26,30,35,39,44,48,49,53,58,62/
C     ------------------------------------------------------------------
      CALL JEMARQ()

      CALL JEVETE('&INEL.'//NOMTE(1:8)//'.DESR',' ',LZR)

      ZERO = 0.0D0

      CALL DXROEP(RHO,EPAIS)
      ROE = RHO*EPAIS

      CALL JEVECH('PCACOQU','L',JCOQU)
      CTOR = ZR(JCOQU+3)
      EXCENT = ZR(JCOQU+4)
C
C --- ON NE CALCULE PAS ENCORE LA MATRICE DE MASSE D'UN ELEMENT
C --- DE PLAQUE EXCENTRE, ON S'ARRETE EN ERREUR FATALE :
C     ------------------------------------------------
      IF (EXCENT.NE.ZERO) THEN
        CALL UTMESS('F','Q4G','POUR L''INSTANT ON NE FAIT PAS '//
     +              'LE CALCUL DE LA  MATRICE DE MASSE D''UN ELEMENT'//
     +              ' DE PLAQUE Q4G EXCENTRE.')
      ENDIF

C     ----- CALCUL DES GRANDEURS GEOMETRIQUES SUR LE QUADRANGLE --------
      CALL GQUAD4(XYZL,ZR(LZR))

      DO 10 K = 1,96
        MEFL(K,1) = 0.D0
   10 CONTINUE
      DO 20 K = 1,144
        FLEX(K,1) = 0.D0
   20 CONTINUE

      DO 50 INT = 1,NPG

C        ----- CALCUL DU JACOBIEN SUR LE QUADRANGLE -------------------
        CALL JQUAD4(INT,XYZL,ZR(LZR))

C        ---- CALCUL DE LA MATRICE BC ----------------------------------
        CALL Q4GBC(INT,ZR(LZR),BC)

C        ----- CALCUL DES FONCTIONS D'INTERPOLATION EN FLEXION ---------
        CALL Q4GNIW(INT,ZR(LZR),BC,WQ4)

        DETJ = ZR(LZR-1+LDETJ)
        WGT = ZR(LZR-1+LWGT+INT-1)*DETJ*ROE

        DO 40 I = 1,12
          DO 30 J = 1,12
            FLEX(I,J) = FLEX(I,J) + WQ4(I)*WQ4(J)*WGT
   30     CONTINUE
   40   CONTINUE
   50 CONTINUE

C     ----- CALCUL DE LA MATRICE MASSE EN MEMBRANE ---------------------
      COEFM = ZR(LZR-1+LAIRE)*ROE/9.D0
      DO 60 K = 1,64
        AMEMB(K) = 0.D0
   60 CONTINUE
      DO 70 K = 1,8
        AMEMB(II(K)) = 1.D0
        AMEMB(JJ(K)) = 0.25D0
   70 CONTINUE
      DO 80 K = 1,16
        AMEMB(LL(K)) = 0.5D0
   80 CONTINUE
      DO 90 K = 1,64
        MEMB(K,1) = COEFM*AMEMB(K)
   90 CONTINUE

      IF (( OPTION .EQ. 'MASS_MECA' ).OR.(OPTION.EQ.'M_GAMMA')) THEN
        CALL DXQLOC(FLEX,MEMB,MEFL,CTOR,MAS)
      ELSE IF (OPTION.EQ.'MASS_MECA_DIAG') THEN
        CALL DXQLOC(FLEX,MEMB,MEFL,CTOR,MASLOC)
        WGT = ZR(LZR-1+LAIRE)*ROE
        CALL UTPSLG(4,6,PGL,MASLOC,MASGLO)
        CALL DIALUM(4,6,24,WGT,MASGLO,MAS)
      ELSE IF (OPTION.EQ.'ECIN_ELEM_DEPL') THEN
        CALL JEVECH('PDEPLAR','L',JDEPG)
        CALL UTPVGL(4,6,PGL,ZR(JDEPG),DEPL)
        CALL DXQLOE(FLEX,MEMB,MEFL,CTOR,0,DEPL,ENER)
      END IF
      CALL JEDEMA()
      END
