      SUBROUTINE TE0477(OPTION,NOMTE)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF ELEMENTS  DATE 26/01/2004   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.

C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.

C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.............................................................
      IMPLICIT REAL*8 (A-H,O-Z)

C     BUT: CONSTRUCTION DU VECTEUR DES FLUX THERMO-HYDRAULIQUES POUR
C          CHARGEMENT FORCE_ARETE POUR LES ELEMENTS
C          ISOPARAMETRIQUES 3D  POREUX DE JOINT (THM)
C          (I.E. CALCUL DU VECTEUR DES FORCES NODALES EQUIVALENTES
C                A UN  FLUX  LINEIQUE LE LONG D'UNE ARETE POUR
C                LES ELEMENTS 3D).

C          OPTIONS : 'FLUX_THM_REP'
C                  I.E. CHAR_MECA_FLUX_R

C     ENTREES  ---> OPTION : OPTION DE CALCUL
C              ---> NOMTE  : NOM DU TYPE ELEMENT
C.......................................................................

      CHARACTER*8 NOMPAR(4),ELREFE
      CHARACTER*16 NOMTE,OPTION
      REAL*8 XYZGAU(3),FORLIN(3),INSTAN,JAC
      REAL*8 TPLUS,DELTAT,THETA
      INTEGER IPRES,IFLUX,ITEMPS,NPG,IPOIDS,IDFDK
      INTEGER IRES,IGEOM,IPG,LDEC

C---------------- COMMUNS NORMALISES  JEVEUX  --------------------------
      COMMON /IVARJE/ZI(1)
      COMMON /RVARJE/ZR(1)
      COMMON /CVARJE/ZC(1)
      COMMON /LVARJE/ZL(1)
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      INTEGER ZI
      REAL*8 ZR
      COMPLEX*16 ZC
      LOGICAL ZL
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
C------------FIN  COMMUNS NORMALISES  JEVEUX  --------------------------


      CALL ELREF1(ELREFE)


C --- CARACTERISTIQUES DU TYPE D'ELEMENT :
C --- INTEGRATION ET INTERPOLATION
C      ----------------------------
      CALL ELREF4(' ','RIGI',NDIM,NNO,NNOS,NPG,IPOIDS,IVF,IDFDK,JGANO)
      CALL JEVECH('PGEOMER','L',IGEOM)
      CALL JEVECH('PVECTUR','E',IRES)
      CALL JEVECH('PFLUXR','L',IFLUX)
      CALL JEVECH('PTEMPSR','L',ITEMPS)
      DELTAT = ZR(ITEMPS+1)

      DO 10 I = 1,2*NNO
        ZR(IRES+I-1) = 0.0D0
   10 CONTINUE

C    BOUCLE SUR LES POINTS DE GAUSS

      DO 30 IPG = 1,NPG

        LDEC = (IPG-1)*NNO
        CALL VFF3D(NNO,ZR(IPOIDS+IPG-1),ZR(IDFDK+LDEC),ZR(IGEOM),JAC)

        DO 20 I = 1,NNO
          II = 2* (I-1) - 1
          ZR(IRES+II+1) = ZR(IRES+II+1) -
     &                    DELTAT*ZR(IFLUX+ (IPG-1)*2)*ZR(IVF+LDEC+I-1)*
     &                    JAC

          ZR(IRES+II+2) = ZR(IRES+II+2) -
     &                    DELTAT*ZR(IFLUX+ (IPG-1)*2+1)*ZR(IVF+LDEC+I-
     &                    1)*JAC


   20   CONTINUE

   30 CONTINUE
      END
