      SUBROUTINE ACEVDI(NBOCC,NOMAZ,NOMOZ,NLM,NLG,NLN,NLJ,IER)
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER           NBOCC,            NLM,NLG,NLN,NLJ,IER
      CHARACTER*(*)           NOMAZ,NOMOZ
C ----------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 05/10/2004   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C ----------------------------------------------------------------------
C     AFFE_CARA_ELEM
C     VERIFICATION DES MOTS CLES POUR L'ELEMENT DISCRET
C ----------------------------------------------------------------------
C IN  : NBOCC  : NOMBRE D'OCCURENCE
C OUT : NLM    : NOMBRE TOTAL DE MAILLE
C OUT : NLG    : NOMBRE TOTAL DE GROUPE DE MAILLE
C ----------------------------------------------------------------------
C     NCD    : NOMBRE D'ARGUMENTS ADMIS POUR "CARA"
C     NRD    : NOMBRE D'ARGUMENTS ADMIS POUR "REPERE"
C     NID    : DIMENSION DU TABLEAU DES ARGUMENTS INCOMPATIBLES
C               SOUS  UN  MEME  MOT  CLE  "CARA"
C     COMDIS : TABLEAU DES ARGUMENTS INCOMPATIBLES SOUS "CARA" :
C               ( A M K N S T TR )
C ----------------------------------------------------------------------
      REAL*8        R8B
      CHARACTER*8   K8B,   NOMU, NOMA, NOMO
      CHARACTER*16  REP, TOU, CONCEP, CMD, MCF
C     ------------------------------------------------------------------
      CALL GETRES(NOMU,CONCEP,CMD)
C
      NOMA = NOMAZ
      NOMO = NOMOZ
      NLM = 0
      NLG = 0
      NLN = 0
      NLJ = 0
      I3D = 0
      I2D = 0
      MCF = ' '
C
C --- RECUPERATION DE LA DIMENSION DU MAILLAGE
      NDIM = 3
      CALL DISMOI('F','Z_CST',NOMOZ,'MODELE',IBID,K8B,IER)
      IF ( K8B(1:3) .EQ. 'OUI' )  NDIM = 2
C
C --- ON REGARDE SI LE MODELE COMPORTE DES ELEMENTS DISCRETS 3D
      CALL MODEXI(NOMOZ,'DIS_',I3D)
C
C --- ON REGARDE SI LE MODELE COMPORTE DES ELEMENTS DISCRETS 2D
      CALL MODEXI(NOMOZ,'2D_DIS_',I2D)
C
C --- ON INTERDIT SUR UN MAILLAGE 2D D'AVOIR DES ELEMENTS DISCRETS
C --- 2D ET 3D
      IF (I2D.EQ.1.AND.I3D.EQ.1.AND.NDIM.EQ.2) THEN
          CALL UTMESS('E',CMD,'ON INTERDIT D''AVOIR SUR UN MAILLAGE '
     +              //'2D DES ELEMENTS DISCRETS 2D ET 3D .')
          IER = IER + 1
      ENDIF
      IF (I2D.EQ.1) MCF = 'DISCRET_2D'
      IF (I3D.EQ.1) MCF = 'DISCRET'
C
C --- ON INTERDIT SUR UN MAILLAGE 3D D'AVOIR DES ELEMENTS DISCRETS
C --- 2D
      IF (I2D.EQ.1.AND.NDIM.EQ.3) THEN
          CALL UTMESS('E',CMD,'ON INTERDIT D''AVOIR SUR UN MAILLAGE '
     +              //'3D DES ELEMENTS DISCRETS 2D .')
          IER = IER + 1
      ENDIF
C
C
      DO 10 IOC = 1,NBOCC
C
         CALL GETVEM(NOMA,'GROUP_MA',MCF,'GROUP_MA',IOC,1,0,K8B,NG)
         CALL GETVEM(NOMA,'MAILLE'  ,MCF,'MAILLE'  ,IOC,1,0,K8B,NM)
         CALL GETVEM(NOMA,'GROUP_NO',MCF,'GROUP_NO',IOC,1,0,K8B,NJ)
         CALL GETVEM(NOMA,'NOEUD'   ,MCF,'NOEUD'   ,IOC,1,0,K8B,NN)
C
         NSOM = NG + NM + NJ + NN
         IF (NSOM.EQ.NG .OR. NSOM.EQ.NM .OR. NSOM.EQ.NJ
     +                                  .OR. NSOM.EQ.NN) THEN
            NLM = MAX(NLM,-NM)
            NLG = MAX(NLG,-NG)
            NLN = MAX(NLN,-NN)
            NLJ = MAX(NLJ,-NJ)
         ENDIF
C
 10   CONTINUE
C
      LMAX2 = MAX(1,NLM,NLG,NLN,NLJ)
      CALL ACEVD2 ( NOMA, NOMO, LMAX2, NBOCC )
C
      END
