      SUBROUTINE NBSUCO (CHAR,MOTFAC,NOMA,IREAD,IWRITE,JSUMA,
     &                  JSUNO,JNOQUA,NTRAV,ORDSTC,INDQUA)
C
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 07/10/2004   AUTEUR MABBAS M.ABBAS 
C ======================================================================
C COPYRIGHT (C) 1991 - 2004  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
      IMPLICIT     NONE
      CHARACTER*8  CHAR
      CHARACTER*16 MOTFAC
      CHARACTER*8  NOMA
      INTEGER      IREAD     
      INTEGER      JSUMA
      INTEGER      JSUNO
      INTEGER      JNOQUA    
      INTEGER      NTRAV   
      INTEGER      ORDSTC
      INTEGER      INDQUA      
      INTEGER      IWRITE
   
C
C ----------------------------------------------------------------------
C ROUTINE APPELEE PAR : POINCO
C ----------------------------------------------------------------------
C
C DETERMINATION DU NOMBRE DE MAILLES ET DE NOEUDS DE CONTACT
C  POUR LA ZONE IREAD
C REMPLISSAGE DES POINTEURS ASSOCIES JSUMA,JSUNO,JNOQUA
C
C IN  CHAR   : NOM UTILISATEUR DU CONCEPT DE CHARGE
C IN  MOTFAC : MOT-CLE FACTEUR (VALANT 'CONTACT')
C IN  NOMA   : NOM DU MAILLAGE
C IN  NZOCO  : NOMBRE DE ZONES DE CONTACT
C IN  NTRAV  : NOMBRE MAXIMUM DE GROUPES ET DE MAILLES IMPLIQUES DANS 
C              LE CONTACT (TOUTES ZONES CONFONDUES)
C IN  ORDSTC : ORDRE DE STOCKAGE DES ZONES MAITRES ET ESCLAVES
C              0: MAITRES PUIS ESCLAVES
C              1: ESCLAVES PUIS MAITRES
C IN  INDQUA : VAUT 1 LORSQUE L'ON DOIT IGNORER LES NOEUDS MILIEUX DANS
C              NBNOEL (PENALISATION SUR LE CONTACT OU METHODE CONTINUE)
C IN  NSUCO  : NOMBRE TOTAL DE SURFACES DE CONTACT
C IN  JSYME  : POINTEUR DU VECTEUR DES SURFACES SYMETRIQUES
C IN  NBSYME : NOMBRE DE SURFACES SYMETRIQUES
C OUT NMACO  : NOMBRE TOTAL DE MAILLES DES SURFACES
C OUT NNOCO  : NOMBRE TOTAL DE NOEUDS DES SURFACES
C OUT NNOQUA : NOMBRE TOTAL DE NOEUDS QUADRATIQUES DES SURFACES
C OUT PSURMA : POINTEUR DES MAILLES DES SURFACES
C OUT PSURNO : POINTEUR DES NOEUDS DES SURFACES
C OUT PSURNO : POINTEUR DES NOEUDS QUADRATIQUES DES SURFACES
C
C -------------- DEBUT DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER            ZI
      COMMON  / IVARJE / ZI(1)
      REAL*8             ZR
      COMMON  / RVARJE / ZR(1)
      COMPLEX*16         ZC
      COMMON  / CVARJE / ZC(1)
      LOGICAL            ZL
      COMMON  / LVARJE / ZL(1)
      CHARACTER*8        ZK8
      CHARACTER*16                ZK16
      CHARACTER*24                          ZK24
      CHARACTER*32                                    ZK32
      CHARACTER*80                                              ZK80
      COMMON  / KVARJE / ZK8(1) , ZK16(1) , ZK24(1) , ZK32(1) , ZK80(1)
C
C ---------------- FIN DECLARATIONS NORMALISEES JEVEUX -----------------
C
      INTEGER      JTRAV
C
C ----------------------------------------------------------------------
C
      CALL JEMARQ()
C

      CALL WKVECT ('&&NBSUCO.TRAV','V V K8',NTRAV,JTRAV)

      IF (ORDSTC.EQ.1) THEN
C       LES ESCLAVES
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'GROUP_MA_ESCL',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)

         CALL NBNOCO (CHAR,MOTFAC,NOMA,'MAILLE_ESCL',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
C       LES MAITRES
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'GROUP_MA_MAIT',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'MAILLE_MAIT',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
      ELSE
C       LES MAITRES
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'GROUP_MA_MAIT',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'MAILLE_MAIT',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
C       LES ESCLAVES
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'GROUP_MA_ESCL',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
         CALL NBNOCO (CHAR,MOTFAC,NOMA,'MAILLE_ESCL',IREAD,INDQUA,
     +            JTRAV,IWRITE,JSUMA,JSUNO,JNOQUA)
      ENDIF

      CALL JEDETR ('&&NBSUCO.TRAV')

C
C ----------------------------------------------------------------------
C
      CALL JEDEMA()
      END
