      SUBROUTINE PROLMA(MATREZ,LIMAT,NBMAT,BASEZ,NUMEDD,FACSYM)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF MODELISA  DATE 25/09/2002   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR
C (AT YOUR OPTION) ANY LATER VERSION.
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.
C ======================================================================
C.======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)

C     PROLMA  --  LE BUT EST D'IDENTIFIER LA ROUTINE
C                 QUI VA CONSTRUIRE LA MATR_ASSE DE NOM MATRES RESULTANT
C                 DE LA COMBINAISON LINEAIRE DES NBMAT MATR_ASSE DE LA
C                 LISTE LISMAT DE NOMS DE MATR_ASSE.
C                 POUR UN STOCKAGE EN LIGNE DE CIEL: --- PROSLC
C                 POUR UN STOCKAGE MORSE          :  --- PROSMO
C
C   ARGUMENT        E/S  TYPE         ROLE
C    MATREZ         OUT    K*     NOM DE LA MATR_ASSE RESULTANT DE LA
C                                 COMBINAISON LINEAIRE DES MATR_ASSE
C                                 DE LA LISTE LISMAT.
C    LIMAT          IN    K24     LISTE DES MATR_ASSE A COMBINER
C                                 DES MATR_ASSE A COMBINER.
C    NBMAT          IN    I       ON FAIT LA COMBINAISON LINEAIRE
C                                 DES NBMAT PREMIERS MATR_ASSE DE LA
C                                 LISTE LIMAT.
C    BASEZ          IN    K*      NOM DE LA BASE SUR LAQUELLE ON
C                                 CONSTRUIT LA MATR_ASSE.
C    NUMEDD         IN    K14    NOM DU NUME_DDL SUR LEQUEL S'APPUIERA
C                                 LA MATR_ASSE MATREZ
C        SI NUMEDD  =' ', LE NOM DU NUME_DDL SERA OBTENU PAR GCNCON
C        SI NUMEDD /=' ', ON PRENDRA NUMEDD COMME NOM DE NUME_DDL
C
C    FACSYM   IN    L   /.TRUE. : ON FAIT LA FACTORISATION SYMBOLIQUE
C                                 DE LA MATRICE (MLTPRE)
C                       /.FALSE. : ON NE LA FAIT PAS
C.========================= DEBUT DES DECLARATIONS ====================
C ----- COMMUNS NORMALISES  JEVEUX
      INTEGER ZI
      COMMON /IVARJE/ZI(1)
      REAL*8 ZR
      COMMON /RVARJE/ZR(1)
      COMPLEX*16 ZC
      COMMON /CVARJE/ZC(1)
      LOGICAL ZL,FACSYM
      COMMON /LVARJE/ZL(1)
      CHARACTER*8 ZK8
      CHARACTER*16 ZK16
      CHARACTER*24 ZK24
      CHARACTER*32 ZK32
      CHARACTER*80 ZK80
      COMMON /KVARJE/ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
      CHARACTER*32 JEXNUM,JEXNOM,JEXATR
C -----  ARGUMENTS
      INTEGER NBMAT
      CHARACTER*(*) MATREZ,BASEZ,NUMEDD
      CHARACTER*24 LIMAT(NBMAT)
C -----  VARIABLES LOCALES
      CHARACTER*4 STOCK
      CHARACTER*24 KMAREF
      INTEGER IDMARF
C.========================= DEBUT DU CODE EXECUTABLE ==================

      CALL JEMARQ()
C
C     RECUPERATION DU TYPE DE STOCKAGE
C
      KMAREF = LIMAT(1) (1:19)//'.REFA'
      CALL JEVEUO(KMAREF,'L',IDMARF)
      STOCK = ZK24(IDMARF + 2) (16:19)
C
      IF(STOCK.EQ.'SLCS') THEN
        CALL PROSLC(MATREZ,LIMAT,NBMAT,BASEZ,NUMEDD)
      ELSE IF (STOCK.EQ.'SMOS') THEN
        CALL PROSMO(MATREZ,LIMAT,NBMAT,BASEZ,NUMEDD,FACSYM)
      ENDIF
C
      CALL JEDEMA()
C
      END
