      SUBROUTINE DECOD2(REC,IREC,IFIELD,ITYPE,ILU,RLU,TROUVE)
      IMPLICIT  NONE
      CHARACTER*(*) REC(20)
      INTEGER IREC,IFIELD,ITYPE,ILU
      REAL*8 RLU
      LOGICAL TROUVE

C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 21/07/99   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C----------------------------------------------------------------------

C    EXTRACTION DE L'ENREGISTREMENT IREC ET DU CHAMP IFIELD
C               DU NUMERO D'ORDRE OU DE L'INSTANT OU DE LA
C               FREQUENCE

C IN  : REC    : K80  : TABLEAU DE CARACTERES CONTENANT L'ENTETE DU
C                       DATASET
C IN  : IREC   : I    : NUMERO DE L'ENREGISTREMENT A TRAITER
C IN  : IFIELD : I    : NUMERO DU CHAMP A TRAITER
C IN  : ITYPE  : I    : TYPE DE VALEUR LUE (0:ENTIER, 1:REELLE)
C OUT : ILU    : I    : VALEUR ENTIERE LUE (NUMERO D'ORDRE)
C OUT : RLU    : I    : VALEUR REELLE LUE (INSTANT OU FREQUENCE)
C OUT : TROUVE : L    : .TRUE.  ON A TROUVE LA VALEUR ATTENDUE
C                       .FALSE. ON N A PAS TROUVE LA VALEUR ATTENDUE

C---------------------------------------------------------------------
      CHARACTER*80 FIELD
      INTEGER IER

C- INITIALISATION

      ILU = 0
      RLU = 0.D0
      TROUVE = .TRUE.

C- RECHERCHE DU CHAMP A TRAITER

      CALL TRFMOT(REC(IREC),FIELD,IFIELD)

      IF (ITYPE.EQ.0) THEN

C- DECODAGE D'UN ENTIER ET VERIFICATION

        CALL LXLIIS(FIELD,ILU,IER)
        IF (IER.EQ.1) TROUVE = .FALSE.

      ELSE

C- DECODAGE D'UN REEL ET VERIFICATION

        CALL LXLIR8(FIELD,RLU,IER)
        IF (IER.EQ.1) TROUVE = .FALSE.

      END IF

      END
