      SUBROUTINE IMPFC3 (NOMNOZ, NOMCMZ, LONLIS, NOMNOE, NOMCMP,
     +                   VALE, NOMAIL, NBCHIF, IFM )
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF PREPOST  DATE 16/06/2004   AUTEUR DURAND C.DURAND 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C.======================================================================
      IMPLICIT REAL*8 (A-H,O-Z)
C
C      IMPFC3 -- IMPRESSION D'UNE LIGNE D'UNE MATRICE ELEMENTAIRE D'UN
C                MATR_ELEM SELON LE GRAIN 'VALEUR'
C                (I.E. ON IMPRIME UNE VALEUR PAR LIGNE)
C                ON IMPRIME SEULEMENT LES COMPOSANTES LICITES 
C                (LICITE VEUT DIRE 'CHOISI PAR L'UTILISATEUR')
C                LES VALEURS SONT COMPLEXES.
C
C   ARGUMENT        E/S  TYPE         ROLE
C    NOMNOZ          IN   K*     NOM DU NOEUD POUR LEQUEL ON VA 
C                                IMPRIMER LA LIGNE DE LA MATRICE
C    NOMCMZ          IN   K*     NOM DE LA COMPOSANTE POUR LAQUELLLE  
C                                ON VA IMPRIMER LA LIGNE DE LA MATRICE
C    LONLIS          IN   I      LONGUEUR 'UTILE' DES TABLEAUX NOMNOE,
C                                NOMCMP ET  VALE
C    NOMNOE(*)       IN   K8     LISTE DES NOEUDS SUR-LESQUELS PORTENT
C                                LES TERMES DU TABLEAU VALE
C    NOMCMP(*)       IN   K8     LISTE DES COMPOSANTES SUR-LESQUELLES 
C                                PORTENT LES TERMES DU TABLEAU VALE
C    VALE(*)         IN   C      TABLEAU DES VALEURS DE LA LIGNE OU
C                                DE LA COLONNE A IMPRIMER 
C    NOMAIL          IN   K8     NOM DE LA MAILLE DONT ON IMPRIME LES
C                                VALEURS
C    NBCHIF          IN   I      NOMBRE DE CHIFFRES A METTRE APRES
C                                LA VIRGULE DANS LE FORMAT D'IMPRESSION
C    IFM             IN   I      UNITE LOGIQUE D'IMPRESSION
C                                LA MATRICE ELEMENTAIRE
C.========================= DEBUT DES DECLARATIONS ====================
C -----  ARGUMENTS
      CHARACTER*(*) NOMNOZ, NOMCMZ
      CHARACTER*8   NOMNOE(*), NOMCMP(*), NOMAIL
      COMPLEX*16    VALE(*)
C -----  VARIABLES LOCALES
      CHARACTER*1   SLACH 
      CHARACTER*2   KNBCH, KLVALR
      CHARACTER*8   NOMNO1, NOMCM1
      CHARACTER*38  FORM1
      CHARACTER*80  FORVAR
      CHARACTER*130 FORMAV
C
C.========================= DEBUT DU CODE EXECUTABLE ==================
C
C --- INITIALISATIONS :
C     ---------------
      SLACH  = '/'
      NOMNO1 = NOMNOZ
      NOMCM1 = NOMCMZ
C
C --- NOMBRE DE CHIFFRES A METTRE APRES LA VIRGULE
C --- ON RAPPELLE QUE LA FONCTION NDRSEM() RENVOIE LE NOMBRE 
C --- DE CHIFFRES EN DECIMAL D'UN REEL :
C     --------------------------------
C      NBCH = MIN (NDRSEM( ), NBCHIF)
      NBCH = MIN (14, NBCHIF)
      NBCH1 = NBCH - 1
C
C --- LONGUEUR PRISE POUR REPRESENTER UNE VALEUR REELLE :
C     -------------------------------------------------
      LVALRE = NBCH + 6
C
C --- FORMAT D'ECRITURE DES VALEURS REELLES :
C     -------------------------------------
      CALL CODENT(NBCH1,'G',KNBCH)
      CALL CODENT(LVALRE,'D',KLVALR)
C
      FORVAR = '"("'//'1PD'//KLVALR//'.'//KNBCH//'","'//
     +                '1PD'//KLVALR//'.'//KNBCH//'")"'
C
C --- FORMAT D'ECRITURE D'UNE LIGNE POUR LE GRAIN = 'VALEUR' :
C     -----------------------------------------------------
      FORM1 = '2X,A8,A1,A8,A1,A8,2X,A8,A1,A8,A1,A8,2X'
      FORMAV = '('//FORM1//','//FORVAR//')'
C
C ---   BOUCLE SUR LES VALEURS DE LA LIGNE DE LA MATRICE :
C       ------------------------------------------------
      DO 10 I = 1, LONLIS
          WRITE(IFM,FORMAV) NOMAIL,SLACH,NOMNO1,SLACH,
     +                      NOMCM1,NOMAIL,SLACH,NOMNOE(I),SLACH,
     +                      NOMCMP(I),DBLE(VALE(I)),DIMAG(VALE(I))
 10   CONTINUE     
C
      END
