      SUBROUTINE FOLIE0 ( NBFR, FREQ, ACCE, VALTG, VALTD, LISS, NOMF )
      IMPLICIT  NONE
      INTEGER             NBFR
      REAL*8              FREQ(*), ACCE(*), VALTG, VALTD, LISS
      CHARACTER*(*)       NOMF
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 09/12/2002   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2002  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY  
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY  
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR     
C (AT YOUR OPTION) ANY LATER VERSION.                                   
C                                                                       
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT   
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF            
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU      
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                              
C                                                                       
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE     
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,         
C   1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.         
C ======================================================================
C
C  IN : NBFR   : NOMBRE DE FREQUENCES DE LA FONCTION A TRAITER
C  IN : FREQ   : LISTE DES ABSCISSES DE LA FONCTION A TRAITER
C  IN : ACCE   : LISTE DES ORDONNEES DE LA FONCTION A TRAITER
C  IN : VALTG  : VALEUR DE L'ELARGISSEMENT A GAUCHE
C  IN : VALTD  : VALEUR DE L'ELARGISSEMENT A DROITE
C  IN : LISS   : CRITERE POUR L'ELIMINATION DES POINTS DE LISSAGE
C OUT : NOMF   : NOM JEVEUX, FONCTION ELARGIE ET LISSEE 
C     ------------------------------------------------------------------
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16            ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER       I, JELIM, JENV, NBFS, NBFL1, NBFL2, JRESU1, JRESU2,
     +              NBVAL, NBELIM, IRET, JRESU
      CHARACTER*8   K8B
      CHARACTER*24  ENVLOP
C     ------------------------------------------------------------------
C
      CALL JEMARQ()
C
C --- CALCUL DE L'ENVELOPPE AVEC ELARGISSEMENT GAUCHE ET DROITE
C
      ENVLOP = '&&FOLIE0.ENVELOPPE'
C
      CALL FOLIE2 ( NBFR, FREQ, ACCE, VALTG, VALTD, ENVLOP )
C
      CALL JEVEUO ( ENVLOP(1:19)//'.VALE', 'L', JENV )
      CALL JELIRA ( ENVLOP(1:19)//'.VALE', 'LONMAX', NBFS, K8B )
C
      NBFS = NBFS / 2
C
C --- LISSAGE DU SPECTRE EN PLUSIEURS PASSAGES
C
C --- ON BOUCLE TANT QU'IL Y A DES POINTS A ELIMINER
C
      NBFL1  = NBFS
      NBVAL  = NBFS
      JRESU2 = JENV
C
 100  CONTINUE
C
      CALL WKVECT ( '&&FOLIE0.RESU_1' , 'V V R', 2*NBFL1, JRESU1 )
      DO 10 I = 1 , NBFL1
         ZR(JRESU1+I-1) = ZR(JRESU2+I-1)
         ZR(JRESU1+NBFL1+I-1) = ZR(JRESU2+NBFL1+I-1)
 10   CONTINUE  
C
      CALL WKVECT ( '&&FOLIE0.ELIMINE' , 'V V I', NBFL1, JELIM )
C
      CALL FOLIE3 ( NBFL1, ZR(JRESU1), ZR(JRESU1+NBFL1), LISS, 
     +                                             ZI(JELIM), NBELIM )
CCC      WRITE(6,*)'--->> ON A ELIMINE ', NBELIM
C
      IF ( NBELIM .EQ. 0 ) GOTO 9999
C
      NBFL2 = NBFL1 - NBELIM
      CALL JEEXIN ( '&&FOLIE0.RESU_2' , IRET )
      IF ( IRET .NE. 0 )  CALL JEDETR ( '&&FOLIE0.RESU_2' )
      CALL WKVECT ( '&&FOLIE0.RESU_2' , 'V V R', 2*NBFL2, JRESU2 )
C
      NBVAL = 0
      DO 12 I = 1 , NBFL1
         IF ( ZI(JELIM+I-1) .EQ. 1 ) GOTO 12
         NBVAL =  NBVAL + 1
         ZR(JRESU2+NBVAL-1) = ZR(JRESU1+I-1)
         ZR(JRESU2+NBFL2+NBVAL-1) = ZR(JRESU1+NBFL1+I-1)
CCC   WRITE(6,1000) NBVAL,ZR(JRESU2+NBVAL-1),ZR(JRESU2+NBFL2+NBVAL-1)
 12   CONTINUE  
C
      NBFL1  = NBFL2
      CALL JEDETR ( '&&FOLIE0.RESU_1'  )
      CALL JEDETR ( '&&FOLIE0.ELIMINE' )
      GOTO 100
C
 9999 CONTINUE
C
      CALL WKVECT ( NOMF , 'V V R', 2*NBVAL, JRESU )
C
      DO 20 I = 1 , NBVAL
         ZR(JRESU+I-1) = ZR(JRESU1+I-1)
         ZR(JRESU+NBVAL+I-1) = ZR(JRESU1+NBFL1+I-1)
 20   CONTINUE  
C
      CALL JEDETR ( '&&FOLIE0.RESU_1' )
      CALL JEDETR ( '&&FOLIE0.RESU_2' )
      CALL JEDETR ( '&&FOLIE0.ELIMINE' )
      CALL DETRSD ( 'FONCTION', ENVLOP )
C
CCC 1000 FORMAT ( 1P,' POINT ',I3,1X,E12.5,1X,E12.5 )
C
      CALL JEDEMA()
      END
