      SUBROUTINE FOVIMA ( NOMFON, TINI, LTINI, TFIN, LTFIN,
     &                    CRIT, EPSI, NBVALU, VARMAX, FONMAX  )
      IMPLICIT NONE
      INTEGER          LTINI, LTFIN, NBVALU
      REAL*8           TINI, TFIN, EPSI, FONMAX(*),VARMAX(*)
      CHARACTER*8      CRIT
      CHARACTER*(*)    NOMFON
C     ------------------------------------------------------------------
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 07/03/2001   AUTEUR CIBHHLV L.VIVAN 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C     ------------------------------------------------------------------
C     CALCUL DU MAX DE LA FONCTION DANS L INTERVALLE TDEBUT ET TFIN 
C     SI CES BORNES NE SONT PAS RENSEIGNES ON PREND TOUTES LES 
C     VARIABLES DE LA FONCTION
C     IN :  NOMFON NOM DE LA FONCTION 
C     IN :  TINI TEMP DEBUT
C     IN :  LTINI  VAUT 1 
C                  L UTILISATEUR RENSEINE  INST_INIT
C                  SINON LTINI DIFFERENT DE 0
C     IN :  TFIN TEMP FIN
C     IN :  LTFIN  VAUT 1 
C                   L UTILISATEUR A RENSEIGNE INST_FIN
C                  SINON LTFIN DIFFERENT DE 0
C     IN :  CRIT : CRITERE DE POSITION DANS L INTERVALLE ABSOLU 
C           OU RELATIVE
C     IN :  EPSI :TOLERANCE D ERREUR
C     OUT : NBVALU NOMBRE DE VALEUR A CONSIDERE
C     OUT : VARMAX L(ES) INSTANT(S) OU LA FONCTION EST MAXIMALE
C     OUT : FONMAX LA VALEUR DU MAX DE LA FONCTION
C
C     ----- DEBUT COMMUNS NORMALISES  JEVEUX  --------------------------
      INTEGER          ZI
      COMMON  /IVARJE/ ZI(1)
      REAL*8           ZR
      COMMON  /RVARJE/ ZR(1)
      COMPLEX*16       ZC
      COMMON  /CVARJE/ ZC(1)
      LOGICAL          ZL
      COMMON  /LVARJE/ ZL(1)
      CHARACTER*8      ZK8
      CHARACTER*16            ZK16
      CHARACTER*24                    ZK24
      CHARACTER*32                            ZK32
      CHARACTER*80                                    ZK80
      COMMON  /KVARJE/ ZK8(1),ZK16(1),ZK24(1),ZK32(1),ZK80(1)
C     -----  FIN  COMMUNS NORMALISES  JEVEUX  -----------------------
C
      INTEGER        INTRP0, INTRP1, IDEB, IFIN, IABSS, LABSS,
     +               LORDO, NBVAL, LVAR, LFON, NBPTS, IER, NBMAX
      REAL*8         T0, T1, FT0, FT1
      CHARACTER*1    K1BID  
      CHARACTER*19   NOMFI
      CHARACTER*24   VALE
C     ----------------------------------------------------------------
C
      CALL JEMARQ()
      NOMFI = NOMFON
C
      VALE = NOMFI//'.VALE'
      CALL JELIRA(VALE,'LONUTI',NBVAL,K1BID)
      CALL JEVEUO(VALE,'L',LVAR)
      NBPTS = NBVAL/2
      LFON  = LVAR + NBPTS
C
      CALL FONOC0 ( ZR(LVAR), TINI, LTINI, TFIN, LTFIN, CRIT, EPSI,
     &                     NBPTS, T0, IDEB, INTRP0, T1, IFIN, INTRP1 )
C
C --- ALLOCATION DES TABLEAUX AUXILIARES ---
C
      NBVALU = IFIN - IDEB + 1
      IF( INTRP0 .EQ. 1)  NBVALU = NBVALU + 1
      IF( INTRP1 .EQ. 1)  NBVALU = NBVALU + 1
      IF(IDEB .EQ. 0 .AND. IFIN .EQ. 0)  NBVALU = 2
C
      CALL WKVECT ( '&&FOCMAX.ABSS', 'V V R', NBVALU, LABSS )
      CALL WKVECT ( '&&FOCMAX.ORDO', 'V V R', NBVALU, LORDO )
C
C --- STOKAGE DES INSTANTS COMPRIS ENTRE T0 ET T1 ---
C
      ZR(LABSS) = T0
      DO 55 IABSS = 2, NBVALU-1
         ZR(LABSS+IABSS-1) = ZR(LVAR+IDEB+IABSS-2) 
 55   CONTINUE        
      ZR(LABSS+NBVALU-1) = T1
C
C --- STOKAGE DES VALEURS  DE LA FONCTION POUR 
C                 LES INSTANTS COMPRIS ENTRE T0 ET T1 
C
      DO 66 IABSS = 2, NBVALU-1
         ZR(LORDO+IABSS-1) =  ( ZR(LFON+IDEB+IABSS-2) )
 66   CONTINUE
      IF (INTRP0 .EQ. 0) THEN
         FT0 =  ZR(LFON+IDEB-1)    
      ELSE
         CALL FOINTE('F ',NOMFON, 1, 'INST', T0, FT0, IER )
      ENDIF
      ZR(LORDO) = FT0 
C
      IF (INTRP1 .EQ. 0) THEN
         FT1 =  ZR(LFON+IFIN-1)   
      ELSE
         CALL FOINTE('F ',NOMFON, 1, 'INST', T1, FT1, IER )
      ENDIF
      ZR(LORDO+NBVALU-1) = FT1
C             
C --- CALCUL DU MAX DE LA FONCTION ENTRE T0 ET T1
C
      CALL FOC1MA(NBVALU,ZR(LABSS),ZR(LORDO),NBMAX,VARMAX,FONMAX)
C
      CALL JEDETR('&&FOCMAX.ABSS')
      CALL JEDETR('&&FOCMAX.ORDO')
C
      CALL JEDEMA()
      END
