      SUBROUTINE MAJOUR (LONCH,REAROT,INDRO,CHAINI,CHADEL,COEF,  CHAMAJ)
C            CONFIGURATION MANAGEMENT OF EDF VERSION
C MODIF UTILITAI  DATE 17/01/97   AUTEUR VABHHTS J.PELLET 
C ======================================================================
C COPYRIGHT (C) 1991 - 2001  EDF R&D                  WWW.CODE-ASTER.ORG
C THIS PROGRAM IS FREE SOFTWARE; YOU CAN REDISTRIBUTE IT AND/OR MODIFY
C IT UNDER THE TERMS OF THE GNU GENERAL PUBLIC LICENSE AS PUBLISHED BY
C THE FREE SOFTWARE FOUNDATION; EITHER VERSION 2 OF THE LICENSE, OR   
C (AT YOUR OPTION) ANY LATER VERSION.                                 
C
C THIS PROGRAM IS DISTRIBUTED IN THE HOPE THAT IT WILL BE USEFUL, BUT 
C WITHOUT ANY WARRANTY; WITHOUT EVEN THE IMPLIED WARRANTY OF          
C MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. SEE THE GNU    
C GENERAL PUBLIC LICENSE FOR MORE DETAILS.                            
C
C YOU SHOULD HAVE RECEIVED A COPY OF THE GNU GENERAL PUBLIC LICENSE   
C ALONG WITH THIS PROGRAM; IF NOT, WRITE TO EDF R&D CODE_ASTER,       
C    1 AVENUE DU GENERAL DE GAULLE, 92141 CLAMART CEDEX, FRANCE.      
C ======================================================================
C
C FONCTION: MET A JOUR LE CHAM_NO CHAMAJ D'APRES LA RELATION:
C                   CHAMAJ = CHAINI + COEF*CHADEL.
C           POUR LES TRANSLATIONS ET LES PETITES ROTATIONS, ON APPLIQUE
C           LA FORMULE PRECEDENTE A LA LETTRE.
C           POUR LES GRANDES ROTATIONS, LE VECTEUR-ROTATION DE CHAMAJ
C           EST CELUI DU PRODUIT DE LA ROTATION DEFINIE DANS CHAINI PAR
C           COEF FOIS L'INCREMENT DE ROTATION DEFINI DANS CHADEL.
C
C     IN  : LONCH     : LONGUEUR DES CHAM_NO
C           REAROT    : LOGICAL: TRUE  S'IL Y A DES DDL DE GRDE ROTATION
C                                FALSE SINON
C           INDRO     : VECTEUR DONNANT LE TYPE DES DDL:
C                          0: TRANSLATION OU PETITE ROTATION
C                          1: GRANDE ROTATION
C           CHAINI    : CHAM_NO DONNE
C           CHADEL    : CHAM_NO DONNE
C           COEF      : REEL DONNE
C
C     OUT : CHAMAJ    : CHAM_NO MIS A JOUR
C ------------------------------------------------------------------
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL REAROT
      INTEGER INDRO(*)
      REAL*8 CHAINI(*),CHADEL(*),CHAMAJ(*)
      INTEGER IRAN(3)
      REAL*8 TETA(3),DELTET(3),QUATER(4),DELQUA(4)
C
C
      IF (.NOT.REAROT) THEN
         DO 10 I=1,LONCH
            CHAMAJ(I) = CHAINI(I) + COEF*CHADEL(I)
10       CONTINUE
      ELSE
         ICOMP = 0
         DO 20 I=1,LONCH
            IF (INDRO(I).EQ.0) THEN
               CHAMAJ(I) = CHAINI(I) + COEF*CHADEL(I)
            ELSE IF (INDRO(I).EQ.1) THEN
               ICOMP = ICOMP + 1
               IRAN(ICOMP) = I
               TETA  (ICOMP) = CHAINI(I)
               DELTET(ICOMP) = COEF*CHADEL(I)
               IF (ICOMP.EQ.3) THEN
                  ICOMP = 0
                  CALL VROQUA (TETA  ,QUATER)
                  CALL VROQUA (DELTET,DELQUA)
                  CALL PROQUA (DELQUA,QUATER)
                  CALL QUAVRO (TETA  ,QUATER)
                  DO 15 IC=1,3
                     CHAMAJ(IRAN(IC)) = TETA (IC)
15                CONTINUE
               ENDIF
            ELSE
               CALL UTMESS ('F','MAJOUR','LE CHAMP NURO CREE PAR NUROTA'
     &                      //' COMPORTE D''AUTRES VALEURS QUE 0 OU 1')
            ENDIF
20       CONTINUE
      ENDIF
      END
