#! /bin/bash 
#############################################################################
# Controle des Rgles de Programmation (CRP) inter-compilation
#
# ./crp_aster.sh source_fortran suppr_fortran message reptmp
# admet pour arguments : - le fortran complet  analyser
#                        - les sources fortran supprims (FORSUPPR bibli nom)
#                        - un fichier de messages
#                     - le nom du rpertoire de travail
#
#############################################################################

. ?DABIN?/init_crp_crs.sh

REPSOU=$1
if [ ! -d $1 ] ; then
  echo " Repertoire des sources Fortran inexistant ($1) " 
  exit 4 
fi
FICSUP=$1/$2
FICMES=$3

iret_ftn=0
TMPCRP=$4
rm -rf $TMPCRP $FICMES
mkdir -p $TMPCRP/FS
cat $REPSOU/*.f > $TMPCRP/fortran.f

cp  -r $REPSOU/*.f  $TMPCRP/FS
if [ `cat $TMPCRP/fortran.f | wc -l ` -gt 0 ] ; then
  cd $TMPCRP
  echo "" >>$FICMES
  echo "================================================================"\
            >>$FICMES	
  echo "=== Verification des sources FORTRAN avec CRP		     ==="\
            >>$FICMES	
  echo "================================================================"\
            >>$FICMES  
  . $DABIN/prepa_crp.sh
  iret_ftn=$?
  if [ $iret_ftn -lt 4 ] ; then
#
# appel de l'excutable crp (contrle des rgles de programmation)
#
    $DABIN/crp.sh -new -repinter $INTER_REP $crpSuppr -m $TMPCRP/fortran.f >$TMPCRP/err_ftn
    iret_ftn=$?
    if [ $iret_ftn -gt 4 ] ;  then
       echo "(F/U-222): Bug CRP ...." >>$FICMES
       cat $TMPCRP/err_ftn >>$FICMES	  
       exit 4 
    fi
    if [ $iret_ftn -gt 2 ] ; then
      . $DABIN/bilan_crp.sh
      status=$i_ecrp
      if [ $status -gt 2 ] ; then
         echo "(F/U-222): Erreur(s) detectee(s) par crp :">>$FICMES
         cat $TMPCRP/err_exp_ftn >>$FICMES
         echo "" >>$FICMES
         cat $TMPCRP/err_ftn >>$FICMES
         iret_ftn=4
      else
         iret_ftn=0
         echo "(I/U-111): Information(s) donnee(s) par crp :">>$FICMES
         cat $TMPCRP/err_ftn >>$FICMES      
      fi
    else
      echo "(A/U-223): Alarme(s) detectee(s) par crp :">>$FICMES
      cat $TMPCRP/err_ftn >>$FICMES	  
    fi
  fi
fi

if [ $iret_ftn -gt 0 ] ; then 
   cat $3 
   echo " "
   echo "===> Erreur(s) dtecte(s) par CRP "
   echo " "
else
   echo " "
   echo "===> Aucune erreur dtecte par CRP "
   echo " "
fi
exit $iret_ftn 
