#! /bin/bash 
#################################################################
# Controle des Rgles de Syntaxe (CRS)       
#
# ./crs.sh source_fortran fichmess reptmp
# admet pour argument - le rpertoire des sources fortran  analyser
#                     - un fichier de messages
#                     - le nom du rpertoire de travail
# 
# fait appel  l'excutable : crs_ANSI 
# et utilise le fichier     : niverrCRS
# ncessite la prsence de l'utilitaire de dcoupage de FORTRAN fsplit
#        http://rpmfind.net/linux/RPM
#################################################################

. ?DABIN?/init_crp_crs.sh

TMPCRS=$3

i_crs=0
rm -rf $TMPCRS $FICMES 
mkdir -p $TMPCRS

REPFORT=$1
FICMES=$2
if [ ! -d $REPFORT ] ; then
  echo " Repertoire des sources Fortran inexistant ($REPFORT) " 
  exit 4 
fi
FORT=$TMPCRS/FORTRAN.f
cat $REPFORT/*.f > $FORT

# Execution de CRS pour verif F77 ANSI
$REPCRS/crs $FORT > $TMPCRS/ZZZZmsgCRS
status=$?
if [ $status -gt 0 ] ; then 
   # Plantage sale
   i_crs=4 
else  
# Fichier de declaration des niveaux d'erreur
  cp $DABIN/CRS/param/niverrCRS $TMPCRS
# Extraction des messages CRS
  awk '{print $1,$2}' $TMPCRS/niverrCRS >$TMPCRS/ficAnCRS
  echo "FIN_DEF" >>$TMPCRS/ficAnCRS
  grep 'CRS_[0-9]*' $TMPCRS/ZZZZmsgCRS | awk '{print $1,$3}' >>$TMPCRS/ficAnCRS
        
        
cat >$TMPCRS/ZZZZanCRS.awk <<eof
    BEGIN {
    	INIT=1;
    	}
    {
       if (\$1 == "FIN_DEF") {
    	  INIT=0;
    	  next;
    	  }
       if (INIT) {
    	  tNIV[\$1]=\$2;
    	  next;
    	  }
       else {
    	  if (tNIV[\$1] == 0) {
    	     print >>msg0;
    	     next;
    	     }
    	  else if (tNIV[\$1] == 2) {
    	     print >>msg2;
    	     next;
    	     }
    	  else if (tNIV[\$1] == 4) {
    	     print >>msg4;
    	     next;
    	     }
    	  else {
    	     print "x";
    	     }
    	  }
   }
eof
   rm -f $TMPCRS/errCRS0 $TMPCRS/errCRS2 $TMPCRS/errCRS4
   awk -f $TMPCRS/ZZZZanCRS.awk msg0=$TMPCRS/errCRS0 msg2=$TMPCRS/errCRS2 msg4=$TMPCRS/errCRS4 $TMPCRS/ficAnCRS
   if [ -f TMPCRS/errCRS4 ] ; then  
      #~~~~~~~~~~~~~~~~~~~~~#
      # Erreurs CRS fatales #
      #~~~~~~~~~~~~~~~~~~~~~#
      i_crs=4
      echo "===> Compilation refusee pour le Code_Aster a cause des erreurs FORTRAN CRS suivantes :">>$FICMES
      sort -u $TMPCRS/errCRS4>>$FICMES
      echo "">>$FICMES
   else  
      if [ -f  $TMPCRS/errCRS2 ] ; then  
         #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
         # Erreurs CRS masquables par une carte C TOLE #
         #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
         
         # Extraction des cartes C TOLE du source FORTRAN   
	 mkdir $TMPCRS/fs >&/dev/null
	 DPWD=`pwd`
	 cp $FORT $TMPCRS/fortran.f
	 cd $TMPCRS/fs  
	 $DABIN/bin/fsplit ../fortran.f >&/dev/null
              
	 for sub in `ls *.f` ;
	    do
            SUB=`echo  $sub | tr '[a-z]' '[A-Z]'`
            rsub=`basename $SUB .F`
            awk '/^C [ ]*TOLE [ ]*/ {for(i=3;i<=NF;i++) print $i,subr}' subr=$rsub $sub >>$TMPCRS/err_tole 
	 done   	
         cd $DPWD
        			  
         # Uniquement les cartes C TOLE CRS_
         grep '^CRS_' $TMPCRS/err_tole  | sort -u >$TMPCRS/err_tole_s
         sort -u $TMPCRS/errCRS2 >$TMPCRS/err_nom_s
        			  
         # toutes les erreurs non compensees par des cartes C TOLE
         comm -23  $TMPCRS/err_nom_s $TMPCRS/err_tole_s >$TMPCRS/WA4
        			  
         if [ `cat $TMPCRS/WA4 | wc -l ` -gt 0 ] ; then  
            #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
            # Warning CRS sans carte TOLE #
            #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~#
            i_crs=4
            echo "===> Compilation refusee pour le Code_Aster a cause des erreurs FORTRAN CRS suivantes (sans carte 'C TOLE') :">>$FICMES
            sort -u $TMPCRS/WA4>>$FICMES
            echo "">>$FICMES
         else  
            echo " ">>$FICMES
            echo "===> Aucune erreur dtecte par CRS ">>$FICMES
            echo " ">>$FICMES
         fi  	     
      fi 
   fi     	     
fi # Passage CRS
if [ $i_crs -gt 2 ] ; then 
   cat $TMPCRS/ZZZZmsgCRS >>$FICMES
   echo " ">>$FICMES
   echo "===> Erreur(s) dtecte(s) par CRS ">>$FICMES
   echo " ">>$FICMES
fi
exit $i_crs
