#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 10 "fortran.y"

/*
  fortran.c:

    Copyright (C) 1992 by Robert K. Moniot.
    This program is free software.  Permission is granted to
    modify it and/or redistribute it.  There is no warranty
    for this program.


	    This grammar is ANSI standard-conforming, except for:
		-- complex constant and a few other ambiguities needing
		   significant lookahead cannot be split across lines.

	    Extensions supported:
	        -- Case insensitive.
	 	-- Hollerith constants.
		-- Variable names may be longer than 6 characters.  Also
		   allows underscores and dollar signs in names.
		-- DO ... ENDDO and DO WHILE loop forms allowed.
		-- NAMELIST supported.
		-- TYPE and ACCEPT I/O statements allowed.
		-- Tabs are permitted in input, and (except in character data)
		   expand into blanks up to the next column equal to 1 mod 8.
		-- Type declarations INTEGER*2, REAL*8, etc. are allowed.
		-- IMPLICIT NONE allowed.
	 */

/*  Author: R. Moniot
 *  Date:   August 1988
 *  Last revision: July 1993
 */
 
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "ftnchek.h"
#include "symtab.h"
#include "valchek.h"

	/* The following section is for use with bison-derived
	   parser.  Define alloca to be malloc for those cases
	   not covered by the cases covered there.  The ifdefs
	   are those in the skeleton parser with includes removed */
#ifdef AIXC	/* IBM RS/6000 xlc compiler does it this way */
#pragma alloca
#endif
#ifndef alloca
#ifdef __GNUC__
#else /* Not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__)
#else /* Not sparc */
#ifdef MSDOS
#endif /* MSDOS */
#endif /* Not sparc.  */
#endif /* Not GNU C.  */
#define alloca malloc
#endif /* alloca now defined.  */

void exit();

#ifndef YYDEBUG	/* If not declared otherwise... */
/* long yydebug;	declare yydebug to satisfy extern in ftnchek.c */
#ifdef DEVELOPMENT
#define YYDEBUG 1		/* For development it is handy */
#else
#define YYDEBUG 0
#endif
#endif

#ifdef DEVELOPMENT
#define DEBUG_PARSER 
#endif

int current_datatype,	/* set when parse type_name or type_stmt */
    stmt_sequence_no,   /* set when parsing, reset to 0 at end_stmt */
    control_item_count;	/* count of items in control_info_list */
long current_typesize;	/* for type*len declarations */

extern unsigned prev_stmt_line_num; /* shared with advance */

unsigned true_prev_stmt_line_num;	/* shared with symtab.c */

/*********************** Ajoute par Albert Y pour Aster ***********/

static int last_specification = 1;

/******************************************************************/

int current_module_hash = -1,	/* hashtable index of current module name */
    current_module_type,
    executable_stmt=FALSE,
    prev_stmt_class=0,
		 /* flags for lexer */
    complex_const_allowed=FALSE, /* for help in lookahead for these */
    in_assignment_stmt=FALSE,
    inside_format=FALSE,	/* when inside parens of FORMAT  */
    integer_context=FALSE,	/* says integers-only are to follow */
    prev_goto=FALSE,
    goto_flag=FALSE;	/* if unconditional GOTO was encountered */



/******  AY ajout ************/


/* Pour la regle P.I.8 CRP_10 */
int continue_line = FALSE;
int comment_line = FALSE;


PRIVATE char intrn_name[MAX_XTERNAL][8];
PRIVATE int nbintrn = 0;
#ifdef CRP_11
void ay_chk_transfer();
#define MAX_DOLABEL 100
PRIVATE int dolabel[MAX_DOLABEL];
PRIVATE int nbdolabel = 0;
#endif

PRIVATE crp_sblevel *subprog_level, *subprog_level0;

PRIVATE int value_flag, char_size, len_specification_nook;
PRIVATE int def_arg_num = 0;
PRIVATE int normal_return;

/******  Fin AY ajout ********/

int     implicit_NONE = FALSE;
char *line_implicit_real8 = (char *)0, *ind_implicit_real8;
int implicit_real8 = FALSE;
int subprogram_header = FALSE;
long exec_stmt_count=0;	/* count of executable stmts in program */
extern int new_error_level;
#define affect_ifzero(a,b) ((b) == 0? (a):(b))

PRIVATE void
print_comlist(), print_exprlist(), END_processing();
PRIVATE Token *
  append_token();
PRIVATE int
  do_bounds_type();
		/* Uses of Token fields for nonterminals: */
/*
  1. dim_bound_lists: dimensioning info for arrays:
       token.class = no. of dimensions,
       token.subclass = no. of elements
  2. expressions
       token.value.integer = hash index (of identifier)
       token.class = type_byte = storage_class << 4 + datatype
       token.subclass = flags: CONST_EXPR, LVALUE_EXPR, etc.
  3. common variable lists
       token.subclass = flag: COMMA_FLAG used to handle extra/missing commas
*/

#define SEQ_HEADER   1
#define SEQ_IMPLICIT 2
#define SEQ_SPECIF   3
#define SEQ_STMT_FUN 4
#define SEQ_EXEC     5
#define SEQ_END      6

#line 180 "y.tab.c"
#define YYERRCODE 256
#define tok_identifier 257
#define tok_array_identifier 258
#define tok_label 259
#define tok_integer_const 260
#define tok_real_const 261
#define tok_dp_const 262
#define tok_complex_const 263
#define tok_dcomplex_const 264
#define tok_logical_const 265
#define tok_string 266
#define tok_hollerith 267
#define tok_edit_descriptor 268
#define tok_letter 269
#define tok_relop 270
#define tok_AND 271
#define tok_OR 272
#define tok_EQV 273
#define tok_NEQV 274
#define tok_NOT 275
#define tok_power 276
#define tok_concat 277
#define tok_ACCEPT 278
#define tok_ASSIGN 279
#define tok_BACKSPACE 280
#define tok_BLOCK 281
#define tok_BLOCKDATA 282
#define tok_BYTE 283
#define tok_CALL 284
#define tok_CHARACTER 285
#define tok_CLOSE 286
#define tok_COMMON 287
#define tok_COMPLEX 288
#define tok_CONTINUE 289
#define tok_DATA 290
#define tok_DIMENSION 291
#define tok_DO 292
#define tok_DOUBLE 293
#define tok_DOUBLECOMPLEX 294
#define tok_DOUBLEPRECISION 295
#define tok_DOWHILE 296
#define tok_ELSE 297
#define tok_ELSEIF 298
#define tok_END 299
#define tok_ENDDO 300
#define tok_ENDFILE 301
#define tok_ENDIF 302
#define tok_ENTRY 303
#define tok_EQUIVALENCE 304
#define tok_EXTERNAL 305
#define tok_FILE 306
#define tok_FORMAT 307
#define tok_FUNCTION 308
#define tok_GO 309
#define tok_GOTO 310
#define tok_IF 311
#define tok_IMPLICIT 312
#define tok_INCLUDE 313
#define tok_INQUIRE 314
#define tok_INTEGER 315
#define tok_INTRINSIC 316
#define tok_LOGICAL 317
#define tok_NAMELIST 318
#define tok_NONE 319
#define tok_OPEN 320
#define tok_PARAMETER 321
#define tok_PAUSE 322
#define tok_PRECISION 323
#define tok_PRINT 324
#define tok_PROGRAM 325
#define tok_READ 326
#define tok_REAL 327
#define tok_RETURN 328
#define tok_REWIND 329
#define tok_SAVE 330
#define tok_STOP 331
#define tok_SUBROUTINE 332
#define tok_THEN 333
#define tok_TO 334
#define tok_TYPE 335
#define tok_WHILE 336
#define tok_WRITE 337
#define tok_illegal 338
#define EOS 127
#define REDUCE 339
const short yylhs[] = {                                        -1,
    0,    0,    1,    1,    2,    2,    2,    3,    3,    5,
    5,    7,    7,    7,    7,    7,    8,    8,    8,    8,
    6,    6,   16,    4,    9,    9,    9,    9,    9,   17,
   17,   21,   21,   21,   21,   21,   21,   21,   21,   10,
   10,   32,   32,   32,   32,   32,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   11,   11,   56,   56,   56,   56,   57,
   57,   57,   66,   12,   22,   67,   22,   13,   69,   71,
   69,   69,   73,   69,   70,   72,   75,   74,   74,   74,
   14,   79,   81,   79,   80,   68,   68,   82,   82,   83,
   83,   15,   15,   84,   84,   24,   85,   85,   86,   87,
   87,   88,   88,   88,   88,   91,   25,   90,   90,   92,
   92,   93,   93,   93,   94,   95,   95,   26,   26,   26,
   99,   99,  102,  100,  101,  101,  101,   98,   98,  103,
  103,  104,  104,   27,  105,  105,  106,  107,  108,  108,
  109,  109,   28,   28,   28,   28,   76,   76,   76,  112,
  112,  112,  112,  114,  114,  114,  114,  114,   77,   78,
  110,  110,  116,  116,  111,  111,  117,  117,  117,  117,
  118,   19,   19,  119,  121,  119,  123,  120,  122,  122,
  124,  124,  115,  115,  115,   18,  126,  126,  128,  127,
   29,  130,  130,   30,  131,  131,   31,   31,  132,  132,
  133,  133,   20,  134,  134,  134,  138,  139,  135,  136,
  136,  140,  140,  137,  137,  143,  143,  145,  145,  144,
  144,  147,  147,  148,  148,  142,  150,  150,  152,  153,
   39,  141,  141,  141,  141,   40,   34,   41,   41,   35,
   35,   35,  159,  159,  160,  160,   36,   58,   59,  163,
  162,   62,  164,  165,   62,   63,   64,   64,   60,  168,
   60,  169,   60,  166,  166,  166,  167,  167,   61,   61,
   42,   37,   43,  171,  171,  171,  171,  173,   46,  175,
   46,  176,  172,   44,   44,   44,   44,   44,  178,   45,
   45,   47,  180,  181,   47,   48,  182,  183,   48,  177,
  177,  184,  184,  186,  186,  186,  187,  187,  174,  174,
  188,  188,  189,  190,   52,  191,   53,  192,   54,   50,
   50,  193,   51,   51,  194,  194,   49,   49,  195,  185,
  185,  179,  179,  197,   23,  198,  198,  199,  199,  200,
  200,  200,  201,  201,  202,  202,  202,  202,  203,  203,
  203,  203,  203,  203,  206,  204,  204,  204,  207,  208,
  205,  156,  210,  210,  211,  211,  212,  214,   55,  215,
   55,  217,   55,  213,  216,  216,  216,  216,   38,   38,
  218,  219,  220,  220,  221,  221,  129,  151,  222,  222,
  222,  223,  223,  224,  224,  225,  225,  226,  226,  227,
  227,  227,  227,  227,  228,  228,  228,  229,  229,  196,
  196,  230,  230,  230,  230,  230,  230,  233,  233,  233,
  233,  234,  234,  234,  234,  234,  161,  170,  125,   89,
  149,  231,   96,   96,  236,  232,  232,  155,  155,   97,
   97,   97,   97,  237,  154,  154,  209,  235,   65,   65,
  146,  146,  146,  146,  146,  146,  113,  157,  158,
};
const short yylen[] = {                                         2,
    1,    0,    1,    2,    1,    1,    1,    1,    1,    2,
    1,    1,    1,    1,    1,    2,    1,    1,    1,    1,
    1,    2,    2,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    4,    3,    0,    7,    1,    3,    0,
    7,    3,    0,    7,    2,    1,    1,    1,    1,    1,
    1,    3,    0,    7,    1,    0,    1,    1,    3,    1,
    1,    2,    3,    2,    1,    3,    1,    3,    4,    1,
    3,    1,    3,    1,    3,    0,    4,    3,    5,    3,
    3,    1,    1,    1,    4,    2,    2,    3,    3,    4,
    1,    2,    0,    3,    3,    2,    1,    1,    2,    1,
    2,    1,    1,    3,    1,    2,    2,    3,    1,    2,
    1,    2,    3,    3,    3,    4,    1,    3,    1,    1,
    1,    1,    1,    2,    1,    2,    1,    1,    1,    3,
    1,    3,    1,    1,    1,    3,    1,    3,    1,    3,
    1,    3,    3,    1,    0,    4,    0,    5,    1,    3,
    1,    3,    3,    1,    3,    5,    1,    3,    0,    4,
    3,    1,    3,    3,    1,    3,    2,    3,    1,    3,
    1,    3,    3,    1,    2,    3,    0,    0,    6,    1,
    3,    1,    1,    1,    3,    1,    3,    1,    1,    1,
    1,    1,    3,    1,    1,    7,    3,    5,    0,    0,
    6,    1,    1,    1,    1,    6,    4,    6,    7,    3,
    6,    7,    1,    2,    2,    4,   10,    2,    3,    0,
    5,    2,    0,    0,    8,    2,    2,    3,    5,    0,
    7,    0,    6,    3,    4,    2,    3,    5,    3,    2,
    2,    3,    3,    0,    1,    1,    1,    0,    3,    0,
    4,    0,    5,    5,    6,    7,    3,    5,    1,    3,
    5,    3,    0,    0,    7,    3,    0,    0,    7,    1,
    3,    3,    1,    1,    3,    3,    3,    1,    1,    3,
    1,    1,    7,    0,    6,    0,    6,    0,    6,    3,
    5,    1,    3,    5,    1,    2,    3,    5,    1,    1,
    1,    1,    1,    0,    6,    0,    1,    1,    2,    1,
    1,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    2,    2,    0,    0,
    5,    4,    0,    1,    1,    3,    1,    0,    3,    0,
    5,    0,    6,    2,    1,    3,    3,    5,    2,    3,
    4,    1,    0,    1,    1,    3,    1,    1,    1,    3,
    3,    1,    3,    1,    3,    1,    2,    1,    3,    1,
    2,    2,    3,    3,    1,    3,    3,    1,    3,    1,
    3,    1,    1,    1,    1,    1,    3,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    4,    4,    1,    3,    1,    2,    2,    2,    2,    3,
    4,    4,    5,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    2,    1,    1,    1,    1,    0,    1,
};
const short yydefred[] = {                                      0,
    0,  457,  458,    0,    0,  468,  332,    0,  105,  168,
    0,  169,  326,    0,  162,    0,    0,    0,  468,    0,
  167,  165,    0,    0,    0,    0,    0,  335,    0,    0,
  116,    0,  344,   87,    0,  253,    0,  181,    0,  328,
  160,    0,  163,    0,  324,    0,    0,    0,   73,  299,
  161,    0,  339,    0,    0,   95,    0,  292,    7,    0,
    0,    3,    5,    6,    8,    9,   11,   12,   13,   14,
   15,   17,   18,   19,   20,   21,   25,   26,   27,   28,
   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
   39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
   49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
   59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
   69,   70,   71,   72,   78,    0,    0,    0,   86,    0,
    0,    0,   91,    0,    0,    0,  159,    0,    0,    0,
  242,  244,  245,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   16,   10,   22,  432,  433,  434,
  435,  436,  431,  429,  430,    0,  343,  422,    0,    0,
    0,  424,    0,  420,    0,  425,  426,  428,    0,    0,
  104,  459,  460,  384,    0,  137,    0,    0,  143,    0,
    0,  131,  133,  138,    0,  281,    0,    0,  214,    0,
  220,  222,  223,    0,    0,  107,    0,  166,  164,  272,
  266,  262,    0,  263,    0,  336,    0,   23,  280,  267,
    0,    0,  202,    0,    0,  254,  260,    0,    0,  205,
    0,    0,    0,  145,    0,    0,    0,  285,  287,  286,
    0,    0,    0,  389,    0,    0,    0,    0,    0,    0,
  415,  207,    0,  211,    0,  209,    0,    0,    0,    4,
    0,    0,   85,    0,  174,    0,  171,    0,    0,    0,
    0,  175,    0,    0,    0,  102,    0,    0,    0,    0,
   88,    0,   90,    0,  184,  239,    0,  449,  468,    0,
    0,    0,    0,  258,    0,  468,    0,    0,  455,  456,
    0,    0,    0,    0,    0,  319,  322,  398,    0,    0,
  404,    0,    0,    0,    0,    0,  341,    0,    0,    0,
    0,    0,    0,    0,  448,    0,    0,    0,    0,  300,
    0,    0,    0,  446,  447,    0,  469,    0,    0,  136,
    0,    0,  128,    0,  139,  129,  132,    0,  141,  235,
    0,  232,  234,    0,  213,    0,  215,    0,  217,  106,
    0,    0,    0,    0,  279,  268,   75,    0,    0,    0,
  201,    0,    0,    0,   24,    0,  204,    0,    0,  144,
  146,    0,    0,  149,    0,  199,    0,  197,  283,  302,
  303,    0,    0,    0,  390,    0,    0,    0,    0,    0,
    0,  208,    0,  282,  306,  307,    0,   79,    0,   82,
    0,  153,    0,  467,    0,  194,  170,    0,    0,  154,
    0,    0,  155,   92,    0,  103,  158,  183,  187,  182,
  185,    0,    0,    0,    0,    0,    0,  250,  468,    0,
    0,  259,    0,  270,    0,    0,    0,    0,    0,    0,
  289,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  310,  313,  297,    0,    0,  330,    0,  333,    0,
  337,    0,    0,    0,  375,  380,  468,    0,    0,  379,
    0,    0,  443,  427,    0,  421,    0,    0,    0,    0,
    0,    0,    0,  135,  114,    0,  110,    0,    0,  130,
    0,    0,  216,  221,    0,  108,  275,    0,    0,    0,
    0,    0,    0,    0,  124,  117,    0,  203,  366,  355,
  356,  354,  361,    0,  359,  362,  360,    0,  363,  365,
    0,  369,    0,    0,  348,  350,  351,  352,  357,  358,
  364,    0,    0,  206,  148,  152,  150,    0,  314,    0,
    0,    0,    0,    0,   74,  419,    0,    0,  417,  416,
  212,  210,    0,    0,    0,    0,  172,    0,    0,    0,
  178,  180,  176,  156,    0,    0,    0,    0,  450,    0,
    0,  255,    0,  468,    0,  468,  247,  468,    0,    0,
    0,    0,    0,    0,    0,  320,  291,    0,  405,  409,
    0,    0,    0,    0,    0,    0,    0,  372,    0,    0,
    0,  382,    0,  441,    0,  301,  391,    0,  442,    0,
    0,  109,    0,    0,    0,  233,    0,  464,  465,  466,
    0,    0,    0,  228,    0,  224,  226,    0,  230,  461,
    0,  264,  101,  100,    0,    0,   98,    0,  126,  118,
    0,    0,  127,    0,    0,  367,  368,    0,    0,  349,
  261,    0,    0,    0,    0,    0,  196,  198,    0,    0,
  293,    0,    0,  193,  195,    0,    0,    0,  189,  186,
    0,  452,  451,    0,    0,    0,    0,    0,    0,    0,
    0,  269,    0,    0,  312,  294,    0,    0,  311,  298,
  331,  334,  338,  377,  376,  381,  386,    0,  468,    0,
  444,    0,  246,  327,  111,  115,  113,    0,  462,  463,
    0,    0,    0,  273,    0,    0,    0,    0,  121,  120,
    0,  353,  370,  345,  329,  315,  325,    0,  316,  200,
    0,    0,    0,    0,    0,    0,    0,  188,    0,  241,
  453,    0,  248,  256,  251,    0,    0,    0,    0,    0,
    0,  295,  383,    0,    0,    0,  225,  219,  231,  227,
    0,   77,   99,  125,  119,    0,    0,  305,  309,   81,
   84,   94,  192,  190,  249,  252,  468,  271,    0,    0,
  296,  388,    0,  236,  265,  371,  317,    0,  278,  323,
    0,    0,    0,  257,  238,
};
const short yydgoto[] = {                                      60,
   61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
   71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
   81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
  111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
  121,  122,  123,  124,  459,  243,  368,  645,  125,  126,
  409,  127,  411,  128,  129,  130,  131,  132,  133,  134,
  425,  646,  647,  135,  205,  189,  496,  497,  498,  370,
  222,  512,  513,  514,  515,  481,  288,  190,  191,  192,
  193,  348,  194,  195,  233,  234,  235,  383,  384,  266,
  271,  136,  416,  137,  417,  267,  272,  138,  284,  285,
  577,  678,  576,  679,  569,  387,  388,  551,  740,  224,
  231,  255,  256,  198,  199,  200,  635,  505,  722,  201,
  139,  203,  636,  637,  638,  639,  351,  352,  140,  766,
  318,  432,  681,  168,  142,  143,  436,  338,  144,  437,
  247,  145,  374,  364,  725,  146,  590,  589,  363,  591,
  241,  147,  304,  305,  453,  259,  461,  148,  169,  554,
  742,  563,  743,  462,  463,  550,  739,  306,  307,  236,
  185,  229,  149,  150,  151,  248,  225,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  658,  776,  171,  473,
  474,  475,  153,  327,  610,  479,  708,  172,  173,  488,
  489,  308,  309,  310,  311,  312,  313,  250,  251,  174,
  175,  176,  177,  178,  179,  483,  435,
};
const short yysindex[] = {                                   1063,
  -82,    0,    0, 1145,  811,    0,    0, -229,    0,    0,
 -179,    0,    0,   98,    0,  -56,  175, -179,    0, -226,
    0,    0,   77,  -91,  144,  539,  -41,    0,   78, -179,
    0, -179,    0,    0, -143,    0,  176,    0,  -44,    0,
    0, -179,    0,  187,    0,  212,  742,  811,    0,    0,
    0,  749,    0,  425,  742,    0,  811,    0,    0,    0,
 1063,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -179, -179,  -50,    0, -179,
   83,  167,    0, -179,  -87,  220,    0, 1198,  203,  241,
    0,    0,    0,  179, 1221,  260,  675,  888,  511,  541,
  561,  252,  279,  284,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  696,    0,    0,  185,    8,
    0,    0,  327,    0,  241,    0,    0,    0,  332,   11,
    0,    0,    0,    0,  356,    0,  227,  409,    0,  387,
    6,    0,    0,    0,  429,    0,   -7,  266,    0,   46,
    0,    0,    0,  409,  308,    0,   11,    0,    0,    0,
    0,    0,  -29,    0,  333,    0,  342,    0,    0,    0,
  362,  460,    0,  319,  480,    0,    0,  412,  520,    0,
  340, -179,  108,    0, -179,  547, -179,    0,    0,    0,
  450,  394, -179,    0,  915,  915,  452,  537,  105,   47,
    0,    0, -179,    0,  430,    0,  464,  436,  574,    0,
  491,  494,    0,  409,    0,  471,    0,   16,  505,  604,
  489,    0, -179,  522,  513,    0,  536,  440,  554,  676,
    0,  685,    0,  524,    0,    0,  772,    0,    0,  103,
   11,  431,  613,    0,   11,    0,  719,  726,    0,    0,
 1022,  675,  416,  636,  736,    0,    0,    0,  510,  538,
    0,  597,  105,  577,  531,  577,    0,  416,  720,  577,
  743,  577,  745,  772,    0,  468,  759,  696,   64,    0,
  675,  915,  598,    0,    0,  696,    0,  555,  577,    0,
  844,  826,    0,   25,    0,    0,    0, -179,    0,    0,
  849,    0,    0,  284,    0,  175,    0,  175,    0,    0,
 -179,  855,  696,  696,    0,    0,    0,  878, -179,  569,
    0, -179,  210,  696,    0,  577,    0, -179,  882,    0,
    0,  901, -179,    0,  577,    0,  372,    0,    0,    0,
    0,  820,   47,   47,    0,  915,  915,  915,  915,  915,
  904,    0,  312,    0,    0,    0,  577,    0,  925,    0,
  937,    0, -179,    0,  845,    0,    0,   16,   16,    0,
 -179,  579,    0,    0,  949,    0,    0,    0,    0,    0,
    0,  696,  903,  105,  932,   11,  523,    0,    0,  957,
  871,    0,  959,    0, 1022,  597,   64,  960,  696,  696,
    0,  675,  892,  696,  696, 1022,    0,    0,  966,  416,
  544,    0,    0,    0,  675,  670,    0,  680,    0,  747,
    0,    0,  990,  997,    0,    0,    0,  416,  756,    0,
  805,  416,    0,    0,  581,    0,  416, 1001, 1003,  105,
  813,  186,  865,    0,    0,  908,    0,  994,  105,    0,
 -179,  184,    0,    0, 1036,    0,    0,   80,  128,  170,
 1008,  980, 1015,  241,    0,    0, 1023,    0,    0,    0,
    0,    0,    0,  210,    0,    0,    0,  806,    0,    0,
  839,    0, 1039,  210,    0,    0,    0,    0,    0,    0,
    0,  141,  982,    0,    0,    0,    0, 1073,    0,  984,
 1075,  988, -179,  675,    0,    0,   47,   47,    0,    0,
    0,    0,  675, 1005,  170,  170,    0, 1076, 1080,  105,
    0,    0,    0,    0,  170,  889, 1272,  416,    0, 1116,
  977,    0, 1000,    0, 1014,    0,    0,    0,  696, 1035,
 1127,  105,  675,  510,  510,    0,    0,  538,    0,    0,
  617,  413,  577,  595, 1062, 1064, 1065,    0,  186, 1071,
   11,    0,  659,    0,  696,    0,    0,  696,    0, 1074,
 1077,    0,  826, 1011, 1138,    0,    0,    0,    0,    0,
  641,  641,    0,    0, 1156,    0,    0, 1160,    0,    0,
 1079,    0,    0,    0, 1162, 1163,    0,  598,    0,    0,
 -179, -179,    0, -179,  163,    0,    0, 1022, 1081,    0,
    0, 1082,  617, 1083, -179,  696,    0,    0,  736,  736,
    0, 1170, 1171,    0,    0, 1177, 1174, 1016,    0,    0,
 1093,    0,    0, 1180, 1022, 1095,   11, 1096, 1020,   11,
  148,    0, 1022, 1164,    0,    0,  675,  621,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1097,    0,  416,
    0,  416,    0,    0,    0,    0,    0, 1022,    0,    0,
 1036, 1179, 1051,    0,  894, 1101,  170, 1041,    0,    0,
 1054,    0,    0,    0,    0,    0,    0, 1168,    0,    0,
  416, 1104, 1105, 1106, 1109, 1118,  961,    0,  889,    0,
    0, 1119,    0,    0,    0, 1120, 1204, 1122, 1206, 1022,
  624,    0,    0,   11, 1207, 1211,    0,    0,    0,    0,
 1126,    0,    0,    0,    0, 1192,  617,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1022, 1214,
    0,    0, 1022,    0,    0,    0,    0,   11,    0,    0,
 1212, 1132, 1022,    0,    0,
};
const short yyrindex[] = {                                   1270,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1154,    0,    0,    0,
    0,    0,    0,    0, 1154,    0,    0,    0,    0,    0,
 1290,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  983,
  987,  996,    0,    0,    0,  -10,    0,    0,    0,   51,
    0,    0,    0, 1032, 1032,    0, 1178,    0,    0,    0,
    0,  548, 1183,  608,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  643,
  134,    0,    0,    0,  484,    0,    0,    0,  421,    0,
    0,    0,    0,    0,    0,    0,    0,    2,    0,    0,
    0,    0,    0,    0,  428,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  301,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1266,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  853,   29,  222,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1267, 1283,    0,  663,    0,    0,    0,    0,  666,  668,
    0,    0,    0,    0, 1284,    0,    0,    0,    0,    0,
    0, 1285,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  669,    0, 1199,    0,    0,    0,   14,  354,
    0,   74,  118,    0,    0,    0,    0,   36,    0,    0,
    0,    0,    0, 1286,    0,    0,    0,    0,    0,    0,
    0,    0, 1287,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  336,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1288,    0,    0,    0,    0,    0,    0,    0,
    0,  527,  117,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  721,  869,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   91,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  231, 1289,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   23,   59,    0, 1056,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   66,    0, 1291,    0,    0,    0, 1060,    0,    0,
    0, 1072,    0,    0,    0,    0, 1078,    0, 1293,  264,
    0,    0,    0,    0,    0,    0,    0, 1087,  709,    0,
   40,    0,    0,    0,    0,    0,    0,    0,    0, 1294,
 1088,    0,    0, 1089,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1295,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  923,  943,    0,    0,
    0,    0,    0,    0, 1294, 1294,    0,    0,    0, 1094,
    0,    0,    0,    0, 1294,    0,    0, 1203,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   41,    0,  113,  270,    0,    0,  359,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   72,    0,    0,    0,
    0,    0,  568,    0, 1292,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1296,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1213, 1242,
    0,    0,    0,    0,    0,    0, 1103,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  702,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1115,
    0, 1142,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1143,    0,    0,
 1144,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   19,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1297,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0, 1321,    0,    0,    0,    0, 1327,    0,    0, 1241,
    0,    0,    0,    0,    0, 1392,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1373,    0,
    0,    0,    0,    0,   -4,    0,    0,  245,    0,    0,
    0,    0,    0, -132, 1271, -127, -126, -122,    0,    0,
    0,    0,  677,    0,    0,    5,    0,  782,  783,    0,
    0,  752,  256,    0,    0, -327, -134, 1061, 1218, -157,
    0,    0, -173,    0,    0, 1181,    0,    0, 1027,    0,
  -75,    0, -273,    0,  551,  998,  991,    0,    0,  836,
    0,    0,    0,  667, -477,    0,  862,    0,    0,    0,
    0,    0, 1017,    0, -163,    0,    0,    0,    0, 1059,
    4, -175,  697,  698,    0,    0,    0,  917, -168,    0,
  -13,    0,    0,   15,    0,    0,   -6, -199,    0, -392,
 -500,   35,    0,    0,    0,    0,  662,    0,    0, -645,
 1396,    0,    0, -277,    0,    0,  798,    0,   94,    0,
    0,    0,    0,  861, -147,    0,    0, -379,    0,    0,
    0,    0,    0,    0,    0,  442,    0,    0,  934, -465,
    0,    0,    0,    0,    0,    0,    0,    0,   27,    0,
    0,  859,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  533, 1030, 1033, -259,  -51, -171,  433, 1153,
    0,    0,    0, -262,   20,  872, -381,
};
#define YYTABLESIZE 1599
const short yytable[] = {                                     180,
  249,  319,  321,  323,  427,  280,  184,  362,  491,  188,
  281,  282,  207,  204,  141,  283,  345,  325,  141,  154,
  202,  350,  206,  154,  448,  221,  152,  223,  353,  157,
  152,  141,  197,  347,  357,  211,  154,  230,  334,  276,
  335,  446,  240,  152,  155,  142,  585,  759,  142,  254,
  240,  580,  187,  485,  399,  415,  274,  399,  213,  277,
  181,  208,  457,  457,  457,  457,  457,  457,  660,  457,
  196,  187,  596,  393,  394,  141,  340,  182,  183,  340,
  154,  438,  686,  459,  438,  219,  134,  152,  399,  358,
  437,  441,  359,  400,  243,  443,  209,  243,  458,  458,
  458,  458,  458,  458,  484,  458,  377,  422,  422,  377,
  422,  243,  422,  467,  406,  432,  210,  406,  432,  460,
  641,  261,  262,  422,  268,  264,  269,  269,  142,  275,
  277,  454,  346,  303,  265,  270,  270,  291,  295,  290,
  399,  242,  439,  799,  187,  277,  440,  398,  454,  397,
  258,  500,  329,  400,  232,  437,  400,  733,  408,  141,
  298,  408,  340,  147,  154,  300,  134,  438,  642,  182,
  183,  152,  299,  392,  455,  455,  455,  455,  455,  296,
  455,  661,  341,  214,  752,  188,  347,  604,  758,  660,
  226,  455,  503,  689,  455,  455,  600,  422,  530,  684,
  406,  202,  524,  732,  220,  531,  525,  528,  529,  527,
  273,  643,  141,  596,  197,  227,  354,  154,  289,   37,
  526,  228,  532,  197,  152,  557,  558,  379,  331,  438,
  382,  634,  386,  232,  380,  434,  582,  549,  392,  400,
  765,  315,  640,  147,  408,  530,  157,  157,  401,  524,
    3,  237,  531,  525,  528,  529,  527,   34,  142,  142,
  455,  278,  410,  286,  410,  410,  410,  526,  269,  532,
  337,  407,  434,  340,  407,  414,  669,  270,  142,  410,
  287,  490,  186,  410,  332,  670,  399,  399,  447,  295,
  499,  324,  457,  457,  457,  457,  457,  157,  457,  457,
  460,  186,  460,  293,  408,  197,  460,  408,  460,  356,
  401,  330,  478,  401,  482,  801,  134,  303,  326,  487,
  728,  454,  482,  328,  698,  805,  350,  345,  458,  458,
  458,  458,  458,  353,  458,  458,  449,  450,  472,  182,
  183,  422,  422,  188,  406,  406,  406,  406,  410,  508,
  509,  361,  449,  450,  182,  183,  204,  407,  253,  202,
  542,  202,  372,  570,  511,  506,  333,  518,  719,  720,
  141,  336,  141,  544,  186,  154,  649,  154,  382,  653,
  548,  434,  152,  378,  152,  400,  400,  408,  408,  408,
  408,  408,  355,  592,  402,  339,  401,  402,  254,  403,
  449,  450,  403,  455,  455,  455,  455,  455,  264,  455,
  455,  707,  552,  449,  450,  553,  269,  265,  578,  761,
  449,  450,  519,  182,  183,  270,  182,  183,  520,  521,
  522,    2,    3,  187,  360,  182,  183,  391,  303,  523,
  182,  458,    2,    3,  280,  371,  170,  634,  342,  281,
  282,  303,  302,  695,  283,  246,  697,  245,  640,  365,
  640,  456,  456,  456,  456,  456,  377,  456,  366,  519,
  611,  253,  349,  403,  140,  520,  521,  522,  456,  406,
  402,  456,  456,  182,  183,  403,  523,  754,  367,  170,
  757,  410,  410,  410,  410,  410,  188,  625,  170,  369,
  633,  407,  407,  407,  407,  644,  620,  166,  476,  477,
  246,  300,  245,  343,  413,  736,    2,    3,  299,  373,
  390,  354,    2,    3,  423,  423,  423,  423,  423,  434,
  423,  249,  421,  408,  408,  408,  408,  408,  375,  696,
  303,  423,  401,  401,  342,  423,  418,  456,  386,  303,
  316,  252,  317,  246,  140,  245,  402,  276,  276,  376,
  644,  644,  405,  583,  792,  421,  584,  431,  182,  183,
  644,  499,  499,  151,  465,  691,  389,  687,  395,  303,
  320,  690,  317,  246,  602,  245,  385,  603,  303,  170,
  404,  455,  274,  274,  455,  297,  490,  412,  802,  710,
  322,  482,  317,  246,  712,  245,  249,  694,  455,  229,
  423,  231,  517,  407,  231,  420,  166,  408,  317,  246,
  410,  245,  421,  704,  452,  402,  402,  402,  300,  797,
  403,  403,  403,  249,  482,  299,  276,  166,  452,  424,
  246,  592,  245,  182,  183,  419,  511,  511,  423,  511,
  430,  456,  741,  151,  456,  433,  166,  464,  317,  246,
  738,  245,  426,  186,  452,  218,  570,  452,  456,    2,
    3,  274,  158,  159,  160,  161,  162,  163,  164,  165,
  428,  182,  183,  303,  140,  140,  342,  301,  449,  450,
  456,  456,  456,  456,  456,  516,  456,  456,  166,  414,
  709,  246,  764,  245,  140,  574,  173,  616,  592,  177,
  605,  179,  321,  603,  302,  429,  633,  246,  769,  245,
  606,  700,  644,  603,    2,    3,  268,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  216,  592,  246,  442,
  245,  570,  301,  422,  422,  422,  422,  762,  422,  440,
  791,  570,  440,  423,  423,  423,  423,  423,  444,  423,
  423,  411,  451,  411,  411,  411,  440,    2,    3,  342,
  158,  159,  160,  161,  162,  163,  164,  165,  411,  452,
  798,  454,  411,  151,  151,  301,  445,  607,  166,  173,
  603,  246,  177,  245,  179,  321,  612,    2,    3,  613,
  158,  159,  160,  161,  162,  163,  164,  165,  455,  672,
  673,  166,  396,  332,  246,  301,  245,    2,    3,  676,
  158,  159,  160,  161,  162,  163,  164,  165,  556,  433,
  215,  559,  560,  457,  458,  301,  158,  159,  160,  161,
  162,  163,  164,  165,  216,  614,  467,  411,  615,  217,
  166,  301,  167,  619,    2,    3,  615,  158,  159,  160,
  161,  162,  163,  164,  165,  166,  456,  495,  246,  469,
  245,  471,  301,    2,    3,  244,  158,  159,  160,  161,
  162,  163,  164,  165,  166,  480,  568,  246,  492,  245,
  494,  301,  502,  418,  418,  418,  418,  418,  507,  418,
  158,  159,  160,  161,  162,  621,  729,  730,  603,  412,
  418,  412,  412,  412,  418,    2,    3,  510,  158,  159,
  160,  161,  162,  163,  164,  165,  412,  314,  545,  167,
  412,    2,    3,  301,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  579,  546,  246,  555,  245,  622,  301,
  561,  623,    2,    3,  166,  158,  159,  160,  161,  162,
  163,  164,  165,  414,  565,  414,  414,  414,  571,  572,
  301,  422,  422,  422,  422,  422,  566,  422,  422,  418,
  414,  594,  595,  413,  414,  413,  413,  413,  575,  581,
  411,  411,  411,  411,  411,  412,  586,  587,  182,  183,
  413,  238,  588,  593,  413,    2,    3,  239,  158,  159,
  160,  161,  162,  163,  164,  165,  166,  683,  597,  246,
  650,  245,  662,  651,  664,  603,  601,  665,    2,    3,
  608,  158,  159,  160,  161,  162,  163,  164,  165,  166,
  609,  617,  246,  685,  245,  671,  618,  648,  603,  414,
  166,  624,  716,  246,  688,  245,  748,  584,  652,  749,
  756,  166,  654,  584,  246,  656,  245,    2,    3,  413,
  158,  159,  160,  161,  162,  163,  164,  165,  632,  659,
  631,  774,    2,    3,  615,  158,  159,  160,  161,  162,
  163,  164,  165,  632,  775,  631,  340,  651,  657,  340,
  385,    2,    3,  385,  158,  159,  160,  161,  162,  163,
  164,  165,  445,  466,  667,  445,  674,  468,  395,  470,
  675,  395,  418,  418,  418,  418,  418,  112,  122,  123,
  112,  122,  123,  663,  439,  666,  493,  439,  412,  412,
  412,  412,  412,  191,    2,    3,  191,  158,  159,  160,
  161,  162,  163,  164,  165,  387,  682,  677,  387,    2,
    3,  692,  158,  159,  160,  161,  162,  163,  164,  165,
  693,    2,    3,  543,  158,  159,  160,  161,  162,  163,
  164,  165,  396,  318,  397,  396,  318,  397,  701,   59,
  702,  703,  414,  414,  414,  414,  414,  706,  718,  721,
  713,  723,  726,  714,  564,  724,  727,  734,  735,  737,
  744,  745,  413,  413,  413,  413,  413,  746,  747,  750,
  751,  753,  755,  763,  760,  768,  771,  772,  777,  783,
  778,  779,  780,    2,    3,  781,  158,  159,  160,  161,
  162,  163,  164,  165,  782,  785,  786,  787,  788,  789,
  793,  794,  795,  796,  800,  803,    2,    3,  804,  158,
  159,  160,  161,  162,  163,  164,  165,    2,    3,    2,
  158,  159,  160,  161,  162,  163,  164,  165,    2,    3,
  284,  158,  159,  160,  161,  162,  163,  164,  165,    1,
   88,  468,  182,  183,   89,  627,  159,  160,  161,  162,
  628,  629,  630,   90,  288,   76,   80,  182,  183,  378,
  158,  159,  160,  161,  162,  628,  629,  630,    1,    2,
    3,    4,   83,   93,   89,  290,  373,  393,  346,  240,
  156,  374,  321,  394,   96,  347,   97,  237,  218,  304,
    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
   15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
   25,   26,   27,   28,   29,   30,   31,   32,  308,   33,
   34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
   44,  260,   45,   46,   47,  294,   48,   49,   50,   51,
   52,   53,   54,   55,   56,  157,  212,   57,  263,   58,
    1,    2,    3,  773,  715,  731,  717,  344,  501,  547,
  567,  573,  680,  381,  668,  784,  504,  767,  626,  562,
  770,  790,    5,    6,    7,    8,    9,   10,   11,   12,
   13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
   23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
  257,   33,   34,   35,   36,   37,   38,  655,   40,   41,
   42,   43,   44,  699,   45,   46,   47,  705,   48,   49,
   50,   51,   52,   53,   54,   55,   56,    2,    3,   57,
   10,   58,   12,  598,  486,   15,  711,  599,    0,    0,
   20,   21,   22,    0,    0,    0,    0,    0,    5,    6,
    7,    0,    0,    0,   11,    0,   13,    0,    0,   16,
    0,    0,   41,    0,   43,    0,  279,    0,    0,  292,
    0,   28,    0,    0,   51,    0,    0,    0,    0,   35,
   36,   37,    0,    0,   40,    0,    0,    0,    0,    0,
   45,    0,   47,    0,   48,    0,   50,    0,   52,   53,
    0,   55,    0,  293,   10,   57,   12,   58,    0,   15,
    0,    0,    0,    0,   20,   21,   22,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   41,    0,   43,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   51,
};
const short yycheck[] = {                                       6,
   52,  149,  150,  151,  278,  138,   11,  207,  336,   14,
  138,  138,   19,   18,    0,  138,  190,  152,    4,    0,
   17,  197,   18,    4,  302,   30,    0,   32,  197,   40,
    4,   17,   40,  191,  198,  127,   17,   42,  173,  127,
  175,  301,   47,   17,  127,   44,  439,  693,   47,   54,
   55,  433,   47,  331,   41,   40,  132,   44,   24,   41,
  290,  288,   40,   41,   42,   43,   44,   45,  534,   47,
  127,   47,  452,  245,  246,   61,   41,  257,  258,   44,
   61,   41,  583,   61,   44,  127,   47,   61,   42,   44,
   62,  291,   47,   47,   44,  295,  323,   47,   40,   41,
   42,   43,   44,   45,   41,   47,   41,   42,   43,   44,
   45,   61,   47,   42,   41,   44,   40,   44,   47,   61,
   41,  126,  127,   58,   42,  130,  131,  132,  127,  134,
  135,   41,  127,  147,  130,  131,  132,  144,  145,  144,
  127,   48,   40,  789,   47,  127,   44,   43,   58,   45,
   57,  127,  166,   41,   47,  127,   44,  658,   41,  145,
  146,   44,  127,   47,  145,  146,  127,  127,   41,  257,
  258,  145,  146,   40,   41,   42,   43,   44,   45,  145,
   47,   41,  187,   40,  685,  190,  344,  465,   41,  655,
  334,   58,  356,  586,   61,   62,  456,  273,   36,  581,
  127,  198,   40,   41,  127,   43,   44,   45,   46,   47,
   44,   42,  198,  593,   40,   40,  197,  198,   40,  311,
   58,  266,   60,   40,  198,  397,  398,  232,   44,  127,
  235,  505,  237,   47,  127,  287,  436,  385,  243,  127,
  718,  148,  505,  127,  127,   36,  257,  258,  253,   40,
  258,   40,   43,   44,   45,   46,   47,  308,  257,  258,
  127,   42,   41,   61,   43,   44,   45,   58,  273,   60,
  260,   41,  324,   47,   44,  260,  554,  273,  277,   58,
   40,  333,  277,   62,  277,  563,  273,  274,  302,  296,
  342,   40,  270,  271,  272,  273,  274,  308,  276,  277,
  314,  277,  316,  333,   41,   40,  320,   44,  322,   44,
   41,  127,  326,   44,  328,  793,  277,  331,   40,  333,
  648,   58,  336,   40,  602,  803,  502,  501,  270,  271,
  272,  273,  274,  502,  276,  277,  273,  274,  324,  257,
  258,  276,  277,  348,  271,  272,  273,  274,  127,  363,
  364,   44,  273,  274,  257,  258,  361,  127,   47,  356,
  374,  358,   44,  415,  369,  361,   40,  372,  631,  632,
  356,   40,  358,  378,  277,  356,  511,  358,  383,  514,
  385,  433,  356,   44,  358,  273,  274,  270,  271,  272,
  273,  274,  127,  445,   41,   40,  127,   44,  403,   41,
  273,  274,   44,  270,  271,  272,  273,  274,  413,  276,
  277,  611,   41,  273,  274,   44,  421,  413,  432,  697,
  273,  274,  260,  257,  258,  421,  257,  258,  266,  267,
  268,  257,  258,   47,  127,  257,  258,   44,  452,  277,
  257,  258,  257,  258,  577,  127,    5,  721,   40,  577,
  577,  465,   40,  601,  577,   43,   44,   45,  721,  127,
  723,   41,   42,   43,   44,   45,  127,   47,  127,  260,
  477,   47,   44,   44,   47,  266,  267,  268,   58,   44,
  127,   61,   62,  257,  258,  127,  277,  687,  127,   48,
  690,  270,  271,  272,  273,  274,  501,  502,   57,   40,
  505,  271,  272,  273,  274,  510,  492,   40,   41,   42,
   43,  492,   45,  127,   44,  663,  257,  258,  492,   40,
  127,  502,  257,  258,   41,   42,   43,   44,   45,  581,
   47,  583,   44,  270,  271,  272,  273,  274,  127,  127,
  554,   58,  273,  274,   40,   62,   42,  127,  553,  563,
   40,  127,   42,   43,  127,   45,  127,  257,  258,   40,
  565,  566,  127,   41,  764,   44,   44,   44,  257,  258,
  575,  623,  624,   47,   44,  589,  127,  584,  127,  593,
   40,  588,   42,   43,   41,   45,   40,   44,  602,  148,
  127,   44,  257,  258,   47,  336,  648,  127,  798,  613,
   40,  615,   42,   43,  618,   45,  658,  593,   61,   42,
  127,   44,   44,   40,   47,  127,   40,  127,   42,   43,
  127,   45,   44,  609,   44,  272,  273,  274,  609,  777,
  272,  273,  274,  685,  648,  609,  336,   40,   44,  127,
   43,  693,   45,  257,  258,   42,  651,  652,  127,  654,
  127,   44,  666,  127,   47,   58,   40,  127,   42,   43,
  665,   45,  127,  277,   44,  127,  718,   44,   61,  257,
  258,  336,  260,  261,  262,  263,  264,  265,  266,  267,
  127,  257,  258,  697,  257,  258,   44,  275,  273,  274,
  270,  271,  272,  273,  274,  127,  276,  277,   40,  260,
   42,   43,  709,   45,  277,  127,   44,  127,  760,   44,
   41,   44,   44,   44,   40,   40,  721,   43,  723,   45,
   41,  127,  727,   44,  257,  258,   42,  260,  261,  262,
  263,  264,  265,  266,  267,   40,  306,  789,   43,  127,
   45,  793,  275,   42,   43,   44,   45,  127,   47,   41,
  127,  803,   44,  270,  271,  272,  273,  274,   40,  276,
  277,   41,  127,   43,   44,   45,   58,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,   58,   44,
  787,  272,   62,  257,  258,  275,   61,   41,   40,  127,
   44,   43,  127,   45,  127,  127,   41,  257,  258,   44,
  260,  261,  262,  263,  264,  265,  266,  267,  271,  565,
  566,   40,  276,  277,   43,  275,   45,  257,  258,  575,
  260,  261,  262,  263,  264,  265,  266,  267,  396,   58,
  292,  399,  400,  257,  258,  275,  260,  261,  262,  263,
  264,  265,  266,  267,  306,   41,  127,  127,   44,  311,
   40,  275,   42,   41,  257,  258,   44,  260,  261,  262,
  263,  264,  265,  266,  267,   40,  270,   42,   43,  127,
   45,  127,  275,  257,  258,  127,  260,  261,  262,  263,
  264,  265,  266,  267,   40,  127,   42,   43,  334,   45,
   47,  275,   44,   41,   42,   43,   44,   45,   44,   47,
  260,  261,  262,  263,  264,   41,  651,  652,   44,   41,
   58,   43,   44,   45,   62,  257,  258,   40,  260,  261,
  262,  263,  264,  265,  266,  267,   58,   40,   47,   42,
   62,  257,  258,  275,  260,  261,  262,  263,  264,  265,
  266,  267,   40,   41,   44,   43,  127,   45,   41,  275,
   47,   44,  257,  258,   40,  260,  261,  262,  263,  264,
  265,  266,  267,   41,   40,   43,   44,   45,  418,  419,
  275,  270,  271,  272,  273,  274,   40,  276,  277,  127,
   58,  449,  450,   41,   62,   43,   44,   45,   40,   58,
  270,  271,  272,  273,  274,  127,   40,  127,  257,  258,
   58,  260,   44,   44,   62,  257,  258,  266,  260,  261,
  262,  263,  264,  265,  266,  267,   40,   41,  127,   43,
   41,   45,   41,   44,   41,   44,   61,   44,  257,  258,
   41,  260,  261,  262,  263,  264,  265,  266,  267,   40,
   44,   41,   43,   44,   45,   41,   44,   40,   44,  127,
   40,   58,   42,   43,   41,   45,   41,   44,   44,   44,
   41,   40,   40,   44,   43,  260,   45,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,   43,   41,
   45,   41,  257,  258,   44,  260,  261,  262,  263,  264,
  265,  266,  267,   43,   41,   45,   41,   44,  260,   44,
   41,  257,  258,   44,  260,  261,  262,  263,  264,  265,
  266,  267,   41,  316,  127,   44,   41,  320,   41,  322,
   41,   44,  270,  271,  272,  273,  274,   41,   41,   41,
   44,   44,   44,   61,   41,   61,  339,   44,  270,  271,
  272,  273,  274,   41,  257,  258,   44,  260,  261,  262,
  263,  264,  265,  266,  267,   41,   41,  269,   44,  257,
  258,  127,  260,  261,  262,  263,  264,  265,  266,  267,
   44,  257,  258,  376,  260,  261,  262,  263,  264,  265,
  266,  267,   41,   41,   41,   44,   44,   44,  127,  127,
  127,  127,  270,  271,  272,  273,  274,  127,   61,   44,
  127,   42,   41,  127,  407,  127,   44,  127,  127,  127,
   41,   41,  270,  271,  272,  273,  274,   41,   45,  127,
   41,  127,  127,  127,   61,   47,  333,  127,   61,  269,
  127,  127,  127,  257,  258,  127,  260,  261,  262,  263,
  264,  265,  266,  267,  127,  127,  127,   44,  127,   44,
   44,   41,  127,   62,   41,   44,  257,  258,  127,  260,
  261,  262,  263,  264,  265,  266,  267,  257,  258,    0,
  260,  261,  262,  263,  264,  265,  266,  267,  257,  258,
  127,  260,  261,  262,  263,  264,  265,  266,  267,    0,
  308,  260,  257,  258,  308,  260,  261,  262,  263,  264,
  265,  266,  267,  308,  127,   40,   40,  257,  258,  127,
  260,  261,  262,  263,  264,  265,  266,  267,  256,  257,
  258,  259,   40,   40,   40,  127,   41,   41,   41,  127,
    4,   41,   44,   41,   41,   41,   41,   41,   47,  127,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  127,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,   61,  320,  321,  322,  145,  324,  325,  326,  327,
  328,  329,  330,  331,  332,    4,   24,  335,  128,  337,
  256,  257,  258,  727,  623,  654,  624,  190,  348,  383,
  413,  421,  577,  233,  553,  749,  358,  721,  502,  403,
  723,  760,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
   55,  307,  308,  309,  310,  311,  312,  524,  314,  315,
  316,  317,  318,  603,  320,  321,  322,  609,  324,  325,
  326,  327,  328,  329,  330,  331,  332,  257,  258,  335,
  283,  337,  285,  454,  332,  288,  615,  455,   -1,   -1,
  293,  294,  295,   -1,   -1,   -1,   -1,   -1,  278,  279,
  280,   -1,   -1,   -1,  284,   -1,  286,   -1,   -1,  289,
   -1,   -1,  315,   -1,  317,   -1,  319,   -1,   -1,  299,
   -1,  301,   -1,   -1,  327,   -1,   -1,   -1,   -1,  309,
  310,  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,
  320,   -1,  322,   -1,  324,   -1,  326,   -1,  328,  329,
   -1,  331,   -1,  333,  283,  335,  285,  337,   -1,  288,
   -1,   -1,   -1,   -1,  293,  294,  295,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  315,   -1,  317,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  327,
};
#define YYFINAL 60
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 339
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,"'$'",0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,
0,0,"':'",0,"'<'","'='","'>'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"EOS",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,"tok_identifier","tok_array_identifier","tok_label",
"tok_integer_const","tok_real_const","tok_dp_const","tok_complex_const",
"tok_dcomplex_const","tok_logical_const","tok_string","tok_hollerith",
"tok_edit_descriptor","tok_letter","tok_relop","tok_AND","tok_OR","tok_EQV",
"tok_NEQV","tok_NOT","tok_power","tok_concat","tok_ACCEPT","tok_ASSIGN",
"tok_BACKSPACE","tok_BLOCK","tok_BLOCKDATA","tok_BYTE","tok_CALL",
"tok_CHARACTER","tok_CLOSE","tok_COMMON","tok_COMPLEX","tok_CONTINUE",
"tok_DATA","tok_DIMENSION","tok_DO","tok_DOUBLE","tok_DOUBLECOMPLEX",
"tok_DOUBLEPRECISION","tok_DOWHILE","tok_ELSE","tok_ELSEIF","tok_END",
"tok_ENDDO","tok_ENDFILE","tok_ENDIF","tok_ENTRY","tok_EQUIVALENCE",
"tok_EXTERNAL","tok_FILE","tok_FORMAT","tok_FUNCTION","tok_GO","tok_GOTO",
"tok_IF","tok_IMPLICIT","tok_INCLUDE","tok_INQUIRE","tok_INTEGER",
"tok_INTRINSIC","tok_LOGICAL","tok_NAMELIST","tok_NONE","tok_OPEN",
"tok_PARAMETER","tok_PAUSE","tok_PRECISION","tok_PRINT","tok_PROGRAM",
"tok_READ","tok_REAL","tok_RETURN","tok_REWIND","tok_SAVE","tok_STOP",
"tok_SUBROUTINE","tok_THEN","tok_TO","tok_TYPE","tok_WHILE","tok_WRITE",
"tok_illegal","REDUCE",
};
const char * const yyrule[] = {
"$accept : prog_body",
"prog_body : stmt_list",
"prog_body :",
"stmt_list : stmt_list_item",
"stmt_list : stmt_list stmt_list_item",
"stmt_list_item : ordinary_stmt",
"stmt_list_item : include_stmt",
"stmt_list_item : EOS",
"ordinary_stmt : stmt",
"ordinary_stmt : end_stmt",
"stmt : tok_label unlabeled_stmt",
"stmt : unlabeled_stmt",
"unlabeled_stmt : subprogram_header",
"unlabeled_stmt : specification_stmt",
"unlabeled_stmt : executable_stmt",
"unlabeled_stmt : restricted_stmt",
"unlabeled_stmt : error EOS",
"subprogram_header : prog_stmt",
"subprogram_header : function_stmt",
"subprogram_header : subroutine_stmt",
"subprogram_header : block_data_stmt",
"end_stmt : unlabeled_end_stmt",
"end_stmt : tok_label unlabeled_end_stmt",
"unlabeled_end_stmt : tok_END EOS",
"include_stmt : tok_INCLUDE tok_string EOS",
"specification_stmt : anywhere_stmt",
"specification_stmt : parameter_stmt",
"specification_stmt : implicit_stmt",
"specification_stmt : data_stmt",
"specification_stmt : specif_stmt",
"anywhere_stmt : entry_stmt",
"anywhere_stmt : format_stmt",
"specif_stmt : dimension_stmt",
"specif_stmt : equivalence_stmt",
"specif_stmt : common_stmt",
"specif_stmt : namelist_stmt",
"specif_stmt : type_stmt",
"specif_stmt : external_stmt",
"specif_stmt : intrinsic_stmt",
"specif_stmt : save_stmt",
"executable_stmt : transfer_stmt",
"executable_stmt : nontransfer_stmt",
"transfer_stmt : unconditional_goto",
"transfer_stmt : assigned_goto",
"transfer_stmt : arithmetic_if_stmt",
"transfer_stmt : stop_stmt",
"transfer_stmt : return_stmt",
"nontransfer_stmt : assignment_stmt",
"nontransfer_stmt : assign_stmt",
"nontransfer_stmt : computed_goto",
"nontransfer_stmt : continue_stmt",
"nontransfer_stmt : pause_stmt",
"nontransfer_stmt : read_stmt",
"nontransfer_stmt : accept_stmt",
"nontransfer_stmt : write_stmt",
"nontransfer_stmt : print_stmt",
"nontransfer_stmt : type_output_stmt",
"nontransfer_stmt : rewind_stmt",
"nontransfer_stmt : backspace_stmt",
"nontransfer_stmt : endfile_stmt",
"nontransfer_stmt : open_stmt",
"nontransfer_stmt : close_stmt",
"nontransfer_stmt : inquire_stmt",
"nontransfer_stmt : call_stmt",
"restricted_stmt : restricted_nontransfer_stmt",
"restricted_stmt : else_or_endif_stmt",
"restricted_nontransfer_stmt : logical_if_stmt",
"restricted_nontransfer_stmt : block_if_stmt",
"restricted_nontransfer_stmt : do_stmt",
"restricted_nontransfer_stmt : enddo_stmt",
"else_or_endif_stmt : else_if_stmt",
"else_or_endif_stmt : else_stmt",
"else_or_endif_stmt : end_if_stmt",
"$$1 :",
"prog_stmt : tok_PROGRAM $$1 symbolic_name EOS",
"entry_stmt : tok_ENTRY symbolic_name EOS",
"$$2 :",
"entry_stmt : tok_ENTRY symbolic_name $$2 '(' dummy_argument_list ')' EOS",
"function_stmt : unlabeled_function_stmt",
"unlabeled_function_stmt : typed_function_handle symbolic_name EOS",
"$$3 :",
"unlabeled_function_stmt : typed_function_handle symbolic_name $$3 '(' dummy_argument_list ')' EOS",
"unlabeled_function_stmt : plain_function_handle symbolic_name EOS",
"$$4 :",
"unlabeled_function_stmt : plain_function_handle symbolic_name $$4 '(' dummy_argument_list ')' EOS",
"typed_function_handle : type_name function_keyword",
"plain_function_handle : function_keyword",
"function_keyword : tok_FUNCTION",
"type_name : arith_type_name",
"type_name : plain_char_type_name",
"type_name : char_type_name",
"subroutine_stmt : unlabeled_subroutine_stmt",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name EOS",
"$$5 :",
"unlabeled_subroutine_stmt : subroutine_handle symbolic_name $$5 '(' dummy_argument_list ')' EOS",
"subroutine_handle : tok_SUBROUTINE",
"dummy_argument_list :",
"dummy_argument_list : non_empty_arg_list",
"non_empty_arg_list : dummy_argument",
"non_empty_arg_list : non_empty_arg_list ',' dummy_argument",
"dummy_argument : symbolic_name",
"dummy_argument : '*'",
"block_data_stmt : block_data_handle EOS",
"block_data_stmt : block_data_handle symbolic_name EOS",
"block_data_handle : tok_BLOCK tok_DATA",
"block_data_handle : tok_BLOCKDATA",
"dimension_stmt : tok_DIMENSION array_declarator_list EOS",
"array_declarator_list : array_declarator",
"array_declarator_list : array_declarator_list ',' array_declarator",
"array_declarator : symbolic_name '(' dim_bound_list ')'",
"dim_bound_list : dim_bound_item",
"dim_bound_list : dim_bound_list ',' dim_bound_item",
"dim_bound_item : dim_bound_expr",
"dim_bound_item : dim_bound_expr ':' dim_bound_expr",
"dim_bound_item : '*'",
"dim_bound_item : dim_bound_expr ':' '*'",
"$$6 :",
"equivalence_stmt : tok_EQUIVALENCE $$6 equivalence_list EOS",
"equivalence_list : '(' equivalence_list_item ')'",
"equivalence_list : equivalence_list ',' '(' equivalence_list_item ')'",
"equivalence_list_item : equiv_entity ',' equiv_entity",
"equivalence_list_item : equivalence_list_item ',' equiv_entity",
"equiv_entity : symbolic_name",
"equiv_entity : array_equiv_name",
"equiv_entity : substring_equiv_name",
"array_equiv_name : symbolic_name '(' subscript_list ')'",
"substring_equiv_name : symbolic_name substring_interval",
"substring_equiv_name : array_equiv_name substring_interval",
"common_stmt : tok_COMMON common_variable_list EOS",
"common_stmt : tok_COMMON common_block_list EOS",
"common_stmt : tok_COMMON common_variable_list common_block_list EOS",
"common_block_list : labeled_common_block",
"common_block_list : common_block_list labeled_common_block",
"$$7 :",
"labeled_common_block : common_block_name $$7 common_variable_list",
"common_block_name : '/' symbolic_name '/'",
"common_block_name : '/' '/'",
"common_block_name : tok_concat",
"common_variable_list : common_list_item",
"common_variable_list : common_variable_list common_list_item",
"common_list_item : common_entity",
"common_list_item : common_entity ','",
"common_entity : symbolic_name",
"common_entity : array_declarator",
"namelist_stmt : tok_NAMELIST namelist_list EOS",
"namelist_list : namelist_decl",
"namelist_list : namelist_list namelist_decl",
"namelist_decl : namelist_name namelist_var_list",
"namelist_name : '/' symbolic_name '/'",
"namelist_var_list : namelist_item",
"namelist_var_list : namelist_var_list namelist_item",
"namelist_item : symbolic_name",
"namelist_item : symbolic_name ','",
"type_stmt : arith_type_name arith_type_decl_list EOS",
"type_stmt : plain_char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name char_type_decl_list EOS",
"type_stmt : char_type_name ',' char_type_decl_list EOS",
"arith_type_name : sizeable_type_name",
"arith_type_name : sizeable_type_name '*' nonzero_unsigned_int_const",
"arith_type_name : unsizeable_type_name",
"sizeable_type_name : tok_INTEGER",
"sizeable_type_name : tok_REAL",
"sizeable_type_name : tok_COMPLEX",
"sizeable_type_name : tok_LOGICAL",
"unsizeable_type_name : tok_DOUBLE tok_PRECISION",
"unsizeable_type_name : tok_DOUBLEPRECISION",
"unsizeable_type_name : tok_DOUBLE tok_COMPLEX",
"unsizeable_type_name : tok_DOUBLECOMPLEX",
"unsizeable_type_name : tok_BYTE",
"plain_char_type_name : tok_CHARACTER",
"char_type_name : plain_char_type_name '*' len_specification",
"arith_type_decl_list : arith_type_decl_item",
"arith_type_decl_list : arith_type_decl_list ',' arith_type_decl_item",
"arith_type_decl_item : symbolic_name",
"arith_type_decl_item : array_declarator",
"char_type_decl_list : char_type_decl_item",
"char_type_decl_list : char_type_decl_list ',' char_type_decl_item",
"char_type_decl_item : symbolic_name",
"char_type_decl_item : symbolic_name '*' len_specification",
"char_type_decl_item : array_declarator",
"char_type_decl_item : array_declarator '*' len_specification",
"implicit_handle : tok_IMPLICIT",
"implicit_stmt : implicit_handle implicit_decl_list EOS",
"implicit_stmt : implicit_handle tok_NONE EOS",
"implicit_decl_list : implicit_decl_item",
"$$8 :",
"implicit_decl_list : implicit_decl_list ',' $$8 implicit_decl_item",
"$$9 :",
"implicit_decl_item : type_name '(' $$9 letter_list ')'",
"letter_list : letter_list_item",
"letter_list : letter_list ',' letter_list_item",
"letter_list_item : tok_letter",
"letter_list_item : tok_letter '-' tok_letter",
"len_specification : '(' '*' ')'",
"len_specification : nonzero_unsigned_int_const",
"len_specification : '(' int_constant_expr ')'",
"parameter_stmt : tok_PARAMETER '(' parameter_defn_list ')' EOS",
"parameter_defn_list : parameter_defn_item",
"parameter_defn_list : parameter_defn_list ',' parameter_defn_item",
"$$10 :",
"parameter_defn_item : symbolic_name $$10 '=' parameter_expr",
"external_stmt : tok_EXTERNAL external_name_list EOS",
"external_name_list : symbolic_name",
"external_name_list : external_name_list ',' symbolic_name",
"intrinsic_stmt : tok_INTRINSIC intrinsic_name_list EOS",
"intrinsic_name_list : symbolic_name",
"intrinsic_name_list : intrinsic_name_list ',' symbolic_name",
"save_stmt : tok_SAVE EOS",
"save_stmt : tok_SAVE save_list EOS",
"save_list : save_item",
"save_list : save_list ',' save_item",
"save_item : symbolic_name",
"save_item : '/' symbolic_name '/'",
"data_stmt : tok_DATA data_defn_list EOS",
"data_defn_list : data_defn_item",
"data_defn_list : data_defn_list data_defn_item",
"data_defn_list : data_defn_list ',' data_defn_item",
"$$11 :",
"$$12 :",
"data_defn_item : data_defn_assignee_list '/' $$11 data_value_list $$12 '/'",
"data_defn_assignee_list : data_defn_assignee",
"data_defn_assignee_list : data_defn_assignee_list ',' data_defn_assignee",
"data_defn_assignee : lvalue",
"data_defn_assignee : data_implied_do_list",
"data_value_list : data_value",
"data_value_list : data_value_list ',' data_value",
"data_value : data_constant_value",
"data_value : data_repeat_factor '*' data_constant_value",
"data_repeat_factor : nonzero_unsigned_int_const",
"data_repeat_factor : symbolic_name",
"data_constant_value : data_constant",
"data_constant_value : symbolic_name",
"data_dlist : data_dlist_item",
"data_dlist : data_dlist ',' data_dlist_item",
"data_dlist_item : array_element_lvalue",
"data_dlist_item : data_implied_do_list",
"data_implied_do_list : '(' data_dlist ',' symbolic_name '=' data_do_loop_bounds ')'",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr",
"data_do_loop_bounds : int_constant_expr ',' int_constant_expr ',' int_constant_expr",
"$$13 :",
"$$14 :",
"assignment_stmt : lvalue '=' $$13 expr $$14 EOS",
"lvalue : variable_name",
"lvalue : array_element_lvalue",
"lvalue : substring_lvalue",
"lvalue : stmt_function_handle",
"assign_stmt : tok_ASSIGN pre_label label tok_TO variable_name EOS",
"unconditional_goto : goto pre_label label EOS",
"computed_goto : goto '(' goto_list ')' integer_expr EOS",
"computed_goto : goto '(' goto_list ')' ',' integer_expr EOS",
"assigned_goto : goto symbolic_name EOS",
"assigned_goto : goto symbolic_name '(' goto_list ')' EOS",
"assigned_goto : goto symbolic_name ',' '(' goto_list ')' EOS",
"goto : tok_GOTO",
"goto : tok_GO tok_TO",
"goto_list : pre_label label",
"goto_list : goto_list ',' pre_label label",
"arithmetic_if_stmt : if_handle pre_label label ',' pre_label label ',' pre_label label EOS",
"logical_if_stmt : if_handle executable_stmt",
"block_if_stmt : if_handle tok_THEN EOS",
"$$15 :",
"if_handle : tok_IF '(' $$15 expr ')'",
"else_if_stmt : tok_ELSE block_if_stmt",
"$$16 :",
"$$17 :",
"else_if_stmt : tok_ELSEIF '(' $$16 expr ')' $$17 tok_THEN EOS",
"else_stmt : tok_ELSE EOS",
"end_if_stmt : tok_ENDIF EOS",
"end_if_stmt : tok_END tok_IF EOS",
"do_stmt : do_handle variable_name '=' do_loop_bounds EOS",
"$$18 :",
"do_stmt : do_handle tok_WHILE '(' $$18 expr ')' EOS",
"$$19 :",
"do_stmt : tok_DOWHILE '(' $$19 expr ')' EOS",
"do_handle : tok_DO pre_label label",
"do_handle : tok_DO pre_label label ','",
"do_handle : tok_DO pre_label",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr",
"do_loop_bounds : int_real_dp_expr ',' int_real_dp_expr ',' int_real_dp_expr",
"enddo_stmt : tok_END tok_DO EOS",
"enddo_stmt : tok_ENDDO EOS",
"continue_stmt : tok_CONTINUE EOS",
"stop_stmt : tok_STOP stop_info EOS",
"pause_stmt : tok_PAUSE stop_info EOS",
"stop_info :",
"stop_info : tok_integer_const",
"stop_info : symbolic_name",
"stop_info : tok_string",
"$$20 :",
"write_stmt : write_handle $$20 EOS",
"$$21 :",
"write_stmt : write_handle io_list $$21 EOS",
"$$22 :",
"write_handle : tok_WRITE $$22 '(' control_info_list ')'",
"read_stmt : read_handle '(' control_info_list ')' EOS",
"read_stmt : read_handle '(' control_info_list ')' io_list EOS",
"read_stmt : read_handle '(' control_info_list ')' ',' io_list EOS",
"read_stmt : read_handle format_id EOS",
"read_stmt : read_handle format_id ',' io_list EOS",
"read_handle : tok_READ",
"accept_stmt : tok_ACCEPT format_id EOS",
"accept_stmt : tok_ACCEPT format_id ',' io_list EOS",
"print_stmt : tok_PRINT format_id EOS",
"$$23 :",
"$$24 :",
"print_stmt : tok_PRINT format_id ',' $$23 io_list $$24 EOS",
"type_output_stmt : tok_TYPE format_id EOS",
"$$25 :",
"$$26 :",
"type_output_stmt : tok_TYPE format_id ',' $$25 io_list $$26 EOS",
"control_info_list : control_info_item",
"control_info_list : control_info_list ',' control_info_item",
"control_info_item : symbolic_name '=' unit_id",
"control_info_item : unit_id",
"open_info_list : unit_id",
"open_info_list : symbolic_name '=' unit_id",
"open_info_list : open_info_list ',' open_info_item",
"open_info_item : symbolic_name '=' unit_id",
"open_info_item : symbolic_name",
"io_list : io_item",
"io_list : io_list ',' io_item",
"io_item : expr",
"io_item : io_implied_do_list",
"io_implied_do_list : '(' io_list ',' variable_name '=' do_loop_bounds ')'",
"$$27 :",
"open_stmt : tok_OPEN $$27 '(' open_info_list ')' EOS",
"$$28 :",
"close_stmt : tok_CLOSE $$28 '(' control_info_list ')' EOS",
"$$29 :",
"inquire_stmt : tok_INQUIRE $$29 '(' control_info_list ')' EOS",
"backspace_stmt : backspace_handle unit_id EOS",
"backspace_stmt : backspace_handle '(' control_info_list ')' EOS",
"backspace_handle : tok_BACKSPACE",
"endfile_stmt : endfile_handle unit_id EOS",
"endfile_stmt : endfile_handle '(' control_info_list ')' EOS",
"endfile_handle : tok_ENDFILE",
"endfile_handle : tok_END tok_FILE",
"rewind_stmt : rewind_handle unit_id EOS",
"rewind_stmt : rewind_handle '(' control_info_list ')' EOS",
"rewind_handle : tok_REWIND",
"unit_id : expr",
"unit_id : '*'",
"format_id : char_expr",
"format_id : '*'",
"$$30 :",
"format_stmt : tok_FORMAT $$30 '(' format_spec ')' EOS",
"format_spec :",
"format_spec : nonempty_format_spec",
"nonempty_format_spec : fmt_spec_item",
"nonempty_format_spec : nonempty_format_spec fmt_spec_item",
"fmt_spec_item : repeatable_fmt_item",
"fmt_spec_item : unrepeatable_fmt_item",
"fmt_spec_item : fmt_item_separator",
"repeatable_fmt_item : '(' nonempty_format_spec ')'",
"repeatable_fmt_item : tok_edit_descriptor",
"unrepeatable_fmt_item : tok_string",
"unrepeatable_fmt_item : tok_hollerith",
"unrepeatable_fmt_item : repeat_spec",
"unrepeatable_fmt_item : variable_fmt_item",
"fmt_item_separator : ','",
"fmt_item_separator : '/'",
"fmt_item_separator : tok_concat",
"fmt_item_separator : ':'",
"fmt_item_separator : '.'",
"fmt_item_separator : nonstandard_fmt_item",
"nonstandard_fmt_item : '$'",
"repeat_spec : tok_integer_const",
"repeat_spec : '-' tok_integer_const",
"repeat_spec : '+' tok_integer_const",
"$$31 :",
"$$32 :",
"variable_fmt_item : '<' $$31 integer_expr $$32 '>'",
"stmt_function_handle : scalar_name '(' stmt_function_dummy_list ')'",
"stmt_function_dummy_list :",
"stmt_function_dummy_list : nonempty_stmt_fun_dummy_list",
"nonempty_stmt_fun_dummy_list : stmt_function_dummy_arg",
"nonempty_stmt_fun_dummy_list : nonempty_stmt_fun_dummy_list ',' stmt_function_dummy_arg",
"stmt_function_dummy_arg : variable_name",
"$$33 :",
"call_stmt : call_handle $$33 EOS",
"$$34 :",
"call_stmt : call_handle '(' ')' $$34 EOS",
"$$35 :",
"call_stmt : call_handle '(' expr_list ')' $$35 EOS",
"call_handle : tok_CALL symbolic_name",
"expr_list : expr",
"expr_list : '*' pre_label label",
"expr_list : expr_list ',' expr",
"expr_list : expr_list ',' '*' pre_label label",
"return_stmt : tok_RETURN EOS",
"return_stmt : tok_RETURN integer_expr EOS",
"function_reference : fun_or_substr_handle '(' fun_arg_list ')'",
"fun_or_substr_handle : scalar_name",
"fun_arg_list :",
"fun_arg_list : nonempty_fun_arg_list",
"nonempty_fun_arg_list : expr",
"nonempty_fun_arg_list : nonempty_fun_arg_list ',' expr",
"parameter_expr : expr",
"expr : log_expr",
"log_expr : log_disjunct",
"log_expr : expr tok_EQV log_disjunct",
"log_expr : expr tok_NEQV log_disjunct",
"log_disjunct : log_term",
"log_disjunct : log_disjunct tok_OR log_term",
"log_term : log_factor",
"log_term : log_term tok_AND log_factor",
"log_factor : log_primary",
"log_factor : tok_NOT log_primary",
"log_primary : arith_expr",
"log_primary : log_primary tok_relop log_primary",
"arith_expr : term",
"arith_expr : '-' term",
"arith_expr : '+' term",
"arith_expr : arith_expr '+' term",
"arith_expr : arith_expr '-' term",
"term : factor",
"term : term '/' factor",
"term : term '*' factor",
"factor : char_expr",
"factor : char_expr tok_power factor",
"char_expr : primary",
"char_expr : char_expr tok_concat primary",
"primary : variable_name",
"primary : array_element_name",
"primary : function_reference",
"primary : substring_name",
"primary : literal_const",
"primary : '(' expr ')'",
"literal_const : numeric_const",
"literal_const : tok_string",
"literal_const : tok_hollerith",
"literal_const : tok_logical_const",
"numeric_const : tok_integer_const",
"numeric_const : tok_real_const",
"numeric_const : tok_dp_const",
"numeric_const : tok_complex_const",
"numeric_const : tok_dcomplex_const",
"integer_expr : arith_expr",
"int_real_dp_expr : arith_expr",
"int_constant_expr : arith_expr",
"dim_bound_expr : arith_expr",
"array_element_lvalue : array_name '(' subscript_list ')'",
"array_element_name : array_name '(' subscript_list ')'",
"subscript_list : subscript",
"subscript_list : subscript_list ',' subscript",
"subscript : expr",
"substring_name : fun_or_substr_handle substring_interval",
"substring_name : array_element_name substring_interval",
"substring_lvalue : scalar_name substring_interval",
"substring_lvalue : array_element_lvalue substring_interval",
"substring_interval : '(' ':' ')'",
"substring_interval : '(' substr_index_expr ':' ')'",
"substring_interval : '(' ':' substr_index_expr ')'",
"substring_interval : '(' substr_index_expr ':' substr_index_expr ')'",
"substr_index_expr : arith_expr",
"variable_name : scalar_name",
"variable_name : array_name",
"scalar_name : tok_identifier",
"array_name : tok_array_identifier",
"symbolic_name : tok_identifier",
"symbolic_name : tok_array_identifier",
"data_constant : numeric_const",
"data_constant : '-' numeric_const",
"data_constant : '+' numeric_const",
"data_constant : tok_logical_const",
"data_constant : tok_string",
"data_constant : tok_hollerith",
"nonzero_unsigned_int_const : tok_integer_const",
"pre_label :",
"label : tok_integer_const",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 3333 "fortran.y"
void
init_parser()			/* Initialize various flags & counters */
{
	initial_flag = TRUE;	/* set flag for keyword test */
	implicit_flag=FALSE;	/* clear flags for IMPLICIT stmt */
	implicit_letter_flag = FALSE;
	implicit_type_given = FALSE;
	implicit_none = FALSE;
	global_save = FALSE;
	prev_token_class = EOS;
	complex_const_allowed = FALSE;
	stmt_sequence_no = 0;
	true_prev_stmt_line_num = 0;
        strcpy(new_subprogram_name,"__MAIN");
}

		/* Propagate non-integer type if any of DO loop
		   bounds are non-integer. */
PRIVATE int
do_bounds_type(t1,t2,t3)
     Token *t1, *t2, *t3;
{
  int result_class;
       if(datatype_of(t1->class) != type_INTEGER) result_class = t1->class;
  else if(datatype_of(t2->class) != type_INTEGER) result_class = t2->class;
  else if(datatype_of(t3->class) != type_INTEGER) result_class = t3->class;
  else result_class = t1->class;
  return result_class;
}


/* Debugging routine: prints the expression list of various productions */

PRIVATE void
print_exprlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s arglist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
  	    while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
	    }
	}
}

PRIVATE void
print_comlist(s,t)
	char *s;
	Token *t;
{

	fprintf(list_fd,"\n%s varlist: ",s);

	if(t == NULL)
		fprintf(list_fd,"(empty)");
	else {
  	    while( (t=t->next_token) != NULL) {
		  fprintf(list_fd,"%s ",type_name[datatype_of(t->class)]);
		  if( is_true(ID_EXPR,t->subclass) )
			fprintf(list_fd,"(%s) ",token_name(*t));
		}
	  }
}

/* After having parsed prog_stmt, function_stmt, subroutine_stmt,
   block_data_stmt, the stmt_sequence_no is set to the value SEQ_HEADER.
*/

void
check_seq_header(t)
     Token *t;
{
	if(stmt_sequence_no >= SEQ_HEADER) {
/*
	   syntax_error( (t == (Token *) NULL? line_num: t->line_num),
			NO_COL_NUM,
			"missing END statement inserted");
	   msg_tail( (t == (Token *) NULL? "at end of file":
		      "prior to statement") );
*/

	   crp_end_processing();
	   END_processing(t);
	}
	stmt_sequence_no = SEQ_HEADER;
}

void
check_stmt_sequence(t,seq_num)
     Token *t;
     int seq_num;
{
    if(stmt_sequence_no > seq_num) {
/*
	 syntax_error(t->line_num, NO_COL_NUM,
		      "Statement out of order.");
*/
    }
    else {
	stmt_sequence_no = seq_num;
    }
}

	/* After having parsed end_stmt, common block lists and
	   subprogram argument lists are copied over into global symbol
	   table, the local symbol table is printed out and then cleared,
	   and stmt_sequence_no is set to zero for start of next module.
	*/

extern int new_create_base;

PRIVATE void
END_processing(t)
	Token *t;
{
  crp_end_processing();
  if(current_module_hash != -1) {
	if(do_list && t != (Token *)NULL)
	    flush_line_out(t->line_num);
	check_loose_ends(current_module_hash);
	process_lists(current_module_hash);
/*
	debug_symtabs();
	print_loc_symbols(current_module_hash);
*/
	crp_print_loc_symbols(current_module_hash);
	init_symtab();
  }
  exec_stmt_count = 0;
  stmt_sequence_no = 0;
  current_module_hash = -1;
  implicit_type_given = FALSE;
  implicit_none = FALSE;
  true_prev_stmt_line_num = 0;
  integer_context = FALSE;
  global_save = FALSE;


  /*  Vider la sortie */

  implicit_NONE = FALSE;
  implicit_real8 = FALSE;
  subprogram_header = FALSE;
  continue_line = FALSE;

  line_implicit_real8 = (char *)0;
#ifdef CRP_11
  nbdolabel = 0;
#endif
  nbintrn = 0;
  g_nbextrn = 0;
}

		/* Routine to add token t to the front of a token list. */
PRIVATE Token *
append_token(tlist,t)
     Token *tlist, *t;
{
	Token *tcopy;
	if((tcopy=new_token()) == (Token *)NULL){
	  oops_message(OOPS_FATAL,line_num,NO_COL_NUM,
#ifdef LARGE_MACHINE
"Out of token space\nRecompile me with larger TOKENSPACESZ value"
#else
"Out of token space\nRecompile me with LARGE_MACHINE option"
#endif
		       );
	}

	*tcopy = *t;		/* make permanent copy of token */
	tcopy->next_token = tlist; /* link it onto front of list */
	return tcopy;		/* return it as new tlist */
}

#ifdef CRP_11
void ay_chk_transfer(id)
Token id;
{
    int i;
    for (i=0;i<nbdolabel;i++)
    {
	if ( id.value.integer == dolabel[i] )
	{
		printf("CRP_1002 routine %s ligne %u.\n      Un tranfert a un do label %d\n",
			new_subprogram_name, id.line_num-g_line_input, id.value.integer);
	    return;
	}
    }
}
#endif
#ifdef CKHEXTERNAL
ay_chk_external(id)
Token id;
{
   char name[8];
    int i;
  if ( !value_flag )
  {
    strcpy(name,token_name(id));
    for(i=0;i<g_nbextrn;i++)
    {
        if ( strcmp(name,g_extrn_name[i]) == 0 )
        {
	    printf("\nCRP_1000 %s : ligne %u col %u %s est declaree dans external\n", new_subprogram_name, line_num, col_num, name);
        }
    }
    for(i=0;i<nbintrn;i++)
    {
        if ( strcmp(name,intrn_name[i]) == 0 )
        {
	    printf("\nCRP_1001 %s : ligne %u col %u %s est declaree dans intrinsic\n", new_subprogram_name, line_num, col_num, name);
        }
    }
  }
}
#endif
#line 1749 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 284 "fortran.y"
{
				/* Create id token for prog if unnamed. */
			  if(current_module_hash == -1) {
			    implied_id_token(&(yyvsp[0]),unnamed_prog);
			    def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[0]),(Token*)NULL);
			    current_module_hash =
			      def_curr_module(&(yyvsp[0]));
			    current_module_type = type_PROGRAM;
			  }

					/* Handle END statement */
			  if(curr_stmt_class == tok_END) {
			    if(prev_stmt_class != tok_RETURN)
			      do_RETURN(current_module_hash,&(yyvsp[0]));
			    END_processing(&(yyval));
			    goto_flag = prev_goto = FALSE;
			  }
			  prev_stmt_class = curr_stmt_class;
			  integer_context = FALSE;
			  true_prev_stmt_line_num = yyval.line_num;
			}
break;
case 10:
#line 320 "fortran.y"
{
#ifdef CHECK_LABELS
			  def_label(&(yyvsp[-1]));
#endif
			  if(executable_stmt)
                          {
			    prev_goto = goto_flag;
                          }
			  if ( yyvsp[0].class != tok_CONTINUE && yyvsp[0].class != tok_FORMAT )
			  {
				syntax_error(yyvsp[-1].line_num, yyvsp[-1].col_num,
					g_message[9], "CRP_11");
			  }
			}
break;
case 11:
#line 335 "fortran.y"
{
			  if(executable_stmt) {
			    prev_goto = goto_flag;
			  }
			}
break;
case 12:
#line 343 "fortran.y"
{
			    exec_stmt_count = 0;
			    executable_stmt = FALSE;
			    implicit_real8 = FALSE;
			    subprogram_header = TRUE;
			    last_specification = yyvsp[0].line_num;
			}
break;
case 13:
#line 351 "fortran.y"
{
			    last_specification = yyvsp[0].line_num;
			    executable_stmt = FALSE;
			}
break;
case 14:
#line 356 "fortran.y"
{	/* handle statement functions correctly */
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[0].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN) {
			    stmt_sequence_no = SEQ_STMT_FUN;
			    executable_stmt = FALSE;
			  }
			  else {
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
                            if ( ! executable_stmt )
                            {
                                if ( !  implicit_NONE )
                                {
                                    int n;
                                    if ( (n = new_implicit_real8()) < 20 )
                                    {
				        syntax_error(yyvsp[0].line_num, 1,
				g_message[1], "CRP_3");
				        new_error_level = 4;
                                    }
				    else
				    {
					implicit_real8 = TRUE;
				    }
                                }
                            }
			    executable_stmt = TRUE;
			  }
			}
break;
case 15:
#line 386 "fortran.y"
{
			    stmt_sequence_no = SEQ_EXEC;
			    ++exec_stmt_count;
                            if ( ! executable_stmt )
                            {
                                if ( ! implicit_NONE )
                                {
				    int n;
                                    if ( (n= new_implicit_real8()) < 20 )
                                    {
				        syntax_error(yyvsp[0].line_num, 1,
				g_message[1], "CRP_3");
				        new_error_level = 4;
                                    }
				    else
				    {
					implicit_real8 = TRUE;
				    }
                                }
                            }
			    executable_stmt = TRUE;
			}
break;
case 16:
#line 409 "fortran.y"
{
			    executable_stmt = TRUE;
			    if(stmt_sequence_no == 0)
			      stmt_sequence_no = SEQ_HEADER;
			    complex_const_allowed = FALSE; /* turn off flags */
			    inside_format=FALSE;
			    integer_context = FALSE;
			    in_assignment_stmt = FALSE;
			    yyval.line_num = prev_stmt_line_num; /* best guess */
			    yyerrok; /* (error message already given) */
			}
break;
case 17:
#line 423 "fortran.y"
{
			    current_module_type = type_PROGRAM;
			}
break;
case 18:
#line 427 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			}
break;
case 19:
#line 431 "fortran.y"
{
			    current_module_type = type_SUBROUTINE;
			}
break;
case 20:
#line 435 "fortran.y"
{
			    current_module_type = type_BLOCK_DATA;
			}
break;
case 24:
#line 448 "fortran.y"
{
#ifdef ALLOW_INCLUDE
			  if(f77_standard) {
			      nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			  }
 			  open_include_file(yyvsp[-1].value.string);
#endif
 			}
break;
case 25:
#line 464 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				stmt_sequence_no = SEQ_IMPLICIT;
			     }
			}
break;
case 26:
#line 470 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_IMPLICIT) {
				   stmt_sequence_no = SEQ_IMPLICIT;
			     }
			     else if(stmt_sequence_no > SEQ_SPECIF) {
			       check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			     }
			}
break;
case 27:
#line 479 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_IMPLICIT);
			}
break;
case 28:
#line 483 "fortran.y"
{
			     if(stmt_sequence_no < SEQ_STMT_FUN) {
				stmt_sequence_no = SEQ_STMT_FUN;
		 	     }
			}
break;
case 29:
#line 489 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[0]),SEQ_SPECIF);
			}
break;
case 30:
#line 495 "fortran.y"
{
			     goto_flag = prev_goto = FALSE;
			}
break;
case 40:
#line 515 "fortran.y"
{
			    goto_flag=TRUE;
			}
break;
case 41:
#line 519 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 64:
#line 552 "fortran.y"
{
			    goto_flag=FALSE;
			}
break;
case 65:
#line 556 "fortran.y"
{
			    prev_goto = goto_flag =FALSE;
			}
break;
case 68:
#line 565 "fortran.y"
{	/* Flag DO w/o label or DO WHILE forms here */
			  if(is_true(NONSTD_USAGE_FLAG,yyvsp[0].subclass))
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
#endif
			}
break;
case 69:
#line 574 "fortran.y"
{
#ifdef ALLOW_DO_ENDO
			    if(f77_standard)
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
#endif
			}
break;
case 73:
#line 588 "fortran.y"
{check_seq_header(&(yyvsp[0]));}
break;
case 74:
#line 590 "fortran.y"
{
                            strcpy(new_subprogram_name,token_name(yyvsp[-1]));
                            g_line_input = yyvsp[-3].line_num - 1;
			     def_function(
				type_PROGRAM,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			     current_module_hash =
			       def_curr_module(&(yyvsp[-1]));
			}
break;
case 75:
#line 605 "fortran.y"
{
/*
                          strcpy(new_subprogram_name,token_name($2));
			  g_line_input = $1.line_num - 1;
*/
			  crp_ajout_new_sub(token_name(yyvsp[-1]));
			  do_ENTRY(&(yyvsp[-1]),(Token*)NULL
				   ,current_module_hash);
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[12], "CRP_15");
			    new_error_level = 4;
			}
break;
case 76:
#line 618 "fortran.y"
{
/*
			    g_line_input = $1.line_num - 1;
			    strcpy(new_subprogram_name,token_name($2));
*/
			}
break;
case 77:
#line 625 "fortran.y"
{
			  crp_ajout_new_sub(new_subprogram_name);
			  do_ENTRY(&(yyvsp[-5]),&(yyvsp[-2])
				   ,current_module_hash);
			    syntax_error(yyvsp[-6].line_num,yyvsp[-6].col_num,
				g_message[12], "CRP_15");
			    new_error_level = 4;
			}
break;
case 79:
#line 641 "fortran.y"
{
			  g_line_input = yyvsp[-2].line_num - 1;
			     if(f77_standard) {
				nonstandard(yyvsp[-1].line_num,
			     (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))));
				msg_tail(": parentheses required");
			     }
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-1]),(Token*)NULL);
			 current_module_hash=
			   def_curr_module(&(yyvsp[-1]));
                         strcpy(new_subprogram_name,token_name(yyvsp[-1]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 80:
#line 657 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			    strcpy(new_subprogram_name,token_name(yyvsp[0]));
			}
break;
case 81:
#line 662 "fortran.y"
{
			 def_function(
				current_datatype,current_typesize,
				      &(yyvsp[-5]),&(yyvsp[-2]));
			 current_module_hash=
			   def_curr_module(&(yyvsp[-5]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 82:
#line 671 "fortran.y"
{
			  g_line_input = yyvsp[-2].line_num - 1;
			     if(f77_standard) {
				nonstandard(yyvsp[-1].line_num,
			      (unsigned)(yyvsp[-1].col_num+strlen(token_name(yyvsp[-1]))));
				msg_tail(": parentheses required");
			     }
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-1]),(Token*)NULL);
			 current_module_hash=
			   def_curr_module(&(yyvsp[-1]));
                         strcpy(new_subprogram_name,token_name(yyvsp[-1]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 83:
#line 686 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			    strcpy(new_subprogram_name,token_name(yyvsp[0]));
			}
break;
case 84:
#line 691 "fortran.y"
{
			 def_function(
				type_UNDECL,size_DEFAULT,&(yyvsp[-5]),&(yyvsp[-2]));
			 current_module_hash=
			   def_curr_module(&(yyvsp[-5]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 87:
#line 707 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 89:
#line 714 "fortran.y"
{
			    
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_4");
			}
break;
case 92:
#line 734 "fortran.y"
{
                            g_line_input = yyvsp[-2].line_num - 1;
			  def_function(
				 type_SUBROUTINE,size_DEFAULT,
				       &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyvsp[-1]));
                         strcpy(new_subprogram_name,token_name(yyvsp[-1]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 93:
#line 745 "fortran.y"
{
			    g_line_input = yyvsp[-1].line_num - 1;
			    strcpy(new_subprogram_name,token_name(yyvsp[0]));
			}
break;
case 94:
#line 750 "fortran.y"
{
			  def_function(
				 type_SUBROUTINE,size_DEFAULT,&(yyvsp[-5]),&(yyvsp[-2]));
			  current_module_hash=
			    def_curr_module(&(yyvsp[-5]));
			 crp_ajout_new_sub(new_subprogram_name);
			}
break;
case 95:
#line 760 "fortran.y"
{
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 96:
#line 766 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			    g_argument_nb = 0;
			}
break;
case 97:
#line 771 "fortran.y"
{
			    g_argument_nb = def_arg_num+1;
			}
break;
case 98:
#line 777 "fortran.y"
{
			    def_arg_num = 0;
			    if ( normal_return )
			    {
			        strcpy(g_argument[0].name,token_name(yyvsp[0]));
			    }
			    else
			    {
			        strcpy(g_argument[0].name,"*");
			    }
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 99:
#line 790 "fortran.y"
{
			    def_arg_num++;
			    if ( normal_return )
			    {
			        strcpy(g_argument[def_arg_num].name,token_name(yyvsp[0]));
			    }
			    else
			    {
			        strcpy(g_argument[def_arg_num].name,"*");
			    }
			    if ( def_arg_num == MAX_PARM )
			    {
			        sprintf(new_char_val,g_message[18], MAX_PARM);
			        syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				  new_char_val, "CRP_21");
				        new_error_level = 4;
			    }
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 100:
#line 812 "fortran.y"
{
			     def_arg_name(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     normal_return = TRUE;
			}
break;
case 101:
#line 818 "fortran.y"
{
			     yyval.class = type_byte(class_LABEL,type_LABEL);
			     yyval.subclass = 0;
			     normal_return = FALSE;
			     syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				  g_message[7], "CRP_9");
				        new_error_level = 4;
			}
break;
case 102:
#line 832 "fortran.y"
{
				  /* form name %DATnn */
			  ++block_data_number;
			  sprintf(unnamed_block_data+4,"%02d"
				  ,block_data_number%100);
			  implied_id_token(&(yyval),unnamed_block_data);

			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyval),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyval));
                          strcpy(new_subprogram_name,"BLDT00");
                          g_line_input = yyvsp[-1].line_num - 1;
			}
break;
case 103:
#line 848 "fortran.y"
{
			  def_function(
				 type_BLOCK_DATA,size_DEFAULT,
				       &(yyvsp[-1]),(Token*)NULL);
			  current_module_hash=
			    def_curr_module(&(yyvsp[-1]));
                          strcpy(new_subprogram_name,token_name(yyvsp[-1]));
                          g_line_input = yyvsp[-2].line_num - 1;
			}
break;
case 104:
#line 860 "fortran.y"
{
			    syntax_error(yyvsp[-1].line_num,yyvsp[-1].col_num,
				g_message[13], "CRP_16");
			    new_error_level = 4;
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 105:
#line 867 "fortran.y"
{
			    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				g_message[13], "CRP_16");
			    new_error_level = 4;
			  check_seq_header(&(yyvsp[0]));
			}
break;
case 106:
#line 877 "fortran.y"
{
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[14], "CRP_17");
			    new_error_level = 4;
			}
break;
case 109:
#line 890 "fortran.y"
{
			     def_array_dim(&(yyvsp[-3]),&(yyvsp[-1]));
			     crp_set_length(&(yyvsp[-3]), yyvsp[-1].subclass);
		/* @@ */
			}
break;
case 110:
#line 899 "fortran.y"
{
			     yyval.class = 1;
			     yyval.subclass = yyvsp[0].subclass;
			}
break;
case 111:
#line 904 "fortran.y"
{
			     yyval.class = yyvsp[-2].class + 1; /* one more dimension */
			     yyval.subclass = yyvsp[-2].subclass * yyvsp[0].subclass;
			}
break;
case 112:
#line 911 "fortran.y"
{
			      if( datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.subclass = yyvsp[0].value.integer;
			      else
				yyval.subclass = 0;
			}
break;
case 113:
#line 919 "fortran.y"
{	/* avoid getting 0 - 0 + 1 = 1 if bounds nonconstant */
			      if( datatype_of(yyvsp[-2].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[-2].subclass)
				 && datatype_of(yyvsp[0].class) == type_INTEGER
				 && is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
			      {
				yyval.subclass = yyvsp[0].value.integer - yyvsp[-2].value.integer + 1;
			      }
			      else
				yyval.subclass = 0;
			}
break;
case 114:
#line 931 "fortran.y"
{
			     yyval.subclass = 0;
			}
break;
case 115:
#line 935 "fortran.y"
{
			     yyval.subclass = 0;
			}
break;
case 116:
#line 941 "fortran.y"
{equivalence_flag = TRUE;}
break;
case 117:
#line 943 "fortran.y"
{
			    equivalence_flag = FALSE;
			    syntax_error(yyvsp[-3].line_num,yyvsp[-3].col_num,
				g_message[15], "CRP_18");
			    new_error_level = 4;
			}
break;
case 120:
#line 956 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			}
break;
case 121:
#line 960 "fortran.y"
{
			  equivalence(&(yyvsp[-2]), &(yyvsp[0]));
			}
break;
case 122:
#line 967 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 123:
#line 971 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 124:
#line 975 "fortran.y"
{
			     def_equiv_name(&(yyvsp[0]));
			}
break;
case 128:
#line 990 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval), &(yyvsp[-1]));
			}
break;
case 130:
#line 996 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			     def_com_block(&(yyval),&(yyvsp[-2]));
			}
break;
case 131:
#line 1006 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			}
break;
case 132:
#line 1010 "fortran.y"
{
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			}
break;
case 133:
#line 1017 "fortran.y"
{g_entity_nb=0;}
break;
case 134:
#line 1018 "fortran.y"
{
			     def_com_block(&(yyvsp[-2]),&(yyvsp[0]));
			     yyval.subclass = yyvsp[0].subclass;
			     yyval.line_num = yyvsp[0].line_num;
			     yyval.col_num = yyvsp[0].col_num;
			     crp_mem_common(&(yyvsp[-2]));
			}
break;
case 135:
#line 1028 "fortran.y"
{
			     yyval = yyvsp[-1];
			}
break;
case 136:
#line 1033 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			}
break;
case 137:
#line 1037 "fortran.y"
{
			     implied_id_token(&(yyval),blank_com_name);
			}
break;
case 138:
#line 1043 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 139:
#line 1048 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			}
break;
case 140:
#line 1057 "fortran.y"
{			   /* no comma */
			     yyval.subclass = yyvsp[0].subclass;
			     make_false(COMMA_FLAG,yyval.subclass);
			}
break;
case 141:
#line 1062 "fortran.y"
{			   /* has comma */
			     yyval.subclass = yyvsp[-1].subclass;
			     make_true(COMMA_FLAG,yyval.subclass);
   			}
break;
case 142:
#line 1069 "fortran.y"
{
/* @@ */
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     crp_set_common_type(&(yyvsp[0]), &g_entity_nb, 1);
			}
break;
case 143:
#line 1076 "fortran.y"
{
			     def_com_variable(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     crp_set_common_type(&(yyvsp[0]), &g_entity_nb, yyvsp[0].subclass);
			}
break;
case 146:
#line 1094 "fortran.y"
{
			    yyval = yyvsp[0];
			}
break;
case 147:
#line 1100 "fortran.y"
{
			     def_namelist(&(yyvsp[-1]),&(yyvsp[0]));
			     yyval = yyvsp[0];
			}
break;
case 148:
#line 1107 "fortran.y"
{
			    yyval = yyvsp[-1];
			}
break;
case 149:
#line 1113 "fortran.y"
{
			     yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 150:
#line 1117 "fortran.y"
{
			    yyval.subclass = yyvsp[0].subclass;
			    yyval.line_num = yyvsp[0].line_num;
			    yyval.col_num = yyvsp[0].col_num;
			    yyval.next_token = append_token(yyvsp[-1].next_token,&(yyvsp[0]));
			}
break;
case 151:
#line 1126 "fortran.y"
{			   /* no comma */
			     def_namelist_item(&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[0]),&(yyval));
			     make_false(COMMA_FLAG,yyval.subclass);
			}
break;
case 152:
#line 1132 "fortran.y"
{			   /* has comma */
			     def_namelist_item(&(yyvsp[-1]));
			     primary_id_expr(&(yyvsp[-1]),&(yyval));
			     make_true(COMMA_FLAG,yyval.subclass);
			}
break;
case 154:
#line 1142 "fortran.y"
{
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_4");
			}
break;
case 157:
#line 1154 "fortran.y"
{
			  if ( current_datatype == type_REAL )
			  {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_4");
			  }
			  else if ( current_datatype == type_COMPLEX )
			  {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_4");
			  }
		/*
		     A. Y le 13/01/95

		     ANOMALIE AGLA_01
		     ----------------
		     La modification ci-dessosu est introduite pour corriger un
		     bug dans FTNCHEK qui attribue la taille par DEFAUT a une
		     variable lorsque le premier caractere de celle ci coincidee
		     avec l'un des caracteres declares dans IMPLICIT.

			  current_typesize = size_DEFAULT;

		     La ligne ci-dessus entraine une anomalie. Elle est remplacee
		     par la ligne ci-dessous.

		*/
	                   current_typesize = type_size[current_datatype];

			}
break;
case 158:
#line 1192 "fortran.y"
{
			    current_typesize = yyvsp[0].value.integer;
			    if ( current_datatype == type_COMPLEX )
			    {
			     if ( current_typesize != 16 )
			     {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_4");
			      }
			    }
			    if ( current_datatype == type_REAL )
			    {
                              if ( current_typesize != 8 )
			      {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_4");
			      }
			    }
			    if ( current_datatype == type_INTEGER )
			    {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_4");
			    }
			    if ( current_datatype == type_LOGICAL )
			    {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_4");
			    }
			    
#if 0 /* defunct feature */
			    if(local_wordsize > 0) {
			      /*  recognize REAL*2w as DOUBLE PRECISION */
			      if(current_datatype == type_REAL
				 && yyvsp[0].value.integer == type_size[type_DP])
                              {
				current_datatype = type_DP;
                              }
			      /*  recognize COMPLEX*4w as DOUBLE COMPLEX */
			      if(current_datatype == type_COMPLEX
				 && yyvsp[0].value.integer==type_size[type_DCOMPLEX])
				current_datatype = type_DCOMPLEX;
			    }
#endif
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			}
break;
case 159:
#line 1253 "fortran.y"
{
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[2],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_4");
			}
break;
case 160:
#line 1263 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     integer_context = TRUE;
			}
break;
case 161:
#line 1268 "fortran.y"
{
			     current_datatype = type_REAL;
			     integer_context = TRUE;
			}
break;
case 162:
#line 1273 "fortran.y"
{
			     current_datatype = type_COMPLEX;
			     integer_context = TRUE;
			}
break;
case 163:
#line 1278 "fortran.y"
{
			     current_datatype = type_LOGICAL;
			     integer_context = TRUE;
			}
break;
case 164:
#line 1285 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
                             
			}
break;
case 165:
#line 1291 "fortran.y"
{
			     current_datatype = type_DP;
			     current_typesize = size_DEFAULT;
			}
break;
case 166:
#line 1296 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			}
break;
case 167:
#line 1304 "fortran.y"
{
			     current_datatype = type_DCOMPLEX;
			     current_typesize = size_DEFAULT;
			     if(f77_standard) {
				nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			     }
			}
break;
case 168:
#line 1312 "fortran.y"
{
			     current_datatype = type_INTEGER;
			     current_typesize = 1;
			     if(f77_standard)
			       nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			}
break;
case 169:
#line 1321 "fortran.y"
{
			     current_datatype = type_STRING;
			     current_typesize = 1;
			     integer_context = TRUE;
			}
break;
case 170:
#line 1329 "fortran.y"
{
			     current_typesize = yyvsp[0].value.integer;
			}
break;
case 173:
#line 1339 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 174:
#line 1344 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
			}
break;
case 177:
#line 1355 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
/*
			     if ( len_specification_nook )
			     {
				if ( crp_is_argument(token_name($1), def_arg_num) )
				{
				    syntax_error($1.line_num,$1.col_num,
				         "Chaine de caractere en parametre mal declaree.\n",
				    "CRP_8888");
				}
			     }
*/
			}
break;
case 178:
#line 1371 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
/*
			     if ( len_specification_nook )
			     {
				if ( crp_is_argument(token_name($1), def_arg_num) )
				{
				    syntax_error($1.line_num,$1.col_num,
				         "Chaine de caractere en parametre mal declaree.\n",
					"CRP_8888");
				}
			     }
*/
			}
break;
case 179:
#line 1387 "fortran.y"
{
			     declare_type(&(yyvsp[0]),
					  current_datatype,current_typesize);
/*
			     if ( len_specification_nook )
			     {
				if ( crp_is_argument(token_name($1), def_arg_num) )
				{
				    syntax_error($1.line_num,$1.col_num,
				         "Chaine de caractere en parametre mal declaree.\n",
				    "CRP_8888");
				}
			     }
*/
			}
break;
case 180:
#line 1403 "fortran.y"
{
			     declare_type(&(yyvsp[-2]),
					  current_datatype,yyvsp[0].value.integer);
/*
			     if ( len_specification_nook )
			     {
				if ( crp_is_argument(token_name($1), def_arg_num) )
				{
				    syntax_error($1.line_num,$1.col_num,
				         "Chaine de caractere en parametre mal declaree.\n",
				    "CRP_8888");
				}
			     }
*/
			}
break;
case 181:
#line 1422 "fortran.y"
{implicit_flag=TRUE;}
break;
case 182:
#line 1426 "fortran.y"
{
			    implicit_flag=FALSE;
			    if(implicit_none) {
/*
				syntax_error($1.line_num,$1.col_num,
				     "conflicts with IMPLICIT NONE","",NULL);
*/
			    }
			    else {
				implicit_type_given = TRUE;
			    }
			}
break;
case 183:
#line 1440 "fortran.y"
{
                            /* Implicit none est trouve. */
			    implicit_flag=FALSE;
                            implicit_NONE = TRUE;
                            if ( line_implicit_real8 )
                            {
                                /* Plus besoin d'inserer implicit real*8 */
				*ind_implicit_real8 = '\0';
                            }
				if(implicit_type_given) {
/*
				    syntax_error($1.line_num,$1.col_num,
					 "conflicts with IMPLICIT statement","",NULL);
*/
				}
				else {
				    if(f77_standard)
				      nonstandard(yyvsp[-1].line_num,yyvsp[-1].col_num);
				    implicit_none = TRUE;
				}
			}
break;
case 185:
#line 1464 "fortran.y"
{initial_flag = TRUE;}
break;
case 187:
#line 1470 "fortran.y"
{implicit_letter_flag = TRUE;}
break;
case 188:
#line 1472 "fortran.y"
{
			    implicit_letter_flag = FALSE;
			}
break;
case 191:
#line 1482 "fortran.y"
{
			  int c1 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1))) {
			    nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			    msg_tail(": nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
			     		c1,c1);
			}
break;
case 192:
#line 1494 "fortran.y"
{
			  int c1 = (int)yyvsp[-2].subclass,
			      c2 = (int)yyvsp[0].subclass;
#if  ALLOW_DOLLARSIGNS || ALLOW_UNDERSCORES
			  if(f77_standard && (!isalpha(c1) || !isalpha(c2))) {
			    if(!isalpha(c1))
			      nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			    else
			      nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			    msg_tail("nonalphabetic character");
			  }
#endif
			   set_implicit_type(current_datatype,current_typesize,
					c1,c2);
			}
break;
case 193:
#line 1514 "fortran.y"
{yyval.value.integer = size_ADJUSTABLE;len_specification_nook=FALSE;}
break;
case 194:
#line 1516 "fortran.y"
{yyval.value.integer = yyvsp[0].value.integer;len_specification_nook=TRUE;}
break;
case 195:
#line 1518 "fortran.y"
{
			      if((yyval.value.integer = yyvsp[-1].value.integer) <= 0 ){
				warning(yyvsp[-1].line_num,yyvsp[-1].col_num,
					"invalid length specification");
				msg_tail(": substituting 1");
				yyval.value.integer = 1;
			        len_specification_nook=TRUE;
			      }
			    }
break;
case 199:
#line 1537 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 200:
#line 1539 "fortran.y"
{
			     def_parameter(&(yyvsp[-3]),&(yyvsp[0]));
			     primary_id_expr(&(yyvsp[-3]),&(yyvsp[-3]));
			     assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-1]),&(yyvsp[0]));
			     complex_const_allowed = FALSE;
			}
break;
case 201:
#line 1549 "fortran.y"
{
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[5], "CRP_7");
			    new_error_level = 4;
			}
break;
case 202:
#line 1557 "fortran.y"
{
                             if ( g_nbextrn < MAX_XTERNAL )
                             {
			         strcpy(g_extrn_name[g_nbextrn], token_name(yyvsp[0]));
			         g_nbextrn++;
			     }
			     def_ext_name(&(yyvsp[0]));
			}
break;
case 203:
#line 1566 "fortran.y"
{
			     if ( g_nbextrn < MAX_XTERNAL )
			     {
			         strcpy(g_extrn_name[g_nbextrn], token_name(yyvsp[0]));
			         g_nbextrn++;
			     }
			     def_ext_name(&(yyvsp[0]));
			}
break;
case 204:
#line 1578 "fortran.y"
{
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[16], "CRP_19");
			    new_error_level = 4;
			}
break;
case 205:
#line 1586 "fortran.y"
{
			     if ( nbintrn < MAX_XTERNAL )
			     {
			         strcpy(intrn_name[nbintrn], token_name(yyvsp[0]));
			         nbintrn++;
			     }
			     def_intrins_name(&(yyvsp[0]));
			}
break;
case 206:
#line 1595 "fortran.y"
{
			     if ( nbintrn < MAX_XTERNAL )
			     {
			         strcpy(intrn_name[nbintrn], token_name(yyvsp[0]));
			         nbintrn++;
			     }
			     def_intrins_name(&(yyvsp[0]));
			}
break;
case 207:
#line 1607 "fortran.y"
{
			  global_save = TRUE;
			}
break;
case 211:
#line 1618 "fortran.y"
{
			     save_variable(&(yyvsp[0]));
			}
break;
case 212:
#line 1622 "fortran.y"
{
/***			     def_com_block(&($2),(Token*)NULL);***/
			     save_com_block(&(yyvsp[-1]));
			}
break;
case 217:
#line 1638 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 218:
#line 1640 "fortran.y"
{complex_const_allowed=FALSE;}
break;
case 222:
#line 1649 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			}
break;
case 229:
#line 1665 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			}
break;
case 231:
#line 1672 "fortran.y"
{
			     use_parameter(&(yyvsp[0]));
			}
break;
case 234:
#line 1683 "fortran.y"
{
			     use_lvalue(&(yyvsp[0]));
			}
break;
case 236:
#line 1691 "fortran.y"
{
			    use_implied_do_index(&(yyvsp[-3]));
			}
break;
case 239:
#line 1702 "fortran.y"
{complex_const_allowed = TRUE;
				    in_assignment_stmt = TRUE;}
break;
case 240:
#line 1704 "fortran.y"
{
			  assignment_stmt_type(&(yyvsp[-3]),&(yyvsp[-2]),
					&(yyvsp[0]));
			  complex_const_allowed = FALSE;
			  in_assignment_stmt = FALSE;
			}
break;
case 241:
#line 1711 "fortran.y"
{
				/* Clear u-b-s flags spuriously set */
			  if(is_true(STMT_FUNCTION_EXPR, yyvsp[-5].subclass)
				     && stmt_sequence_no <= SEQ_STMT_FUN)
			     stmt_function_stmt(&(yyvsp[-5]));
		        }
break;
case 246:
#line 1729 "fortran.y"
{
			    do_ASSIGN(&(yyvsp[-1]));
			}
break;
case 247:
#line 1737 "fortran.y"
{
#ifdef CRP_11
			    ay_chk_transfer(yyvsp[-1]);
#endif
			}
break;
case 250:
#line 1751 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-1]));
			}
break;
case 251:
#line 1755 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-4]));
			}
break;
case 252:
#line 1759 "fortran.y"
{
			     do_assigned_GOTO(&(yyvsp[-5]));
			}
break;
case 253:
#line 1765 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 254:
#line 1769 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 255:
#line 1775 "fortran.y"
{
#ifdef CRP_11
			    ay_chk_transfer(yyvsp[0]);
#endif
			}
break;
case 256:
#line 1781 "fortran.y"
{
#ifdef CRP_11
			    ay_chk_transfer(yyvsp[0]);
#endif
			}
break;
case 257:
#line 1791 "fortran.y"
{
#ifdef CRP_11
			    ay_chk_transfer(yyvsp[-7]);
			    ay_chk_transfer(yyvsp[-4]);
			    ay_chk_transfer(yyvsp[-1]);
#endif
/*
			  int t=datatype_of($1.class);
			  if(t != type_INTEGER && t != type_REAL
			     && t != type_DP && t != type_ERROR ) {
			    syntax_error($1.line_num,$1.col_num,
		  "integer, real, or double precision expression required");
			  }
*/
			}
break;
case 258:
#line 1810 "fortran.y"
{
/*
			  int t=datatype_of($1.class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error($1.line_num,$1.col_num,
					  "logical expression required");
*/
			}
break;
case 259:
#line 1822 "fortran.y"
{
/*
			  int t=datatype_of($1.class);
			  if(t != type_LOGICAL && t != type_ERROR)
			     syntax_error($1.line_num,$1.col_num,
					  "logical expression required");
*/
			}
break;
case 260:
#line 1832 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 261:
#line 1833 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;	/* for is_keyword */
			    yyval = yyvsp[-1]; /* Inherit expr for type checking above */
			}
break;
case 263:
#line 1846 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 264:
#line 1847 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			    complex_const_allowed = FALSE;

			    initial_flag = TRUE;
			}
break;
case 269:
#line 1877 "fortran.y"
{
			     use_lvalue(&(yyvsp[-3]));
			     use_variable(&(yyvsp[-3]));

				/* Check for non-integer DO index or bounds */
/*
			     if(datatype_of($2.class) == type_INTEGER
				&& datatype_of($4.class) != type_INTEGER)
			       warning($3.line_num,$3.col_num,
				  "type mismatch between DO index and bounds");

			     else if(datatype_of($2.class) != type_INTEGER)
			       if(datatype_of($4.class) != type_INTEGER) {
				 if(port_check)
				   nonportable($4.line_num,$4.col_num,
					       "non-integer DO loop bounds");
			       }
			       else {
				 if(trunc_check)
				   warning($2.line_num,$2.col_num,
					   "DO index is not integer");
			       }
*/
			}
break;
case 270:
#line 1902 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 271:
#line 1903 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			}
break;
case 272:
#line 1911 "fortran.y"
{complex_const_allowed=TRUE;}
break;
case 273:
#line 1912 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[-2].subclass)){
				use_variable(&(yyvsp[-2]));
			    }
			    complex_const_allowed=FALSE;
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			}
break;
case 274:
#line 1922 "fortran.y"
{
#ifdef CRP_11
			    dolabel[nbdolabel++] = yyvsp[0].value.integer;
#endif
			}
break;
case 275:
#line 1928 "fortran.y"
{
#ifdef CRP_11
			    dolabel[nbdolabel++] = yyvsp[-1].value.integer;
#endif
			}
break;
case 276:
#line 1934 "fortran.y"
{
			    make_true(NONSTD_USAGE_FLAG,yyval.subclass);
			    integer_context=FALSE;
			}
break;
case 277:
#line 1941 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-2]),&(yyvsp[0]),&(yyvsp[0]));
			}
break;
case 278:
#line 1945 "fortran.y"
{
			    yyval.class=do_bounds_type(&(yyvsp[-4]),&(yyvsp[-2]),&(yyvsp[0]));
			}
break;
case 282:
#line 1960 "fortran.y"
{
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[10], "CRP_12");
			    new_error_level = 4;
			}
break;
case 286:
#line 1974 "fortran.y"
{
			     use_variable(&(yyvsp[0]));
			}
break;
case 288:
#line 1982 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 290:
#line 1984 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 292:
#line 1987 "fortran.y"
{control_item_count = 0;}
break;
case 293:
#line 1989 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 299:
#line 2002 "fortran.y"
{control_item_count = 0;}
break;
case 300:
#line 2006 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			}
break;
case 301:
#line 2011 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-4].line_num,yyvsp[-4].col_num);
			}
break;
case 303:
#line 2020 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 304:
#line 2021 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 306:
#line 2025 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-2].line_num,yyvsp[-2].col_num);
			}
break;
case 307:
#line 2030 "fortran.y"
{complex_const_allowed = TRUE;}
break;
case 308:
#line 2031 "fortran.y"
{complex_const_allowed = FALSE;}
break;
case 309:
#line 2032 "fortran.y"
{
			    if(f77_standard)
				nonstandard(yyvsp[-6].line_num,yyvsp[-6].col_num);
			}
break;
case 310:
#line 2040 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 311:
#line 2044 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 312:
#line 2053 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			}
break;
case 313:
#line 2057 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
					/* WRITE(string,...) means store
					   output in the string */
				if(curr_stmt_class == tok_WRITE
				 && control_item_count == 0
				 && datatype_of(yyvsp[0].class) == type_STRING)
				    use_lvalue(&(yyvsp[0]));
					/* READ/WRITE(..,namelist) means
					   I/O with variables of namelist. */
				else if( control_item_count == 1
				    && datatype_of(yyvsp[0].class) == type_NAMELIST)
				    ref_namelist(&(yyvsp[0]),curr_stmt_class);

				use_variable(&(yyvsp[0]));
			    }
			}
break;
case 314:
#line 2083 "fortran.y"
{
			    if( yyvsp[0].class != '*'
			       && is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    ++control_item_count;
			}
break;
case 315:
#line 2091 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			    ++control_item_count;
			}
break;
case 316:
#line 2096 "fortran.y"
{
			    ++control_item_count;
			}
break;
case 317:
#line 2102 "fortran.y"
{
			    use_io_keyword(&(yyvsp[-2]),&(yyvsp[0]),curr_stmt_class);
			}
break;
case 318:
#line 2106 "fortran.y"
{
			    use_special_open_keywd(&(yyvsp[0]));
			}
break;
case 321:
#line 2117 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				if( curr_stmt_class == tok_READ ||
				    curr_stmt_class == tok_ACCEPT )
				    use_lvalue(&(yyvsp[0]));
				else
				    use_variable(&(yyvsp[0]));
			    }
			}
break;
case 323:
#line 2131 "fortran.y"
{
			     use_implied_do_index(&(yyvsp[-3]));
			}
break;
case 324:
#line 2137 "fortran.y"
{control_item_count = 0;}
break;
case 326:
#line 2142 "fortran.y"
{control_item_count = 0;}
break;
case 328:
#line 2147 "fortran.y"
{control_item_count = 0;}
break;
case 330:
#line 2153 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 332:
#line 2161 "fortran.y"
{control_item_count = 0;}
break;
case 333:
#line 2166 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 335:
#line 2174 "fortran.y"
{control_item_count = 0;}
break;
case 336:
#line 2175 "fortran.y"
{control_item_count = 0;}
break;
case 337:
#line 2180 "fortran.y"
{
			    if( yyvsp[-1].class != '*'
			       && is_true(ID_EXPR,yyvsp[-1].subclass)){
				use_variable(&(yyvsp[-1]));
			    }
			}
break;
case 339:
#line 2188 "fortran.y"
{control_item_count = 0;}
break;
case 342:
#line 2202 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
			}
break;
case 344:
#line 2211 "fortran.y"
{inside_format=TRUE;}
break;
case 345:
#line 2212 "fortran.y"
{
			  inside_format=FALSE;
			}
break;
case 364:
#line 2248 "fortran.y"
{
			  if(f77_standard)
			     nonstandard(yyvsp[0].line_num,yyvsp[0].col_num);
			}
break;
case 369:
#line 2263 "fortran.y"
{inside_format=FALSE;}
break;
case 370:
#line 2264 "fortran.y"
{inside_format=TRUE;}
break;
case 371:
#line 2265 "fortran.y"
{
			  if(f77_standard)
			     nonstandard(yyvsp[-4].line_num,yyvsp[-4].col_num);
			}
break;
case 372:
#line 2274 "fortran.y"
{
			  check_stmt_sequence(&(yyvsp[-3]),SEQ_STMT_FUN);

				def_stmt_function(&(yyvsp[-3]),&(yyvsp[-1]));
			        crp_stmt_function(token_name(yyvsp[-3]));
					/* make token info */
				primary_id_expr(&(yyvsp[-3]),&(yyval));
#ifdef DEBUG_PARSER
				if(debug_parser)
				  print_exprlist("stmt function",&(yyvsp[-1]));
#endif
			}
break;
case 373:
#line 2289 "fortran.y"
{
			    yyval.next_token = (Token*)NULL;
			}
break;
case 375:
#line 2296 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 376:
#line 2301 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 378:
#line 2311 "fortran.y"
{
			     int iret, subr_flag;
#ifdef DEBUG_PARSER
				  printf("call_handle\n");
#endif
			     iret = call_subr(&(yyvsp[0]),(Token*)NULL,def_arg_num);
			     complex_const_allowed = FALSE;
                             if ( iret != OK )
                             {
			         if ( iret == TOLEUTILICRA )
			         {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[4],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_6");
			         }
                                 else if ( iret == NOOK )
			         {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[28],
			                  subprog_level->subprogram_name,
					  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
                                        new_char_val, "CRP_998");
			             }
                  }
			         if ( iret != OK_ARG )
			         {
			             crp_inter_routine(
					subprog_level->subprogram_name,
					0,
				        subprog_level->argument,
					type_SUBROUTINE,0,
					yyvsp[0].line_num, yyvsp[0].col_num);
			         }
			}
break;
case 379:
#line 2348 "fortran.y"
{free(subprog_level);}
break;
case 380:
#line 2351 "fortran.y"
{
			   int iret, subr_flag;
#ifdef DEBUG_PARSER
				  printf("call_handle()\n");
#endif
			   iret = call_subr(&(yyvsp[-2]),(Token*)NULL, def_arg_num);
			   complex_const_allowed = FALSE;
                           if ( iret != OK )
                           {
			         if ( iret == TOLEUTILICRA )
			         {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[4],
			                  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_6");
			         }
                                 else if ( iret == NOOK )
			         {
				    new_error_level = 4;
                                    sprintf(new_char_val, g_message[28],
			                  subprog_level->subprogram_name,
					  subprog_level->subprogram_name);
                                    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
                                        new_char_val, "CRP_998");
			         }
                            }
			         if ( iret != OK_ARG )
			         {
			            crp_inter_routine(
					subprog_level->subprogram_name,
					0,
				        subprog_level->argument,
					type_SUBROUTINE,0,
					yyvsp[-2].line_num, yyvsp[-2].col_num);
			         }
			}
break;
case 381:
#line 2388 "fortran.y"
{free(subprog_level);}
break;
case 382:
#line 2391 "fortran.y"
{
			     int iret, subr_flag;
			     iret = call_subr(&(yyvsp[-3]),&(yyvsp[-1]), def_arg_num);
#ifdef DEBUG_PARSER
			     if (debug_parser)
				     print_exprlist("call stmt",&(yyvsp[-1]));
			     if (debug_parser) printf("\ncall_subr(%s)=%d",yyvsp[-3],iret);
#endif
			     complex_const_allowed = FALSE;
              if ( iret != OK ) {
			        if ( iret == TOLEUTILICRA ) {
				         new_error_level = 4;
                     sprintf(new_char_val, g_message[4],
			            subprog_level->subprogram_name);
                     syntax_error(yyvsp[-3].line_num,yyvsp[-3].col_num,new_char_val, "CRP_6");
			            }
                  else if ( iret == NOOK ) {
				         new_error_level = 4;
                     sprintf(new_char_val, g_message[28],
			            subprog_level->subprogram_name,
					      subprog_level->subprogram_name);
                     syntax_error(yyvsp[-3].line_num,yyvsp[-3].col_num,new_char_val, "CRP_998");
			            }
                  }
			      if ( iret != OK_ARG ) {
			         crp_inter_routine(
					      subprog_level->subprogram_name,
					      subprog_level->call_arg_num+1,
				         subprog_level->argument,
					      type_SUBROUTINE,0,
					      yyvsp[-3].line_num, yyvsp[-3].col_num);
			         }
			}
break;
case 383:
#line 2424 "fortran.y"
{free(subprog_level);}
break;
case 384:
#line 2428 "fortran.y"
{
			     complex_const_allowed = TRUE;
			     subprog_level = (crp_sblevel *)malloc(sizeof(crp_sblevel));
                             subprog_level->prev = NULL;
			     yyval = yyvsp[0];
			     strcpy(subprog_level->subprogram_name,token_name(yyvsp[0]));
			     
			}
break;
case 385:
#line 2438 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
#ifdef CHKEXTERNAL
			    ay_chk_external(yyvsp[0]);
#endif
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			    subprog_level->call_arg_num = 0;
                            
			    crp_actual_arg_set(subprog_level->argument,
				subprog_level->call_arg_num, &(yyvsp[0]), !value_flag);
                            
			    if ( value_flag && crp_is_normal(subprog_level->subprogram_name) )
			    {
				int ret, line_num;
				char *sub_name;
				if ( (ret = crp_value_violation(
					subprog_level->subprogram_name,
					subprog_level->call_arg_num,
					&sub_name, &line_num)) == 8 )
				{
                                    warning(yyvsp[0].line_num,yyvsp[0].col_num,
                                        "No de param a l'appel depasse le nombre de param su sous programme.\n");
				}
				else
			        {
				  if ( ret & 1 )
				  {
				    new_error_level = 4;
                                    sprintf(new_char_val,
                              g_message[26], subprog_level->call_arg_num+1,
			      (subprog_level->call_arg_num==0)?"er":"eme",
			      subprog_level->subprogram_name,sub_name,line_num);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num, new_char_val, "CRP_200");
				  }
				}
			    }
			}
break;
case 386:
#line 2479 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			    subprog_level->call_arg_num = 0;
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				  g_message[6], "CRP_8");
				        new_error_level = 4;
			    crp_actual_labelarg_set(subprog_level->argument,
				subprog_level->call_arg_num, &(yyvsp[-2]) );
			}
break;
case 387:
#line 2489 "fortran.y"
{
#ifdef CHKEXTERNAL
			    ay_chk_external(yyvsp[0]);
#endif
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_actual_arg(&(yyvsp[0]));
				 use_variable(&(yyvsp[0]));
			    }
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			    subprog_level->call_arg_num++;
			    crp_actual_arg_set(subprog_level->argument,
				subprog_level->call_arg_num, &(yyvsp[0]),!value_flag);
/* inhiber apres appel de Jacques le 06/10
			    if ( subprog_level->call_arg_num == MAX_PARM )
			    {
			        sprintf(new_char_val,g_message[18], MAX_PARM);
			        syntax_error($3.line_num,$3.col_num,
				  new_char_val, "CRP_21");
				        new_error_level = 4;
			    }
*/
			    if ( value_flag && crp_is_normal(subprog_level->subprogram_name)) 
                            { 
			      int ret, line_num;
			      char *sub_name;
                              if ( (ret=crp_value_violation(
					subprog_level->subprogram_name,
					subprog_level->call_arg_num,
					&sub_name, &line_num)) == 8 ) 
			      {
                                    warning(yyvsp[0].line_num,yyvsp[0].col_num,
                                        "No de param a l'appel depasse le nombre de param su sous programme.\n");
			      }
			      else
			      {
				if ( ret & 1 )
                                {  
                                    sprintf(new_char_val, g_message[26],
				subprog_level->call_arg_num+1,
				(subprog_level->call_arg_num==0)?"er":"eme",
				subprog_level->subprogram_name,sub_name,line_num);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num, new_char_val, "CRP_200");
				    new_error_level = 4;
                                }  
/*
				if ( ret & 2 )
				{
                                    sprintf(new_char_val,
                                        "Violation de longueur de la chaine au %d%s parametre de %s.",
					subprog_level->call_arg_num+1,
					(subprog_level->call_arg_num+1 == 1)?"er":"eme",
					subprog_level->subprogram_name);
                                    syntax_error($3.line_num,$3.col_num,
                                        new_char_val, "", NULL);
				    new_error_level = 4;
				}
*/
                               }
                            }
			}
break;
case 388:
#line 2550 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-4].next_token,&(yyvsp[0]));
			    subprog_level->call_arg_num++;
/* inhiber apres appel de Jacques le 06/10
			    if ( subprog_level->call_arg_num == MAX_PARM )
			    {
			        sprintf(new_char_val,g_message[18], MAX_PARM);
			        syntax_error($3.line_num,$3.col_num,
				  new_char_val, "CRP_21");
				        new_error_level = 4;
			    }
*/
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				  g_message[6], "CRP_8");
				        new_error_level = 4;
			    crp_actual_labelarg_set(subprog_level->argument,
				subprog_level->call_arg_num,&(yyvsp[-2]));
			}
break;
case 389:
#line 2572 "fortran.y"
{ 
			    syntax_error(yyvsp[-1].line_num,yyvsp[-1].col_num,
				g_message[11], "CRP_14");
			    new_error_level = 4;
			     do_RETURN(current_module_hash,&(yyvsp[-1]));
			}
break;
case 390:
#line 2579 "fortran.y"
{
			    syntax_error(yyvsp[-2].line_num,yyvsp[-2].col_num,
				g_message[11], "CRP_14");
			    new_error_level = 4;
			     do_RETURN(current_module_hash,&(yyvsp[-2]));
			}
break;
case 391:
#line 2589 "fortran.y"
{
			int iret, func_flag;
#ifdef DEBUG_PARSER
			printf("fun_or_substr_handle()\n");
#endif
			/* restore context */
			if (!is_true(COMPLEX_FLAG,yyvsp[-3].subclass))
			    complex_const_allowed=FALSE;
			if (is_true(IN_ASSIGN,yyvsp[-3].subclass))
			   in_assignment_stmt = TRUE;

			/* Change empty arg list to no arg list */
			if (yyvsp[-1].next_token == NULL) {
			   iret = call_func(&(yyvsp[-3]),(Token *)NULL,def_arg_num);
                           }
			else {
			   iret = call_func(&(yyvsp[-3]),&(yyvsp[-1]), def_arg_num);
                           }
			/* make token info */
			crp_func_ref_expr(subprog_level->subprogram_name,&(yyvsp[-1]),&(yyval));
                        if ( iret != OK ) {
			   if ( iret == TOLEUTILICRA ){
			      new_error_level = 4;
                              sprintf(new_char_val, g_message[4],
			                  subprog_level->subprogram_name);
                              syntax_error(yyvsp[-3].line_num,yyvsp[-3].col_num,
                                        new_char_val, "CRP_6");
			      }
                            else if ( iret == NOOK ) {
			       new_error_level = 4;
                               sprintf(new_char_val, g_message[28],
			                  subprog_level->subprogram_name,
					  subprog_level->subprogram_name);
                               syntax_error(yyvsp[-3].line_num,yyvsp[-3].col_num,
                                        new_char_val, "CRP_998");
			       }
             }
			 if ( iret != OK_ARG ) {
			    crp_inter_routine (
				     subprog_level->subprogram_name,
				     subprog_level->call_arg_num+1,
				     subprog_level->argument,
				     yyvsp[-3].class, yyvsp[-3].size,
				     yyvsp[-3].line_num, yyvsp[-3].col_num);
			    }
			 subprog_level0 = subprog_level->prev;
                         free(subprog_level);
                         subprog_level= subprog_level0;
			 }
break;
case 392:
#line 2641 "fortran.y"
{
			  if(complex_const_allowed)/* save context */
			    make_true(COMPLEX_FLAG,yyval.subclass);
			  complex_const_allowed=TRUE;
			  if(in_assignment_stmt)
			    make_true(IN_ASSIGN,yyval.subclass);
			  in_assignment_stmt = FALSE;

                          subprog_level0 = (crp_sblevel *)malloc(sizeof(crp_sblevel));
                          subprog_level0->prev = subprog_level;
                          subprog_level = subprog_level0;
			  strcpy(subprog_level->subprogram_name,token_name(yyvsp[0]));
			}
break;
case 393:
#line 2656 "fortran.y"
{
			        subprog_level->call_arg_num = -1;
				yyval.class = 0;
				yyval.next_token = NULL;
			}
break;
case 395:
#line 2665 "fortran.y"
{
#ifdef CHKEXTERNAL
			    ay_chk_external(yyvsp[0]);
#endif
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			    subprog_level->call_arg_num = 0;
			    crp_actual_arg_set(subprog_level->argument,
				subprog_level->call_arg_num,&(yyvsp[0]),!value_flag);
			    if ( value_flag && crp_is_normal(subprog_level->subprogram_name)) 
                            { 
			      int ret, line_num;
			      char *sub_name;
                              if ( (ret=crp_value_violation(
					subprog_level->subprogram_name,
					subprog_level->call_arg_num,
					&sub_name, &line_num)) == 8 ) 
			      {
                                    warning(yyvsp[0].line_num,yyvsp[0].col_num,
                                        "No de param a l'appel depasse le nombre de param su sous programme.\n");
			      }
			      else
			      {
				if ( ret & 1 )
                                {  
                                    sprintf(new_char_val, g_message[26],
				          subprog_level->call_arg_num+1,
				(subprog_level->call_arg_num==0)?"er":"eme",
			subprog_level->subprogram_name,sub_name,line_num);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num, new_char_val, "CRP_200");
				    new_error_level = 4;
                                }  
/*
				if ( ret & 2 )
				{
                                    sprintf(new_char_val,
                                        "Violation de longueur de la chaine au %d%s parametre de %s.\n",
					subprog_level->call_arg_num+1,
					(subprog_level->call_arg_num+1 == 1)?"er":"eme",
					subprog_level->subprogram_name);
                                    syntax_error($1.line_num,$1.col_num,
                                        new_char_val,"",NULL);
				    new_error_level = 4;
				}
*/
			      }
                            }
			}
break;
case 396:
#line 2713 "fortran.y"
{
#ifdef CHKEXTERNAL
			    ay_chk_external(yyvsp[0]);
#endif
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			    subprog_level->call_arg_num++;
			    crp_actual_arg_set(subprog_level->argument,
				subprog_level->call_arg_num, &(yyvsp[0]),!value_flag);
/* inhiber apres appel de Jacques le 06/10
			    if ( subprog_level->call_arg_num == MAX_PARM )
			    {
			        sprintf(new_char_val,g_message[18], MAX_PARM);
			        syntax_error($3.line_num,$3.col_num,
				  new_char_val, "CRP_21");
				        new_error_level = 4;
			    }
*/
			    if ( value_flag && crp_is_normal(subprog_level->subprogram_name)) 
                            { 
			      int ret, line_num;
			      char *sub_name;
                              if ( (ret=crp_value_violation(
					subprog_level->subprogram_name,
					subprog_level->call_arg_num,
					&sub_name,&line_num)) == 8 ) 
			      {
                                    warning(yyvsp[0].line_num,yyvsp[0].col_num,
                                        "No de param a l'appel depasse le nombre de param su sous programme.\n");
			      }
			      else
			      {
				if ( ret & 1 )
                                {  
                                    sprintf(new_char_val,
                                        g_message[26],
					subprog_level->call_arg_num+1,
				(subprog_level->call_arg_num==0)?"er":"eme",
			subprog_level->subprogram_name,sub_name,line_num);
                                    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num, new_char_val, "CRP_200");
				    new_error_level = 4;
                                }  
/*
				if ( ret & 2 )
				{
				    new_error_level = 4;
                                    sprintf(new_char_val,
                                        "Violation de longueur de la chaine au %d%s parametre de %s.\n",
					subprog_level->call_arg_num+1,
					(subprog_level->call_arg_num+1 == 1)?"er":"eme",
					subprog_level->subprogram_name);
                                    syntax_error($3.line_num,$3.col_num,
                                        new_char_val,"",NULL);
				}
*/
			      }
                            }
			}
break;
case 397:
#line 2775 "fortran.y"
{
			  int t=datatype_of(yyvsp[0].class);
			  if( t != type_ERROR){
			    if( ! is_const_type(t) ) {
/*
			      syntax_error($1.line_num,$1.col_num,
		      "arithmetic, char, or logical expression expected","",NULL);
*/
			    }
			    else {
			      if( !is_true(PARAMETER_EXPR,yyvsp[0].subclass) ) {
/*
				syntax_error($1.line_num,$1.col_num,
					   "constant expression expected","",NULL);
*/
			      }
			    /* Here we allow, with some warnings, expr
			       containing intrins func or **REAL in
			       PARAMETER defn. */
			      else if( !is_true(CONST_EXPR,yyvsp[0].subclass) ) {
				if(f77_standard) {
/*
				  nonstandard($1.line_num,$1.col_num);
				  msg_tail(
			 "intrinsic function or **REAL in PARAMETER defn");
*/
				}
			      }
			    }
			  }
			}
break;
case 398:
#line 2810 "fortran.y"
{
#ifdef DEBUG_PARSER
			    if(debug_parser) {
				fprintf(list_fd,
					"\nexpr: class=0x%x subclass=0x%x",
					yyvsp[0].class,
					yyvsp[0].subclass);
			    }
#endif
			}
break;
case 400:
#line 2825 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 401:
#line 2831 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 403:
#line 2841 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 405:
#line 2851 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 407:
#line 2861 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			    value_flag = 1;
			}
break;
case 409:
#line 2870 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 411:
#line 2881 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			    value_flag = 1;
			}
break;
case 412:
#line 2886 "fortran.y"
{
			    unexpr_type(&(yyvsp[-1]),&(yyvsp[0]),&(yyval));
			    value_flag = 1;
			}
break;
case 413:
#line 2891 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 414:
#line 2897 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 416:
#line 2907 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    if(div_check &&
			       !is_true(CONST_EXPR,yyvsp[0].subclass)){
				warning(yyvsp[-1].line_num,yyvsp[-1].col_num,
					"Possible division by zero");
			    }
			    value_flag = 1;
			}
break;
case 417:
#line 2918 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 418:
#line 2926 "fortran.y"
{
			    if ( yyvsp[0].class == type_STRING )
			    {
                               char_size = yyval.size;
			    }
			}
break;
case 419:
#line 2933 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 421:
#line 2942 "fortran.y"
{
			    binexpr_type(&(yyvsp[-2]),&(yyvsp[-1]),&(yyvsp[0])
					 ,&(yyval));
			    value_flag = 1;
			}
break;
case 422:
#line 2950 "fortran.y"
{ value_flag = 0; }
break;
case 423:
#line 2953 "fortran.y"
{ value_flag = 0; }
break;
case 424:
#line 2956 "fortran.y"
{ value_flag = 1; }
break;
case 425:
#line 2959 "fortran.y"
{ value_flag = 0; }
break;
case 426:
#line 2962 "fortran.y"
{
			    yyval.subclass = 0;
			    make_true(CONST_EXPR,yyval.subclass);
			    make_true(PARAMETER_EXPR,yyval.subclass);
			    make_true(LIT_CONST,yyval.subclass);
			    make_true(EVALUATED_EXPR,yyval.subclass);
			    value_flag = 1;
			}
break;
case 427:
#line 2971 "fortran.y"
{
			    yyval = yyvsp[-1];
				/* (identifier) becomes a non-identifier */
			    if(is_true(LVALUE_EXPR,yyvsp[-1].subclass)) {
/*
				if(pretty_flag) {
				  ugly_code($2.line_num,$2.col_num,
					  "Extraneous parentheses");
				}
*/
				use_variable(&(yyvsp[-1]));
				make_false(LVALUE_EXPR,yyval.subclass);
				make_false(ARRAY_ID_EXPR,yyval.subclass);
				make_false(ID_EXPR,yyval.subclass);
			    }
			    value_flag = 1;
			}
break;
case 428:
#line 2993 "fortran.y"
{
			    /* (class is set in numeric_const productions) */
			    yyval.size = size_DEFAULT;
			}
break;
case 429:
#line 2998 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_STRING);
			    /* (size is set in get_string) */
			}
break;
case 430:
#line 3003 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_HOLLERITH);
			    /* (size is set in get_hollerith) */
			    if(port_check && hollerith_check) {
				warning(yyvsp[0].line_num,yyvsp[0].col_num,
				"hollerith constant may not be portable");
			    }
			}
break;
case 431:
#line 3012 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_LOGICAL);
			    yyval.size = size_DEFAULT;
			}
break;
case 432:
#line 3019 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_INTEGER);
			}
break;
case 433:
#line 3023 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_REAL);
			    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				g_message[3], "CRP_5");
				        new_error_level = 4;
			}
break;
case 434:
#line 3030 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DP);
			}
break;
case 435:
#line 3034 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_COMPLEX);
			    syntax_error(yyvsp[0].line_num,yyvsp[0].col_num,
				g_message[3], "CRP_5");
				        new_error_level = 4;
			}
break;
case 436:
#line 3041 "fortran.y"
{
			    yyval.class = type_byte(class_VAR,type_DCOMPLEX);
			}
break;
case 437:
#line 3048 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
/*
			    if(datatype_of($1.class) != type_INTEGER) {
				syntax_error(
					$1.line_num,$1.col_num,
					"expression must be integer type");
			    }
*/
			}
break;
case 438:
#line 3064 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    {
/*
				int t=datatype_of($1.class);
				    if(t != type_INTEGER && t != type_REAL
					&& t != type_DP ) {
					syntax_error(
					  $1.line_num,$1.col_num,
		"expression must be integer, real, or double precision type");
			    	    }
*/
			    }
			}
break;
case 439:
#line 3086 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }
			    if( ! is_true(CONST_EXPR,yyvsp[0].subclass) ) {
/*
				syntax_error(
					$1.line_num,$1.col_num,
					"constant expression expected");
*/
			    }
			    else {
			      if(datatype_of(yyvsp[0].class) != type_INTEGER){
/*
				syntax_error(
					$1.line_num,$1.col_num,
					"integer expression expected");
*/
			      }
			      else {
				yyval.value.integer = int_expr_value(&(yyvsp[0]));
			      }
			    }
			}
break;
case 440:
#line 3114 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				use_variable(&(yyvsp[0]));
			    }

			    if( datatype_of(yyvsp[0].class) != type_INTEGER ){
/*
				syntax_error(
					$1.line_num,$1.col_num,
					"integer dimension expected");
*/
				yyval.value.integer = 0;
			    }
			    else {
			      if( is_true(EVALUATED_EXPR,yyvsp[0].subclass) )
				yyval.value.integer =
				  int_expr_value(&(yyvsp[0]));
			      else		/* must be dummy */
				yyval.value.integer = 0;
			    }
			}
break;
case 441:
#line 3142 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array lvalue",&(yyvsp[-1]));
#endif
					/* array now becomes scalar */
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			}
break;
case 442:
#line 3154 "fortran.y"
{
				ref_array(&(yyvsp[-3]),&(yyvsp[-1]));
#ifdef DEBUG_PARSER
				if(debug_parser)
				    print_exprlist("array",&(yyvsp[-1]));
#endif
					/* array now becomes scalar */
				make_false(ARRAY_ID_EXPR,yyval.subclass);
			}
break;
case 443:
#line 3166 "fortran.y"
{
			    yyval.next_token = append_token((Token*)NULL,&(yyvsp[0]));
			}
break;
case 444:
#line 3170 "fortran.y"
{
			    yyval.next_token = append_token(yyvsp[-2].next_token,&(yyvsp[0]));
			}
break;
case 445:
#line 3176 "fortran.y"
{
			    if(is_true(ID_EXPR,yyvsp[0].subclass)){
				 use_variable(&(yyvsp[0]));
			    }
				/* check subscript exprs for integer type */
			    if(datatype_of(yyvsp[0].class) != type_INTEGER)
			      if(trunc_check)
			         warning(yyvsp[0].line_num,yyvsp[0].col_num,
					 "subscript is not integer");
			}
break;
case 446:
#line 3190 "fortran.y"
{
				   /* restore status of complex flag */
			    if(!is_true(COMPLEX_FLAG,yyvsp[-1].subclass))
				  complex_const_allowed=FALSE;
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));

                            subprog_level0 = subprog_level->prev;
                            free(subprog_level);
                            subprog_level= subprog_level0;
			}
break;
case 447:
#line 3202 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 448:
#line 3208 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 449:
#line 3212 "fortran.y"
{
			    yyval.size=substring_size(&(yyvsp[-1]),&(yyvsp[0]));
			}
break;
case 450:
#line 3218 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=0; /* 0 means LEN */
			}
break;
case 451:
#line 3224 "fortran.y"
{
			    yyval.class=yyvsp[-2].value.integer;
			    yyval.subclass=0; /* 0 means LEN */
			}
break;
case 452:
#line 3229 "fortran.y"
{
			    yyval.class=1;
			    yyval.subclass=yyvsp[-1].value.integer;
			}
break;
case 453:
#line 3234 "fortran.y"
{
			      yyval.class=yyvsp[-3].value.integer;
			      yyval.subclass=yyvsp[-1].value.integer;
			}
break;
case 454:
#line 3241 "fortran.y"
{
			  if(is_true(ID_EXPR,yyvsp[0].subclass)){
			    use_variable(&(yyvsp[0]));
			  }
				/* check validity and replace nonconst
				   value by size_UNKNOWN. */
			  if(is_true(CONST_EXPR,yyvsp[0].subclass)) {
			    if( (yyval.value.integer=int_expr_value(&(yyvsp[0]))) < 1) {
/*
			      syntax_error($1.line_num,$1.col_num,
					   "invalid substring index");
*/
			    }
			  }
			  else  /* (no longer need ID hash index) */
			    yyval.value.integer=size_UNKNOWN;
			}
break;
case 457:
#line 3268 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 458:
#line 3275 "fortran.y"
{
			    ref_variable(&(yyvsp[0]));
			    primary_id_expr(&(yyvsp[0]),&(yyval));
			}
break;
case 467:
#line 3301 "fortran.y"
{
			  if(yyvsp[0].value.integer == 0) {
			    warning(yyvsp[0].line_num,yyvsp[0].col_num,
				    "nonzero integer expected");
			    msg_tail(": substituting 1");
			    yyval.value.integer = 1;
			  }
			}
break;
case 468:
#line 3316 "fortran.y"
{
			    integer_context=TRUE;
			}
break;
case 469:
#line 3323 "fortran.y"
{
				integer_context=FALSE;
				yyval.class = type_byte(class_LABEL,type_LABEL);
				yyval.subclass = 0;
			}
break;
#line 4854 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
